/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/network","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(Y){for(var e=[],v=0,T=Y.length;v<T;v++)e[v]=ve[Y[v]];return e};define(ve[42],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(T,D){if(!T)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(ve[51],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function T(P){const d=[];for(let g in P)v.call(P,g)&&d.push(P[g]);return d}e.values=T;function D(P,d){for(let g in P)if(v.call(P,g)&&d({key:g,value:P[g]},function(){delete P[g]})===!1)return}e.forEach=D;function A(P,d){const g=Object.create(null);for(const r of P){const a=d(r);let p=g[a];p||(p=g[a]=[]),p.push(r)}return g}e.groupBy=A;function y(P,d){const g=new Map;for(const r of P){const a=d(r);let p=g.get(a);p||(p=[],g.set(a,p)),p.push(r)}return g}e.groupByNumber=y;function C(P){const d=Object.create(null);return P&&P.forEach((g,r)=>{d[r]=g}),d}e.fromMap=C;function S(P,d){const g=[],r=[];for(let a of P)d.has(a)||g.push(a);for(let a of d)P.has(a)||r.push(a);return{removed:g,added:r}}e.diffSets=S;function k(P,d){const g=[],r=[];for(let[a,p]of P)d.has(a)||g.push(p);for(let[a,p]of d)P.has(a)||r.push(p);return{removed:g,added:r}}e.diffMaps=k;class i{constructor(){this.map=new Map}add(d,g){let r=this.map.get(d);r||(r=new Set,this.map.set(d,r)),r.add(g)}delete(d,g){const r=this.map.get(d);!r||(r.delete(g),r.size===0&&this.map.delete(d))}forEach(d,g){const r=this.map.get(d);!r||r.forEach(g)}}e.SetMap=i}),define(ve[52],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(y){return(C,S,k)=>{let i=null,P=null;if(typeof k.value=="function"?(i="value",P=k.value):typeof k.get=="function"&&(i="get",P=k.get),!P)throw new Error("not supported");k[i]=y(P,S)}}e.createDecorator=v;function T(y,C,S){let k=null,i=null;if(typeof S.value=="function"?(k="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",i=S.get),!i)throw new Error("not supported");const P=`$memoize$${C}`;S[k]=function(...d){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,d)}),this[P]}}e.memoize=T;function D(y,C,S){return v((k,i)=>{const P=`$debounce$${i}`,d=`$debounce$result$${i}`;return function(...g){this[d]||(this[d]=S?S():void 0),clearTimeout(this[P]),C&&(this[d]=C(this[d],...g),g=[this[d]]),this[P]=setTimeout(()=>{k.apply(this,g),this[d]=S?S():void 0},y)}})}e.debounce=D;function A(y,C,S){return v((k,i)=>{const P=`$throttle$timer$${i}`,d=`$throttle$result$${i}`,g=`$throttle$lastRun$${i}`,r=`$throttle$pending$${i}`;return function(...a){if(this[d]||(this[d]=S?S():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),C&&(this[d]=C(this[d],...a)),!this[r]){const p=this[g]+y;p<=Date.now()?(this[g]=Date.now(),k.apply(this,[this[d]]),this[d]=S?S():void 0):(this[r]=!0,this[P]=setTimeout(()=>{this[r]=!1,this[g]=Date.now(),k.apply(this,[this[d]]),this[d]=S?S():void 0},p-Date.now()))}}})}e.throttle=A}),define(ve[12],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function T(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=T;function D(m){S(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=D;function A(m){S(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=A;function y(m){if(m instanceof Error){let{name:t,message:n}=m;const l=m.stacktrace||m.stack;return{$isError:!0,name:t,message:n,stack:l}}return m}e.transformErrorForSerialization=y;const C="Canceled";function S(m){return m instanceof Error&&m.name===C&&m.message===C}e.isPromiseCanceledError=S;class k extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=k;function i(){const m=new Error(C);return m.name=m.message,m}e.canceled=i;function P(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=P;function d(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=d;function g(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function r(m){const t=new Error(`${m} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function a(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=a;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class f extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=f;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function o(m){const t=m;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=o;function c(m,t=Object.create(null)){const n=new Error(m);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=c}),define(ve[13],be([0,1,12]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(U,F=0){return U[U.length-(1+F)]}e.tail=T;function D(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=D;function A(U,F,L=(M,x)=>M===x){if(U===F)return!0;if(!U||!F||U.length!==F.length)return!1;for(let M=0,x=U.length;M<x;M++)if(!L(U[M],F[M]))return!1;return!0}e.equals=A;function y(U,F,L){let M=0,x=U.length-1;for(;M<=x;){const G=(M+x)/2|0,J=L(U[G],F);if(J<0)M=G+1;else if(J>0)x=G-1;else return G}return-(M+1)}e.binarySearch=y;function C(U,F){let L=0,M=U.length;if(M===0)return 0;for(;L<M;){const x=Math.floor((L+M)/2);F(U[x])?M=x:L=x+1}return L}e.findFirstInSorted=C;function S(U,F,L){if(U=U|0,U>=F.length)throw new TypeError("invalid index");let M=F[Math.floor(F.length*Math.random())],x=[],G=[],J=[];for(let te of F){const me=L(te,M);me<0?x.push(te):me>0?G.push(te):J.push(te)}return U<x.length?S(U,x,L):U<x.length+J.length?J[0]:S(U-(x.length+J.length),G,L)}e.quickSelect=S;function k(U,F){const L=[];let M;for(const x of U.slice(0).sort(F))!M||F(M[0],x)!==0?(M=[x],L.push(M)):M.push(x);return L}e.groupBy=k;function i(U,F,L){const M=[];function x(te,me,Le){if(!(me===0&&Le.length===0)){const We=M[M.length-1];We&&We.start+We.deleteCount===te?(We.deleteCount+=me,We.toInsert.push(...Le)):M.push({start:te,deleteCount:me,toInsert:Le})}}let G=0,J=0;for(;;){if(G===U.length){x(G,0,F.slice(J));break}if(J===F.length){x(G,U.length-G,[]);break}const te=U[G],me=F[J],Le=L(te,me);Le===0?(G+=1,J+=1):Le<0?(x(G,1,[]),G+=1):Le>0&&(x(G,0,[me]),J+=1)}return M}e.sortedDiff=i;function P(U,F,L){const M=i(U,F,L),x=[],G=[];for(const J of M)x.push(...U.slice(J.start,J.start+J.deleteCount)),G.push(...J.toInsert);return{removed:x,added:G}}e.delta=P;function d(U,F,L){if(L===0)return[];const M=U.slice(0,L).sort(F);return r(U,F,M,L,U.length),M}e.top=d;function g(U,F,L,M,x){return L===0?Promise.resolve([]):new Promise((G,J)=>{(async()=>{const te=U.length,me=U.slice(0,L).sort(F);for(let Le=L,We=Math.min(L+M,te);Le<te;Le=We,We=Math.min(We+M,te)){if(Le>L&&await new Promise(Fe=>setTimeout(Fe)),x&&x.isCancellationRequested)throw(0,v.canceled)();r(U,F,me,Le,We)}return me})().then(G,J)})}e.topAsync=g;function r(U,F,L,M,x){for(const G=L.length;M<x;M++){const J=U[M];if(F(J,L[G-1])<0){L.pop();const te=C(L,me=>F(J,me)<0);L.splice(te,0,J)}}}function a(U){return U.filter(F=>!!F)}e.coalesce=a;function p(U){let F=0;for(let L=0;L<U.length;L++)U[L]&&(U[F]=U[L],F+=1);U.length=F}e.coalesceInPlace=p;function f(U,F,L){U.splice(L,0,U.splice(F,1)[0])}e.move=f;function E(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=E;function o(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=o;function c(U,F){if(!F)return U.filter((M,x)=>U.indexOf(M)===x);const L=Object.create(null);return U.filter(M=>{const x=F(M);return L[x]?!1:(L[x]=!0,!0)})}e.distinct=c;function m(U){const F=new Set;return U.filter(L=>F.has(L)?!1:(F.add(L),!0))}e.distinctES6=m;function t(U){const F=Object.create(null);return L=>{const M=U(L);return F[M]?!1:(F[M]=!0,!0)}}e.uniqueFilter=t;function n(U,F){for(let L=U.length-1;L>=0;L--){const M=U[L];if(F(M))return L}return-1}e.lastIndex=n;function l(U,F){return U.length>0?U[0]:F}e.firstOrDefault=l;function s(U,F,L=(M,x)=>M===x){let M=0;for(let x=0,G=Math.min(U.length,F.length);x<G&&L(U[x],F[x]);x++)M++;return M}e.commonPrefixLength=s;function u(U){return[].concat(...U)}e.flatten=u;function w(U,F){let L=typeof F=="number"?U:0;typeof F=="number"?L=U:(L=0,F=U);const M=[];if(L<=F)for(let x=L;x<F;x++)M.push(x);else for(let x=L;x>F;x--)M.push(x);return M}e.range=w;function b(U,F,L){return U.reduce((M,x)=>(M[F(x)]=L?L(x):x,M),Object.create(null))}e.index=b;function I(U,F){return U.push(F),()=>h(U,F)}e.insert=I;function h(U,F){const L=U.indexOf(F);if(L>-1)return U.splice(L,1),F}e.remove=h;function _(U,F,L){const M=U.slice(0,F),x=U.slice(F);return M.concat(L,x)}e.arrayInsert=_;function R(U,F){let L;if(typeof F=="number"){let M=F;L=()=>{const x=Math.sin(M++)*179426549;return x-Math.floor(x)}}else L=Math.random;for(let M=U.length-1;M>0;M-=1){const x=Math.floor(L()*(M+1)),G=U[M];U[M]=U[x],U[x]=G}}e.shuffle=R;function B(U,F){const L=U.indexOf(F);L>-1&&(U.splice(L,1),U.unshift(F))}e.pushToStart=B;function z(U,F){const L=U.indexOf(F);L>-1&&(U.splice(L,1),U.push(F))}e.pushToEnd=z;function he(U,F){return Array.isArray(U)?U.map(F):F(U)}e.mapArrayOrNot=he;function de(U){return Array.isArray(U)?U:[U]}e.asArray=de;function W(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=W;function j(U,F){for(const L of U){const M=F(L);if(M!==void 0)return M}}e.mapFind=j}),define(ve[53],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(T){const D=this;let A=!1,y;return function(){return A||(A=!0,y=T.apply(D,arguments)),y}}e.once=v}),define(ve[54],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(ve[43],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(T){function D(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}T.is=D;const A=Object.freeze([]);function y(){return A}T.empty=y;function*C(m){yield m}T.single=C;function S(m){return m||A}T.from=S;function k(m){return!m||m[Symbol.iterator]().next().done===!0}T.isEmpty=k;function i(m){return m[Symbol.iterator]().next().value}T.first=i;function P(m,t){for(const n of m)if(t(n))return!0;return!1}T.some=P;function d(m,t){for(const n of m)if(t(n))return n}T.find=d;function*g(m,t){for(const n of m)t(n)&&(yield n)}T.filter=g;function*r(m,t){for(const n of m)yield t(n)}T.map=r;function*a(...m){for(const t of m)for(const n of t)yield n}T.concat=a;function*p(m){for(const t of m)for(const n of t)yield n}T.concatNested=p;function f(m,t,n){let l=n;for(const s of m)l=t(l,s);return l}T.reduce=f;function*E(m,t,n=m.length){for(t<0&&(t+=m.length),n<0?n+=m.length:n>m.length&&(n=m.length);t<n;t++)yield m[t]}T.slice=E;function o(m,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,m];const l=m[Symbol.iterator]();for(let s=0;s<t;s++){const u=l.next();if(u.done)return[n,T.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return l}}]}T.consume=o;function c(m,t,n=(l,s)=>l===s){const l=m[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=l.next(),w=s.next();if(u.done!==w.done)return!1;if(u.done)return!0;if(!n(u.value,w.value))return!1}}T.equals=c})(v=e.Iterable||(e.Iterable={}))}),define(ve[44],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let l=0,s=t.length,u="",w=0,b=16,I=0;function h(W){let j=0,U=0;for(;j<W;){const F=t.charCodeAt(l);if(F>=48&&F<=57)U=U*16+F-48;else if(F>=65&&F<=70)U=U*16+F-65+10;else if(F>=97&&F<=102)U=U*16+F-97+10;else break;l++,j++}return j<W&&(U=-1),U}function _(W){l=W,u="",w=0,b=16,I=0}function R(){const W=l;if(t.charCodeAt(l)===48)l++;else for(l++;l<t.length&&k(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===46)if(l++,l<t.length&&k(t.charCodeAt(l)))for(l++;l<t.length&&k(t.charCodeAt(l));)l++;else return I=3,t.substring(W,l);let j=l;if(l<t.length&&(t.charCodeAt(l)===69||t.charCodeAt(l)===101))if(l++,(l<t.length&&t.charCodeAt(l)===43||t.charCodeAt(l)===45)&&l++,l<t.length&&k(t.charCodeAt(l))){for(l++;l<t.length&&k(t.charCodeAt(l));)l++;j=l}else I=3;return t.substring(W,j)}function B(){let W="",j=l;for(;;){if(l>=s){W+=t.substring(j,l),I=2;break}const U=t.charCodeAt(l);if(U===34){W+=t.substring(j,l),l++;break}if(U===92){if(W+=t.substring(j,l),l++,l>=s){I=2;break}switch(t.charCodeAt(l++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const L=h(4);L>=0?W+=String.fromCharCode(L):I=4;break;default:I=5}j=l;continue}if(U>=0&&U<=31)if(S(U)){W+=t.substring(j,l),I=2;break}else I=6;l++}return W}function z(){if(u="",I=0,w=l,l>=s)return w=s,b=17;let W=t.charCodeAt(l);if(C(W)){do l++,u+=String.fromCharCode(W),W=t.charCodeAt(l);while(C(W));return b=15}if(S(W))return l++,u+=String.fromCharCode(W),W===13&&t.charCodeAt(l)===10&&(l++,u+=`
`),b=14;switch(W){case 123:return l++,b=1;case 125:return l++,b=2;case 91:return l++,b=3;case 93:return l++,b=4;case 58:return l++,b=6;case 44:return l++,b=5;case 34:return l++,u=B(),b=10;case 47:const j=l-1;if(t.charCodeAt(l+1)===47){for(l+=2;l<s&&!S(t.charCodeAt(l));)l++;return u=t.substring(j,l),b=12}if(t.charCodeAt(l+1)===42){l+=2;const U=s-1;let F=!1;for(;l<U;){if(t.charCodeAt(l)===42&&t.charCodeAt(l+1)===47){l+=2,F=!0;break}l++}return F||(l++,I=1),u=t.substring(j,l),b=13}return u+=String.fromCharCode(W),l++,b=16;case 45:if(u+=String.fromCharCode(W),l++,l===s||!k(t.charCodeAt(l)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=R(),b=11;default:for(;l<s&&he(W);)l++,W=t.charCodeAt(l);if(w!==l){switch(u=t.substring(w,l),u){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return u+=String.fromCharCode(W),l++,b=16}}function he(W){if(C(W)||S(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function de(){let W;do W=z();while(W>=12&&W<=15);return W}return{setPosition:_,getPosition:()=>l,scan:n?de:z,getToken:()=>b,getTokenValue:()=>u,getTokenOffset:()=>w,getTokenLength:()=>l-w,getTokenError:()=>I}}e.createScanner=y;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,n){const l=[],s=new Object;let u;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function I(h,_,R,B){w.value=h,w.offset=_,w.length=R,w.type=B,w.colonOffset=void 0,u=w}try{o(t,{onObjectBegin:(h,_)=>{if(n<=h)throw s;u=void 0,b=n>h,l.push("")},onObjectProperty:(h,_,R)=>{if(n<_||(I(h,_,R,"property"),l[l.length-1]=h,n<=_+R))throw s},onObjectEnd:(h,_)=>{if(n<=h)throw s;u=void 0,l.pop()},onArrayBegin:(h,_)=>{if(n<=h)throw s;u=void 0,l.push(0)},onArrayEnd:(h,_)=>{if(n<=h)throw s;u=void 0,l.pop()},onLiteralValue:(h,_,R)=>{if(n<_||(I(h,_,R,m(h)),n<=_+R))throw s},onSeparator:(h,_,R)=>{if(n<=_)throw s;if(h===":"&&u&&u.type==="property")u.colonOffset=_,b=!1,u=void 0;else if(h===","){const B=l[l.length-1];typeof B=="number"?l[l.length-1]=B+1:(b=!0,l[l.length-1]=""),u=void 0}}})}catch(h){if(h!==s)throw h}return{path:l,previousNode:u,isAtPropertyKey:b,matches:h=>{let _=0;for(let R=0;_<h.length&&R<l.length;R++)if(h[_]===l[R]||h[_]==="*")_++;else if(h[_]!=="**")return!1;return _===h.length}}}e.getLocation=P;function d(t,n=[],l=A.DEFAULT){let s=null,u=[];const w=[];function b(h){Array.isArray(u)?u.push(h):s!==null&&(u[s]=h)}return o(t,{onObjectBegin:()=>{const h={};b(h),w.push(u),u=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const h=[];b(h),w.push(u),u=h,s=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:b,onError:(h,_,R)=>{n.push({error:h,offset:_,length:R})}},l),u[0]}e.parse=d;function g(t,n=[],l=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(h){s.type==="property"&&(s.length=h-s.offset,s=s.parent)}function w(h){return s.children.push(h),h}o(t,{onObjectBegin:h=>{s=w({type:"object",offset:h,length:-1,parent:s,children:[]})},onObjectProperty:(h,_,R)=>{s=w({type:"property",offset:_,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:h,offset:_,length:R,parent:s})},onObjectEnd:(h,_)=>{s.length=h+_-s.offset,s=s.parent,u(h+_)},onArrayBegin:(h,_)=>{s=w({type:"array",offset:h,length:-1,parent:s,children:[]})},onArrayEnd:(h,_)=>{s.length=h+_-s.offset,s=s.parent,u(h+_)},onLiteralValue:(h,_,R)=>{w({type:m(h),offset:_,length:R,parent:s,value:h}),u(_+R)},onSeparator:(h,_,R)=>{s.type==="property"&&(h===":"?s.colonOffset=_:h===","&&u(_))},onError:(h,_,R)=>{n.push({error:h,offset:_,length:R})}},l);const I=s.children[0];return I&&delete I.parent,I}e.parseTree=g;function r(t,n){if(!!t){let l=t;for(let s of n)if(typeof s=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let u=!1;for(const w of l.children)if(Array.isArray(w.children)&&w.children[0].value===s){l=w.children[1],u=!0;break}if(!u)return}else{const u=s;if(l.type!=="array"||u<0||!Array.isArray(l.children)||u>=l.children.length)return;l=l.children[u]}return l}}e.findNodeAtLocation=r;function a(t){if(!t.parent||!t.parent.children)return[];const n=a(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;n.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&n.push(l)}return n}e.getNodePath=a;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const n=Object.create(null);for(let l of t.children){const s=l.children[1];s&&(n[l.children[0].value]=p(s))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function f(t,n,l=!1){return n>=t.offset&&n<t.offset+t.length||l&&n===t.offset+t.length}e.contains=f;function E(t,n,l=!1){if(f(t,n,l)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=n;u++){const w=E(s[u],n,l);if(w)return w}return t}}e.findNodeAtOffset=E;function o(t,n,l=A.DEFAULT){const s=y(t,!1);function u(me){return me?()=>me(s.getTokenOffset(),s.getTokenLength()):()=>!0}function w(me){return me?Le=>me(Le,s.getTokenOffset(),s.getTokenLength()):()=>!0}const b=u(n.onObjectBegin),I=w(n.onObjectProperty),h=u(n.onObjectEnd),_=u(n.onArrayBegin),R=u(n.onArrayEnd),B=w(n.onLiteralValue),z=w(n.onSeparator),he=u(n.onComment),de=w(n.onError),W=l&&l.disallowComments,j=l&&l.allowTrailingComma;function U(){for(;;){const me=s.scan();switch(s.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:W||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(me){case 12:case 13:W?F(10):he();break;case 16:F(1);break;case 15:case 14:break;default:return me}}}function F(me,Le=[],We=[]){if(de(me),Le.length+We.length>0){let Fe=s.getToken();for(;Fe!==17;){if(Le.indexOf(Fe)!==-1){U();break}else if(We.indexOf(Fe)!==-1)break;Fe=U()}}}function L(me){const Le=s.getTokenValue();return me?B(Le):I(Le),U(),!0}function M(){switch(s.getToken()){case 11:let me=0;try{me=JSON.parse(s.getTokenValue()),typeof me!="number"&&(F(2),me=0)}catch(Le){F(2)}B(me);break;case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return U(),!0}function x(){return s.getToken()!==10?(F(3,[],[2,5]),!1):(L(!1),s.getToken()===6?(z(":"),U(),te()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function G(){b(),U();let me=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(me||F(4,[],[]),z(","),U(),s.getToken()===2&&j)break}else me&&F(6,[],[]);x()||F(4,[],[2,5]),me=!0}return h(),s.getToken()!==2?F(7,[2],[]):U(),!0}function J(){_(),U();let me=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(me||F(4,[],[]),z(","),U(),s.getToken()===4&&j)break}else me&&F(6,[],[]);te()||F(4,[],[4,5]),me=!0}return R(),s.getToken()!==4?F(8,[4],[]):U(),!0}function te(){switch(s.getToken()){case 3:return J();case 1:return G();case 10:return L(!0);default:return M()}}return U(),s.getToken()===17?l.allowEmptyContent?!0:(F(4,[],[]),!1):te()?(s.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=o;function c(t,n){let l=y(t),s=[],u,w=0,b;do switch(b=l.getPosition(),u=l.scan(),u){case 12:case 13:case 17:w!==b&&s.push(t.substring(w,b)),n!==void 0&&s.push(l.getTokenValue().replace(/[^\r\n]/g,n)),w=l.getPosition();break}while(u!==17);return s.join("")}e.stripComments=c;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(ve[107],be([0,1,44]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(S,k,i){let P,d,g,r,a;if(k){for(r=k.offset,a=r+k.length,g=r;g>0&&!C(S,g-1);)g--;let w=a;for(;w<S.length&&!C(S,w);)w++;d=S.substring(g,w),P=A(d,i)}else d=S,P=0,g=0,r=0,a=S.length;const p=y(i,S);let f=!1,E=0,o;i.insertSpaces?o=D(" ",i.tabSize||4):o="	";const c=(0,v.createScanner)(d,!1);let m=!1;function t(){return p+D(o,P+E)}function n(){let w=c.scan();for(f=!1;w===15||w===14;)f=f||w===14,w=c.scan();return m=w===16||c.getTokenError()!==0,w}const l=[];function s(w,b,I){!m&&b<a&&I>r&&S.substring(b,I)!==w&&l.push({offset:b,length:I-b,content:w})}let u=n();if(u!==17){const w=c.getTokenOffset()+g,b=D(o,P);s(b,g,w)}for(;u!==17;){let w=c.getTokenOffset()+c.getTokenLength()+g,b=n(),I="";for(;!f&&(b===12||b===13);){const _=c.getTokenOffset()+g;s(" ",w,_),w=c.getTokenOffset()+c.getTokenLength()+g,I=b===12?t():"",b=n()}if(b===2)u!==1&&(E--,I=t());else if(b===4)u!==3&&(E--,I=t());else{switch(u){case 3:case 1:E++,I=t();break;case 5:case 12:I=t();break;case 13:f?I=t():I=" ";break;case 6:I=" ";break;case 10:if(b===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?I=" ":b!==5&&b!==17&&(m=!0);break;case 16:m=!0;break}f&&(b===12||b===13)&&(I=t())}const h=c.getTokenOffset()+g;s(I,w,h),u=b}return l}e.format=T;function D(S,k){let i="";for(let P=0;P<k;P++)i+=S;return i}function A(S,k){let i=0,P=0;const d=k.tabSize||4;for(;i<S.length;){const g=S.charAt(i);if(g===" ")P++;else if(g==="	")P+=d;else break;i++}return Math.floor(P/d)}function y(S,k){for(let i=0;i<k.length;i++){const P=k.charAt(i);if(P==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=y;function C(S,k){return`\r
`.indexOf(S.charAt(k))!==-1}e.isEOL=C}),define(ve[108],be([0,1,44,107]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(k,i,P){return A(k,i,void 0,P)}e.removeProperty=D;function A(k,i,P,d,g){const r=i.slice(),a=[],p=(0,v.parseTree)(k,a);let f,E;for(;r.length>0&&(E=r.pop(),f=(0,v.findNodeAtLocation)(p,r),f===void 0&&P!==void 0);)typeof E=="string"?P={[E]:P}:P=[P];if(f)if(f.type==="object"&&typeof E=="string"&&Array.isArray(f.children)){const o=(0,v.findNodeAtLocation)(f,[E]);if(o!==void 0)if(P===void 0){if(!o.parent)throw new Error("Malformed AST");const c=f.children.indexOf(o.parent);let m,t=o.parent.offset+o.parent.length;if(c>0){const n=f.children[c-1];m=n.offset+n.length}else m=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return y(k,{offset:m,length:t-m,content:""},d)}else return y(k,{offset:o.offset,length:o.length,content:JSON.stringify(P)},d);else{if(P===void 0)return[];const c=`${JSON.stringify(E)}: ${JSON.stringify(P)}`,m=g?g(f.children.map(n=>n.children[0].value)):f.children.length;let t;if(m>0){const n=f.children[m-1];t={offset:n.offset+n.length,length:0,content:","+c}}else f.children.length===0?t={offset:f.offset+1,length:0,content:c}:t={offset:f.offset+1,length:0,content:c+","};return y(k,t,d)}}else if(f.type==="array"&&typeof E=="number"&&Array.isArray(f.children))if(P!==void 0){const o=`${JSON.stringify(P)}`;let c;if(f.children.length===0||E===0)c={offset:f.offset+1,length:0,content:f.children.length===0?o:o+","};else{const m=E===-1||E>f.children.length?f.children.length:E,t=f.children[m-1];c={offset:t.offset+t.length,length:0,content:","+o}}return y(k,c,d)}else{const o=E,c=f.children[o];let m;if(f.children.length===1)m={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===o){const t=f.children[o-1],n=t.offset+t.length,l=f.offset+f.length;m={offset:n,length:l-2-n,content:""}}else m={offset:c.offset,length:f.children[o+1].offset-c.offset,content:""};return y(k,m,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${f.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(P)},d)}}e.setProperty=A;function y(k,i,P){let d=C(k,i),g=i.offset,r=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;g>0&&!(0,T.isEOL)(d,g-1);)g--;for(;r<d.length&&!(0,T.isEOL)(d,r);)r++}const a=(0,T.format)(d,{offset:g,length:r-g},P);for(let f=a.length-1;f>=0;f--){const E=a[f];d=C(d,E),g=Math.min(g,E.offset),r=Math.max(r,E.offset+E.length),r+=E.content.length-E.length}const p=k.length-(d.length-r)-g;return[{offset:g,length:p,content:d.substring(g,r)}]}e.withFormatting=y;function C(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=C;function S(k,i){let P=i.slice(0).sort((g,r)=>{const a=g.offset-r.offset;return a===0?g.length-r.length:a}),d=k.length;for(let g=P.length-1;g>=0;g--){let r=P[g];if(r.offset+r.length<=d)k=C(k,r);else throw new Error("Overlapping edit");d=r.offset}return k}e.applyEdits=S}),define(ve[109],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(ve[6],be([0,1,53,43]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let A=null;function y(o){A=o}if(e.setDisposableTracker=y,D){const o="__is_disposable_tracked__";A=new class{trackDisposable(c){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(m)},3e3)}markTracked(c){if(c&&c!==a.None)try{c[o]=!0}catch(m){}}}}function C(o){!A||A.markTracked(o)}function S(o){return A&&A.trackDisposable(o),o}e.trackDisposable=S;class k extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=k;function i(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=i;function P(o){if(T.Iterable.is(o)){let c=[];for(const m of o)if(m){C(m);try{m.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new k(c);return Array.isArray(o)?[]:o}else if(o)return C(o),o.dispose(),o}e.dispose=P;function d(...o){return o.forEach(C),g(()=>P(o))}e.combinedDisposable=d;function g(o){const c=S({dispose:()=>{C(c),o()}});return c}e.toDisposable=g;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return C(c),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new r,S(this)}dispose(){C(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var m;this._isDisposed||c===this._value||((m=this._value)===null||m===void 0||m.dispose(),c&&C(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,C(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=p;class f{constructor(){this.references=new Map}acquire(c,...m){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...m)},this.references.set(c,t));const{object:n}=t,l=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:n,dispose:l}}}e.ReferenceCollection=f;class E{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=E}),define(ve[45],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(A){this.element=A,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class T{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let A=this._first;for(;A!==v.Undefined;){const y=A.next;A.prev=v.Undefined,A.next=v.Undefined,A=y}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const C=new v(A);if(this._first===v.Undefined)this._first=C,this._last=C;else if(y){const k=this._last;this._last=C,C.prev=k,k.next=C}else{const k=this._first;this._first=C,C.next=k,k.prev=C}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(C))}}shift(){if(this._first!==v.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==v.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==v.Undefined&&A.next!==v.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===v.Undefined&&A.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):A.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):A.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==v.Undefined;)yield A.element,A=A.next}}e.LinkedList=T}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(ye,Ee){for(var Ce=0;Ce<Ee.length;Ce++){var ie=Ee[Ce];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(ye,ie.key,ie)}}function e(ye,Ee,Ce){return Ee&&Y(ye.prototype,Ee),Ce&&Y(ye,Ce),ye}function v(ye,Ee){if(!!ye){if(typeof ye=="string")return T(ye,Ee);var Ce=Object.prototype.toString.call(ye).slice(8,-1);if(Ce==="Object"&&ye.constructor&&(Ce=ye.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(ye);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return T(ye,Ee)}}function T(ye,Ee){(Ee==null||Ee>ye.length)&&(Ee=ye.length);for(var Ce=0,ie=new Array(Ee);Ce<Ee;Ce++)ie[Ce]=ye[Ce];return ie}function D(ye,Ee){var Ce;if(typeof Symbol=="undefined"||ye[Symbol.iterator]==null){if(Array.isArray(ye)||(Ce=v(ye))||Ee&&ye&&typeof ye.length=="number"){Ce&&(ye=Ce);var ie=0;return function(){return ie>=ye.length?{done:!0}:{done:!1,value:ye[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=ye[Symbol.iterator](),Ce.next.bind(Ce)}function A(ye){var Ee={exports:{}};return ye(Ee,Ee.exports),Ee.exports}var y=A(function(ye){function Ee(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(ie){ye.exports.defaults=ie}ye.exports={defaults:Ee(),getDefaults:Ee,changeDefaults:Ce}}),C=/[&<>"']/,S=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(Ee){return P[Ee]};function g(ye,Ee){if(Ee){if(C.test(ye))return ye.replace(S,d)}else if(k.test(ye))return ye.replace(i,d);return ye}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(ye){return ye.replace(r,function(Ee,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var p=/(^|[^\[])\^/g;function f(ye,Ee){ye=ye.source||ye,Ee=Ee||"";var Ce={replace:function(ae,N){return N=N.source||N,N=N.replace(p,"$1"),ye=ye.replace(ae,N),Ce},getRegex:function(){return new RegExp(ye,Ee)}};return Ce}var E=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ye,Ee,Ce){if(ye){var ie;try{ie=decodeURIComponent(a(Ce)).replace(E,"").toLowerCase()}catch(ae){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}Ee&&!o.test(Ce)&&(Ce=s(Ee,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ae){return null}return Ce}var m={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ye,Ee){m[" "+ye]||(t.test(ye)?m[" "+ye]=ye+"/":m[" "+ye]=I(ye,"/",!0)),ye=m[" "+ye];var Ce=ye.indexOf(":")===-1;return Ee.substring(0,2)==="//"?Ce?Ee:ye.replace(n,"$1")+Ee:Ee.charAt(0)==="/"?Ce?Ee:ye.replace(l,"$1")+Ee:ye+Ee}var u={exec:function(){}};function w(ye){for(var Ee=1,Ce,ie;Ee<arguments.length;Ee++){Ce=arguments[Ee];for(ie in Ce)Object.prototype.hasOwnProperty.call(Ce,ie)&&(ye[ie]=Ce[ie])}return ye}function b(ye,Ee){var Ce=ye.replace(/\|/g,function(N,Q,oe){for(var ke=!1,Ie=Q;--Ie>=0&&oe[Ie]==="\\";)ke=!ke;return ke?"|":" |"}),ie=Ce.split(/ \|/),ae=0;if(ie.length>Ee)ie.splice(Ee);else for(;ie.length<Ee;)ie.push("");for(;ae<ie.length;ae++)ie[ae]=ie[ae].trim().replace(/\\\|/g,"|");return ie}function I(ye,Ee,Ce){var ie=ye.length;if(ie===0)return"";for(var ae=0;ae<ie;){var N=ye.charAt(ie-ae-1);if(N===Ee&&!Ce)ae++;else if(N!==Ee&&Ce)ae++;else break}return ye.substr(0,ie-ae)}function h(ye,Ee){if(ye.indexOf(Ee[1])===-1)return-1;for(var Ce=ye.length,ie=0,ae=0;ae<Ce;ae++)if(ye[ae]==="\\")ae++;else if(ye[ae]===Ee[0])ie++;else if(ye[ae]===Ee[1]&&(ie--,ie<0))return ae;return-1}function _(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ye,Ee){if(Ee<1)return"";for(var Ce="";Ee>1;)Ee&1&&(Ce+=ye),Ee>>=1,ye+=ye;return Ce+ye}var B={escape:g,unescape:a,edit:f,cleanUrl:c,resolveUrl:s,noopTest:u,merge:w,splitCells:b,rtrim:I,findClosingBracket:h,checkSanitizeDeprecation:_,repeatString:R},z=y.defaults,he=B.rtrim,de=B.splitCells,W=B.escape,j=B.findClosingBracket;function U(ye,Ee,Ce){var ie=Ee.href,ae=Ee.title?W(Ee.title):null,N=ye[1].replace(/\\([\[\]])/g,"$1");return ye[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:ie,title:ae,text:N}:{type:"image",raw:Ce,href:ie,title:ae,text:W(N)}}function F(ye,Ee){var Ce=ye.match(/^(\s+)(?:```)/);if(Ce===null)return Ee;var ie=Ce[1];return Ee.split(`
`).map(function(ae){var N=ae.match(/^\s+/);if(N===null)return ae;var Q=N[0];return Q.length>=ie.length?ae.slice(ie.length):ae}).join(`
`)}var L=function(){function ye(Ce){this.options=Ce||z}var Ee=ye.prototype;return Ee.space=function(ie){var ae=this.rules.block.newline.exec(ie);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Ee.code=function(ie){var ae=this.rules.block.code.exec(ie);if(ae){var N=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?N:he(N,`
`)}}},Ee.fences=function(ie){var ae=this.rules.block.fences.exec(ie);if(ae){var N=ae[0],Q=F(N,ae[3]||"");return{type:"code",raw:N,lang:ae[2]?ae[2].trim():ae[2],text:Q}}},Ee.heading=function(ie){var ae=this.rules.block.heading.exec(ie);if(ae){var N=ae[2].trim();if(/#$/.test(N)){var Q=he(N,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(N=Q.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:N}}},Ee.nptable=function(ie){var ae=this.rules.block.nptable.exec(ie);if(ae){var N={type:"table",header:de(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[],raw:ae[0]};if(N.header.length===N.align.length){var Q=N.align.length,oe;for(oe=0;oe<Q;oe++)/^ *-+: *$/.test(N.align[oe])?N.align[oe]="right":/^ *:-+: *$/.test(N.align[oe])?N.align[oe]="center":/^ *:-+ *$/.test(N.align[oe])?N.align[oe]="left":N.align[oe]=null;for(Q=N.cells.length,oe=0;oe<Q;oe++)N.cells[oe]=de(N.cells[oe],N.header.length);return N}}},Ee.hr=function(ie){var ae=this.rules.block.hr.exec(ie);if(ae)return{type:"hr",raw:ae[0]}},Ee.blockquote=function(ie){var ae=this.rules.block.blockquote.exec(ie);if(ae){var N=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],text:N}}},Ee.list=function(ie){var ae=this.rules.block.list.exec(ie);if(ae){var N=ae[0],Q=ae[2],oe=Q.length>1,ke={type:"list",raw:N,ordered:oe,start:oe?+Q.slice(0,-1):"",loose:!1,items:[]},Ie=ae[0].match(this.rules.block.item),Ae=!1,Be,Ye,rt,tt,Qe,gt,bt,pe,ue=Ie.length;rt=this.rules.block.listItemStart.exec(Ie[0]);for(var re=0;re<ue;re++){if(Be=Ie[re],N=Be,re!==ue-1){if(tt=this.rules.block.listItemStart.exec(Ie[re+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Ie.splice(re,2,Ie[re]+`
`+Ie[re+1]),re--,ue--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==Q[Q.length-1]:oe===(tt[2].length===1))&&(Qe=Ie.slice(re+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-Qe.length),re=ue-1);rt=tt}Ye=Be.length,Be=Be.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Be.indexOf(`
 `)&&(Ye-=Be.length,Be=this.options.pedantic?Be.replace(/^ {1,4}/gm,""):Be.replace(new RegExp("^ {1,"+Ye+"}","gm"),"")),gt=Ae||/\n\n(?!\s*$)/.test(Be),re!==ue-1&&(Ae=Be.charAt(Be.length-1)===`
`,gt||(gt=Ae)),gt&&(ke.loose=!0),this.options.gfm&&(bt=/^\[[ xX]\] /.test(Be),pe=void 0,bt&&(pe=Be[1]!==" ",Be=Be.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:N,task:bt,checked:pe,loose:gt,text:Be})}return ke}},Ee.html=function(ie){var ae=this.rules.block.html.exec(ie);if(ae)return{type:this.options.sanitize?"paragraph":"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):W(ae[0]):ae[0]}},Ee.def=function(ie){var ae=this.rules.block.def.exec(ie);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var N=ae[1].toLowerCase().replace(/\s+/g," ");return{tag:N,raw:ae[0],href:ae[2],title:ae[3]}}},Ee.table=function(ie){var ae=this.rules.block.table.exec(ie);if(ae){var N={type:"table",header:de(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(N.header.length===N.align.length){N.raw=ae[0];var Q=N.align.length,oe;for(oe=0;oe<Q;oe++)/^ *-+: *$/.test(N.align[oe])?N.align[oe]="right":/^ *:-+: *$/.test(N.align[oe])?N.align[oe]="center":/^ *:-+ *$/.test(N.align[oe])?N.align[oe]="left":N.align[oe]=null;for(Q=N.cells.length,oe=0;oe<Q;oe++)N.cells[oe]=de(N.cells[oe].replace(/^ *\| *| *\| *$/g,""),N.header.length);return N}}},Ee.lheading=function(ie){var ae=this.rules.block.lheading.exec(ie);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1]}},Ee.paragraph=function(ie){var ae=this.rules.block.paragraph.exec(ie);if(ae)return{type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1]}},Ee.text=function(ie){var ae=this.rules.block.text.exec(ie);if(ae)return{type:"text",raw:ae[0],text:ae[0]}},Ee.escape=function(ie){var ae=this.rules.inline.escape.exec(ie);if(ae)return{type:"escape",raw:ae[0],text:W(ae[1])}},Ee.tag=function(ie,ae,N){var Q=this.rules.inline.tag.exec(ie);if(Q)return!ae&&/^<a /i.test(Q[0])?ae=!0:ae&&/^<\/a>/i.test(Q[0])&&(ae=!1),!N&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?N=!0:N&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(N=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:ae,inRawBlock:N,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):W(Q[0]):Q[0]}},Ee.link=function(ie){var ae=this.rules.inline.link.exec(ie);if(ae){var N=ae[2].trim();if(!this.options.pedantic&&/^</.test(N)){if(!/>$/.test(N))return;var Q=he(N.slice(0,-1),"\\");if((N.length-Q.length)%2==0)return}else{var oe=j(ae[2],"()");if(oe>-1){var ke=ae[0].indexOf("!")===0?5:4,Ie=ke+ae[1].length+oe;ae[2]=ae[2].substring(0,oe),ae[0]=ae[0].substring(0,Ie).trim(),ae[3]=""}}var Ae=ae[2],Be="";if(this.options.pedantic){var Ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ye&&(Ae=Ye[1],Be=Ye[3])}else Be=ae[3]?ae[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(N)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),U(ae,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Be&&Be.replace(this.rules.inline._escapes,"$1")},ae[0])}},Ee.reflink=function(ie,ae){var N;if((N=this.rules.inline.reflink.exec(ie))||(N=this.rules.inline.nolink.exec(ie))){var Q=(N[2]||N[1]).replace(/\s+/g," ");if(Q=ae[Q.toLowerCase()],!Q||!Q.href){var oe=N[0].charAt(0);return{type:"text",raw:oe,text:oe}}return U(N,Q,N[0])}},Ee.emStrong=function(ie,ae,N){N===void 0&&(N="");var Q=this.rules.inline.emStrong.lDelim.exec(ie);if(!!Q&&!(Q[3]&&N.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var oe=Q[1]||Q[2]||"";if(!oe||oe&&(N===""||this.rules.inline.punctuation.exec(N))){var ke=Q[0].length-1,Ie,Ae,Be=ke,Ye=0,rt=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ae=ae.slice(-1*ie.length+ke);(Q=rt.exec(ae))!=null;)if(Ie=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Ie){if(Ae=Ie.length,Q[3]||Q[4]){Be+=Ae;continue}else if((Q[5]||Q[6])&&ke%3&&!((ke+Ae)%3)){Ye+=Ae;continue}if(Be-=Ae,!(Be>0)){if(Be+Ye-Ae<=0&&!ae.slice(rt.lastIndex).match(rt)&&(Ae=Math.min(Ae,Ae+Be+Ye)),Math.min(ke,Ae)%2)return{type:"em",raw:ie.slice(0,ke+Q.index+Ae+1),text:ie.slice(1,ke+Q.index+Ae)};if(Math.min(ke,Ae)%2==0)return{type:"strong",raw:ie.slice(0,ke+Q.index+Ae+1),text:ie.slice(2,ke+Q.index+Ae-1)}}}}}},Ee.codespan=function(ie){var ae=this.rules.inline.code.exec(ie);if(ae){var N=ae[2].replace(/\n/g," "),Q=/[^ ]/.test(N),oe=/^ /.test(N)&&/ $/.test(N);return Q&&oe&&(N=N.substring(1,N.length-1)),N=W(N,!0),{type:"codespan",raw:ae[0],text:N}}},Ee.br=function(ie){var ae=this.rules.inline.br.exec(ie);if(ae)return{type:"br",raw:ae[0]}},Ee.del=function(ie){var ae=this.rules.inline.del.exec(ie);if(ae)return{type:"del",raw:ae[0],text:ae[2]}},Ee.autolink=function(ie,ae){var N=this.rules.inline.autolink.exec(ie);if(N){var Q,oe;return N[2]==="@"?(Q=W(this.options.mangle?ae(N[1]):N[1]),oe="mailto:"+Q):(Q=W(N[1]),oe=Q),{type:"link",raw:N[0],text:Q,href:oe,tokens:[{type:"text",raw:Q,text:Q}]}}},Ee.url=function(ie,ae){var N;if(N=this.rules.inline.url.exec(ie)){var Q,oe;if(N[2]==="@")Q=W(this.options.mangle?ae(N[0]):N[0]),oe="mailto:"+Q;else{var ke;do ke=N[0],N[0]=this.rules.inline._backpedal.exec(N[0])[0];while(ke!==N[0]);Q=W(N[0]),N[1]==="www."?oe="http://"+Q:oe=Q}return{type:"link",raw:N[0],text:Q,href:oe,tokens:[{type:"text",raw:Q,text:Q}]}}},Ee.inlineText=function(ie,ae,N){var Q=this.rules.inline.text.exec(ie);if(Q){var oe;return ae?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):W(Q[0]):Q[0]:oe=W(this.options.smartypants?N(Q[0]):Q[0]),{type:"text",raw:Q[0],text:oe}}},ye}(),M=B.noopTest,x=B.edit,G=B.merge,J={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};J._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,J._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,J.def=x(J.def).replace("label",J._label).replace("title",J._title).getRegex(),J.bullet=/(?:[*+-]|\d{1,9}[.)])/,J.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,J.item=x(J.item,"gm").replace(/bull/g,J.bullet).getRegex(),J.listItemStart=x(/^( *)(bull)/).replace("bull",J.bullet).getRegex(),J.list=x(J.list).replace(/bull/g,J.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+J.def.source+")").getRegex(),J._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",J._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,J.html=x(J.html,"i").replace("comment",J._comment).replace("tag",J._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),J.paragraph=x(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.blockquote=x(J.blockquote).replace("paragraph",J.paragraph).getRegex(),J.normal=G({},J),J.gfm=G({},J.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),J.gfm.nptable=x(J.gfm.nptable).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.gfm.table=x(J.gfm.table).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.pedantic=G({},J.normal,{html:x(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",J._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:x(J.normal._paragraph).replace("hr",J.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",J.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=x(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=x(J._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=x(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=x(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=x(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=x(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=x(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=x(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=x(te.reflink).replace("label",te._label).getRegex(),te.reflinkSearch=x(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=G({},te),te.pedantic=G({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:x(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:x(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=G({},te.normal,{escape:x(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),te.gfm.url=x(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=G({},te.gfm,{br:x(te.br).replace("{2,}","*").getRegex(),text:x(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:J,inline:te},Le=y.defaults,We=me.block,Fe=me.inline,ze=B.repeatString;function H(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(ye){var Ee="",Ce,ie,ae=ye.length;for(Ce=0;Ce<ae;Ce++)ie=ye.charCodeAt(Ce),Math.random()>.5&&(ie="x"+ie.toString(16)),Ee+="&#"+ie+";";return Ee}var ee=function(){function ye(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Le,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ie={block:We.normal,inline:Fe.normal};this.options.pedantic?(ie.block=We.pedantic,ie.inline=Fe.pedantic):this.options.gfm&&(ie.block=We.gfm,this.options.breaks?ie.inline=Fe.breaks:ie.inline=Fe.gfm),this.tokenizer.rules=ie}ye.lex=function(ie,ae){var N=new ye(ae);return N.lex(ie)},ye.lexInline=function(ie,ae){var N=new ye(ae);return N.inlineTokens(ie)};var Ee=ye.prototype;return Ee.lex=function(ie){return ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens,!0),this.inline(this.tokens),this.tokens},Ee.blockTokens=function(ie,ae,N){ae===void 0&&(ae=[]),N===void 0&&(N=!0),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var Q,oe,ke,Ie;ie;){if(Q=this.tokenizer.space(ie)){ie=ie.substring(Q.raw.length),Q.type&&ae.push(Q);continue}if(Q=this.tokenizer.code(ie)){ie=ie.substring(Q.raw.length),Ie=ae[ae.length-1],Ie&&Ie.type==="paragraph"?(Ie.raw+=`
`+Q.raw,Ie.text+=`
`+Q.text):ae.push(Q);continue}if(Q=this.tokenizer.fences(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.heading(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.nptable(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.hr(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.blockquote(ie)){ie=ie.substring(Q.raw.length),Q.tokens=this.blockTokens(Q.text,[],N),ae.push(Q);continue}if(Q=this.tokenizer.list(ie)){for(ie=ie.substring(Q.raw.length),ke=Q.items.length,oe=0;oe<ke;oe++)Q.items[oe].tokens=this.blockTokens(Q.items[oe].text,[],!1);ae.push(Q);continue}if(Q=this.tokenizer.html(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(N&&(Q=this.tokenizer.def(ie))){ie=ie.substring(Q.raw.length),this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.lheading(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(N&&(Q=this.tokenizer.paragraph(ie))){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.text(ie)){ie=ie.substring(Q.raw.length),Ie=ae[ae.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+Q.raw,Ie.text+=`
`+Q.text):ae.push(Q);continue}if(ie){var Ae="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return ae},Ee.inline=function(ie){var ae,N,Q,oe,ke,Ie,Ae=ie.length;for(ae=0;ae<Ae;ae++)switch(Ie=ie[ae],Ie.type){case"paragraph":case"text":case"heading":{Ie.tokens=[],this.inlineTokens(Ie.text,Ie.tokens);break}case"table":{for(Ie.tokens={header:[],cells:[]},oe=Ie.header.length,N=0;N<oe;N++)Ie.tokens.header[N]=[],this.inlineTokens(Ie.header[N],Ie.tokens.header[N]);for(oe=Ie.cells.length,N=0;N<oe;N++)for(ke=Ie.cells[N],Ie.tokens.cells[N]=[],Q=0;Q<ke.length;Q++)Ie.tokens.cells[N][Q]=[],this.inlineTokens(ke[Q],Ie.tokens.cells[N][Q]);break}case"blockquote":{this.inline(Ie.tokens);break}case"list":{for(oe=Ie.items.length,N=0;N<oe;N++)this.inline(Ie.items[N].tokens);break}}return ie},Ee.inlineTokens=function(ie,ae,N,Q){ae===void 0&&(ae=[]),N===void 0&&(N=!1),Q===void 0&&(Q=!1);var oe,ke,Ie=ie,Ae,Be,Ye;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)rt.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+ze("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+ze("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;){if(Be||(Ye=""),Be=!1,oe=this.tokenizer.escape(ie)){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(oe=this.tokenizer.tag(ie,N,Q)){ie=ie.substring(oe.raw.length),N=oe.inLink,Q=oe.inRawBlock;var tt=ae[ae.length-1];tt&&oe.type==="text"&&tt.type==="text"?(tt.raw+=oe.raw,tt.text+=oe.text):ae.push(oe);continue}if(oe=this.tokenizer.link(ie)){ie=ie.substring(oe.raw.length),oe.type==="link"&&(oe.tokens=this.inlineTokens(oe.text,[],!0,Q)),ae.push(oe);continue}if(oe=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(oe.raw.length);var Qe=ae[ae.length-1];oe.type==="link"?(oe.tokens=this.inlineTokens(oe.text,[],!0,Q),ae.push(oe)):Qe&&oe.type==="text"&&Qe.type==="text"?(Qe.raw+=oe.raw,Qe.text+=oe.text):ae.push(oe);continue}if(oe=this.tokenizer.emStrong(ie,Ie,Ye)){ie=ie.substring(oe.raw.length),oe.tokens=this.inlineTokens(oe.text,[],N,Q),ae.push(oe);continue}if(oe=this.tokenizer.codespan(ie)){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(oe=this.tokenizer.br(ie)){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(oe=this.tokenizer.del(ie)){ie=ie.substring(oe.raw.length),oe.tokens=this.inlineTokens(oe.text,[],N,Q),ae.push(oe);continue}if(oe=this.tokenizer.autolink(ie,q)){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(!N&&(oe=this.tokenizer.url(ie,q))){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(oe=this.tokenizer.inlineText(ie,Q,H)){ie=ie.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Ye=oe.raw.slice(-1)),Be=!0,ke=ae[ae.length-1],ke&&ke.type==="text"?(ke.raw+=oe.raw,ke.text+=oe.text):ae.push(oe);continue}if(ie){var gt="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(gt);break}else throw new Error(gt)}}return ae},e(ye,null,[{key:"rules",get:function(){return{block:We,inline:Fe}}}]),ye}(),se=y.defaults,ce=B.cleanUrl,_e=B.escape,$e=function(){function ye(Ce){this.options=Ce||se}var Ee=ye.prototype;return Ee.code=function(ie,ae,N){var Q=(ae||"").match(/\S*/)[0];if(this.options.highlight){var oe=this.options.highlight(ie,Q);oe!=null&&oe!==ie&&(N=!0,ie=oe)}return ie=ie.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+_e(Q,!0)+'">'+(N?ie:_e(ie,!0))+`</code></pre>
`:"<pre><code>"+(N?ie:_e(ie,!0))+`</code></pre>
`},Ee.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},Ee.html=function(ie){return ie},Ee.heading=function(ie,ae,N,Q){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+Q.slug(N)+'">'+ie+"</h"+ae+`>
`:"<h"+ae+">"+ie+"</h"+ae+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(ie,ae,N){var Q=ae?"ol":"ul",oe=ae&&N!==1?' start="'+N+'"':"";return"<"+Q+oe+`>
`+ie+"</"+Q+`>
`},Ee.listitem=function(ie){return"<li>"+ie+`</li>
`},Ee.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(ie){return"<p>"+ie+`</p>
`},Ee.table=function(ie,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+ae+`</table>
`},Ee.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},Ee.tablecell=function(ie,ae){var N=ae.header?"th":"td",Q=ae.align?"<"+N+' align="'+ae.align+'">':"<"+N+">";return Q+ie+"</"+N+`>
`},Ee.strong=function(ie){return"<strong>"+ie+"</strong>"},Ee.em=function(ie){return"<em>"+ie+"</em>"},Ee.codespan=function(ie){return"<code>"+ie+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(ie){return"<del>"+ie+"</del>"},Ee.link=function(ie,ae,N){if(ie=ce(this.options.sanitize,this.options.baseUrl,ie),ie===null)return N;var Q='<a href="'+_e(ie)+'"';return ae&&(Q+=' title="'+ae+'"'),Q+=">"+N+"</a>",Q},Ee.image=function(ie,ae,N){if(ie=ce(this.options.sanitize,this.options.baseUrl,ie),ie===null)return N;var Q='<img src="'+ie+'" alt="'+N+'"';return ae&&(Q+=' title="'+ae+'"'),Q+=this.options.xhtml?"/>":">",Q},Ee.text=function(ie){return ie},ye}(),fe=function(){function ye(){}var Ee=ye.prototype;return Ee.strong=function(ie){return ie},Ee.em=function(ie){return ie},Ee.codespan=function(ie){return ie},Ee.del=function(ie){return ie},Ee.html=function(ie){return ie},Ee.text=function(ie){return ie},Ee.link=function(ie,ae,N){return""+N},Ee.image=function(ie,ae,N){return""+N},Ee.br=function(){return""},ye}(),De=function(){function ye(){this.seen={}}var Ee=ye.prototype;return Ee.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(ie,ae){var N=ie,Q=0;if(this.seen.hasOwnProperty(N)){Q=this.seen[ie];do Q++,N=ie+"-"+Q;while(this.seen.hasOwnProperty(N))}return ae||(this.seen[ie]=Q,this.seen[N]=0),N},Ee.slug=function(ie,ae){ae===void 0&&(ae={});var N=this.serialize(ie);return this.getNextSafeSlug(N,ae.dryrun)},ye}(),Re=y.defaults,He=B.unescape,we=function(){function ye(Ce){this.options=Ce||Re,this.options.renderer=this.options.renderer||new $e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new De}ye.parse=function(ie,ae){var N=new ye(ae);return N.parse(ie)},ye.parseInline=function(ie,ae){var N=new ye(ae);return N.parseInline(ie)};var Ee=ye.prototype;return Ee.parse=function(ie,ae){ae===void 0&&(ae=!0);var N="",Q,oe,ke,Ie,Ae,Be,Ye,rt,tt,Qe,gt,bt,pe,ue,re,K,Me,Te,Je=ie.length;for(Q=0;Q<Je;Q++)switch(Qe=ie[Q],Qe.type){case"space":continue;case"hr":{N+=this.renderer.hr();continue}case"heading":{N+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,He(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{N+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(rt="",Ye="",Ie=Qe.header.length,oe=0;oe<Ie;oe++)Ye+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[oe]),{header:!0,align:Qe.align[oe]});for(rt+=this.renderer.tablerow(Ye),tt="",Ie=Qe.cells.length,oe=0;oe<Ie;oe++){for(Be=Qe.tokens.cells[oe],Ye="",Ae=Be.length,ke=0;ke<Ae;ke++)Ye+=this.renderer.tablecell(this.parseInline(Be[ke]),{header:!1,align:Qe.align[ke]});tt+=this.renderer.tablerow(Ye)}N+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Qe.tokens),N+=this.renderer.blockquote(tt);continue}case"list":{for(gt=Qe.ordered,bt=Qe.start,pe=Qe.loose,Ie=Qe.items.length,tt="",oe=0;oe<Ie;oe++)re=Qe.items[oe],K=re.checked,Me=re.task,ue="",re.task&&(Te=this.renderer.checkbox(K),pe?re.tokens.length>0&&re.tokens[0].type==="text"?(re.tokens[0].text=Te+" "+re.tokens[0].text,re.tokens[0].tokens&&re.tokens[0].tokens.length>0&&re.tokens[0].tokens[0].type==="text"&&(re.tokens[0].tokens[0].text=Te+" "+re.tokens[0].tokens[0].text)):re.tokens.unshift({type:"text",text:Te}):ue+=Te),ue+=this.parse(re.tokens,pe),tt+=this.renderer.listitem(ue,Me,K);N+=this.renderer.list(tt,gt,bt);continue}case"html":{N+=this.renderer.html(Qe.text);continue}case"paragraph":{N+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(tt=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;Q+1<Je&&ie[Q+1].type==="text";)Qe=ie[++Q],tt+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);N+=ae?this.renderer.paragraph(tt):tt;continue}default:{var et='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return N},Ee.parseInline=function(ie,ae){ae=ae||this.renderer;var N="",Q,oe,ke=ie.length;for(Q=0;Q<ke;Q++)switch(oe=ie[Q],oe.type){case"escape":{N+=ae.text(oe.text);break}case"html":{N+=ae.html(oe.text);break}case"link":{N+=ae.link(oe.href,oe.title,this.parseInline(oe.tokens,ae));break}case"image":{N+=ae.image(oe.href,oe.title,oe.text);break}case"strong":{N+=ae.strong(this.parseInline(oe.tokens,ae));break}case"em":{N+=ae.em(this.parseInline(oe.tokens,ae));break}case"codespan":{N+=ae.codespan(oe.text);break}case"br":{N+=ae.br();break}case"del":{N+=ae.del(this.parseInline(oe.tokens,ae));break}case"text":{N+=ae.text(oe.text);break}default:{var Ie='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}return N},ye}(),Ke=B.merge,V=B.checkSanitizeDeprecation,Z=B.escape,ge=y.getDefaults,Ne=y.changeDefaults,Ve=y.defaults;function xe(ye,Ee,Ce){if(typeof ye=="undefined"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof Ee=="function"&&(Ce=Ee,Ee=null),Ee=Ke({},xe.defaults,Ee||{}),V(Ee),Ce){var ie=Ee.highlight,ae;try{ae=ee.lex(ye,Ee)}catch(ke){return Ce(ke)}var N=function(Ie){var Ae;if(!Ie)try{Ae=we.parse(ae,Ee)}catch(Be){Ie=Be}return Ee.highlight=ie,Ie?Ce(Ie):Ce(null,Ae)};if(!ie||ie.length<3||(delete Ee.highlight,!ae.length))return N();var Q=0;xe.walkTokens(ae,function(ke){ke.type==="code"&&(Q++,setTimeout(function(){ie(ke.text,ke.lang,function(Ie,Ae){if(Ie)return N(Ie);Ae!=null&&Ae!==ke.text&&(ke.text=Ae,ke.escaped=!0),Q--,Q===0&&N()})},0))}),Q===0&&N();return}try{var oe=ee.lex(ye,Ee);return Ee.walkTokens&&xe.walkTokens(oe,Ee.walkTokens),we.parse(oe,Ee)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+Z(ke.message+"",!0)+"</pre>";throw ke}}xe.options=xe.setOptions=function(ye){return Ke(xe.defaults,ye),Ne(xe.defaults),xe},xe.getDefaults=ge,xe.defaults=Ve,xe.use=function(ye){var Ee=Ke({},ye);if(ye.renderer&&function(){var ie=xe.defaults.renderer||new $e,ae=function(oe){var ke=ie[oe];ie[oe]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),Be=0;Be<Ie;Be++)Ae[Be]=arguments[Be];var Ye=ye.renderer[oe].apply(ie,Ae);return Ye===!1&&(Ye=ke.apply(ie,Ae)),Ye}};for(var N in ye.renderer)ae(N);Ee.renderer=ie}(),ye.tokenizer&&function(){var ie=xe.defaults.tokenizer||new L,ae=function(oe){var ke=ie[oe];ie[oe]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),Be=0;Be<Ie;Be++)Ae[Be]=arguments[Be];var Ye=ye.tokenizer[oe].apply(ie,Ae);return Ye===!1&&(Ye=ke.apply(ie,Ae)),Ye}};for(var N in ye.tokenizer)ae(N);Ee.tokenizer=ie}(),ye.walkTokens){var Ce=xe.defaults.walkTokens;Ee.walkTokens=function(ie){ye.walkTokens(ie),Ce&&Ce(ie)}}xe.setOptions(Ee)},xe.walkTokens=function(ye,Ee){for(var Ce=D(ye),ie;!(ie=Ce()).done;){var ae=ie.value;switch(Ee(ae),ae.type){case"table":{for(var N=D(ae.tokens.header),Q;!(Q=N()).done;){var oe=Q.value;xe.walkTokens(oe,Ee)}for(var ke=D(ae.tokens.cells),Ie;!(Ie=ke()).done;)for(var Ae=Ie.value,Be=D(Ae),Ye;!(Ye=Be()).done;){var rt=Ye.value;xe.walkTokens(rt,Ee)}break}case"list":{xe.walkTokens(ae.items,Ee);break}default:ae.tokens&&xe.walkTokens(ae.tokens,Ee)}}},xe.parseInline=function(ye,Ee){if(typeof ye=="undefined"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");Ee=Ke({},xe.defaults,Ee||{}),V(Ee);try{var Ce=ee.lexInline(ye,Ee);return Ee.walkTokens&&xe.walkTokens(Ce,Ee.walkTokens),we.parseInline(Ce,Ee)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+Z(ie.message+"",!0)+"</pre>";throw ie}},xe.Parser=we,xe.parser=we.parse,xe.Renderer=$e,xe.TextRenderer=fe,xe.Lexer=ee,xe.lexer=ee.lex,xe.Tokenizer=L,xe.Slugger=De,xe.parse=xe;var Xe=xe;return Xe}),define(ve[82],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(y,C,S){return Math.min(Math.max(y,C),S)}e.clamp=v;function T(y,C){return(C+y%C)%C}e.rot=T;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class A{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function Y(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function y(S){A.push(S,Date.now())}function C(){const S=[];for(let k=0;k<A.length;k+=2)S.push({name:A[k],startTime:A[k+1]});return S}return{mark:y,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(D+y.startTime)});return A}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=v(T))})(),define(ve[21],be([0,1]),function(Y,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let D=!1,A=!1,y=!1,C=!1,S=!1,k=!1,i=!1,P,d=T,g,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const p=typeof((v=a==null?void 0:a.versions)===null||v===void 0?void 0:v.electron)=="string"&&a.type==="renderer";if(e.isElectronSandboxed=p&&(a==null?void 0:a.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=a==null?void 0:a.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)r=navigator.userAgent,D=r.indexOf("Windows")>=0,A=r.indexOf("Macintosh")>=0,i=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=r.indexOf("Linux")>=0,k=!0,P=navigator.language,d=P;else if(typeof a=="object"){D=a.platform==="win32",A=a.platform==="darwin",y=a.platform==="linux",C=y&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,P=T,d=T;const s=a.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),w=u.availableLanguages["*"];P=u.locale,d=w||T,g=u._translationsConfigFile}catch(u){}S=!0}else console.error("Unable to resolve platform.");var f;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function E(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let o=0;A?o=1:D?o=3:y&&(o=2),e.isWindows=D,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=C,e.isNative=S,e.isWeb=k,e.isIOS=i,e.platform=o,e.userAgent=r,e.language=d;var c;(function(s){function u(){return e.language}s.value=u;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=w;function b(){return e.language==="en"}s.isDefault=b})(c=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let w=[];e.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeSetImmediateId)for(let h=0,_=w.length;h<_;h++){const R=w[h];if(R.id===I.data.vscodeSetImmediateId){w.splice(h,1),R.callback();return}}});let b=0;return I=>{const h=++b;w.push({id:h,callback:I}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(typeof(a==null?void 0:a.nextTick)=="function")return a.nextTick.bind(a);const u=Promise.resolve();return w=>u.then(w)}();var m;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(m=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||i?2:D?1:3;let t=!0,n=!1;function l(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=l}),define(ve[46],be([0,1,21]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof v.globals.vscode!="undefined"){const D=v.globals.vscode.process;T={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(A){return(0,v.setImmediate)(A)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:T={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(D){return(0,v.setImmediate)(D)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(ve[14],be([0,1,46]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,D=97,A=90,y=122,C=46,S=47,k=92,i=58,P=63;class d extends Error{constructor(c,m,t){let n;typeof m=="string"&&m.indexOf("not ")===0?(n="must not be",m=m.replace(/^not /,"")):n="must be";const l=c.indexOf(".")!==-1?"property":"argument";let s=`The "${c}" ${l} ${n} of type ${m}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function g(o,c){if(typeof o!="string")throw new d(c,"string",o)}function r(o){return o===S||o===k}function a(o){return o===S}function p(o){return o>=T&&o<=A||o>=D&&o<=y}function f(o,c,m,t){let n="",l=0,s=-1,u=0,w=0;for(let b=0;b<=o.length;++b){if(b<o.length)w=o.charCodeAt(b);else{if(t(w))break;w=S}if(t(w)){if(!(s===b-1||u===1))if(u===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const I=n.lastIndexOf(m);I===-1?(n="",l=0):(n=n.slice(0,I),l=n.length-1-n.lastIndexOf(m)),s=b,u=0;continue}else if(n.length!==0){n="",l=0,s=b,u=0;continue}}c&&(n+=n.length>0?`${m}..`:"..",l=2)}else n.length>0?n+=`${m}${o.slice(s+1,b)}`:n=o.slice(s+1,b),l=b-s-1;s=b,u=0}else w===C&&u!==-1?++u:u=-1}return n}function E(o,c){if(c===null||typeof c!="object")throw new d("pathObject","Object",c);const m=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return m?m===c.root?`${m}${t}`:`${m}${o}${t}`:t}e.win32={resolve(...o){let c="",m="",t=!1;for(let n=o.length-1;n>=-1;n--){let l;if(n>=0){if(l=o[n],g(l,"path"),l.length===0)continue}else c.length===0?l=v.cwd():(l=v.env[`=${c}`]||v.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===k)&&(l=`${c}\\`));const s=l.length;let u=0,w="",b=!1;const I=l.charCodeAt(0);if(s===1)r(I)&&(u=1,b=!0);else if(r(I))if(b=!0,r(l.charCodeAt(1))){let h=2,_=h;for(;h<s&&!r(l.charCodeAt(h));)h++;if(h<s&&h!==_){const R=l.slice(_,h);for(_=h;h<s&&r(l.charCodeAt(h));)h++;if(h<s&&h!==_){for(_=h;h<s&&!r(l.charCodeAt(h));)h++;(h===s||h!==_)&&(w=`\\\\${R}\\${l.slice(_,h)}`,u=h)}}}else u=1;else p(I)&&l.charCodeAt(1)===i&&(w=l.slice(0,2),u=2,s>2&&r(l.charCodeAt(2))&&(b=!0,u=3));if(w.length>0)if(c.length>0){if(w.toLowerCase()!==c.toLowerCase())continue}else c=w;if(t){if(c.length>0)break}else if(m=`${l.slice(u)}\\${m}`,t=b,b&&c.length>0)break}return m=f(m,!t,"\\",r),t?`${c}\\${m}`:`${c}${m}`||"."},normalize(o){g(o,"path");const c=o.length;if(c===0)return".";let m=0,t,n=!1;const l=o.charCodeAt(0);if(c===1)return a(l)?"\\":o;if(r(l))if(n=!0,r(o.charCodeAt(1))){let u=2,w=u;for(;u<c&&!r(o.charCodeAt(u));)u++;if(u<c&&u!==w){const b=o.slice(w,u);for(w=u;u<c&&r(o.charCodeAt(u));)u++;if(u<c&&u!==w){for(w=u;u<c&&!r(o.charCodeAt(u));)u++;if(u===c)return`\\\\${b}\\${o.slice(w)}\\`;u!==w&&(t=`\\\\${b}\\${o.slice(w,u)}`,m=u)}}}else m=1;else p(l)&&o.charCodeAt(1)===i&&(t=o.slice(0,2),m=2,c>2&&r(o.charCodeAt(2))&&(n=!0,m=3));let s=m<c?f(o.slice(m),!n,"\\",r):"";return s.length===0&&!n&&(s="."),s.length>0&&r(o.charCodeAt(c-1))&&(s+="\\"),t===void 0?n?`\\${s}`:s:n?`${t}\\${s}`:`${t}${s}`},isAbsolute(o){g(o,"path");const c=o.length;if(c===0)return!1;const m=o.charCodeAt(0);return r(m)||c>2&&p(m)&&o.charCodeAt(1)===i&&r(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let c,m;for(let l=0;l<o.length;++l){const s=o[l];g(s,"path"),s.length>0&&(c===void 0?c=m=s:c+=`\\${s}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof m=="string"&&r(m.charCodeAt(0))){++n;const l=m.length;l>1&&r(m.charCodeAt(1))&&(++n,l>2&&(r(m.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&r(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.win32.normalize(c)},relative(o,c){if(g(o,"from"),g(c,"to"),o===c)return"";const m=e.win32.resolve(o),t=e.win32.resolve(c);if(m===t||(o=m.toLowerCase(),c=t.toLowerCase(),o===c))return"";let n=0;for(;n<o.length&&o.charCodeAt(n)===k;)n++;let l=o.length;for(;l-1>n&&o.charCodeAt(l-1)===k;)l--;const s=l-n;let u=0;for(;u<c.length&&c.charCodeAt(u)===k;)u++;let w=c.length;for(;w-1>u&&c.charCodeAt(w-1)===k;)w--;const b=w-u,I=s<b?s:b;let h=-1,_=0;for(;_<I;_++){const B=o.charCodeAt(n+_);if(B!==c.charCodeAt(u+_))break;B===k&&(h=_)}if(_!==I){if(h===-1)return t}else{if(b>I){if(c.charCodeAt(u+_)===k)return t.slice(u+_+1);if(_===2)return t.slice(u+_)}s>I&&(o.charCodeAt(n+_)===k?h=_:_===2&&(h=3)),h===-1&&(h=0)}let R="";for(_=n+h+1;_<=l;++_)(_===l||o.charCodeAt(_)===k)&&(R+=R.length===0?"..":"\\..");return u+=h,R.length>0?`${R}${t.slice(u,w)}`:(t.charCodeAt(u)===k&&++u,t.slice(u,w))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const c=e.win32.resolve(o);if(c.length<=2)return o;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const m=c.charCodeAt(2);if(m!==P&&m!==C)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return o},dirname(o){g(o,"path");const c=o.length;if(c===0)return".";let m=-1,t=0;const n=o.charCodeAt(0);if(c===1)return r(n)?o:".";if(r(n)){if(m=t=1,r(o.charCodeAt(1))){let u=2,w=u;for(;u<c&&!r(o.charCodeAt(u));)u++;if(u<c&&u!==w){for(w=u;u<c&&r(o.charCodeAt(u));)u++;if(u<c&&u!==w){for(w=u;u<c&&!r(o.charCodeAt(u));)u++;if(u===c)return o;u!==w&&(m=t=u+1)}}}}else p(n)&&o.charCodeAt(1)===i&&(m=c>2&&r(o.charCodeAt(2))?3:2,t=m);let l=-1,s=!0;for(let u=c-1;u>=t;--u)if(r(o.charCodeAt(u))){if(!s){l=u;break}}else s=!1;if(l===-1){if(m===-1)return".";l=m}return o.slice(0,l)},basename(o,c){c!==void 0&&g(c,"ext"),g(o,"path");let m=0,t=-1,n=!0,l;if(o.length>=2&&p(o.charCodeAt(0))&&o.charCodeAt(1)===i&&(m=2),c!==void 0&&c.length>0&&c.length<=o.length){if(c===o)return"";let s=c.length-1,u=-1;for(l=o.length-1;l>=m;--l){const w=o.charCodeAt(l);if(r(w)){if(!n){m=l+1;break}}else u===-1&&(n=!1,u=l+1),s>=0&&(w===c.charCodeAt(s)?--s==-1&&(t=l):(s=-1,t=u))}return m===t?t=u:t===-1&&(t=o.length),o.slice(m,t)}for(l=o.length-1;l>=m;--l)if(r(o.charCodeAt(l))){if(!n){m=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":o.slice(m,t)},extname(o){g(o,"path");let c=0,m=-1,t=0,n=-1,l=!0,s=0;o.length>=2&&o.charCodeAt(1)===i&&p(o.charCodeAt(0))&&(c=t=2);for(let u=o.length-1;u>=c;--u){const w=o.charCodeAt(u);if(r(w)){if(!l){t=u+1;break}continue}n===-1&&(l=!1,n=u+1),w===C?m===-1?m=u:s!==1&&(s=1):m!==-1&&(s=-1)}return m===-1||n===-1||s===0||s===1&&m===n-1&&m===t+1?"":o.slice(m,n)},format:E.bind(null,"\\"),parse(o){g(o,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return c;const m=o.length;let t=0,n=o.charCodeAt(0);if(m===1)return r(n)?(c.root=c.dir=o,c):(c.base=c.name=o,c);if(r(n)){if(t=1,r(o.charCodeAt(1))){let h=2,_=h;for(;h<m&&!r(o.charCodeAt(h));)h++;if(h<m&&h!==_){for(_=h;h<m&&r(o.charCodeAt(h));)h++;if(h<m&&h!==_){for(_=h;h<m&&!r(o.charCodeAt(h));)h++;h===m?t=h:h!==_&&(t=h+1)}}}}else if(p(n)&&o.charCodeAt(1)===i){if(m<=2)return c.root=c.dir=o,c;if(t=2,r(o.charCodeAt(2))){if(m===3)return c.root=c.dir=o,c;t=3}}t>0&&(c.root=o.slice(0,t));let l=-1,s=t,u=-1,w=!0,b=o.length-1,I=0;for(;b>=t;--b){if(n=o.charCodeAt(b),r(n)){if(!w){s=b+1;break}continue}u===-1&&(w=!1,u=b+1),n===C?l===-1?l=b:I!==1&&(I=1):l!==-1&&(I=-1)}return u!==-1&&(l===-1||I===0||I===1&&l===u-1&&l===s+1?c.base=c.name=o.slice(s,u):(c.name=o.slice(s,l),c.base=o.slice(s,u),c.ext=o.slice(l,u))),s>0&&s!==t?c.dir=o.slice(0,s-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let c="",m=!1;for(let t=o.length-1;t>=-1&&!m;t--){const n=t>=0?o[t]:v.cwd();g(n,"path"),n.length!==0&&(c=`${n}/${c}`,m=n.charCodeAt(0)===S)}return c=f(c,!m,"/",a),m?`/${c}`:c.length>0?c:"."},normalize(o){if(g(o,"path"),o.length===0)return".";const c=o.charCodeAt(0)===S,m=o.charCodeAt(o.length-1)===S;return o=f(o,!c,"/",a),o.length===0?c?"/":m?"./":".":(m&&(o+="/"),c?`/${o}`:o)},isAbsolute(o){return g(o,"path"),o.length>0&&o.charCodeAt(0)===S},join(...o){if(o.length===0)return".";let c;for(let m=0;m<o.length;++m){const t=o[m];g(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(o,c){if(g(o,"from"),g(c,"to"),o===c||(o=e.posix.resolve(o),c=e.posix.resolve(c),o===c))return"";const m=1,t=o.length,n=t-m,l=1,s=c.length-l,u=n<s?n:s;let w=-1,b=0;for(;b<u;b++){const h=o.charCodeAt(m+b);if(h!==c.charCodeAt(l+b))break;h===S&&(w=b)}if(b===u)if(s>u){if(c.charCodeAt(l+b)===S)return c.slice(l+b+1);if(b===0)return c.slice(l+b)}else n>u&&(o.charCodeAt(m+b)===S?w=b:b===0&&(w=0));let I="";for(b=m+w+1;b<=t;++b)(b===t||o.charCodeAt(b)===S)&&(I+=I.length===0?"..":"/..");return`${I}${c.slice(l+w)}`},toNamespacedPath(o){return o},dirname(o){if(g(o,"path"),o.length===0)return".";const c=o.charCodeAt(0)===S;let m=-1,t=!0;for(let n=o.length-1;n>=1;--n)if(o.charCodeAt(n)===S){if(!t){m=n;break}}else t=!1;return m===-1?c?"/":".":c&&m===1?"//":o.slice(0,m)},basename(o,c){c!==void 0&&g(c,"ext"),g(o,"path");let m=0,t=-1,n=!0,l;if(c!==void 0&&c.length>0&&c.length<=o.length){if(c===o)return"";let s=c.length-1,u=-1;for(l=o.length-1;l>=0;--l){const w=o.charCodeAt(l);if(w===S){if(!n){m=l+1;break}}else u===-1&&(n=!1,u=l+1),s>=0&&(w===c.charCodeAt(s)?--s==-1&&(t=l):(s=-1,t=u))}return m===t?t=u:t===-1&&(t=o.length),o.slice(m,t)}for(l=o.length-1;l>=0;--l)if(o.charCodeAt(l)===S){if(!n){m=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":o.slice(m,t)},extname(o){g(o,"path");let c=-1,m=0,t=-1,n=!0,l=0;for(let s=o.length-1;s>=0;--s){const u=o.charCodeAt(s);if(u===S){if(!n){m=s+1;break}continue}t===-1&&(n=!1,t=s+1),u===C?c===-1?c=s:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||t===-1||l===0||l===1&&c===t-1&&c===m+1?"":o.slice(c,t)},format:E.bind(null,"/"),parse(o){g(o,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return c;const m=o.charCodeAt(0)===S;let t;m?(c.root="/",t=1):t=0;let n=-1,l=0,s=-1,u=!0,w=o.length-1,b=0;for(;w>=t;--w){const I=o.charCodeAt(w);if(I===S){if(!u){l=w+1;break}continue}s===-1&&(u=!1,s=w+1),I===C?n===-1?n=w:b!==1&&(b=1):n!==-1&&(b=-1)}if(s!==-1){const I=l===0&&m?1:l;n===-1||b===0||b===1&&n===s-1&&n===l+1?c.base=c.name=o.slice(I,s):(c.name=o.slice(I,n),c.base=o.slice(I,s),c.ext=o.slice(n,s))}return l>0?c.dir=o.slice(0,l-1):m&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[55],be([0,1,21]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(y){this._highResolution=T&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new D(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ve[3],be([0,1,12,53,6,45,55]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(f){f.None=()=>D.Disposable.None;function E(W){return(j,U=null,F)=>{let L=!1,M;return M=W(x=>{if(!L)return M?M.dispose():L=!0,j.call(U,x)},null,F),L&&M.dispose(),M}}f.once=E;function o(W,j){return s((U,F=null,L)=>W(M=>U.call(F,j(M)),null,L))}f.map=o;function c(W,j){return s((U,F=null,L)=>W(M=>{j(M),U.call(F,M)},null,L))}f.forEach=c;function m(W,j){return s((U,F=null,L)=>W(M=>j(M)&&U.call(F,M),null,L))}f.filter=m;function t(W){return W}f.signal=t;function n(...W){return(j,U=null,F)=>(0,D.combinedDisposable)(...W.map(L=>L(M=>j.call(U,M),null,F)))}f.any=n;function l(W,j,U){let F=U;return o(W,L=>(F=j(F,L),F))}f.reduce=l;function s(W){let j;const U=new d({onFirstListenerAdd(){j=W(U.fire,U)},onLastListenerRemove(){j.dispose()}});return U.event}f.snapshot=s;function u(W,j,U=100,F=!1,L){let M,x,G,J=0;const te=new d({leakWarningThreshold:L,onFirstListenerAdd(){M=W(me=>{J++,x=j(x,me),F&&!G&&(te.fire(x),x=void 0),clearTimeout(G),G=setTimeout(()=>{const Le=x;x=void 0,G=void 0,(!F||J>1)&&te.fire(Le),J=0},U)})},onLastListenerRemove(){M.dispose()}});return te.event}f.debounce=u;function w(W){const j=new Date().getTime();return o(E(W),U=>new Date().getTime()-j)}f.stopwatch=w;function b(W,j=(U,F)=>U===F){let U=!0,F;return m(W,L=>{const M=U||!j(L,F);return U=!1,F=L,M})}f.latch=b;function I(W,j){return[f.filter(W,j),f.filter(W,U=>!j(U))]}f.split=I;function h(W,j=!1,U=[]){let F=U.slice(),L=W(G=>{F?F.push(G):x.fire(G)});const M=()=>{F&&F.forEach(G=>x.fire(G)),F=null},x=new d({onFirstListenerAdd(){L||(L=W(G=>x.fire(G)))},onFirstListenerDidAdd(){F&&(j?setTimeout(M):M())},onLastListenerRemove(){L&&L.dispose(),L=null}});return x.event}f.buffer=h;class _{constructor(j){this.event=j}map(j){return new _(o(this.event,j))}forEach(j){return new _(c(this.event,j))}filter(j){return new _(m(this.event,j))}reduce(j,U){return new _(l(this.event,j,U))}latch(){return new _(b(this.event))}debounce(j,U=100,F=!1,L){return new _(u(this.event,j,U,F,L))}on(j,U,F){return this.event(j,U,F)}once(j,U,F){return E(this.event)(j,U,F)}}function R(W){return new _(W)}f.chain=R;function B(W,j,U=F=>F){const F=(...G)=>x.fire(U(...G)),L=()=>W.on(j,F),M=()=>W.removeListener(j,F),x=new d({onFirstListenerAdd:L,onLastListenerRemove:M});return x.event}f.fromNodeEventEmitter=B;function z(W,j,U=F=>F){const F=(...G)=>x.fire(U(...G)),L=()=>W.addEventListener(j,F),M=()=>W.removeEventListener(j,F),x=new d({onFirstListenerAdd:L,onLastListenerRemove:M});return x.event}f.fromDOMEventEmitter=z;function he(W){const j=new d;let U=!1;return W.then(void 0,()=>null).then(()=>{U?j.fire(void 0):setTimeout(()=>j.fire(void 0),0)}),U=!0,j.event}f.fromPromise=he;function de(W){return new Promise(j=>E(W)(j))}f.toPromise=de})(C=e.Event||(e.Event={}));class S{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${S._idPool++}`}start(E){this._stopWatch=new y.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let k=-1;function i(f){const E=k;return k=f,{dispose(){k=E}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(E,o=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let o=k;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),!(o<=0||E<o)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),m=this._stacks.get(c)||0;if(this._stacks.set(c,m+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let t,n=0;for(const[l,s]of this._stacks)(!t||n<s)&&(t=l,n=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class d{constructor(E){var o;this._disposed=!1,this._options=E,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((o=this._options)===null||o===void 0?void 0:o._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(E,o,c)=>{var m;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(o?[E,o]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,o);const l=(m=this._leakageMon)===null||m===void 0?void 0:m.check(this._listeners.size);let s;return s={dispose:()=>{l&&l(),s.dispose=d._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof D.DisposableStore?c.add(s):Array.isArray(c)&&c.push(s),s}),this._event}fire(E){var o,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let m of this._listeners)this._deliveryQueue.push([m,E]);for((o=this._perfMon)===null||o===void 0||o.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[m,t]=this._deliveryQueue.shift();try{typeof m=="function"?m.call(void 0,t):m[0].call(m[1],t)}catch(n){(0,v.onUnexpectedError)(n)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var E,o,c,m;(E=this._listeners)===null||E===void 0||E.clear(),(o=this._deliveryQueue)===null||o===void 0||o.clear(),((c=this._options)===null||c===void 0?void 0:c.onLastListenerRemove)&&this._options.onLastListenerRemove(),(m=this._leakageMon)===null||m===void 0||m.dispose(),this._disposed=!0}}e.Emitter=d,d._noop=function(){};class g extends d{constructor(E){super(E);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=g;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const o={event:E,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const c=()=>{this.hasListeners&&this.unhook(o);const m=this.events.indexOf(o);this.events.splice(m,1)};return(0,D.toDisposable)((0,T.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(o=>this.emitter.fire(o))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(E){return(o,c,m)=>E(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>o.call(c,t)):o.call(c,t)},void 0,m)}bufferEvents(E){const o=[];this.buffers.push(o);const c=E();return this.buffers.pop(),o.forEach(m=>m()),c}}e.EventBufferer=a;class p{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=D.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(ve[20],be([0,1,3]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(C,S){const k=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(k)}}});var D;(function(C){function S(k){return k===C.None||k===C.Cancelled||k instanceof A?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(D=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=y}),define(ve[36],be([0,1,3]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(P){const d=this._icons.get(P.id);d?P.description?d.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new T;e.iconRegistry=D;function A(i,P){return new C(i,P)}e.registerCodicon=A;function y(i){return i?i.replace(/\$\((.*?)\)/g,(P,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=y;class C{constructor(P,d,g){this.id=P,this.definition=d,this.description=g,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function S(i,P){const d=["codicon","codicon-"+i];return P&&d.push("codicon-modifier-"+P),d}e.getClassNamesArray=S;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function d(a){if(a instanceof C)return["codicon","codicon-"+a.id];const p=P.exec(a.id);if(!p)return d(C.error);let[,f,E]=p;const o=["codicon","codicon-"+f];return E&&o.push("codicon-modifier-"+E.substr(1)),o}i.asClassNameArray=d;function g(a){return d(a).join(" ")}i.asClassName=g;function r(a){return"."+d(a).join(".")}i.asCSSSelector=r})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(ve[110],be([0,1,12,6]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(o){const c=o;return c?[c.on,c.pause,c.resume,c.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=D;function A(o){const c=o;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(o,c){return new C(o,c)}e.newWriteableStream=y;class C{constructor(c,m){this.reducer=c,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(m=>m(c))}emitError(c){this.listeners.error.length===0?(0,v.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(m=>m(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,m){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(c,m){if(!this.state.destroyed){let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(m);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(o,c){const m=[];let t;for(;(t=o.read())!==null;)m.push(t);return c(m)}e.consumeReadable=S;function k(o,c,m){const t=[];let n;for(;(n=o.read())!==null&&t.length<m;)t.push(n);return n===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const l=n;return n=void 0,l}return o.read()}}}e.peekReadable=k;function i(o,c){return new Promise((m,t)=>{const n=[];P(o,{onData:l=>{c&&n.push(l)},onError:l=>{c?t(l):m(void 0)},onEnd:()=>{m(c?c(n):void 0)}})})}e.consumeStream=i;function P(o,c){o.on("error",m=>c.onError(m)),o.on("end",()=>c.onEnd()),o.on("data",m=>c.onData(m))}e.listenStream=P;function d(o,c){return new Promise((m,t)=>{const n=new T.DisposableStore,l=[],s=b=>{if(l.push(b),l.length>c)return n.dispose(),o.pause(),m({stream:o,buffer:l,ended:!1})},u=b=>t(b),w=()=>m({stream:o,buffer:l,ended:!0});n.add((0,T.toDisposable)(()=>o.removeListener("error",u))),o.on("error",u),n.add((0,T.toDisposable)(()=>o.removeListener("end",w))),o.on("end",w),n.add((0,T.toDisposable)(()=>o.removeListener("data",s))),o.on("data",s)})}e.peekStream=d;function g(o,c){const m=y(c);return m.end(o),m}e.toStream=g;function r(){const o=y(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=r;function a(o){let c=!1;return{read:()=>c?null:(c=!0,o)}}e.toReadable=a;function p(o,c,m){const t=y(m);return P(o,{onData:n=>t.write(c.data(n)),onError:n=>t.error(c.error?c.error(n):n),onEnd:()=>t.end()}),t}e.transform=p;function f(o,c,m){let t=!1;return{read:()=>{const n=c.read();return t?n:(t=!0,n!==null?m([o,n]):o)}}}e.prefixedReadable=f;function E(o,c,m){let t=!1;const n=y(m);return P(c,{onData:l=>t?n.write(l):(t=!0,n.write(m([o,l]))),onError:l=>n.error(l),onEnd:()=>{t||(t=!0,n.write(o)),n.end()}}),n}e.prefixedStream=E}),define(ve[8],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(N){return!N||typeof N!="string"?!0:N.trim().length===0}e.isFalsyOrWhitespace=v;const T=/{(\d+)}/g;function D(N,...Q){return Q.length===0?N:N.replace(T,function(oe,ke){const Ie=parseInt(ke,10);return isNaN(Ie)||Ie<0||Ie>=Q.length?oe:Q[Ie]})}e.format=D;function A(N){return N.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}e.escape=A;function y(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function C(N,Q){let oe=0;const ke=Q.charCodeAt(0);for(let Ie=N.length-1;Ie>=0;Ie--)N.charCodeAt(Ie)===ke&&oe++;return oe}e.count=C;function S(N,Q,oe="\u2026"){return N.length<=Q?N:`${N.substr(0,Q)}${oe}`}e.truncate=S;function k(N,Q=" "){const oe=i(N,Q);return P(oe,Q)}e.trim=k;function i(N,Q){if(!N||!Q)return N;const oe=Q.length;if(oe===0||N.length===0)return N;let ke=0;for(;N.indexOf(Q,ke)===ke;)ke=ke+oe;return N.substring(ke)}e.ltrim=i;function P(N,Q){if(!N||!Q)return N;const oe=Q.length,ke=N.length;if(oe===0||ke===0)return N;let Ie=ke,Ae=-1;for(;Ae=N.lastIndexOf(Q,Ie-1),!(Ae===-1||Ae+oe!==Ie);){if(Ae===0)return"";Ie=Ae}return N.substring(0,Ie)}e.rtrim=P;function d(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(N){return N.replace(/\*/g,"")}e.stripWildcards=g;function r(N,Q,oe={}){if(!N)throw new Error("Cannot create regex from empty string");Q||(N=y(N)),oe.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let ke="";return oe.global&&(ke+="g"),oe.matchCase||(ke+="i"),oe.multiline&&(ke+="m"),oe.unicode&&(ke+="u"),new RegExp(N,ke)}e.createRegExp=r;function a(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function p(N){return!!N.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function f(N){return(N.global?"g":"")+(N.ignoreCase?"i":"")+(N.multiline?"m":"")+(N.unicode?"u":"")}e.regExpFlags=f;function E(N){return N.split(/\r\n|\r|\n/)}e.splitLines=E;function o(N){for(let Q=0,oe=N.length;Q<oe;Q++){const ke=N.charCodeAt(Q);if(ke!==32&&ke!==9)return Q}return-1}e.firstNonWhitespaceIndex=o;function c(N,Q=0,oe=N.length){for(let ke=Q;ke<oe;ke++){const Ie=N.charCodeAt(ke);if(Ie!==32&&Ie!==9)return N.substring(Q,ke)}return N.substring(Q,oe)}e.getLeadingWhitespace=c;function m(N,Q=N.length-1){for(let oe=Q;oe>=0;oe--){const ke=N.charCodeAt(oe);if(ke!==32&&ke!==9)return oe}return-1}e.lastNonWhitespaceIndex=m;function t(N,Q){return N<Q?-1:N>Q?1:0}e.compare=t;function n(N,Q,oe=0,ke=N.length,Ie=0,Ae=Q.length){for(;oe<ke&&Ie<Ae;oe++,Ie++){let rt=N.charCodeAt(oe),tt=Q.charCodeAt(Ie);if(rt<tt)return-1;if(rt>tt)return 1}const Be=ke-oe,Ye=Ae-Ie;return Be<Ye?-1:Be>Ye?1:0}e.compareSubstring=n;function l(N,Q){return s(N,Q,0,N.length,0,Q.length)}e.compareIgnoreCase=l;function s(N,Q,oe=0,ke=N.length,Ie=0,Ae=Q.length){for(;oe<ke&&Ie<Ae;oe++,Ie++){let rt=N.charCodeAt(oe),tt=Q.charCodeAt(Ie);if(rt!==tt){const Qe=rt-tt;if(!(Qe===32&&w(tt))&&!(Qe===-32&&w(rt)))return u(rt)&&u(tt)?Qe:n(N.toLowerCase(),Q.toLowerCase(),oe,ke,Ie,Ae)}}const Be=ke-oe,Ye=Ae-Ie;return Be<Ye?-1:Be>Ye?1:0}e.compareSubstringIgnoreCase=s;function u(N){return N>=97&&N<=122}e.isLowerAsciiLetter=u;function w(N){return N>=65&&N<=90}e.isUpperAsciiLetter=w;function b(N){return u(N)||w(N)}function I(N,Q){return N.length===Q.length&&h(N,Q)}e.equalsIgnoreCase=I;function h(N,Q,oe=N.length){for(let ke=0;ke<oe;ke++){const Ie=N.charCodeAt(ke),Ae=Q.charCodeAt(ke);if(Ie!==Ae){if(b(Ie)&&b(Ae)){const Be=Math.abs(Ie-Ae);if(Be!==0&&Be!==32)return!1}else if(String.fromCharCode(Ie).toLowerCase()!==String.fromCharCode(Ae).toLowerCase())return!1}}return!0}function _(N,Q){const oe=Q.length;return Q.length>N.length?!1:h(N,Q,oe)}e.startsWithIgnoreCase=_;function R(N,Q){let oe,ke=Math.min(N.length,Q.length);for(oe=0;oe<ke;oe++)if(N.charCodeAt(oe)!==Q.charCodeAt(oe))return oe;return ke}e.commonPrefixLength=R;function B(N,Q){let oe,ke=Math.min(N.length,Q.length);const Ie=N.length-1,Ae=Q.length-1;for(oe=0;oe<ke;oe++)if(N.charCodeAt(Ie-oe)!==Q.charCodeAt(Ae-oe))return oe;return ke}e.commonSuffixLength=B;function z(N){return 55296<=N&&N<=56319}e.isHighSurrogate=z;function he(N){return 56320<=N&&N<=57343}e.isLowSurrogate=he;function de(N,Q){return(N-55296<<10)+(Q-56320)+65536}e.computeCodePoint=de;function W(N,Q,oe){const ke=N.charCodeAt(oe);if(z(ke)&&oe+1<Q){const Ie=N.charCodeAt(oe+1);if(he(Ie))return de(ke,Ie)}return ke}e.getNextCodePoint=W;function j(N,Q){const oe=N.charCodeAt(Q-1);if(he(oe)&&Q>1){const ke=N.charCodeAt(Q-2);if(z(ke))return de(ke,oe)}return oe}function U(N,Q){const oe=xe.getInstance(),ke=Q,Ie=N.length,Ae=W(N,Ie,Q);Q+=Ae>=65536?2:1;let Be=oe.getGraphemeBreakType(Ae);for(;Q<Ie;){const Ye=W(N,Ie,Q),rt=oe.getGraphemeBreakType(Ye);if(Ne(Be,rt))break;Q+=Ye>=65536?2:1,Be=rt}return Q-ke}e.nextCharLength=U;function F(N,Q){const oe=xe.getInstance(),ke=Q,Ie=j(N,Q);Q-=Ie>=65536?2:1;let Ae=oe.getGraphemeBreakType(Ie);for(;Q>0;){const Be=j(N,Q),Ye=oe.getGraphemeBreakType(Be);if(Ne(Ye,Ae))break;Q-=Be>=65536?2:1,Ae=Ye}return ke-Q}e.prevCharLength=F;function L(N,Q){const oe=xe.getInstance(),ke=N.length,Ie=Q,Ae=W(N,ke,Q),Be=oe.getGraphemeBreakType(Ae);Q+=Ae>=65536?2:1;let Ye=Be;for(;Q<ke;){const tt=W(N,ke,Q),Qe=oe.getGraphemeBreakType(tt);if(Ne(Ye,Qe))break;Q+=tt>=65536?2:1,Ye=Qe}const rt=Q;for(Q=Ie,Ye=Be;Q>0;){const tt=j(N,Q),Qe=oe.getGraphemeBreakType(tt);if(Ne(Qe,Ye))break;Q-=tt>=65536?2:1,Ye=Qe}return[Q,rt]}function M(N,Q){return Q>0&&he(N.charCodeAt(Q))?L(N,Q-1):L(N,Q)}e.getCharContainingOffset=M;function x(N){const Q=N.length;let oe=0,ke=0;for(;ke<Q;){const Be=W(N,Q,ke);ke+=Be>=65536?2:1,Be<128?oe+=1:Be<2048?oe+=2:Be<65536?oe+=3:oe+=4}const Ie=new Uint8Array(oe);ke=0;let Ae=0;for(;ke<Q;){const Be=W(N,Q,ke);ke+=Be>=65536?2:1,Be<128?Ie[Ae++]=Be:Be<2048?(Ie[Ae++]=192|(Be&1984)>>>6,Ie[Ae++]=128|(Be&63)>>>0):Be<65536?(Ie[Ae++]=224|(Be&61440)>>>12,Ie[Ae++]=128|(Be&4032)>>>6,Ie[Ae++]=128|(Be&63)>>>0):(Ie[Ae++]=240|(Be&1835008)>>>18,Ie[Ae++]=128|(Be&258048)>>>12,Ie[Ae++]=128|(Be&4032)>>>6,Ie[Ae++]=128|(Be&63)>>>0)}return Ie}e.encodeUTF8=x;function G(N){const Q=N.byteLength,oe=[];let ke=0;for(;ke<Q;){const Ie=N[ke];let Ae;if(Ie>=240&&ke+3<Q?Ae=(N[ke++]&7)<<18>>>0|(N[ke++]&63)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=224&&ke+2<Q?Ae=(N[ke++]&15)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=192&&ke+1<Q?Ae=(N[ke++]&31)<<6>>>0|(N[ke++]&63)<<0>>>0:Ae=N[ke++],Ae>=0&&Ae<=55295||Ae>=57344&&Ae<=65535)oe.push(String.fromCharCode(Ae));else if(Ae>=65536&&Ae<=1114111){const Be=Ae-65536,Ye=55296+((Be&1047552)>>>10),rt=56320+((Be&1023)>>>0);oe.push(String.fromCharCode(Ye)),oe.push(String.fromCharCode(rt))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=G;const J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function te(N){return J.test(N)}e.containsRTL=te;const me=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Le(N){return me.test(N)}e.containsEmoji=Le;const We=/^[\t\n\r\x20-\x7E]*$/;function Fe(N){return We.test(N)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(N){return e.UNUSUAL_LINE_TERMINATORS.test(N)}e.containsUnusualLineTerminators=ze;function H(N){for(let Q=0,oe=N.length;Q<oe;Q++)if(q(N.charCodeAt(Q)))return!0;return!1}e.containsFullWidthCharacter=H;function q(N){return N=+N,N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}e.isFullWidthCharacter=q;function ee(N){return N>=127462&&N<=127487||N===8986||N===8987||N===9200||N===9203||N>=9728&&N<=10175||N===11088||N===11093||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129003||N>=129280&&N<=129535||N>=129648&&N<=129750}e.isEmojiImprecise=ee;function se(N,Q){if(N.length<Q)return N;const oe=/\b/g;let ke=0;for(;oe.test(N)&&!(N.length-oe.lastIndex<Q);)ke=oe.lastIndex,oe.lastIndex+=1;return N.substring(ke).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,_e=/\x1b\[\d+m/g,$e=/\x1b\[0?m/g;function fe(N){return N&&(N=N.replace(ce,""),N=N.replace(_e,""),N=N.replace($e,"")),N}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Re(N){return De(N)?N.substr(1):N}e.stripUTF8BOM=Re;function He(N,Q){if(!N||!Q||N.length<Q.length)return!1;const oe=Q.length,ke=N.toLowerCase();let Ie=0,Ae=-1;for(;Ie<oe;){const Be=ke.indexOf(Q[Ie],Ae+1);if(Be<0)return!1;Ae=Be,Ie++}return!0}e.fuzzyContains=He;function we(N,Q=!1){return N?(Q&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}e.containsUppercaseCharacter=we;function Ke(N){return N.charAt(0).toUpperCase()+N.slice(1)}e.uppercaseFirstLetter=Ke;function V(N,Q=1){if(Q===0)return"";let oe=-1;do oe=N.indexOf(`
`,oe+1),Q--;while(Q>0&&oe>=0);return oe===-1?N:(N[oe-1]==="\r"&&oe--,N.substr(0,oe))}e.getNLines=V;function Z(N){const Q=90-65+1;return N=N%(2*Q),N<Q?String.fromCharCode(97+N):String.fromCharCode(65+N-Q)}e.singleLetterHash=Z;function ge(N){return xe.getInstance().getGraphemeBreakType(N)}e.getGraphemeBreakType=ge;function Ne(N,Q){return N===0?Q!==5&&Q!==7:N===2&&Q===3?!1:N===4||N===2||N===3||Q===4||Q===2||Q===3?!0:!(N===8&&(Q===8||Q===9||Q===11||Q===12)||(N===11||N===9)&&(Q===9||Q===10)||(N===12||N===10)&&Q===10||Q===5||Q===13||Q===7||N===1||N===13&&Q===14||N===6&&Q===6)}e.breakBetweenGraphemeBreakType=Ne;var Ve;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class xe{constructor(){this._data=Xe()}static getInstance(){return xe._INSTANCE||(xe._INSTANCE=new xe),xe._INSTANCE}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const oe=this._data,ke=oe.length/3;let Ie=1;for(;Ie<=ke;)if(Q<oe[3*Ie])Ie=2*Ie;else if(Q>oe[3*Ie+1])Ie=2*Ie+1;else return oe[3*Ie+2];return 0}}xe._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ye(N,Q){if(N===0)return 0;const oe=Ee(N,Q);if(oe!==void 0)return oe;const ke=j(Q,N);return N-=Ce(ke),N}e.getLeftDeleteOffset=ye;function Ee(N,Q){let oe=j(Q,N);for(N-=Ce(oe);ie(oe)||oe===65039||oe===8419;){if(N===0)return;oe=j(Q,N),N-=Ce(oe)}if(!!ee(oe)){if(N>=0){const ke=j(Q,N);ke===8205&&(N-=Ce(ke))}return N}}function Ce(N){return N>=65536?2:1}function ie(N){return 127995<=N&&N<=127999}var ae;(function(N){N[N.zwj=8205]="zwj",N[N.emojiVariantSelector=65039]="emojiVariantSelector",N[N.enclosingKeyCap=8419]="enclosingKeyCap"})(ae||(ae={}))}),define(ve[24],be([0,1,8,110]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let C,S;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return D?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return D&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,I){return!((I==null?void 0:I.dontUseNodeBuffer)||!1)&&D?new k(Buffer.from(b)):A?(C||(C=new TextEncoder),new k(C.encode(b))):new k(v.encodeUTF8(b))}static concat(b,I){if(typeof I=="undefined"){I=0;for(let R=0,B=b.length;R<B;R++)I+=b[R].byteLength}const h=k.alloc(I);let _=0;for(let R=0,B=b.length;R<B;R++){const z=b[R];h.set(z,_),_+=z.byteLength}return h}toString(){return D?this.buffer.toString():y?(S||(S=new TextDecoder),S.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(b,I){return new k(this.buffer.subarray(b,I))}set(b,I){b instanceof k?this.buffer.set(b.buffer,I):this.buffer.set(b,I)}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,I){g(this.buffer,b,I)}readUInt32LE(b){return r(this.buffer,b)}writeUInt32LE(b,I){a(this.buffer,b,I)}readUInt8(b){return p(this.buffer,b)}writeUInt8(b,I){f(this.buffer,b,I)}}e.VSBuffer=k;function i(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0}e.readUInt16LE=i;function P(w,b,I){w[I+0]=b&255,b=b>>>8,w[I+1]=b&255}e.writeUInt16LE=P;function d(w,b){return w[b]*2**24+w[b+1]*2**16+w[b+2]*2**8+w[b+3]}e.readUInt32BE=d;function g(w,b,I){w[I+3]=b,b=b>>>8,w[I+2]=b,b=b>>>8,w[I+1]=b,b=b>>>8,w[I]=b}e.writeUInt32BE=g;function r(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0|w[b+2]<<16>>>0|w[b+3]<<24>>>0}e.readUInt32LE=r;function a(w,b,I){w[I+0]=b&255,b=b>>>8,w[I+1]=b&255,b=b>>>8,w[I+2]=b&255,b=b>>>8,w[I+3]=b&255}e.writeUInt32LE=a;function p(w,b){return w[b]}e.readUInt8=p;function f(w,b,I){w[I]=b}e.writeUInt8=f;function E(w){return T.consumeReadable(w,b=>k.concat(b))}e.readableToBuffer=E;function o(w){return T.toReadable(w)}e.bufferToReadable=o;function c(w){return T.consumeStream(w,b=>k.concat(b))}e.streamToBuffer=c;async function m(w){return w.ended?k.concat(w.buffer):k.concat([...w.buffer,await c(w.stream)])}e.bufferedStreamToBuffer=m;function t(w){return T.toStream(w,b=>k.concat(b))}e.bufferToStream=t;function n(w){return T.transform(w,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=n;function l(w){return T.newWriteableStream(b=>k.concat(b),w)}e.newWriteableBufferStream=l;function s(w,b){return T.prefixedReadable(w,b,I=>k.concat(I))}e.prefixedBufferReadable=s;function u(w,b){return T.prefixedStream(w,b,I=>k.concat(I))}e.prefixedBufferStream=u}),define(ve[56],be([0,1,8]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(f){return D(f,0)}e.hash=T;function D(f,E){switch(typeof f){case"object":return f===null?A(349,E):Array.isArray(f)?S(f,E):k(f,E);case"string":return C(f,E);case"boolean":return y(f,E);case"number":return A(f,E);case"undefined":return A(937,E);default:return A(617,E)}}e.doHash=D;function A(f,E){return(E<<5)-E+f|0}function y(f,E){return A(f?433:863,E)}function C(f,E){E=A(149417,E);for(let o=0,c=f.length;o<c;o++)E=A(f.charCodeAt(o),E);return E}e.stringHash=C;function S(f,E){return E=A(104579,E),f.reduce((o,c)=>D(c,o),E)}function k(f,E){return E=A(181387,E),Object.keys(f).sort().reduce((o,c)=>(o=C(c,o),D(f[c],o)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=D(E,this._value),this._value}}e.Hasher=i;var P;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function d(f,E,o=32){const c=o-E,m=~((1<<c)-1);return(f<<E|(m&f)>>>c)>>>0}function g(f,E=0,o=f.byteLength,c=0){for(let m=0;m<o;m++)f[E+m]=c}function r(f,E,o="0"){for(;f.length<E;)f=o+f;return f}function a(f,E=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(o=>o.toString(16).padStart(2,"0")).join(""):r((f>>>0).toString(16),E/4)}e.toHexString=a;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const o=E.length;if(o!==0){const c=this._buff;let m=this._buffLen,t=this._leftoverHighSurrogate,n,l;for(t!==0?(n=t,l=-1,t=0):(n=E.charCodeAt(0),l=0);;){let s=n;if(v.isHighSurrogate(n))if(l+1<o){const u=E.charCodeAt(l+1);v.isLowSurrogate(u)?(l++,s=v.computeCodePoint(n,u)):s=65533}else{t=n;break}else v.isLowSurrogate(n)&&(s=65533);if(m=this._push(c,m,s),l++,l<o)n=E.charCodeAt(l);else break}this._buffLen=m,this._leftoverHighSurrogate=t}}_push(E,o,c){return c<128?E[o++]=c:c<2048?(E[o++]=192|(c&1984)>>>6,E[o++]=128|(c&63)>>>0):c<65536?(E[o++]=224|(c&61440)>>>12,E[o++]=128|(c&4032)>>>6,E[o++]=128|(c&63)>>>0):(E[o++]=240|(c&1835008)>>>18,E[o++]=128|(c&258048)>>>12,E[o++]=128|(c&4032)>>>6,E[o++]=128|(c&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,o=this._buffDV;for(let b=0;b<64;b+=4)E.setUint32(b,o.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)E.setUint32(b,d(E.getUint32(b-12,!1)^E.getUint32(b-32,!1)^E.getUint32(b-56,!1)^E.getUint32(b-64,!1),1),!1);let c=this._h0,m=this._h1,t=this._h2,n=this._h3,l=this._h4,s,u,w;for(let b=0;b<80;b++)b<20?(s=m&t|~m&n,u=1518500249):b<40?(s=m^t^n,u=1859775393):b<60?(s=m&t|m&n|t&n,u=2400959708):(s=m^t^n,u=3395469782),w=d(c,5)+s+l+u+E.getUint32(b*4,!1)&4294967295,l=n,n=t,t=d(m,30),m=c,c=w;this._h0=this._h0+c&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+l&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[47],be([0,1,8]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(T||(T={})),function(D){const A="error",y="warning",C="warn",S="info",k="ignore";function i(d){return d?v.equalsIgnoreCase(A,d)?D.Error:v.equalsIgnoreCase(y,d)||v.equalsIgnoreCase(C,d)?D.Warning:v.equalsIgnoreCase(S,d)?D.Info:D.Ignore:D.Ignore}D.fromValue=i;function P(d){switch(d){case D.Error:return A;case D.Warning:return y;case D.Info:return S;default:return k}}D.toString=P}(T||(T={})),e.default=T}),define(ve[10],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(b){return Array.isArray(b)}e.isArray=v;function T(b){return typeof b=="string"}e.isString=T;function D(b){return Array.isArray(b)&&b.every(I=>T(I))}e.isStringArray=D;function A(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=A;function y(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=y;function C(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=C;function S(b){return b===!0||b===!1}e.isBoolean=S;function k(b){return typeof b=="undefined"}e.isUndefined=k;function i(b){return!P(b)}e.isDefined=i;function P(b){return k(b)||b===null}e.isUndefinedOrNull=P;function d(b,I){if(!b)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}e.assertType=d;function g(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=g;function r(...b){const I=[];for(let h=0;h<b.length;h++){const _=b[h];if(P(_))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);I.push(_)}return I}e.assertAllDefined=r;const a=Object.prototype.hasOwnProperty;function p(b){if(!A(b))return!1;for(let I in b)if(a.call(b,I))return!1;return!0}e.isEmptyObject=p;function f(b){return typeof b=="function"}e.isFunction=f;function E(...b){return b.length>0&&b.every(f)}e.areFunctions=E;function o(b,I){const h=Math.min(b.length,I.length);for(let _=0;_<h;_++)c(b[_],I[_])}e.validateConstraints=o;function c(b,I){if(T(I)){if(typeof b!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(f(I)){try{if(b instanceof I)return}catch(h){}if(!P(b)&&b.constructor===I||I.length===1&&I.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function m(b){let I=[],h=Object.getPrototypeOf(b);for(;Object.prototype!==h;)I=I.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return I}e.getAllPropertyNames=m;function t(b){const I=[];for(const h of m(b))typeof b[h]=="function"&&I.push(h);return I}e.getAllMethodNames=t;function n(b,I){const h=R=>function(){const B=Array.prototype.slice.call(arguments,0);return I(R,B)};let _={};for(const R of b)_[R]=h(R);return _}e.createProxyObject=n;function l(b){return b===null?void 0:b}e.withNullAsUndefined=l;function s(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=s;function u(b){return class{constructor(){return new Proxy({},{get(I,h){if(I[h])return I[h];throw new Error(`Not Implemented: ${b}->${String(h)}`)}})}}}e.NotImplementedProxy=u;function w(b){throw new Error("Unreachable")}e.assertNever=w}),define(ve[37],be([0,1,21,8,14,10]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function C(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=C;function S(n,l=D.posix.sep){if(!n)return"";const s=n.length,u=n.charCodeAt(0);if(y(u)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let b=3;const I=b;for(;b<s&&!y(n.charCodeAt(b));b++);if(I!==b&&!y(n.charCodeAt(b+1))){for(b+=1;b<s;b++)if(y(n.charCodeAt(b)))return n.slice(0,b+1).replace(/[\\/]/g,l)}}return l}else if(p(u)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+l:n.slice(0,2);let w=n.indexOf("://");if(w!==-1){for(w+=3;w<s;w++)if(y(n.charCodeAt(w)))return n.slice(0,w+1)}return""}e.getRoot=S;function k(n){if(!v.isWindows||!n||n.length<5)return!1;let l=n.charCodeAt(0);if(l!==92||(l=n.charCodeAt(1),l!==92))return!1;let s=2;const u=s;for(;s<n.length&&(l=n.charCodeAt(s),l!==92);s++);return!(u===s||(l=n.charCodeAt(s+1),isNaN(l)||l===92))}e.isUNC=k;const i=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(n,l=v.isWindows){const s=l?i:P;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||l&&d.test(n)||n==="."||n===".."||l&&n[n.length-1]==="."||l&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=g;function r(n,l,s){const u=n===l;return!s||u?u:!n||!l?!1:(0,T.equalsIgnoreCase)(n,l)}e.isEqual=r;function a(n,l,s,u=D.sep){if(n===l)return!0;if(!n||!l||l.length>n.length)return!1;if(s){if(!(0,T.startsWithIgnoreCase)(n,l))return!1;if(l.length===n.length)return!0;let b=l.length;return l.charAt(l.length-1)===u&&b--,n.charAt(b)===u}return l.charAt(l.length-1)!==u&&(l+=u),n.indexOf(l)===0}e.isEqualOrParent=a;function p(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=p;function f(n,l){return v.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(l,n)),n=(0,D.normalize)(n),v.isWindows?(n=(0,T.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,T.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=f;function E(n){const l=(0,D.normalize)(n);return v.isWindows?n.length>3?!1:o(l)&&(n.length===2||l.charCodeAt(2)===92):l===D.posix.sep}e.isRootOrDriveLetter=E;function o(n){return v.isWindows?p(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function c(n){return o(n)?n[0]:void 0}e.getDriveLetter=c;function m(n,l,s){return l.length>n.length?-1:n===l?0:(s&&(n=n.toLowerCase(),l=l.toLowerCase()),n.indexOf(l))}e.indexOfPath=m;function t(n){const l=n.split(":");let s,u,w;if(l.forEach(b=>{const I=Number(b);(0,A.isNumber)(I)?u===void 0?u=I:w===void 0&&(w=I):s=s?[s,b].join(":"):b}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:w!==void 0?w:u!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ve[23],be([0,1,10]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const p=Array.isArray(a)?[]:{};return Object.keys(a).forEach(f=>{a[f]&&typeof a[f]=="object"?p[f]=T(a[f]):p[f]=a[f]}),p}e.deepClone=T;function D(a){if(!a||typeof a!="object")return a;const p=[a];for(;p.length>0;){const f=p.shift();Object.freeze(f);for(const E in f)if(A.call(f,E)){const o=f[E];typeof o=="object"&&!Object.isFrozen(o)&&p.push(o)}}return a}e.deepFreeze=D;const A=Object.prototype.hasOwnProperty;function y(a,p){return C(a,p,new Set)}e.cloneAndChange=y;function C(a,p,f){if((0,v.isUndefinedOrNull)(a))return a;const E=p(a);if(typeof E!="undefined")return E;if((0,v.isArray)(a)){const o=[];for(const c of a)o.push(C(c,p,f));return o}if((0,v.isObject)(a)){if(f.has(a))throw new Error("Cannot clone recursive data-structure");f.add(a);const o={};for(let c in a)A.call(a,c)&&(o[c]=C(a[c],p,f));return f.delete(a),o}return a}function S(a,p,f=!0){return(0,v.isObject)(a)?((0,v.isObject)(p)&&Object.keys(p).forEach(E=>{E in a?f&&((0,v.isObject)(a[E])&&(0,v.isObject)(p[E])?S(a[E],p[E],f):a[E]=p[E]):a[E]=p[E]}),a):p}e.mixin=S;function k(a,p){if(a===p)return!0;if(a==null||p===null||p===void 0||typeof a!=typeof p||typeof a!="object"||Array.isArray(a)!==Array.isArray(p))return!1;let f,E;if(Array.isArray(a)){if(a.length!==p.length)return!1;for(f=0;f<a.length;f++)if(!k(a[f],p[f]))return!1}else{const o=[];for(E in a)o.push(E);o.sort();const c=[];for(E in p)c.push(E);if(c.sort(),!k(o,c))return!1;for(f=0;f<o.length;f++)if(!k(a[o[f]],p[o[f]]))return!1}return!0}e.equals=k;function i(a){const p=new Set;return JSON.stringify(a,(f,E)=>{if((0,v.isObject)(E)||Array.isArray(E)){if(p.has(E))return"[Circular]";p.add(E)}return E})}e.safeStringify=i;function P(a,p,f){const E=p(a);return typeof E=="undefined"?f:E}e.getOrDefault=P;function d(a,p){const f=Object.create(null);return!a||!p||Object.keys(p).forEach(o=>{const c=a[o],m=p[o];k(c,m)||(f[o]=m)}),f}e.distinct=d;function g(a,p){const f=p.toLowerCase(),E=Object.keys(a).find(o=>o.toLowerCase()===f);return E?a[E]:a[p]}e.getCaseInsensitive=g;function r(a,p){const f=Object.create(null);for(const E of Object.keys(a))p(E,a[E])&&(f[E]=a[E]);return f}e.filter=r}),define(ve[83],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function T(A){return A<0?0:A>255?255:A|0}e.toUint8=T;function D(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=D}),define(ve[2],be([0,1,21,14]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function C(l,s){if(!l.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!D.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!A.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(l,s){return!l&&!s?"file":l}function k(l,s){switch(l){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const i="",P="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(s,u,w,b,I,h=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=S(s,h),this.authority=u||i,this.path=k(this.scheme,w||i),this.query=b||i,this.fragment=I||i,C(this,h))}static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return o(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:w,path:b,query:I,fragment:h}=s;return u===void 0?u=this.scheme:u===null&&(u=i),w===void 0?w=this.authority:w===null&&(w=i),b===void 0?b=this.path:b===null&&(b=i),I===void 0?I=this.query:I===null&&(I=i),h===void 0?h=this.fragment:h===null&&(h=i),u===this.scheme&&w===this.authority&&b===this.path&&I===this.query&&h===this.fragment?this:new a(u,w,b,I,h)}static parse(s,u=!1){const w=d.exec(s);return w?new a(w[2]||i,n(w[4]||i),n(w[5]||i),n(w[7]||i),n(w[9]||i),u):new a(i,i,i,i,i)}static file(s){let u=i;if(v.isWindows&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const w=s.indexOf(P,2);w===-1?(u=s.substring(2),s=P):(u=s.substring(2,w),s=s.substring(w)||P)}return new a("file",u,s,i,i)}static from(s){return new a(s.scheme,s.authority,s.path,s.query,s.fragment)}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return v.isWindows&&s.scheme==="file"?w=g.file(T.win32.join(o(s,!0),...u)).path:w=T.posix.join(s.path,...u),s.with({path:w})}toString(s=!1){return c(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const u=new a(s);return u._formatted=s.external,u._fsPath=s._sep===r?s.fsPath:null,u}}else return s}}e.URI=g;const r=v.isWindows?1:void 0;class a extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(s=!1){return s?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=r),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(l,s){let u,w=-1;for(let b=0;b<l.length;b++){const I=l.charCodeAt(b);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||s&&I===47)w!==-1&&(u+=encodeURIComponent(l.substring(w,b)),w=-1),u!==void 0&&(u+=l.charAt(b));else{u===void 0&&(u=l.substr(0,b));const h=p[I];h!==void 0?(w!==-1&&(u+=encodeURIComponent(l.substring(w,b)),w=-1),u+=h):w===-1&&(w=b)}}return w!==-1&&(u+=encodeURIComponent(l.substring(w))),u!==void 0?u:l}function E(l){let s;for(let u=0;u<l.length;u++){const w=l.charCodeAt(u);w===35||w===63?(s===void 0&&(s=l.substr(0,u)),s+=p[w]):s!==void 0&&(s+=l[u])}return s!==void 0?s:l}function o(l,s){let u;return l.authority&&l.path.length>1&&l.scheme==="file"?u=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?s?u=l.path.substr(1):u=l.path[1].toLowerCase()+l.path.substr(2):u=l.path,v.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=o;function c(l,s){const u=s?E:f;let w="",{scheme:b,authority:I,path:h,query:_,fragment:R}=l;if(b&&(w+=b,w+=":"),(I||b==="file")&&(w+=P,w+=P),I){let B=I.indexOf("@");if(B!==-1){const z=I.substr(0,B);I=I.substr(B+1),B=z.indexOf(":"),B===-1?w+=u(z,!1):(w+=u(z.substr(0,B),!1),w+=":",w+=u(z.substr(B+1),!1)),w+="@"}I=I.toLowerCase(),B=I.indexOf(":"),B===-1?w+=u(I,!1):(w+=u(I.substr(0,B),!1),w+=I.substr(B))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const B=h.charCodeAt(1);B>=65&&B<=90&&(h=`/${String.fromCharCode(B+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const B=h.charCodeAt(0);B>=65&&B<=90&&(h=`${String.fromCharCode(B+32)}:${h.substr(2)}`)}w+=u(h,!0)}return _&&(w+="?",w+=u(_,!1)),R&&(w+="#",w+=s?R:f(R,!1)),w}function m(l){try{return decodeURIComponent(l)}catch(s){return l.length>3?l.substr(0,3)+m(l.substr(3)):l}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(l){return l.match(t)?l.replace(t,s=>m(s)):l}});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[22],be([0,1,2,8]),function(Y,e,v,T){"use strict";var D,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,n,l){let s=t.get(n);return s===void 0&&(s=l,t.set(n,s)),s}e.getOrSet=C;function S(t){const n=[];return t.forEach((l,s)=>{n.push(`${s} => ${l}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=S;function k(t){const n=[];return t.forEach(l=>{n.push(l)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const l=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return l-s}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class d{constructor(n=!0,l=!0){this._splitOnBackslash=n,this._caseSensitive=l}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class r{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,T.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(n){this._iter=n}static forUris(n=()=>!1){return new p(new r(n))}static forPaths(){return new p(new d)}static forStrings(){return new p(new i)}static forConfigKeys(){return new p(new P)}clear(){this._root=void 0}set(n,l){const s=this._iter.reset(n);let u;for(this._root||(this._root=new a,this._root.segment=s.value()),u=this._root;;){const b=s.cmp(u.segment);if(b>0)u.left||(u.left=new a,u.left.segment=s.value()),u=u.left;else if(b<0)u.right||(u.right=new a,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new a,u.mid.segment=s.value()),u=u.mid;else break}const w=u.value;return u.value=l,u.key=n,w}get(n){var l;return(l=this._getNode(n))===null||l===void 0?void 0:l.value}_getNode(n){const l=this._iter.reset(n);let s=this._root;for(;s;){const u=l.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(l.hasNext())l.next(),s=s.mid;else break}return s}has(n){const l=this._getNode(n);return!((l==null?void 0:l.value)===void 0&&(l==null?void 0:l.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,l){const s=this._iter.reset(n),u=[];let w=this._root;for(;w;){const b=s.cmp(w.segment);if(b>0)u.push([1,w]),w=w.left;else if(b<0)u.push([-1,w]),w=w.right;else if(s.hasNext())s.next(),u.push([0,w]),w=w.mid;else{for(l?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;u.length>0&&w.isEmpty();){let[I,h]=u.pop();switch(I){case 1:h.left=void 0;break;case 0:h.mid=void 0;break;case-1:h.right=void 0;break}w=h}break}}}findSubstr(n){const l=this._iter.reset(n);let s=this._root,u;for(;s;){const w=l.cmp(s.segment);if(w>0)s=s.left;else if(w<0)s=s.right;else if(l.hasNext())l.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(n){const l=this._iter.reset(n);let s=this._root;for(;s;){const u=l.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(l.hasNext())l.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[l,s]of this)n(s,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=p;class f{constructor(n,l){this[D]="ResourceMap",n instanceof f?(this.map=new Map(n.map),this.toKey=l!=null?l:f.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:f.defaultToKey)}set(n,l){return this.map.set(this.toKey(n),l),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,l){typeof l!="undefined"&&(n=n.bind(l));for(let[s,u]of this.map)n(u,v.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield v.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[v.URI.parse(n[0]),n[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[v.URI.parse(n[0]),n[1]]}}e.ResourceMap=f,f.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class o{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,l=0){const s=this._map.get(n);if(!!s)return l!==0&&this.touch(s,l),s.value}set(n,l,s=0){let u=this._map.get(n);if(u)u.value=l,s!==0&&this.touch(u,s);else{switch(u={key:n,value:l,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const l=this._map.get(n);if(!!l)return this._map.delete(n),this.removeItem(l),this._size--,l.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,l){const s=this._state;let u=this._head;for(;u;){if(l?n.bind(l)(u.value,u.key,this):n(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,l=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==l)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:s.key,done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return u}values(){const n=this,l=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==l)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:s.value,done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return u}entries(){const n=this,l=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==l)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:[s.key,s.value],done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return u}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let l=this._head,s=this.size;for(;l&&s>n;)this._map.delete(l.key),l=l.next,s--;this._head=l,this._size=s,l&&(l.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const l=n.next,s=n.previous;if(!l||!s)throw new Error("Invalid list");l.previous=s,s.next=l}n.next=void 0,n.previous=void 0,this._state++}touch(n,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(n===this._head)return;const s=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(l===2){if(n===this._tail)return;const s=n.next,u=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((l,s)=>{n.push([s,l])}),n}fromJSON(n){this.clear();for(const[l,s]of n)this.set(l,s)}}e.LinkedMap=o;class c extends o{constructor(n,l=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,l=2){return super.get(n,l)}peek(n){return super.get(n,0)}set(n,l){return super.set(n,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class m{constructor(n){y.set(this,void 0),it(this,y,n,"f")}get size(){return Ue(this,y,"f").size}forEach(n,l){Ue(this,y,"f").forEach(n,l)}get(n){return Ue(this,y,"f").get(n)}has(n){return Ue(this,y,"f").has(n)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=m}),define(ve[111],be([0,1,22,8]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...fe){return function(De,Re){for(let He=0,we=fe.length;He<we;He++){const Ke=fe[He](De,Re);if(Ke)return Ke}return null}}e.or=D,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(fe,De,Re){if(!Re||Re.length<De.length)return null;let He;return fe?He=T.startsWithIgnoreCase(Re,De):He=Re.indexOf(De)===0,He?De.length>0?[{start:0,end:De.length}]:[]:null}function y(fe,De){const Re=De.toLowerCase().indexOf(fe.toLowerCase());return Re===-1?null:[{start:Re,end:Re+fe.length}]}e.matchesContiguousSubString=y;function C(fe,De){return S(fe.toLowerCase(),De.toLowerCase(),0,0)}e.matchesSubString=C;function S(fe,De,Re,He){if(Re===fe.length)return[];if(He===De.length)return null;if(fe[Re]===De[He]){let we=null;return(we=S(fe,De,Re+1,He+1))?f({start:He,end:He+1},we):null}return S(fe,De,Re,He+1)}function k(fe){return 97<=fe&&fe<=122}function i(fe){return 65<=fe&&fe<=90}e.isUpper=i;function P(fe){return 48<=fe&&fe<=57}function d(fe){return fe===32||fe===9||fe===10||fe===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(fe=>g.add(fe.charCodeAt(0)));function r(fe){return d(fe)||g.has(fe)}function a(fe,De){return fe===De||r(fe)&&r(De)}function p(fe){return k(fe)||i(fe)||P(fe)}function f(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function E(fe,De){for(let Re=De;Re<fe.length;Re++){const He=fe.charCodeAt(Re);if(i(He)||P(He)||Re>0&&!p(fe.charCodeAt(Re-1)))return Re}return fe.length}function o(fe,De,Re,He){if(Re===fe.length)return[];if(He===De.length)return null;if(fe[Re]!==De[He].toLowerCase())return null;{let we=null,Ke=He+1;for(we=o(fe,De,Re+1,He+1);!we&&(Ke=E(De,Ke))<De.length;)we=o(fe,De,Re+1,Ke),Ke++;return we===null?null:f({start:He,end:He+1},we)}}function c(fe){let De=0,Re=0,He=0,we=0,Ke=0;for(let Ve=0;Ve<fe.length;Ve++)Ke=fe.charCodeAt(Ve),i(Ke)&&De++,k(Ke)&&Re++,p(Ke)&&He++,P(Ke)&&we++;const V=De/fe.length,Z=Re/fe.length,ge=He/fe.length,Ne=we/fe.length;return{upperPercent:V,lowerPercent:Z,alphaPercent:ge,numericPercent:Ne}}function m(fe){const{upperPercent:De,lowerPercent:Re}=fe;return Re===0&&De>.6}function t(fe){const{upperPercent:De,lowerPercent:Re,alphaPercent:He,numericPercent:we}=fe;return Re>.2&&De<.8&&He>.6&&we<.2}function n(fe){let De=0,Re=0,He=0,we=0;for(let Ke=0;Ke<fe.length;Ke++)He=fe.charCodeAt(Ke),i(He)&&De++,k(He)&&Re++,d(He)&&we++;return(De===0||Re===0)&&we===0?fe.length<=30:De<=5}function l(fe,De){if(!De||(De=De.trim(),De.length===0)||!n(fe)||De.length>60)return null;const Re=c(De);if(!t(Re)){if(!m(Re))return null;De=De.toLowerCase()}let He=null,we=0;for(fe=fe.toLowerCase();we<De.length&&(He=o(fe,De,0,we))===null;)we=E(De,we+1);return He}e.matchesCamelCase=l;function s(fe,De,Re=!1){if(!De||De.length===0)return null;let He=null,we=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();we<De.length&&(He=u(fe,De,0,we,Re))===null;)we=w(De,we+1);return He}e.matchesWords=s;function u(fe,De,Re,He,we){if(Re===fe.length)return[];if(He===De.length)return null;if(a(fe.charCodeAt(Re),De.charCodeAt(He))){let Ke=null,V=He+1;if(Ke=u(fe,De,Re+1,He+1,we),!we)for(;!Ke&&(V=w(De,V))<De.length;)Ke=u(fe,De,Re+1,V,we),V++;return Ke===null?null:f({start:He,end:He+1},Ke)}else return null}function w(fe,De){for(let Re=De;Re<fe.length;Re++)if(r(fe.charCodeAt(Re))||Re>0&&r(fe.charCodeAt(Re-1)))return Re;return fe.length}const b=D(e.matchesPrefix,l,y),I=D(e.matchesPrefix,l,C),h=new v.LRUCache(1e4);function _(fe,De,Re=!1){if(typeof fe!="string"||typeof De!="string")return null;let He=h.get(fe);He||(He=new RegExp(T.convertSimple2RegExpPattern(fe),"i"),h.set(fe,He));const we=He.exec(De);return we?[{start:we.index,end:we.index+we[0].length}]:Re?I(fe,De):b(fe,De)}e.matchesFuzzy=_;function R(fe,De){const Re=H(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,!0);return Re?z(Re):null}e.matchesFuzzy2=R;function B(fe,De,Re,He,we,Ke){const V=Math.min(13,fe.length);for(;Re<V;Re++){const Z=H(fe,De,Re,He,we,Ke,!1);if(Z)return Z}return[0,Ke]}e.anyScore=B;function z(fe){if(typeof fe=="undefined")return[];const De=[],Re=fe[1];for(let He=fe.length-1;He>1;He--){const we=fe[He]+Re,Ke=De[De.length-1];Ke&&Ke.end===we?Ke.end=we+1:De.push({start:we,end:we+1})}return De}e.createMatches=z;const he=128;function de(){const fe=[],De=[];for(let Re=0;Re<=he;Re++)De[Re]=0;for(let Re=0;Re<=he;Re++)fe.push(De.slice(0));return fe}function W(fe){const De=[];for(let Re=0;Re<=fe;Re++)De[Re]=0;return De}const j=W(2*he),U=W(2*he),F=de(),L=de(),M=de(),x=!1;function G(fe,De,Re,He,we){function Ke(Z,ge,Ne=" "){for(;Z.length<ge;)Z=Ne+Z;return Z}let V=` |   |${He.split("").map(Z=>Ke(Z,3)).join("|")}
`;for(let Z=0;Z<=Re;Z++)Z===0?V+=" |":V+=`${De[Z-1]}|`,V+=fe[Z].slice(0,we+1).map(ge=>Ke(ge.toString(),3)).join("|")+`
`;return V}function J(fe,De,Re,He){fe=fe.substr(De),Re=Re.substr(He),console.log(G(L,fe,fe.length,Re,Re.length)),console.log(G(M,fe,fe.length,Re,Re.length)),console.log(G(F,fe,fe.length,Re,Re.length))}function te(fe,De){if(De<0||De>=fe.length)return!1;const Re=fe.codePointAt(De);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(Re)}}function me(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function Le(fe,De,Re){return De[fe]!==Re[fe]}function We(fe,De,Re,He,we,Ke,V=!1){for(;De<Re&&we<Ke;)fe[De]===He[we]&&(V&&(j[De]=we),De+=1),we+=1;return De===Re}e.isPatternInWord=We;var Fe;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var ze;(function(fe){fe.Default=[-100,0];function De(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}fe.isDefault=De})(ze=e.FuzzyScore||(e.FuzzyScore={}));function H(fe,De,Re,He,we,Ke,V){const Z=fe.length>he?he:fe.length,ge=He.length>he?he:He.length;if(!(Re>=Z||Ke>=ge||Z-Re>ge-Ke)&&!!We(De,Re,Z,we,Ke,ge,!0)){q(Z,ge,Re,Ke,De,we);let Ne=1,Ve=1,xe=Re,Xe=Ke;const ye=[!1];for(Ne=1,xe=Re;xe<Z;Ne++,xe++){const N=j[xe],Q=U[xe],oe=xe+1<Z?U[xe+1]:ge;for(Ve=N-Ke+1,Xe=N;Xe<oe;Ve++,Xe++){let ke=Number.MIN_SAFE_INTEGER,Ie=!1;Xe<=Q&&(ke=ee(fe,De,xe,Re,He,we,Xe,ge,Ke,F[Ne-1][Ve-1]===0,ye));let Ae=0;ke!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ae=ke+L[Ne-1][Ve-1]);const Be=Xe>N,Ye=Be?L[Ne][Ve-1]+(F[Ne][Ve-1]>0?-5:0):0,rt=Xe>N+1&&F[Ne][Ve-1]>0,tt=rt?L[Ne][Ve-2]+(F[Ne][Ve-2]>0?-5:0):0;if(rt&&(!Be||tt>=Ye)&&(!Ie||tt>=Ae))L[Ne][Ve]=tt,M[Ne][Ve]=3,F[Ne][Ve]=0;else if(Be&&(!Ie||Ye>=Ae))L[Ne][Ve]=Ye,M[Ne][Ve]=2,F[Ne][Ve]=0;else if(Ie)L[Ne][Ve]=Ae,M[Ne][Ve]=1,F[Ne][Ve]=F[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if(x&&J(fe,Re,He,Ke),!(!ye[0]&&!V)){Ne--,Ve--;const Ee=[L[Ne][Ve],Ke];let Ce=0,ie=0;for(;Ne>=1;){let N=Ve;do{const Q=M[Ne][N];if(Q===3)N=N-2;else if(Q===2)N=N-1;else break}while(N>=1);Ce>1&&De[Re+Ne-1]===we[Ke+Ve-1]&&!Le(N+Ke-1,He,we)&&Ce+1>F[Ne][N]&&(N=Ve),N===Ve?Ce++:Ce=1,ie||(ie=N),Ne--,Ve=N-1,Ee.push(Ve)}ge===Z&&(Ee[0]+=2);const ae=ie-Z;return Ee[0]-=ae,Ee}}}e.fuzzyScore=H;function q(fe,De,Re,He,we,Ke){let V=fe-1,Z=De-1;for(;V>=Re&&Z>=He;)we[V]===Ke[Z]&&(U[V]=Z,V--),Z--}function ee(fe,De,Re,He,we,Ke,V,Z,ge,Ne,Ve){if(De[Re]!==Ke[V])return Number.MIN_SAFE_INTEGER;let xe=1,Xe=!1;return V===Re-He?xe=fe[Re]===we[V]?7:5:Le(V,we,Ke)&&(V===0||!Le(V-1,we,Ke))?(xe=fe[Re]===we[V]?7:5,Xe=!0):te(Ke,V)&&(V===0||!te(Ke,V-1))?xe=5:(te(Ke,V-1)||me(Ke,V-1))&&(xe=5,Xe=!0),xe>1&&Re===He&&(Ve[0]=!0),Xe||(Xe=Le(V,we,Ke)||te(Ke,V-1)||me(Ke,V-1)),Re===He?V>ge&&(xe-=Xe?3:5):Ne?xe+=Xe?2:0:xe+=Xe?0:1,V+1===Z&&(xe-=Xe?3:5),xe}function se(fe,De,Re,He,we,Ke,V){return _e(fe,De,Re,He,we,Ke,!0,V)}e.fuzzyScoreGracefulAggressive=se;function ce(fe,De,Re,He,we,Ke,V){return _e(fe,De,Re,He,we,Ke,!1,V)}e.fuzzyScoreGraceful=ce;function _e(fe,De,Re,He,we,Ke,V,Z){let ge=H(fe,De,Re,He,we,Ke,Z);if(ge&&!V)return ge;if(fe.length>=3){const Ne=Math.min(7,fe.length-1);for(let Ve=Re+1;Ve<Ne;Ve++){const xe=$e(fe,Ve);if(xe){const Xe=H(xe,xe.toLowerCase(),Re,He,we,Ke,Z);Xe&&(Xe[0]-=3,(!ge||Xe[0]>ge[0])&&(ge=Xe))}}}return ge}function $e(fe,De){if(!(De+1>=fe.length)){const Re=fe[De],He=fe[De+1];if(Re!==He)return fe.slice(0,De)+He+Re+fe.slice(De+2)}}}),define(ve[112],be([0,1,36,111,8]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function C(a){return a.replace(y,(p,f)=>f?p:`\\${p}`)}e.escapeIcons=C;const S=new RegExp(`\\\\${A.source}`,"g");function k(a){return a.replace(S,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function P(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(i,(p,f,E,o)=>E?p:f||o||"")}e.stripIcons=P;function d(a){const p=a.indexOf(e.iconStartMarker);return p===-1?{text:a}:g(a,p)}e.parseLabelWithIcons=d;function g(a,p){const f=[];let E="";function o(w){if(w){E+=w;for(const b of w)f.push(t)}}let c=-1,m="",t=0,n,l,s=p;const u=a.length;for(o(a.substr(0,p));s<u;)n=a[s],l=a[s+1],n===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(c=s,o(m),m=e.iconStartMarker,s++):n===")"&&c!==-1?(t+=s-c+1,c=-1,m=""):c!==-1?/^[a-z0-9\-]$/i.test(n)?m+=n:(o(m),c=-1,m=""):o(n),s++;return o(m),{text:E,iconOffsets:f}}function r(a,p,f=!1){const{text:E,iconOffsets:o}=p;if(!o||o.length===0)return(0,T.matchesFuzzy)(a,E,f);const c=(0,D.ltrim)(E," "),m=E.length-c.length,t=(0,T.matchesFuzzy)(a,c,f);if(t)for(const n of t){const l=o[n.start+m]+m;n.start+=l,n.end+=l}return t}e.matchesFuzzyIconAware=r}),define(ve[84],be([0,1,13,112,12]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(a="",p=!1){var f,E;if(this.value=a,typeof this.value!="string")throw(0,D.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(f=p.isTrusted)!==null&&f!==void 0?f:void 0,this.supportThemeIcons=(E=p.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(a,p=0){return this.value+=P(this.supportThemeIcons?(0,T.escapeIcons)(a):a).replace(/([ \t]+)/g,(f,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,p){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=y;function C(r){return S(r)?!r.value:Array.isArray(r)?r.every(C):!0}e.isEmptyMarkdownString=C;function S(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function k(r,a){return!r&&!a?!0:!r||!a?!1:Array.isArray(r)&&Array.isArray(a)?(0,v.equals)(r,a,i):S(r)&&S(a)?i(r,a):!1}e.markedStringsEquals=k;function i(r,a){return r===a?!0:!r||!a?!1:r.value===a.value&&r.isTrusted===a.isTrusted&&r.supportThemeIcons===a.supportThemeIcons}function P(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function d(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function g(r){const a=[],p=r.split("|").map(E=>E.trim());r=p[0];const f=p[1];if(f){const E=/height=(\d+)/.exec(f),o=/width=(\d+)/.exec(f),c=E?E[1]:"",m=o?o[1]:"",t=isFinite(parseInt(m)),n=isFinite(parseInt(c));t&&a.push(`width="${m}"`),n&&a.push(`height="${c}"`)}return{href:r,dimensions:a}}e.parseHrefAndDimensions=g}),define(ve[57],be([0,1,24,8,2]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(k){return JSON.stringify(k,C)}e.stringify=A;function y(k){let i=JSON.parse(k);return i=S(i),i}e.parse=y;function C(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,T.regExpFlags)(i)}:i}function S(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return D.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof v.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=S(k[P],i+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=S(k[P],i+1))}return k}e.revive=S}),define(ve[19],be([0,1,2,21]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,k,i){this._hosts[S]=k,this._ports[S]=i}setConnectionToken(S,k){this._connectionTokens[S]=k}rewrite(S){if(this._delegate)return this._delegate(S);const k=S.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[k],d=this._connectionTokens[k];let g=`path=${encodeURIComponent(S.path)}`;return typeof d=="string"&&(g+=`&tkn=${encodeURIComponent(d)}`),v.URI.from({scheme:T.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,k,i){const P=this.toUri(S,k);return P.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(P):T.isNative&&(i||T.isPreferringBrowserCodeLoad)&&P.scheme===D.file?P.with({scheme:D.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(S,k){const i=this.toUri(S,k);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,k){return v.URI.isUri(S)?S:v.URI.parse(k.toUrl(S))}}e.FileAccess=new y}),define(ve[25],be([0,1,37,14,2,8,19,21]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(g){return(0,D.uriToFsPath)(g,!0)}e.originalFSPath=S;class k{constructor(r){this._ignorePathCasing=r}compare(r,a,p=!1){return r===a?0:(0,A.compare)(this.getComparisonKey(r,p),this.getComparisonKey(a,p))}isEqual(r,a,p=!1){return r===a?!0:!r||!a?!1:this.getComparisonKey(r,p)===this.getComparisonKey(a,p)}getComparisonKey(r,a=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,a,p=!1){if(r.scheme===a.scheme){if(r.scheme===y.Schemas.file)return v.isEqualOrParent(S(r),S(a),this._ignorePathCasing(r))&&r.query===a.query&&(p||r.fragment===a.fragment);if((0,e.isEqualAuthority)(r.authority,a.authority))return v.isEqualOrParent(r.path,a.path,this._ignorePathCasing(r),"/")&&r.query===a.query&&(p||r.fragment===a.fragment)}return!1}joinPath(r,...a){return D.URI.joinPath(r,...a)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return T.posix.basename(r.path)}extname(r){return T.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let a;return r.scheme===y.Schemas.file?a=D.URI.file(T.dirname(S(r))).path:(a=T.posix.dirname(r.path),r.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),a="/")),r.with({path:a})}normalizePath(r){if(!r.path.length)return r;let a;return r.scheme===y.Schemas.file?a=D.URI.file(T.normalize(S(r))).path:a=T.posix.normalize(r.path),r.with({path:a})}relativePath(r,a){if(!(r.scheme!==a.scheme||!(0,e.isEqualAuthority)(r.authority,a.authority))){if(r.scheme===y.Schemas.file){const E=T.relative(S(r),S(a));return C.isWindows?v.toSlashes(E):E}let p=r.path||"/",f=a.path||"/";if(this._ignorePathCasing(r)){let E=0;for(const o=Math.min(p.length,f.length);E<o&&!(p.charCodeAt(E)!==f.charCodeAt(E)&&p.charAt(E).toLowerCase()!==f.charAt(E).toLowerCase());E++);p=f.substr(0,E)+p.substr(E)}return T.posix.relative(p,f)}}resolvePath(r,a){if(r.scheme===y.Schemas.file){const p=D.URI.file(T.resolve(S(r),a));return r.with({authority:p.authority,path:p.path})}return a.indexOf("/")===-1&&(a=v.toSlashes(a),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a)),r.with({path:T.posix.resolve(r.path,a)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,a){return r===a||(0,A.equalsIgnoreCase)(r,a)}hasTrailingPathSeparator(r,a=T.sep){if(r.scheme===y.Schemas.file){const p=S(r);return p.length>v.getRoot(p).length&&p[p.length-1]===a}else{const p=r.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,a=T.sep){return(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,a=T.sep){let p=!1;if(r.scheme===y.Schemas.file){const f=S(r);p=f!==void 0&&f.length===v.getRoot(f).length&&f[f.length-1]===a}else{a="/";const f=r.path;p=f.length===1&&f.charCodeAt(f.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path+"/"}):r}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(g=>g.scheme===y.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new k(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(g,r){const a=[];for(let p=0;p<g.length;p++){const f=r(g[p]);g.some((E,o)=>o===p?!1:(0,e.isEqualOrParent)(f,r(E)))||a.push(g[p])}return a}e.distinctParents=i;var P;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function r(a){const p=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,m]=o.split(":");c&&m&&p.set(c,m)});const E=a.path.substring(0,a.path.indexOf(";"));return E&&p.set(g.META_DATA_MIME,E),p}g.parseMetaData=r})(P=e.DataUri||(e.DataUri={}));function d(g,r,a){if(r){let p=g.path;return p&&p[0]!==T.posix.sep&&(p=T.posix.sep+p),g.with({scheme:a,authority:r,path:p})}return g.with({scheme:a})}e.toLocalResource=d}),define(ve[11],be([0,1,20,12,3,6,45,25]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(L){return!!L&&typeof L.then=="function"}e.isThenable=S;function k(L){const M=new v.CancellationTokenSource,x=L(M.token),G=new Promise((J,te)=>{M.token.onCancellationRequested(()=>{te((0,T.canceled)())}),Promise.resolve(x).then(me=>{M.dispose(),J(me)},me=>{M.dispose(),te(me)})});return new class{cancel(){M.cancel()}then(J,te){return G.then(J,te)}catch(J){return this.then(void 0,J)}finally(J){return G.finally(J)}}}e.createCancelablePromise=k;function i(L,M,x){return Promise.race([L,new Promise(G=>M.onCancellationRequested(()=>G(x)))])}e.raceCancellation=i;async function P(L){let M=-1;const x=L.map((J,te)=>J.then(me=>(M=te,me))),G=await Promise.race(x);return L.forEach((J,te)=>{te!==M&&J.cancel()}),G}e.raceCancellablePromises=P;function d(L,M,x){let G;const J=setTimeout(()=>{G==null||G(void 0),x==null||x()},M);return Promise.race([L.finally(()=>clearTimeout(J)),new Promise(te=>G=te)])}e.raceTimeout=d;function g(L){return new Promise((M,x)=>{const G=L();S(G)?G.then(M,x):M(G)})}e.asPromise=g;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(x,x).then(G)})}return new Promise((x,G)=>{this.queuedPromise.then(x,G)})}return this.activePromise=M(),new Promise((x,G)=>{this.activePromise.then(J=>{this.activePromise=null,x(J)},J=>{this.activePromise=null,G(J)})})}}e.Throttler=r;class a{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=a;class p{constructor(){this.promiseMap=new Map}queue(M,x){var G;const te=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(M)===te&&this.promiseMap.delete(M)});return this.promiseMap.set(M,te),te}}e.SequencerByKey=p;class f{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,x=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,J)=>{this.doResolve=G,this.doReject=J}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=f;class E{constructor(M){this.delayer=new f(M),this.throttler=new r}trigger(M,x){return this.delayer.trigger(()=>this.throttler.queue(M),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class o{constructor(){this._isOpen=!1,this._promise=new Promise((M,x)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class c extends o{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function m(L,M){return M?new Promise((x,G)=>{const J=setTimeout(x,L);M.onCancellationRequested(()=>{clearTimeout(J),G((0,T.canceled)())})}):k(x=>m(L,x))}e.timeout=m;function t(L,M=0){const x=setTimeout(L,M);return(0,A.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=t;function n(L){return L.then(void 0,M=>{})}e.ignoreErrors=n;function l(L){const M=[];let x=0;const G=L.length;function J(){return x<G?L[x++]():null}function te(me){me!=null&&M.push(me);const Le=J();return Le?Le.then(te):Promise.resolve(M)}return Promise.resolve(null).then(te)}e.sequence=l;function s(L,M=G=>!!G,x=null){let G=0;const J=L.length,te=()=>{if(G>=J)return Promise.resolve(x);const me=L[G++];return Promise.resolve(me()).then(We=>M(We)?Promise.resolve(We):te())};return te()}e.first=s;function u(L,M=G=>!!G,x=null){if(L.length===0)return Promise.resolve(x);let G=L.length;const J=()=>{var te,me;G=-1;for(const Le of L)(me=(te=Le).cancel)===null||me===void 0||me.call(te)};return new Promise((te,me)=>{for(const Le of L)Le.then(We=>{--G>=0&&M(We)?(J(),te(We)):G===0&&te(x)}).catch(We=>{--G>=0&&(J(),me(We))})})}e.firstParallel=u;class w{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((x,G)=>{this.outstandingPromises.push({factory:M,c:x,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const x=M.factory();x.then(M.c,M.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=w;class b extends w{constructor(){super(1)}}e.Queue=b;class I{constructor(){this.queues=new Map}queueFor(M,x=C.extUri){const G=x.getComparisonKey(M);let J=this.queues.get(G);return J||(J=new b,D.Event.once(J.onFinished)(()=>{J==null||J.dispose(),this.queues.delete(G)}),this.queues.set(G,J)),J}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=I;class h{constructor(M,x){this._token=-1,typeof M=="function"&&typeof x=="number"&&this.setIfNotSet(M,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},x)}setIfNotSet(M,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},x))}}e.TimeoutTimer=h;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setInterval(()=>{M()},x)}}e.IntervalTimer=_;class R{constructor(M,x){this.timeoutToken=-1,this.runner=M,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class B extends R{constructor(M,x){super(M,x);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const L=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const x=setTimeout(()=>M(L));let G=!1;return{dispose(){G||(G=!0,clearTimeout(x))}}}}else e.runWhenIdle=(L,M)=>{const x=requestIdleCallback(L,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(x))}}}}();class z{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function he(L,M,x){let G;for(let J=0;J<x;J++)try{return await L()}catch(te){G=te,await m(M)}throw G}e.retry=he;class de{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,x,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:x},x.then(()=>this.donePending(M),()=>this.donePending(M)),x}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let x,G;const J=new Promise((te,me)=>{x=te,G=me});this._next={run:M,promise:J,promiseResolve:x,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=de;class W{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,x)=>{this.completeCallback=M,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(x=>{this.completeCallback(M),this.resolved=!0,x()})}error(M){return new Promise(x=>{this.errorCallback(M),this.rejected=!0,x()})}cancel(){new Promise(M=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=j;class U extends D.Emitter{async fireAsync(M,x,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const J of this._listeners)this._asyncDeliveryQueue.push([J,M]);for(;this._asyncDeliveryQueue.size>0&&!x.isCancellationRequested;){const[J,te]=this._asyncDeliveryQueue.shift(),me=[],Le=Object.assign(Object.assign({},te),{waitUntil:We=>{if(Object.isFrozen(me))throw new Error("waitUntil can NOT be called asynchronous");G&&(We=G(We,typeof J=="function"?J:J[0])),me.push(We)}});try{typeof J=="function"?J.call(void 0,Le):J[0].call(J[1],Le)}catch(We){(0,T.onUnexpectedError)(We);continue}Object.freeze(me),await F.settled(me).catch(We=>(0,T.onUnexpectedError)(We))}}}}e.AsyncEmitter=U;var F;(function(L){async function M(te){return typeof Promise.allSettled=="function"?x(te):G(te)}L.allSettled=M;async function x(te){return Promise.allSettled(te)}async function G(te){return Promise.all(te.map(me=>me.then(Le=>({status:"fulfilled",value:Le}),Le=>({status:"rejected",reason:Le}))))}async function J(te){let me;const Le=await Promise.all(te.map(We=>We.then(Fe=>Fe,Fe=>{me||(me=Fe)})));if(typeof me!="undefined")throw me;return Le}L.settled=J})(F=e.Promises||(e.Promises={}))}),define(ve[113],be([0,1,14,11]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new T.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),A=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(h,_,R=!1){const B=h||"",z=_||"",he=D.value.collator.compare(B,z);return D.value.collatorIsNumeric&&he===0&&B!==z?B<z?-1:1:he}e.compareFileNames=C;function S(h,_){const R=A.value.collator;return h=h||"",_=_||"",m(R,h,_)}e.compareFileNamesDefault=S;function k(h,_){const R=A.value.collator;return h=h||"",_=_||"",s(h,_)||m(R,h,_)}e.compareFileNamesUpper=k;function i(h,_){const R=A.value.collator;return h=h||"",_=_||"",l(h,_)||m(R,h,_)}e.compareFileNamesLower=i;function P(h,_){return h=h||"",_=_||"",h===_?0:h<_?-1:1}e.compareFileNamesUnicode=P;function d(h,_,R=!1){R||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase());const[B,z]=o(h),[he,de]=o(_);return B!==he?B<he?-1:1:z===de?0:z<de?-1:1}e.noIntlCompareFileNames=d;function g(h,_){const[R,B]=o(h),[z,he]=o(_);let de=D.value.collator.compare(B,he);if(de===0){if(D.value.collatorIsNumeric&&B!==he)return B<he?-1:1;if(de=D.value.collator.compare(R,z),D.value.collatorIsNumeric&&de===0&&R!==z)return R<z?-1:1}return de}e.compareFileExtensions=g;function r(h,_){h=h||"",_=_||"";const R=c(h),B=c(_),z=A.value.collator,he=y.value.collator;return m(he,R,B)||m(z,h,_)}e.compareFileExtensionsDefault=r;function a(h,_){h=h||"",_=_||"";const R=c(h),B=c(_),z=A.value.collator,he=y.value.collator;return m(he,R,B)||s(h,_)||m(z,h,_)}e.compareFileExtensionsUpper=a;function p(h,_){h=h||"",_=_||"";const R=c(h),B=c(_),z=A.value.collator,he=y.value.collator;return m(he,R,B)||l(h,_)||m(z,h,_)}e.compareFileExtensionsLower=p;function f(h,_){h=h||"",_=_||"";const R=c(h).toLowerCase(),B=c(_).toLowerCase();return R!==B?R<B?-1:1:h!==_?h<_?-1:1:0}e.compareFileExtensionsUnicode=f;const E=/^(.*?)(\.([^.]*))?$/;function o(h,_=!1){const R=h?E.exec(h):[];let B=[R&&R[1]||"",R&&R[3]||""];return _&&(!B[0]&&B[1]||B[0]&&B[0].charAt(0)===".")&&(B=[B[0]+"."+B[1],""]),B}function c(h){const _=h?E.exec(h):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function m(h,_,R){let B=h.compare(_,R);return B!==0?B:_.length!==R.length?_.length<R.length?-1:1:0}function t(h){const _=h.charAt(0);return _.toLocaleUpperCase()!==_}function n(h){const _=h.charAt(0);return _.toLocaleLowerCase()!==_}function l(h,_){return t(h)&&n(_)?-1:n(h)&&t(_)?1:0}function s(h,_){return n(h)&&t(_)?-1:t(h)&&n(_)?1:0}function u(h,_,R=!1){return R||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase()),h===_?0:h<_?-1:1}function w(h,_,R=!1){const B=h.split(v.sep),z=_.split(v.sep),he=B.length-1,de=z.length-1;let W,j;for(let U=0;;U++){if(W=he===U,j=de===U,W&&j)return C(B[U],z[U],R);if(W)return-1;if(j)return 1;const F=u(B[U],z[U],R);if(F!==0)return F}}e.comparePaths=w;function b(h,_,R){const B=h.toLowerCase(),z=_.toLowerCase(),he=I(h,_,R);if(he)return he;const de=B.endsWith(R),W=z.endsWith(R);if(de!==W)return de?-1:1;const j=C(B,z);return j!==0?j:B.localeCompare(z)}e.compareAnything=b;function I(h,_,R){const B=h.toLowerCase(),z=_.toLowerCase(),he=B.startsWith(R),de=z.startsWith(R);if(he!==de)return he?-1:1;if(he&&de){if(B.length<z.length)return-1;if(B.length>z.length)return 1}return 0}e.compareByPrefix=I}),define(ve[28],be([0,1,8,37,14,22,11]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const S="**",k="/",i="[/\\\\]",P="[^/\\\\]",d=/\//g;function g(x){switch(x){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function r(x,G){if(!x)return[];const J=[];let te=!1,me=!1,Le="";for(const We of x){switch(We){case G:if(!te&&!me){J.push(Le),Le="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":me=!0;break;case"]":me=!1;break}Le+=We}return Le&&J.push(Le),J}e.splitGlobAware=r;function a(x){if(!x)return"";let G="";const J=r(x,k);if(J.every(te=>te===S))G=".*";else{let te=!1;J.forEach((me,Le)=>{if(me===S){te||(G+=g(2),te=!0);return}let We=!1,Fe="",ze=!1,H="";for(const q of me){if(q!=="}"&&We){Fe+=q;continue}if(ze&&(q!=="]"||!H)){let ee;q==="-"?ee=q:(q==="^"||q==="!")&&!H?ee="^":q===k?ee="":ee=v.escapeRegExpCharacters(q),H+=ee;continue}switch(q){case"{":We=!0;continue;case"[":ze=!0;continue;case"}":G+=`(?:${r(Fe,",").map(ce=>a(ce)).join("|")})`,We=!1,Fe="";break;case"]":G+="["+H+"]",ze=!1,H="";break;case"?":G+=P;continue;case"*":G+=g(1);continue;default:G+=v.escapeRegExpCharacters(q)}}Le<J.length-1&&(J[Le+1]!==S||Le+2<J.length)&&(G+=i),te=!1})}return G}const p=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},l=function(){return null};function s(x,G){if(!x)return l;let J;typeof x!="string"?J=x.pattern:J=x,J=J.trim();const te=`${J}_${!!G.trimForExclusions}`;let me=t.get(te);if(me)return u(me,x);let Le;if(p.test(J)){const We=J.substr(4);me=function(Fe,ze){return typeof Fe=="string"&&Fe.endsWith(We)?J:null}}else(Le=f.exec(w(J,G)))?me=b(Le[1],J):(G.trimForExclusions?o:E).test(J)?me=I(J,G):(Le=c.exec(w(J,G)))?me=h(Le[1].substr(1),J,!0):(Le=m.exec(w(J,G)))?me=h(Le[1],J,!1):me=_(J);return t.set(te,me),u(me,x)}function u(x,G){return typeof G=="string"?x:function(J,te){return T.isEqualOrParent(J,G.base)?x(D.relative(G.base,J),te):null}}function w(x,G){return G.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function b(x,G){const J=`/${x}`,te=`\\${x}`,me=function(We,Fe){return typeof We!="string"?null:Fe?Fe===x?G:null:We===x||We.endsWith(J)||We.endsWith(te)?G:null},Le=[x];return me.basenames=Le,me.patterns=[G],me.allBasenames=Le,me}function I(x,G){const J=M(x.slice(1,-1).split(",").map(Fe=>s(Fe,G)).filter(Fe=>Fe!==l),x),te=J.length;if(!te)return l;if(te===1)return J[0];const me=function(Fe,ze){for(let H=0,q=J.length;H<q;H++)if(J[H](Fe,ze))return x;return null},Le=J.find(Fe=>!!Fe.allBasenames);Le&&(me.allBasenames=Le.allBasenames);const We=J.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return We.length&&(me.allPaths=We),me}function h(x,G,J){const te=D.sep===D.posix.sep,me=te?x:x.replace(d,D.sep),Le=D.sep+me,We=D.posix.sep+x,Fe=J?function(ze,H){return typeof ze=="string"&&(ze===me||ze.endsWith(Le)||!te&&(ze===x||ze.endsWith(We)))?G:null}:function(ze,H){return typeof ze=="string"&&(ze===me||!te&&ze===x)?G:null};return Fe.allPaths=[(J?"*/":"./")+x],Fe}function _(x){try{const G=new RegExp(`^${a(x)}$`);return function(J){return G.lastIndex=0,typeof J=="string"&&G.test(J)?x:null}}catch(G){return l}}function R(x,G,J){return!x||typeof G!="string"?!1:B(x)(G,void 0,J)}e.match=R;function B(x,G={}){if(!x)return n;if(typeof x=="string"||W(x)){const J=s(x,G);if(J===l)return n;const te=function(me,Le){return!!J(me,Le)};return J.allBasenames&&(te.allBasenames=J.allBasenames),J.allPaths&&(te.allPaths=J.allPaths),te}return F(x,G)}e.parse=B;function z(x){if(!!x){let G;return J=>(G||(G=(x()||Promise.resolve([])).then(te=>te?de(te):{})),G.then(te=>!!te[J]))}}e.hasSiblingPromiseFn=z;function he(x){if(!!x){let G;return J=>{if(!G){const te=x();G=te?de(te):{}}return!!G[J]}}}e.hasSiblingFn=he;function de(x){const G={};for(const J of x)G[J]=!0;return G}function W(x){const G=x;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=W;function j(x){return x.allBasenames||[]}e.getBasenameTerms=j;function U(x){return x.allPaths||[]}e.getPathTerms=U;function F(x,G){const J=M(Object.getOwnPropertyNames(x).map(Fe=>L(Fe,x[Fe],G)).filter(Fe=>Fe!==l)),te=J.length;if(!te)return l;if(!J.some(Fe=>!!Fe.requiresSiblings)){if(te===1)return J[0];const Fe=function(q,ee){for(let se=0,ce=J.length;se<ce;se++){const _e=J[se](q,ee);if(_e)return _e}return null},ze=J.find(q=>!!q.allBasenames);ze&&(Fe.allBasenames=ze.allBasenames);const H=J.reduce((q,ee)=>ee.allPaths?q.concat(ee.allPaths):q,[]);return H.length&&(Fe.allPaths=H),Fe}const me=function(Fe,ze,H){let q;for(let ee=0,se=J.length;ee<se;ee++){const ce=J[ee];ce.requiresSiblings&&H&&(ze||(ze=D.basename(Fe)),q||(q=ze.substr(0,ze.length-D.extname(Fe).length)));const _e=ce(Fe,ze,q,H);if(_e)return _e}return null},Le=J.find(Fe=>!!Fe.allBasenames);Le&&(me.allBasenames=Le.allBasenames);const We=J.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return We.length&&(me.allPaths=We),me}function L(x,G,J){if(G===!1)return l;const te=s(x,J);if(te===l)return l;if(typeof G=="boolean")return te;if(G){const me=G.when;if(typeof me=="string"){const Le=(We,Fe,ze,H)=>{if(!H||!te(We,Fe))return null;const q=me.replace("$(basename)",ze),ee=H(q);return(0,y.isThenable)(ee)?ee.then(se=>se?x:null):ee?x:null};return Le.requiresSiblings=!0,Le}}return te}function M(x,G){const J=x.filter(Fe=>!!Fe.basenames);if(J.length<2)return x;const te=J.reduce((Fe,ze)=>{const H=ze.basenames;return H?Fe.concat(H):Fe},[]);let me;if(G){me=[];for(let Fe=0,ze=te.length;Fe<ze;Fe++)me.push(G)}else me=J.reduce((Fe,ze)=>{const H=ze.patterns;return H?Fe.concat(H):Fe},[]);const Le=function(Fe,ze){if(typeof Fe!="string")return null;if(!ze){let q;for(q=Fe.length;q>0;q--){const ee=Fe.charCodeAt(q-1);if(ee===47||ee===92)break}ze=Fe.substr(q)}const H=te.indexOf(ze);return H!==-1?me[H]:null};Le.basenames=te,Le.patterns=me,Le.allBasenames=te;const We=x.filter(Fe=>!Fe.basenames);return We.push(Le),We}}),define(ve[58],be([0,1,2,14,8,19,21,25,37]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(s,u,w){if(typeof s=="string"&&(s=v.URI.file(s)),w){const I=w.getWorkspaceFolder(s);if(I){const h=w.getWorkspace().folders.length>1;let _;if((0,C.isEqual)(I.uri,s)?_="":_=(0,C.relativePath)(I.uri,s),h){const R=I.name?I.name:(0,C.basename)(I.uri);_=_?R+" \u2022 "+_:R}return _}}if(s.scheme!==A.Schemas.file&&s.scheme!==A.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(s.fsPath))return(0,T.normalize)(P(s.fsPath));let b=(0,T.normalize)(s.fsPath);return!y.isWindows&&(u==null?void 0:u.userHome)&&(b=g(b,u.userHome.fsPath)),b}e.getPathLabel=k;function i(s){if(!!s){typeof s=="string"&&(s=v.URI.file(s));const u=(0,C.basename)(s)||(s.scheme===A.Schemas.file?s.fsPath:s.path);return y.isWindows&&(0,S.isRootOrDriveLetter)(u)?P(u):u}}e.getBaseLabel=i;function P(s){return(0,S.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=P;let d=Object.create(null);function g(s,u){if(y.isWindows||!s||!u)return s;let w=d.original===u?d.normalized:void 0;return w||(w=`${(0,D.rtrim)(u,T.posix.sep)}${T.posix.sep}`,d={original:u,normalized:w}),(y.isLinux?s.startsWith(w):(0,D.startsWithIgnoreCase)(s,w))&&(s=`~/${s.substr(w.length)}`),s}e.tildify=g;function r(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=r;const a="\u2026",p="\\\\",f="~";function E(s,u=T.sep){const w=new Array(s.length);let b=!1;for(let I=0;I<s.length;I++){let h=s[I];if(h===""){w[I]=`.${u}`;continue}if(!h){w[I]=h;continue}b=!0;let _="";h.indexOf(p)===0?(_=h.substr(0,h.indexOf(p)+p.length),h=h.substr(h.indexOf(p)+p.length)):h.indexOf(u)===0?(_=h.substr(0,h.indexOf(u)+u.length),h=h.substr(h.indexOf(u)+u.length)):h.indexOf(f)===0&&(_=h.substr(0,h.indexOf(f)+f.length),h=h.substr(h.indexOf(f)+f.length));const R=h.split(u);for(let B=1;b&&B<=R.length;B++)for(let z=R.length-B;b&&z>=0;z--){b=!1;let he=R.slice(z,z+B).join(u);for(let de=0;!b&&de<s.length;de++)if(de!==I&&s[de]&&s[de].indexOf(he)>-1){const W=z+B===R.length,j=z>0&&s[de].indexOf(u)>-1?u+he:he,U=s[de].endsWith(j);b=!W||U}if(!b){let de="";(R[0].endsWith(":")||_!=="")&&(z===1&&(z=0,B++,he=R[0]+u+he),z>0&&(de=R[0]+u),de=_+de),z>0&&(de=de+a+u),de=de+he,z+B<R.length&&(de=de+u+a),w[I]=de}}b&&(w[I]=h)}return w}e.shorten=E;var o;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function c(s,u=Object.create(null)){const w=[];let b=!1,I="";for(const h of s)if(h==="$"||b&&h==="{")I&&w.push({value:I,type:o.TEXT}),I="",b=!0;else if(h==="}"&&b){const _=u[I];if(typeof _=="string")_.length&&w.push({value:_,type:o.VARIABLE});else if(_){const R=w[w.length-1];(!R||R.type!==o.SEPARATOR)&&w.push({value:_.label,type:o.SEPARATOR})}I="",b=!1}else I+=h;return I&&!b&&w.push({value:I,type:o.TEXT}),w.filter((h,_)=>{if(h.type===o.SEPARATOR){const R=w[_-1],B=w[_+1];return[R,B].every(z=>z&&(z.type===o.VARIABLE||z.type===o.TEXT)&&z.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=c;function m(s,u){return y.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):s.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function t(s,u){return y.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):y.isWindows?s.replace(/&&|&/g,w=>w==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function l(s){const u=s.indexOf("/")!==-1?T.posix:T.win32,w=u.basename(s),b=u.dirname(s);return w.length?{name:w,parentPath:b}:{name:b,parentPath:""}}e.splitName=l}),define(ve[114],be([0,1,2]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(i){return i.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const d=this._uriTransformer.transformIncoming(P);return d===P?P:T(v.URI.from(d))}transformOutgoing(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:T(v.URI.from(d))}transformOutgoingURI(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:v.URI.from(d)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function A(i,P,d){if(!i||d>200)return null;if(typeof i=="object"){if(i instanceof v.URI)return P.transformOutgoing(i);for(let g in i)if(Object.hasOwnProperty.call(i,g)){const r=A(i[g],P,d+1);r!==null&&(i[g]=r)}}return null}function y(i,P){const d=A(i,P,0);return d===null?i:d}e.transformOutgoingURIs=y;function C(i,P,d,g){if(!i||g>200)return null;if(typeof i=="object"){if(i.$mid===1)return d?v.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let r in i)if(Object.hasOwnProperty.call(i,r)){const a=C(i[r],P,d,g+1);a!==null&&(i[r]=a)}}return null}function S(i,P){const d=C(i,P,!1,0);return d===null?i:d}e.transformIncomingURIs=S;function k(i,P){const d=C(i,P,!0,0);return d===null?i:d}e.transformAndReviveIncomingURIs=k}),define(ve[31],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(S){return v.test(S)}e.isUUID=T;const D=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(S){for(let k=0;k<S.length;k++)S[k]=Math.floor(Math.random()*256);return S};function C(){y(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,k="";return k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+="-",k+=A[D[S++]],k+=A[D[S++]],k+="-",k+=A[D[S++]],k+=A[D[S++]],k+="-",k+=A[D[S++]],k+=A[D[S++]],k+="-",k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k}e.generateUuid=C}),define(ve[85],be([0,1,83]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(C){let S=(0,v.toUint8)(C);this._defaultValue=S,this._asciiMap=T._createAsciiMap(S),this._map=new Map}static _createAsciiMap(C){let S=new Uint8Array(256);for(let k=0;k<256;k++)S[k]=C;return S}set(C,S){let k=(0,v.toUint8)(S);C>=0&&C<256?this._asciiMap[C]=k:this._map.set(C,k)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=T;var D;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(D||(D={}));class A{constructor(){this._actual=new T(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=A}),define(ve[115],be([0,1,85]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends v.CharacterClassifier{constructor(C){super(0);for(let S=0,k=C.length;S<k;S++)this.set(C.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function A(y){let C={};return S=>(C.hasOwnProperty(S)||(C[S]=y(S)),C[S])}e.getMapForWordSeparators=A(y=>new D(y))}),define(ve[38],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(D,A){this.lineNumber=D,this.column=A}with(D=this.lineNumber,A=this.column){return D===this.lineNumber&&A===this.column?this:new v(D,A)}delta(D=0,A=0){return this.with(this.lineNumber+D,this.column+A)}equals(D){return v.equals(this,D)}static equals(D,A){return!D&&!A?!0:!!D&&!!A&&D.lineNumber===A.lineNumber&&D.column===A.column}isBefore(D){return v.isBefore(this,D)}static isBefore(D,A){return D.lineNumber<A.lineNumber?!0:A.lineNumber<D.lineNumber?!1:D.column<A.column}isBeforeOrEqual(D){return v.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,A){return D.lineNumber<A.lineNumber?!0:A.lineNumber<D.lineNumber?!1:D.column<=A.column}static compare(D,A){let y=D.lineNumber|0,C=A.lineNumber|0;if(y===C){let S=D.column|0,k=A.column|0;return S-k}return y-C}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new v(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=v}),define(ve[32],be([0,1,38]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(A,y,C,S){A>C||A===C&&y>S?(this.startLineNumber=C,this.startColumn=S,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=C,this.endColumn=S)}isEmpty(){return T.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return T.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return T.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return T.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return T.plusRange(this,A)}static plusRange(A,y){let C,S,k,i;return y.startLineNumber<A.startLineNumber?(C=y.startLineNumber,S=y.startColumn):y.startLineNumber===A.startLineNumber?(C=y.startLineNumber,S=Math.min(y.startColumn,A.startColumn)):(C=A.startLineNumber,S=A.startColumn),y.endLineNumber>A.endLineNumber?(k=y.endLineNumber,i=y.endColumn):y.endLineNumber===A.endLineNumber?(k=y.endLineNumber,i=Math.max(y.endColumn,A.endColumn)):(k=A.endLineNumber,i=A.endColumn),new T(C,S,k,i)}intersectRanges(A){return T.intersectRanges(this,A)}static intersectRanges(A,y){let C=A.startLineNumber,S=A.startColumn,k=A.endLineNumber,i=A.endColumn,P=y.startLineNumber,d=y.startColumn,g=y.endLineNumber,r=y.endColumn;return C<P?(C=P,S=d):C===P&&(S=Math.max(S,d)),k>g?(k=g,i=r):k===g&&(i=Math.min(i,r)),C>k||C===k&&S>i?null:new T(C,S,k,i)}equalsRange(A){return T.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(A){return new v.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(A){return new v.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new T(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new T(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(A){return new T(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new T(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new T(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const k=A.startLineNumber|0,i=y.startLineNumber|0;if(k===i){const P=A.startColumn|0,d=y.startColumn|0;if(P===d){const g=A.endLineNumber|0,r=y.endLineNumber|0;if(g===r){const a=A.endColumn|0,p=y.endColumn|0;return a-p}return g-r}return P-d}return k-i}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=T}),define(ve[116],be([0,1,38,32]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class A extends T.Range{constructor(C,S,k,i){super(C,S,k,i);this.selectionStartLineNumber=C,this.selectionStartColumn=S,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return A.selectionsEqual(this,C)}static selectionsEqual(C,S){return C.selectionStartLineNumber===S.selectionStartLineNumber&&C.selectionStartColumn===S.selectionStartColumn&&C.positionLineNumber===S.positionLineNumber&&C.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,C,S):new A(C,S,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,S){return this.getDirection()===0?new A(C,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,C,S)}static fromPositions(C,S=C){return new A(C.lineNumber,C.column,S.lineNumber,S.column)}static liftSelection(C){return new A(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,S){if(C&&!S||!C&&S)return!1;if(!C&&!S)return!0;if(C.length!==S.length)return!1;for(let k=0,i=C.length;k<i;k++)if(!this.selectionsEqual(C[k],S[k]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,S,k,i,P){return P===0?new A(C,S,k,i):new A(k,i,C,S)}}e.Selection=A}),define(ve[86],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class S{constructor(a,p){this.range=a,this.matches=p}}e.FindMatch=S;var k;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class d{constructor(a,p,f,E,o,c){this.identifier=a,this.range=p,this.text=f,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=o,this._isTracked=c}}e.ValidAnnotatedEditOperation=d;class g{constructor(a,p,f){this.reverseEdits=a,this.changes=p,this.trimAutoWhitespaceLineNumbers=f}}e.ApplyEditsResult=g}),define(ve[117],be([0,1,8,115,38,32,86]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class S{constructor(o,c,m,t){this.searchString=o,this.isRegex=c,this.matchCase=m,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=k(this.searchString):o=this.searchString.indexOf(`
`)>=0;let c=null;try{c=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let m=!this.isRegex&&!o;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new i(c,this.wordSeparators?(0,T.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=S;function k(E){if(!E||E.length===0)return!1;for(let o=0,c=E.length;o<c;o++)if(E.charCodeAt(o)===92){if(o++,o>=c)break;const t=E.charCodeAt(o);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(o,c,m){this.regex=o,this.wordSeparators=c,this.simpleSearch=m}}e.SearchData=i;function P(E,o,c){if(!c)return new y.FindMatch(E,null);let m=[];for(let t=0,n=o.length;t<n;t++)m[t]=o[t];return new y.FindMatch(E,m)}e.createFindMatch=P;class d{constructor(o){let c=[],m=0;for(let t=0,n=o.length;t<n;t++)o.charCodeAt(t)===10&&(c[m++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(o){const c=this._lineFeedsOffsets;let m=0,t=c.length-1;if(t===-1||o<=c[0])return 0;for(;m<t;){const n=m+((t-m)/2>>0);c[n]>=o?t=n-1:c[n+1]>=o?(m=n,t=n):m=n+1}return m+1}}class g{static findMatches(o,c,m,t,n){const l=c.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(o,m,new f(l.wordSeparators,l.regex),t,n):this._doFindMatchesLineByLine(o,m,l,t,n):[]}static _getMultilineMatchRange(o,c,m,t,n,l){let s,u=0;t?(u=t.findLineFeedCountBeforeOffset(n),s=c+n+u):s=c+n;let w;if(t){let _=t.findLineFeedCountBeforeOffset(n+l.length)-u;w=s+l.length+_}else w=s+l.length;const b=o.getPositionAt(s),I=o.getPositionAt(w);return new A.Range(b.lineNumber,b.column,I.lineNumber,I.column)}static _doFindMatchesMultiline(o,c,m,t,n){const l=o.getOffsetAt(c.getStartPosition()),s=o.getValueInRange(c,1),u=o.getEOL()===`\r
`?new d(s):null,w=[];let b=0,I;for(m.reset(0);I=m.next(s);)if(w[b++]=P(this._getMultilineMatchRange(o,l,s,u,I.index,I[0]),I,t),b>=n)return w;return w}static _doFindMatchesLineByLine(o,c,m,t,n){const l=[];let s=0;if(c.startLineNumber===c.endLineNumber){const w=o.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return s=this._findMatchesInLine(m,w,c.startLineNumber,c.startColumn-1,s,l,t,n),l}const u=o.getLineContent(c.startLineNumber).substring(c.startColumn-1);s=this._findMatchesInLine(m,u,c.startLineNumber,c.startColumn-1,s,l,t,n);for(let w=c.startLineNumber+1;w<c.endLineNumber&&s<n;w++)s=this._findMatchesInLine(m,o.getLineContent(w),w,0,s,l,t,n);if(s<n){const w=o.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);s=this._findMatchesInLine(m,w,c.endLineNumber,0,s,l,t,n)}return l}static _findMatchesInLine(o,c,m,t,n,l,s,u){const w=o.wordSeparators;if(!s&&o.simpleSearch){const h=o.simpleSearch,_=h.length,R=c.length;let B=-_;for(;(B=c.indexOf(h,B+_))!==-1;)if((!w||p(w,c,R,B,_))&&(l[n++]=new y.FindMatch(new A.Range(m,B+1+t,m,B+1+_+t),null),n>=u))return n;return n}const b=new f(o.wordSeparators,o.regex);let I;b.reset(0);do if(I=b.next(c),I&&(l[n++]=P(new A.Range(m,I.index+1+t,m,I.index+1+I[0].length+t),I,s),n>=u))return n;while(I);return n}static findNextMatch(o,c,m,t){const n=c.parseSearchRequest();if(!n)return null;const l=new f(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(o,m,l,t):this._doFindNextMatchLineByLine(o,m,l,t)}static _doFindNextMatchMultiline(o,c,m,t){const n=new D.Position(c.lineNumber,1),l=o.getOffsetAt(n),s=o.getLineCount(),u=o.getValueInRange(new A.Range(n.lineNumber,n.column,s,o.getLineMaxColumn(s)),1),w=o.getEOL()===`\r
`?new d(u):null;m.reset(c.column-1);let b=m.next(u);return b?P(this._getMultilineMatchRange(o,l,u,w,b.index,b[0]),b,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(o,new D.Position(1,1),m,t):null}static _doFindNextMatchLineByLine(o,c,m,t){const n=o.getLineCount(),l=c.lineNumber,s=o.getLineContent(l),u=this._findFirstMatchInLine(m,s,l,c.column,t);if(u)return u;for(let w=1;w<=n;w++){const b=(l+w-1)%n,I=o.getLineContent(b+1),h=this._findFirstMatchInLine(m,I,b+1,1,t);if(h)return h}return null}static _findFirstMatchInLine(o,c,m,t,n){o.reset(t-1);const l=o.next(c);return l?P(new A.Range(m,l.index+1,m,l.index+1+l[0].length),l,n):null}static findPreviousMatch(o,c,m,t){const n=c.parseSearchRequest();if(!n)return null;const l=new f(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(o,m,l,t):this._doFindPreviousMatchLineByLine(o,m,l,t)}static _doFindPreviousMatchMultiline(o,c,m,t){const n=this._doFindMatchesMultiline(o,new A.Range(1,1,c.lineNumber,c.column),m,t,10*C);if(n.length>0)return n[n.length-1];const l=o.getLineCount();return c.lineNumber!==l||c.column!==o.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(o,new D.Position(l,o.getLineMaxColumn(l)),m,t):null}static _doFindPreviousMatchLineByLine(o,c,m,t){const n=o.getLineCount(),l=c.lineNumber,s=o.getLineContent(l).substring(0,c.column-1),u=this._findLastMatchInLine(m,s,l,t);if(u)return u;for(let w=1;w<=n;w++){const b=(n+l-w-1)%n,I=o.getLineContent(b+1),h=this._findLastMatchInLine(m,I,b+1,t);if(h)return h}return null}static _findLastMatchInLine(o,c,m,t){let n=null,l;for(o.reset(0);l=o.next(c);)n=P(new A.Range(m,l.index+1,m,l.index+1+l[0].length),l,t);return n}}e.TextModelSearch=g;function r(E,o,c,m,t){if(m===0)return!0;const n=o.charCodeAt(m-1);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const l=o.charCodeAt(m);if(E.get(l)!==0)return!0}return!1}function a(E,o,c,m,t){if(m+t===c)return!0;const n=o.charCodeAt(m+t);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const l=o.charCodeAt(m+t-1);if(E.get(l)!==0)return!0}return!1}function p(E,o,c,m,t){return r(E,o,c,m,t)&&a(E,o,c,m,t)}e.isValidMatch=p;class f{constructor(o,c){this._wordSeparators=o,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const c=o.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(m=this._searchRegex.exec(o),!m))return null;const t=m.index,n=m[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){v.getNextCodePoint(o,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||p(this._wordSeparators,o,c,t,n))return m}while(m);return null}}e.Searcher=f}),define(ve[87],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(C=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)C.indexOf(k)>=0||(S+="\\"+k);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=v();function T(C){let S=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)S=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),S=new RegExp(C.source,k)}return S.lastIndex=0,S}e.ensureValidWordDefinition=T;const D={maxLen:1e3,windowSize:15,timeBudget:150};function A(C,S,k,i,P=D){if(k.length>P.maxLen){let p=C-P.maxLen/2;return p<0?p=0:i+=p,k=k.substring(p,C+P.maxLen/2),A(C,S,k,i,P)}const d=Date.now(),g=C-1-i;let r=-1,a=null;for(let p=1;!(Date.now()-d>=P.timeBudget);p++){const f=g-P.windowSize*p;S.lastIndex=Math.max(0,f);const E=y(S,k,g,r);if(!E&&a||(a=E,f<=0))break;r=f}if(a){let p={word:a[0],startColumn:i+1+a.index,endColumn:i+1+a.index+a[0].length};return S.lastIndex=0,p}return null}e.getWordAtText=A;function y(C,S,k,i){let P;for(;P=C.exec(S);){const d=P.index||0;if(d<=k&&C.lastIndex>=k)return P;if(i>0&&d>i)return null}return null}}),define(ve[118],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class T{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let S=0,k=C.notIn.length;S<k;S++)switch(C.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=T;class D{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of C)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function A(y,C,S){y.has(C)?y.get(C).push(S):y.set(C,[S])}}),define(ve[59],be([0,1,28,14]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(A,y,C,S){if(Array.isArray(A)){let k=0;for(const i of A){const P=D(i,y,C,S);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof A=="string")return S?A==="*"?5:A===C?10:0:0;if(A){const{language:k,pattern:i,scheme:P,hasAccessToAllModels:d}=A;if(!S&&!d)return 0;let g=0;if(P)if(P===y.scheme)g=10;else if(P==="*")g=5;else return 0;if(k)if(k===C)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(i){let r;if(typeof i=="string"?r=i:r=Object.assign(Object.assign({},i),{base:(0,T.normalize)(i.base)}),r===y.fsPath||(0,v.match)(r,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=D}),define(ve[119],be([0,1,85]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class D{constructor(r,a,p){const f=new Uint8Array(r*a);for(let E=0,o=r*a;E<o;E++)f[E]=p;this._data=f,this.rows=r,this.cols=a}get(r,a){return this._data[r*this.cols+a]}set(r,a,p){this._data[r*this.cols+a]=p}}e.Uint8Matrix=D;class A{constructor(r){let a=0,p=0;for(let E=0,o=r.length;E<o;E++){let[c,m,t]=r[E];m>a&&(a=m),c>p&&(p=c),t>p&&(p=t)}a++,p++;let f=new D(p,a,0);for(let E=0,o=r.length;E<o;E++){let[c,m,t]=r[E];f.set(c,m,t)}this._states=f,this._maxCharCode=a}nextState(r,a){return a<0||a>=this._maxCharCode?0:this._states.get(r,a)}}e.StateMachine=A;let y=null;function C(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let k=null;function i(){if(k===null){k=new v.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<g.length;a++)k.set(g.charCodeAt(a),1);const r=".,;";for(let a=0;a<r.length;a++)k.set(r.charCodeAt(a),2)}return k}class P{static _createLink(r,a,p,f,E){let o=E-1;do{const c=a.charCodeAt(o);if(r.get(c)!==2)break;o--}while(o>f);if(f>0){const c=a.charCodeAt(f-1),m=a.charCodeAt(o);(c===40&&m===41||c===91&&m===93||c===123&&m===125)&&o--}return{range:{startLineNumber:p,startColumn:f+1,endLineNumber:p,endColumn:o+2},url:a.substring(f,o+1)}}static computeLinks(r,a=C()){const p=i();let f=[];for(let E=1,o=r.getLineCount();E<=o;E++){const c=r.getLineContent(E),m=c.length;let t=0,n=0,l=0,s=1,u=!1,w=!1,b=!1,I=!1;for(;t<m;){let h=!1;const _=c.charCodeAt(t);if(s===13){let R;switch(_){case 40:u=!0,R=0;break;case 41:R=u?0:1;break;case 91:b=!0,w=!0,R=0;break;case 93:b=!1,R=w?0:1;break;case 123:I=!0,R=0;break;case 125:R=I?0:1;break;case 39:R=l===34||l===96?0:1;break;case 34:R=l===39||l===96?0:1;break;case 96:R=l===39||l===34?0:1;break;case 42:R=l===42?1:0;break;case 124:R=l===124?1:0;break;case 32:R=b?0:1;break;default:R=p.get(_)}R===1&&(f.push(P._createLink(p,c,E,n,t)),h=!0)}else if(s===12){let R;_===91?(w=!0,R=0):R=p.get(_),R===1?h=!0:s=13}else s=a.nextState(s,_),s===0&&(h=!0);h&&(s=1,u=!1,w=!1,I=!1,n=t+1,l=_),t++}s===13&&f.push(P._createLink(p,c,E,n,m))}return f}}e.LinkComputer=P;function d(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:P.computeLinks(g)}e.computeLinks=d}),define(ve[120],be([0,1,3,6]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,C){return this._map.set(y,C),this.fire([y]),(0,T.toDisposable)(()=>{this._map.get(y)===C&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,C){let S=null,k=!1;return this._promises.set(y,C.then(i=>{this._promises.delete(y),!(k||!i)&&(S=this.register(y,i))})),(0,T.toDisposable)(()=>{k=!0,S&&S.dispose()})}getPromise(y){const C=this.get(y);if(C)return Promise.resolve(C);const S=this._promises.get(y);return S?S.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(ve[88],be([0,1,24,21]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(D||(D={}));function A(P){for(let d=0,g=P.length;d<g;d+=4){const r=P[d+0],a=P[d+1],p=P[d+2],f=P[d+3];P[d+0]=f,P[d+1]=p,P[d+2]=a,P[d+3]=r}}function y(P){const d=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return T.isLittleEndian()||A(d),v.VSBuffer.wrap(d)}function C(P){const d=P.buffer;if(T.isLittleEndian()||A(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const g=new Uint8Array(d.byteLength);return g.set(d),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function S(P){const d=new Uint32Array(k(P));let g=0;if(d[g++]=P.id,P.type==="full")d[g++]=1,d[g++]=P.data.length,d.set(P.data,g),g+=P.data.length;else{d[g++]=2,d[g++]=P.deltas.length;for(const r of P.deltas)d[g++]=r.start,d[g++]=r.deleteCount,r.data?(d[g++]=r.data.length,d.set(r.data,g),g+=r.data.length):d[g++]=0}return y(d)}e.encodeSemanticTokensDto=S;function k(P){let d=0;if(d+=1+1,P.type==="full")d+=1+P.data.length;else{d+=1,d+=(1+1+1)*P.deltas.length;for(const g of P.deltas)g.data&&(d+=g.data.length)}return d}function i(P){const d=C(P);let g=0;const r=d[g++];if(d[g++]===1){const E=d[g++],o=d.subarray(g,g+E);return g+=E,{id:r,type:"full",data:o}}const p=d[g++];let f=[];for(let E=0;E<p;E++){const o=d[g++],c=d[g++],m=d[g++];let t;m>0&&(t=d.subarray(g,g+m),g+=m),f[E]={start:o,deleteCount:c,data:t}}return{id:r,type:"delta",deltas:f}}e.decodeSemanticTokensDto=i}),define(ve[89],be([0,1,83]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(y,C){this.index=y,this.remainder=C}}e.PrefixSumIndexOfResult=T;class D{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,C){y=(0,v.toUint32)(y);const S=this.values,k=this.prefixSum,i=C.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y),y+i),this.values.set(C,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,C){return y=(0,v.toUint32)(y),C=(0,v.toUint32)(C),this.values[y]===C?!1:(this.values[y]=C,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,C){y=(0,v.toUint32)(y),C=(0,v.toUint32)(C);const S=this.values,k=this.prefixSum;if(y>=S.length)return!1;let i=S.length-y;return C>=i&&(C=i),C===0?!1:(this.values=new Uint32Array(S.length-C),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y+C),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,v.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),y>=this.values.length&&(y=this.values.length-1);for(let S=C;S<=y;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let C=0,S=this.values.length-1,k=0,i=0,P=0;for(;C<=S;)if(k=C+(S-C)/2|0,i=this.prefixSum[k],P=i-this.values[k],y<P)S=k-1;else if(y>=i)C=k+1;else break;return new T(k,y-P)}}e.PrefixSumComputer=D}),define(ve[121],be([0,1,8,38,89]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(C,S,k,i){this._uri=C,this._lines=S,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const S=C.changes;for(const k of S)this._acceptDeleteRange(k.range),this._acceptInsertText(new T.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,S=this._lines.length,k=new Uint32Array(S);for(let i=0;i<S;i++)k[i]=this._lines[i].length+C;this._lineStarts=new D.PrefixSumComputer(k)}}_setLineText(C,S){this._lines[C]=S,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,S){if(S.length!==0){let k=(0,v.splitLines)(S);if(k.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}k[k.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(C.lineNumber+P-1,0,k[P]),i[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,i)}}}e.MirrorTextModel=A}),define(ve[122],be([16,17]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ve[60],be([0,1,122,10,13]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(k,i){return i&&(k.stack||k.stacktrace)?v.localize(0,null,C(k),y(k.stack)||y(k.stacktrace)):C(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?v.localize(1,null,k.message):k.message||v.localize(2,null)}function S(k=null,i=!1){if(!k)return v.localize(3,null);if(Array.isArray(k)){const P=D.coalesce(k),d=S(P[0],i);return P.length>1?v.localize(4,null,d,P.length):d}if(T.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return A(P.error,i);if(P.exception)return A(P.exception,i)}return k.stack?A(k,i):k.message?k.message:v.localize(5,null)}e.toErrorMessage=S}),define(ve[123],be([16,17]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(ve[124],be([0,1,123,21,87]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=y;class C{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,ge){this._values[Z]=ge}}e.ValidatedEditorOptions=C;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class k{constructor(Z,ge,Ne,Ve){this.id=Z,this.name=ge,this.defaultValue=Ne,this.schema=Ve}compute(Z,ge,Ne){return Ne}}class i{constructor(Z,ge=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(Z){return this.defaultValue}}class P{constructor(Z,ge,Ne,Ve){this.id=Z,this.name=ge,this.defaultValue=Ne,this.schema=Ve}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,ge,Ne){return Ne}}function d(V,Z){return typeof V=="undefined"?Z:V==="false"?!1:Boolean(V)}e.boolean=d;class g extends P{constructor(Z,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Ne),super(Z,ge,Ne,Ve)}validate(Z){return d(Z,this.defaultValue)}}class r extends P{constructor(Z,ge,Ne,Ve,xe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Ne,Xe.minimum=Ve,Xe.maximum=xe),super(Z,ge,Ne,Xe),this.minimum=Ve,this.maximum=xe}static clampedInt(Z,ge,Ne,Ve){if(typeof Z=="undefined")return ge;let xe=parseInt(Z,10);return isNaN(xe)?ge:(xe=Math.max(Ne,xe),xe=Math.min(Ve,xe),xe|0)}validate(Z){return r.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class a extends P{constructor(Z,ge,Ne,Ve,xe){typeof xe!="undefined"&&(xe.type="number",xe.default=Ne),super(Z,ge,Ne,xe),this.validationFn=Ve}static clamp(Z,ge,Ne){return Z<ge?ge:Z>Ne?Ne:Z}static float(Z,ge){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return ge;const Ne=parseFloat(Z);return isNaN(Ne)?ge:Ne}validate(Z){return this.validationFn(a.float(Z,this.defaultValue))}}class p extends P{static string(Z,ge){return typeof Z!="string"?ge:Z}constructor(Z,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Ne),super(Z,ge,Ne,Ve)}validate(Z){return p.string(Z,this.defaultValue)}}function f(V,Z,ge){return typeof V!="string"||ge.indexOf(V)===-1?Z:V}e.stringSet=f;class E extends P{constructor(Z,ge,Ne,Ve,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.enum=Ve,xe.default=Ne),super(Z,ge,Ne,xe),this._allowedValues=Ve}validate(Z){return f(Z,this.defaultValue,this._allowedValues)}}class o extends k{constructor(Z,ge,Ne,Ve,xe,Xe,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=xe,ye.default=Ve),super(Z,ge,Ne,ye),this._allowedValues=xe,this._convert=Xe}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function c(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ge,Ne){return Ne===0?Z.accessibilitySupport:Ne}}class t extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:v.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{insertSpace:d(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(V){switch(V){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function w(V){switch(V){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class b extends i{constructor(){super(123,[62,31])}compute(Z,ge,Ne){const Ve=["monaco-editor"];return ge.get(31)&&Ve.push(ge.get(31)),Z.extraEditorClassName&&Ve.push(Z.extraEditorClassName),ge.get(62)==="default"?Ve.push("mouse-default"):ge.get(62)==="copy"&&Ve.push("mouse-copy"),ge.get(97)&&Ve.push("showUnused"),ge.get(121)&&Ve.push("showDeprecated"),Ve.join(" ")}}class I extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(Z,ge,Ne){return Ne&&Z.emptySelectionClipboard}}class h extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:v.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:v.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{cursorMoveOnType:d(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":f(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ge.loop,this.defaultValue.loop)}}}class _ extends k{constructor(){super(41,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?_.OFF:Z==="true"?_.ON:Z:Boolean(Z)?_.ON:_.OFF}}e.EditorFontLigatures=_,_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(Z,ge,Ne){return Z.fontInfo}}class B extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(Z){let ge=a.float(Z,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(ge,6,100)}compute(Z,ge,Ne){return Z.fontInfo.fontSize}}class z extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(r.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class he extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},ge),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},ge),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},ge),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},ge),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},ge),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ne,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ne,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ne,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ne,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ne,description:v.localize(35,null)}})}validate(Z){var ge,Ne,Ve,xe,Xe;if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{multiple:f(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ge=ye.multipleDefinitions)!==null&&ge!==void 0?ge:f(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=ye.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:f(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=ye.multipleDeclarations)!==null&&Ve!==void 0?Ve:f(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(xe=ye.multipleImplementations)!==null&&xe!==void 0?xe:f(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=ye.multipleReferences)!==null&&Xe!==void 0?Xe:f(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends k{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(50,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:v.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:d(ge.enabled,this.defaultValue.enabled),delay:r.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:d(ge.sticky,this.defaultValue.sticky)}}}var W;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class j extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(Z,ge,Ne){return j.computeLayout(ge,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const ge=Z.height/Z.lineHeight,Ne=Z.scrollBeyondLastLine?ge-1:0,Ve=(Z.viewLineCount+Ne)/(Z.pixelRatio*Z.height),xe=Math.floor(Z.viewLineCount/Ve);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Ne,desiredRatio:Ve,minimapLineCount:xe}}static _computeMinimapLayout(Z,ge){const Ne=Z.outerWidth,Ve=Z.outerHeight,xe=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Xe=ge.stableMinimapLayoutInput,ye=Xe&&Z.outerHeight===Xe.outerHeight&&Z.lineHeight===Xe.lineHeight&&Z.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Xe.pixelRatio&&Z.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&Z.minimap.enabled===Xe.minimap.enabled&&Z.minimap.side===Xe.minimap.side&&Z.minimap.size===Xe.minimap.size&&Z.minimap.showSlider===Xe.minimap.showSlider&&Z.minimap.renderCharacters===Xe.minimap.renderCharacters&&Z.minimap.maxColumn===Xe.minimap.maxColumn&&Z.minimap.scale===Xe.minimap.scale&&Z.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&Z.isViewportWrapping===Xe.isViewportWrapping,Ee=Z.lineHeight,Ce=Z.typicalHalfwidthCharacterWidth,ie=Z.scrollBeyondLastLine,ae=Z.minimap.renderCharacters;let N=xe>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Q=Z.minimap.maxColumn,oe=Z.minimap.size,ke=Z.minimap.side,Ie=Z.verticalScrollbarWidth,Ae=Z.viewLineCount,Be=Z.remainingWidth,Ye=Z.isViewportWrapping,rt=ae?2:3;let tt=Math.floor(xe*Ve);const Qe=tt/xe;let gt=!1,bt=!1,pe=rt*N,ue=N/xe,re=1;if(oe==="fill"||oe==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:Ze,desiredRatio:mt,minimapLineCount:ht}=j.computeContainedMinimapLineCount({viewLineCount:Ae,scrollBeyondLastLine:ie,height:Ve,lineHeight:Ee,pixelRatio:xe});if(Ae/ht>1)gt=!0,bt=!0,N=1,pe=1,ue=N/xe;else{let at=!1,yt=N+1;if(oe==="fit"){const Et=Math.ceil((Ae+Ze)*pe);Ye&&ye&&Be<=ge.stableFitRemainingWidth?(at=!0,yt=ge.stableFitMaxMinimapScale):(at=Et>tt,Ye&&at?(ge.stableMinimapLayoutInput=Z,ge.stableFitRemainingWidth=Be):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0))}if(oe==="fill"||at){gt=!0;const Et=N;pe=Math.min(Ee*xe,Math.max(1,Math.floor(1/mt))),N=Math.min(yt,Math.max(1,Math.floor(pe/rt))),N>Et&&(re=Math.min(2,N/Et)),ue=N/xe/re,tt=Math.ceil(Math.max(ct,Ae+Ze)*pe),Ye&&at&&(ge.stableFitMaxMinimapScale=N)}}}const K=Math.floor(Q*ue),Me=Math.min(K,Math.max(0,Math.floor((Be-Ie-2)*ue/(Ce+ue)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor(xe*Me);const Je=Te/xe;Te=Math.floor(Te*re);const et=ae?1:2,ut=ke==="left"?0:Ne-Me-Ie;return{renderMinimap:et,minimapLeft:ut,minimapWidth:Me,minimapHeightIsEditorHeight:gt,minimapIsSampling:bt,minimapScale:N,minimapLineHeight:pe,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:Qe}}static computeLayout(Z,ge){const Ne=ge.outerWidth|0,Ve=ge.outerHeight|0,xe=ge.lineHeight|0,Xe=ge.lineNumbersDigitCount|0,ye=ge.typicalHalfwidthCharacterWidth,Ee=ge.maxDigitWidth,Ce=ge.pixelRatio,ie=ge.viewLineCount,ae=Z.get(118),N=ae==="inherit"?Z.get(117):ae,Q=N==="inherit"?Z.get(113):N,oe=Z.get(116),ke=Z.get(2),Ie=ge.isDominatedByLongLines,Ae=Z.get(46),Be=Z.get(56).renderType!==0,Ye=Z.get(57),rt=Z.get(91),tt=Z.get(61),Qe=Z.get(89),gt=Qe.verticalScrollbarSize,bt=Qe.verticalHasArrows,pe=Qe.arrowSize,ue=Qe.horizontalScrollbarSize,re=Z.get(54),K=Z.get(35);let Me;if(typeof re=="string"&&/^\d+(\.\d+)?ch$/.test(re)){const _t=parseFloat(re.substr(0,re.length-2));Me=r.clampedInt(_t*ye,0,0,1e3)}else Me=r.clampedInt(re,0,0,1e3);K&&(Me+=16);let Te=0;if(Be){const _t=Math.max(Xe,Ye);Te=Math.round(_t*Ee)}let Je=0;Ae&&(Je=xe);let et=0,ut=et+Je,ct=ut+Te,Ze=ct+Me;const mt=Ne-Je-Te-Me;let ht=!1,ft=!1,at=-1;ke!==2&&(N==="inherit"&&Ie?(ht=!0,ft=!0):Q==="on"||Q==="bounded"?ft=!0:Q==="wordWrapColumn"&&(at=oe));const yt=j._computeMinimapLayout({outerWidth:Ne,outerHeight:Ve,lineHeight:xe,typicalHalfwidthCharacterWidth:ye,pixelRatio:Ce,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:gt,viewLineCount:ie,remainingWidth:mt,isViewportWrapping:ft},ge.memory||new S);yt.renderMinimap!==0&&yt.minimapLeft===0&&(et+=yt.minimapWidth,ut+=yt.minimapWidth,ct+=yt.minimapWidth,Ze+=yt.minimapWidth);const Et=mt-yt.minimapWidth,Ot=Math.max(1,Math.floor((Et-gt-2)/ye)),Tt=bt?pe:0;return ft&&(at=Math.max(1,Ot),Q==="bounded"&&(at=Math.min(at,oe))),{width:Ne,height:Ve,glyphMarginLeft:et,glyphMarginWidth:Je,lineNumbersLeft:ut,lineNumbersWidth:Te,decorationsLeft:ct,decorationsWidth:Me,contentLeft:Ze,contentWidth:Et,minimap:yt,viewportColumn:Ot,isWordWrapMinified:ht,isViewportWrapping:ft,wrappingColumn:at,verticalScrollbarWidth:gt,horizontalScrollbarHeight:ue,overviewRuler:{top:Tt,width:gt,height:Ve-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=j;class U extends k{constructor(){const Z={enabled:!0};super(53,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:v.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:d(Z.enabled,this.defaultValue.enabled)}}}class F extends k{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,description:v.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:d(ge.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class L extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(Z,ge,Ne){return Z.fontInfo.lineHeight}}class M extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:Z.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:v.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:d(ge.enabled,this.defaultValue.enabled),size:f(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(ge.side,this.defaultValue.side,["right","left"]),showSlider:f(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ge.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ge.scale,1,1,3),maxColumn:r.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function x(V){return V==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{top:r.clampedInt(ge.top,0,0,1e3),bottom:r.clampedInt(ge.bottom,0,0,1e3)}}}class J extends k{constructor(){const Z={enabled:!0,cycle:!1};super(72,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:v.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:d(ge.enabled,this.defaultValue.enabled),cycle:d(ge.cycle,this.defaultValue.cycle)}}}class te extends i{constructor(){super(124)}compute(Z,ge,Ne){return Z.pixelRatio}}class me extends k{constructor(){const Z={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:v.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:v.localize(59,null)},other:{type:"boolean",default:Z.other,description:v.localize(60,null)}}}],default:Z,description:v.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const ge=Z,Ne={other:d(ge.other,this.defaultValue.other),comments:d(ge.comments,this.defaultValue.comments),strings:d(ge.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Le;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Le=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class We extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(Z){let ge=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(ge=4,Ne=Z):Z==="interval"?ge=3:Z==="relative"?ge=2:Z==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ne}}}function Fe(V){const Z=V.get(84);return Z==="editable"?V.get(77):Z!=="on"}e.filterValidationDecorations=Fe;class ze extends k{constructor(){const Z=[],ge={type:"number",description:v.localize(67,null)};super(88,"rulers",Z,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:Z,description:v.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let ge=[];for(let Ne of Z)if(typeof Ne=="number")ge.push({column:r.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ve=Ne;ge.push({column:r.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return ge.sort((Ne,Ve)=>Ne.column-Ve.column),ge}return this.defaultValue}}function H(V,Z){if(typeof V!="string")return Z;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z,Ne=r.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=r.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:H(ge.vertical,this.defaultValue.vertical),horizontal:H(ge.horizontal,this.defaultValue.horizontal),useShadows:d(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:r.clampedInt(ge.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:r.clampedInt(ge.verticalSliderSize,Ve,0,1e3),scrollByPage:d(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(70,null),v.localize(71,null)],default:Z.insertMode,description:v.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:v.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:v.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:v.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:v.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:v.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:v.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:v.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{insertMode:f(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ge.showIcons,this.defaultValue.showIcons),showStatusBar:d(ge.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:d(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ge.showMethods,this.defaultValue.showMethods),showFunctions:d(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ge.showConstructors,this.defaultValue.showConstructors),showFields:d(ge.showFields,this.defaultValue.showFields),showVariables:d(ge.showVariables,this.defaultValue.showVariables),showClasses:d(ge.showClasses,this.defaultValue.showClasses),showStructs:d(ge.showStructs,this.defaultValue.showStructs),showInterfaces:d(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ge.showModules,this.defaultValue.showModules),showProperties:d(ge.showProperties,this.defaultValue.showProperties),showEvents:d(ge.showEvents,this.defaultValue.showEvents),showOperators:d(ge.showOperators,this.defaultValue.showOperators),showUnits:d(ge.showUnits,this.defaultValue.showUnits),showValues:d(ge.showValues,this.defaultValue.showValues),showConstants:d(ge.showConstants,this.defaultValue.showConstants),showEnums:d(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ge.showKeywords,this.defaultValue.showKeywords),showWords:d(ge.showWords,this.defaultValue.showWords),showColors:d(ge.showColors,this.defaultValue.showColors),showFiles:d(ge.showFiles,this.defaultValue.showFiles),showReferences:d(ge.showReferences,this.defaultValue.showReferences),showFolders:d(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ge.showSnippets,this.defaultValue.showSnippets),showUsers:d(ge.showUsers,this.defaultValue.showUsers),showIssues:d(ge.showIssues,this.defaultValue.showIssues)}}}class se extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(110,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ce extends i{constructor(){super(125,[77])}compute(Z,ge,Ne){return ge.get(77)?!0:Z.tabFocusMode}}var _e;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(_e=e.WrappingIndent||(e.WrappingIndent={}));function $e(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends i{constructor(){super(127,[126])}compute(Z,ge,Ne){const Ve=ge.get(126);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const De="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Re:T.isLinux?He:De,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function we(V){return e.editorOptionsRegistry[V.id]=V,V}var Ke;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useTabStops=111]="useTabStops",V[V.wordSeparators=112]="wordSeparators",V[V.wordWrap=113]="wordWrap",V[V.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=116]="wordWrapColumn",V[V.wordWrapOverride1=117]="wordWrapOverride1",V[V.wordWrapOverride2=118]="wordWrapOverride2",V[V.wrappingIndent=119]="wrappingIndent",V[V.wrappingStrategy=120]="wrappingStrategy",V[V.showDeprecated=121]="showDeprecated",V[V.inlayHints=122]="inlayHints",V[V.editorClassName=123]="editorClassName",V[V.pixelRatio=124]="pixelRatio",V[V.tabFocusMode=125]="tabFocusMode",V[V.layoutInfo=126]="layoutInfo",V[V.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(111,null)})),acceptSuggestionOnEnter:we(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(112,null),""],markdownDescription:v.localize(113,null)})),accessibilitySupport:we(new m),accessibilityPageSize:we(new r(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(114,null)})),ariaLabel:we(new p(4,"ariaLabel",v.localize(115,null))),autoClosingBrackets:we(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(116,null),v.localize(117,null),""],description:v.localize(118,null)})),autoClosingDelete:we(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(119,null),""],description:v.localize(120,null)})),autoClosingOvertype:we(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(121,null),""],description:v.localize(122,null)})),autoClosingQuotes:we(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(123,null),v.localize(124,null),""],description:v.localize(125,null)})),autoIndent:we(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[v.localize(126,null),v.localize(127,null),v.localize(128,null),v.localize(129,null),v.localize(130,null)],description:v.localize(131,null)})),automaticLayout:we(new g(10,"automaticLayout",!1)),autoSurround:we(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(132,null),v.localize(133,null),v.localize(134,null),""],description:v.localize(135,null)})),stickyTabStops:we(new g(101,"stickyTabStops",!1,{description:v.localize(136,null)})),codeLens:we(new g(12,"codeLens",!0,{description:v.localize(137,null)})),codeLensFontFamily:we(new p(13,"codeLensFontFamily","",{description:v.localize(138,null)})),codeLensFontSize:we(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(139,null)})),colorDecorators:we(new g(15,"colorDecorators",!0,{description:v.localize(140,null)})),columnSelection:we(new g(16,"columnSelection",!1,{description:v.localize(141,null)})),comments:we(new t),contextmenu:we(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new g(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(142,null)})),cursorBlinking:we(new o(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:v.localize(143,null)})),cursorSmoothCaretAnimation:we(new g(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(144,null)})),cursorStyle:we(new o(22,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:v.localize(145,null)})),cursorSurroundingLines:we(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(146,null)})),cursorSurroundingLinesStyle:we(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(147,null),v.localize(148,null)],description:v.localize(149,null)})),cursorWidth:we(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(150,null)})),disableLayerHinting:we(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:we(new g(28,"domReadOnly",!1)),dragAndDrop:we(new g(29,"dragAndDrop",!0,{description:v.localize(151,null)})),emptySelectionClipboard:we(new I),extraEditorClassName:we(new p(31,"extraEditorClassName","")),fastScrollSensitivity:we(new a(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:v.localize(152,null)})),find:we(new h),fixedOverflowWidgets:we(new g(34,"fixedOverflowWidgets",!1)),folding:we(new g(35,"folding",!0,{description:v.localize(153,null)})),foldingStrategy:we(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(154,null),v.localize(155,null)],description:v.localize(156,null)})),foldingHighlight:we(new g(37,"foldingHighlight",!0,{description:v.localize(157,null)})),unfoldOnClickAfterEndOfLine:we(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(158,null)})),fontFamily:we(new p(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(159,null)})),fontInfo:we(new R),fontLigatures2:we(new _),fontSize:we(new B),fontWeight:we(new z),formatOnPaste:we(new g(44,"formatOnPaste",!1,{description:v.localize(160,null)})),formatOnType:we(new g(45,"formatOnType",!1,{description:v.localize(161,null)})),glyphMargin:we(new g(46,"glyphMargin",!0,{description:v.localize(162,null)})),gotoLocation:we(new he),hideCursorInOverviewRuler:we(new g(48,"hideCursorInOverviewRuler",!1,{description:v.localize(163,null)})),highlightActiveIndentGuide:we(new g(49,"highlightActiveIndentGuide",!0,{description:v.localize(164,null)})),hover:we(new de),inDiffEditor:we(new g(51,"inDiffEditor",!1)),letterSpacing:we(new a(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>a.clamp(V,-5,20),{description:v.localize(165,null)})),lightbulb:we(new U),lineDecorationsWidth:we(new P(54,"lineDecorationsWidth",10)),lineHeight:we(new L),lineNumbers:we(new We),lineNumbersMinChars:we(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new g(58,"linkedEditing",!1,{description:v.localize(166,null)})),links:we(new g(59,"links",!0,{description:v.localize(167,null)})),matchBrackets:we(new E(60,"matchBrackets","always",["always","near","never"],{description:v.localize(168,null)})),minimap:we(new M),mouseStyle:we(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new a(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:v.localize(169,null)})),mouseWheelZoom:we(new g(64,"mouseWheelZoom",!1,{markdownDescription:v.localize(170,null)})),multiCursorMergeOverlapping:we(new g(65,"multiCursorMergeOverlapping",!0,{description:v.localize(171,null)})),multiCursorModifier:we(new o(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],x,{markdownEnumDescriptions:[v.localize(172,null),v.localize(173,null)],markdownDescription:v.localize(174,null)})),multiCursorPaste:we(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(175,null),v.localize(176,null)],markdownDescription:v.localize(177,null)})),occurrencesHighlight:we(new g(68,"occurrencesHighlight",!0,{description:v.localize(178,null)})),overviewRulerBorder:we(new g(69,"overviewRulerBorder",!0,{description:v.localize(179,null)})),overviewRulerLanes:we(new r(70,"overviewRulerLanes",3,0,3)),padding:we(new G),parameterHints:we(new J),peekWidgetDefaultFocus:we(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(180,null),v.localize(181,null)],description:v.localize(182,null)})),definitionLinkOpensInPeek:we(new g(74,"definitionLinkOpensInPeek",!1,{description:v.localize(183,null)})),quickSuggestions:we(new me),quickSuggestionsDelay:we(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(184,null)})),readOnly:we(new g(77,"readOnly",!1)),renameOnType:we(new g(78,"renameOnType",!1,{description:v.localize(185,null),markdownDeprecationMessage:v.localize(186,null)})),renderControlCharacters:we(new g(79,"renderControlCharacters",!1,{description:v.localize(187,null)})),renderIndentGuides:we(new g(80,"renderIndentGuides",!0,{description:v.localize(188,null)})),renderFinalNewline:we(new g(81,"renderFinalNewline",!0,{description:v.localize(189,null)})),renderLineHighlight:we(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(190,null)],description:v.localize(191,null)})),renderLineHighlightOnlyWhenFocus:we(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(192,null)})),renderValidationDecorations:we(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(193,null),v.localize(194,null),v.localize(195,null),""],description:v.localize(196,null)})),revealHorizontalRightPadding:we(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new g(87,"roundedSelection",!0,{description:v.localize(197,null)})),rulers:we(new ze),scrollbar:we(new q),scrollBeyondLastColumn:we(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(198,null)})),scrollBeyondLastLine:we(new g(91,"scrollBeyondLastLine",!0,{description:v.localize(199,null)})),scrollPredominantAxis:we(new g(92,"scrollPredominantAxis",!0,{description:v.localize(200,null)})),selectionClipboard:we(new g(93,"selectionClipboard",!0,{description:v.localize(201,null),included:T.isLinux})),selectionHighlight:we(new g(94,"selectionHighlight",!0,{description:v.localize(202,null)})),selectOnLineNumbers:we(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:we(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(203,null),v.localize(204,null)],description:v.localize(205,null)})),showUnused:we(new g(97,"showUnused",!0,{description:v.localize(206,null)})),showDeprecated:we(new g(121,"showDeprecated",!0,{description:v.localize(207,null)})),inlayHints:we(new F),snippetSuggestions:we(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(208,null),v.localize(209,null),v.localize(210,null),v.localize(211,null)],description:v.localize(212,null)})),smartSelect:we(new se),smoothScrolling:we(new g(100,"smoothScrolling",!1,{description:v.localize(213,null)})),stopRenderingLineAfter:we(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new ee),suggestFontSize:we(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(214,null)})),suggestLineHeight:we(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(215,null)})),suggestOnTriggerCharacters:we(new g(106,"suggestOnTriggerCharacters",!0,{description:v.localize(216,null)})),suggestSelection:we(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(217,null),v.localize(218,null),v.localize(219,null)],description:v.localize(220,null)})),tabCompletion:we(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null)],description:v.localize(224,null)})),tabIndex:we(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(225,null),v.localize(226,null),v.localize(227,null)],description:v.localize(228,null)})),useTabStops:we(new g(111,"useTabStops",!0,{description:v.localize(229,null)})),wordSeparators:we(new p(112,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:v.localize(230,null)})),wordWrap:we(new E(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(231,null),v.localize(232,null),v.localize(233,null),v.localize(234,null)],description:v.localize(235,null)})),wordWrapBreakAfterCharacters:we(new p(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new p(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(236,null)})),wordWrapOverride1:we(new E(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new E(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new o(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],$e,{enumDescriptions:[v.localize(237,null),v.localize(238,null),v.localize(239,null),v.localize(240,null)],description:v.localize(241,null)})),wrappingStrategy:we(new E(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(242,null),v.localize(243,null)],description:v.localize(244,null)})),editorClassName:we(new b),pixelRatio:we(new te),tabFocusMode:we(new ce),layoutInfo:we(new j),wrappingInfo:we(new fe)}}),define(ve[125],be([16,17]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[126],be([16,17]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[127],be([16,17]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ve[128],be([16,17]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(ve[129],be([16,17]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[130],be([16,17]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[131],be([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ve[132],be([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[133],be([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[134],be([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[135],be([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[136],be([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[137],be([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[138],be([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[139],be([16,17]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(ve[140],be([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[141],be([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[142],be([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[143],be([16,17]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[144],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var T;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(T=e.EditorOverride||(e.EditorOverride={}));var D;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[145],be([0,1,126]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function A(d){return d=d.trim(),d==="*"||T.test(d)}e.isValidVersionStr=A;function y(d){if(!A(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=d.match(T);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=y;function C(d){if(!d)return null;let g=d.majorBase,r=d.majorMustEqual,a=d.minorBase,p=d.minorMustEqual,f=d.patchBase,E=d.patchMustEqual;d.hasCaret&&(g===0||(p=!1),E=!1);let o=0;if(d.preRelease){const c=D.exec(d.preRelease);if(c){const[,m,t,n]=c;o=Date.UTC(Number(m),Number(t)-1,Number(n))}}return{majorBase:g,majorMustEqual:r,minorBase:a,minorMustEqual:p,patchBase:f,patchMustEqual:E,isMinimum:d.hasGreaterEquals,notBefore:o}}e.normalizeVersion=C;function S(d,g,r){let a;typeof d=="string"?a=C(y(d)):a=d;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let f;if(typeof r=="string"?f=C(y(r)):f=r,!a||!f)return!1;let E=a.majorBase,o=a.minorBase,c=a.patchBase,m=f.majorBase,t=f.minorBase,n=f.patchBase,l=f.notBefore,s=f.majorMustEqual,u=f.minorMustEqual,w=f.patchMustEqual;return f.isMinimum?E>m?!0:E<m?!1:o>t?!0:o<t||p&&p<l?!1:c>=n:(E===1&&m===0&&(!s||!u||!w)&&(m=1,t=0,n=0,s=!0,u=!1,w=!1),E<m?!1:E>m?!s:o<t?!1:o>t?!u:c<n?!1:c>n?!w:!(p&&p<l))}e.isValidVersion=S;function k(d,g,r,a){return r.isBuiltin||typeof r.main=="undefined"?!0:P(d,g,r.engines.vscode,a)}e.isValidExtensionVersion=k;function i(d,g,r){return d==="*"||P(g,r,d)}e.isEngineValid=i;function P(d,g,r,a=[]){let p=C(y(r));if(!p)return a.push(v.localize(0,null,r)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return a.push(v.localize(1,null,r)),!1}else if(!p.majorMustEqual)return a.push(v.localize(2,null,r)),!1;return S(d,g,p)?!0:(a.push(v.localize(3,null,d,r)),!1)}}),define(ve[90],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(A,y=[],C=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=v;const T=(D,...A)=>new v(D,A);e.createSyncDescriptor=T}),define(ve[61],be([0,1,90]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function D(y,C,S){C instanceof v.SyncDescriptor||(C=new v.SyncDescriptor(C,[],S)),T.push([y,C])}e.registerSingleton=D;function A(){return T}e.getSingletonServiceDescriptors=A}),define(ve[146],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=v;class T{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const C=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(y);C.outgoing.set(this._hashFn(y),S),S.incoming.set(this._hashFn(A),C)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let C of this._nodes.values())C.outgoing.delete(y),C.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let C=this._nodes.get(y);return C||(C=new v(A),this._nodes.set(y,C)),C}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,C]of this._nodes)A.push(`${y}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const C=new Set([A]),S=this._findCycle(y,C);if(S)return S}}_findCycle(A,y){for(let[C,S]of A.outgoing){if(y.has(C))return[...y,C].join(" -> ");y.add(C);const k=this._findCycle(S,y);if(k)return k;y.delete(C)}}}e.Graph=T}),define(ve[4],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(k){return k[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function T(C,S,k,i){S[v.DI_TARGET]===S?S[v.DI_DEPENDENCIES].push({id:C,index:k,optional:i}):(S[v.DI_DEPENDENCIES]=[{id:C,index:k,optional:i}],S[v.DI_TARGET]=S)}function D(C){if(v.serviceIds.has(C))return v.serviceIds.get(C);const S=function(k,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(S,k,P,!1)};return S.toString=()=>C,v.serviceIds.set(C,S),S}e.createDecorator=D;function A(C){return C}e.refineServiceDecorator=A;function y(C){return function(S,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(C,S,i,!0)}}e.optional=y}),define(ve[147],be([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,v.createDecorator)("modelService");function T(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(ve[148],be([0,1,3,56,6,22,82,59,147]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(k):!!d.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(g,r){let a={selector:g,provider:r,_score:-1,_time:this._clock++};return this._entries.push(a),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(a){let p=this._entries.indexOf(a);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),a=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const r=[];for(let a of this._entries)a._score>0&&r.push(a.provider);return r}ordered(g){const r=[];return this._orderedForEach(g,a=>r.push(a.provider)),r}orderedGroups(g){const r=[];let a,p;return this._orderedForEach(g,f=>{a&&p===f._score?a.push(f.provider):(p=f._score,a=[f.provider],r.push(a))}),r}_orderedForEach(g,r){if(!!g){this._updateScores(g);for(const a of this._entries)a._score>0&&r(a)}}_updateScores(g){let r={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let a of this._entries)if(a._score=(0,C.score)(a.selector,g.uri,g.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(g)),k(a.selector)&&a._score>0){for(let p of this._entries)p._score=0;a._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(g,r){return g._score<r._score?1:g._score>r._score?-1:g._time<r._time?1:g._time>r._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(g,r,a=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=r,this.max=a,this._cache=new A.LRUCache(50,.7)}_key(g){return g.id+(0,T.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const r=this._key(g),a=this._cache.get(r);return this._clamp(a==null?void 0:a.value)}update(g,r){const a=this._key(g);let p=this._cache.get(a);return p||(p=new y.MovingAverage,this._cache.set(a,p)),p.update(r),this.get(g)}}e.LanguageFeatureRequestDelays=P}),define(ve[62],be([0,1,2,32,148,120,36]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class S{constructor(_,R){this.language=_,this.id=R}}e.LanguageIdentifier=S;var k;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let R=this.getForeground(_),B="mtk"+R,z=this.getFontStyle(_);return z&1&&(B+=" mtki"),z&2&&(B+=" mtkb"),z&4&&(B+=" mtku"),B}static getInlineStyleFromMetadata(_,R){const B=this.getForeground(_),z=this.getFontStyle(_);let he=`color: ${R[B]};`;return z&1&&(he+="font-style: italic;"),z&2&&(he+="font-weight: bold;"),z&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=g;var r;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(_){const R=h[_];let B=R&&y.iconRegistry.get(R);return B||(console.info("No codicon found for CompletionItemKind "+_),B=y.Codicon.symbolProperty),B.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(_,R){let B=h[_];return typeof B=="undefined"&&!R&&(B=9),B}}();var a;(function(h){h[h.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var f;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function m(h){return h&&v.URI.isUri(h.uri)&&T.Range.isIRange(h.range)&&(T.Range.isIRange(h.originSelectionRange)||T.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=m;var t;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(h){h[h.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var l;(function(h){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function B(de){return _.get(de)}h.fromString=B;function z(de){return R.get(de)}h.toString=z;function he(de,W){const j=R.get(de);let U=j&&y.iconRegistry.get("symbol-"+j);return U||(console.info("No codicon found for SymbolKind "+de),U=y.Codicon.symbolProperty),`${W?"inline":"block"} ${U.classNames}`}h.toCssClassName=he})(l=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(_){this.value=_}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var u;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var b;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var I;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(I=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[149],be([0,1,6,10,4,3,45,43]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,D.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(S,k){if(!S)throw new Error("invalid command");if(typeof S=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:S,handler:k})}if(S.description){const r=[];for(let p of S.description.args)r.push(p.constraint);const a=S.handler;S.handler=function(p,...f){return(0,T.validateConstraints)(f,r),a(p,...f)}}const{id:i}=S;let P=this._commands.get(i);P||(P=new y.LinkedList,this._commands.set(i,P));let d=P.unshift(S),g=(0,v.toDisposable)(()=>{d();const r=this._commands.get(i);(r==null?void 0:r.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),g}registerCommandAlias(S,k){return e.CommandsRegistry.registerCommand(S,(i,...P)=>i.get(e.ICommandService).executeCommand(k,...P))}getCommand(S){const k=this._commands.get(S);if(!(!k||k.isEmpty()))return C.Iterable.first(k)}getCommands(){const S=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&S.set(k,i)}return S}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>v.Disposable.None,onDidExecuteCommand:()=>v.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(ve[63],be([0,1,8,4,21]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=D.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",D.isMacintosh),y.set("isLinux",D.isLinux),y.set("isWindows",D.isWindows),y.set("isWeb",D.isWeb),y.set("isMacNative",D.isMacintosh&&!D.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var S;(function(h){h[h.False=0]="False",h[h.True=1]="True",h[h.Defined=2]="Defined",h[h.Not=3]="Not",h[h.Equals=4]="Equals",h[h.NotEquals=5]="NotEquals",h[h.And=6]="And",h[h.Regex=7]="Regex",h[h.NotRegex=8]="NotRegex",h[h.Or=9]="Or",h[h.In=10]="In",h[h.NotIn=11]="NotIn",h[h.Greater=12]="Greater",h[h.GreaterEquals=13]="GreaterEquals",h[h.Smaller=14]="Smaller",h[h.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return d.INSTANCE}static has(_){return g.create(_)}static equals(_,R){return r.create(_,R)}static notEquals(_,R){return f.create(_,R)}static regex(_,R){return n.create(_,R)}static in(_,R){return a.create(_,R)}static not(_){return E.create(_)}static and(..._){return s.create(_)}static or(..._){return u.create(_)}static greater(_,R){return o.create(_,R)}static less(_,R){return m.create(_,R)}static deserialize(_,R=!1){if(!!_)return this._deserializeOrExpression(_,R)}static _deserializeOrExpression(_,R){let B=_.split("||");return u.create(B.map(z=>this._deserializeAndExpression(z,R)))}static _deserializeAndExpression(_,R){let B=_.split("&&");return s.create(B.map(z=>this._deserializeOne(z,R)))}static _deserializeOne(_,R){if(_=_.trim(),_.indexOf("!=")>=0){let B=_.split("!=");return f.create(B[0].trim(),this._deserializeValue(B[1],R))}if(_.indexOf("==")>=0){let B=_.split("==");return r.create(B[0].trim(),this._deserializeValue(B[1],R))}if(_.indexOf("=~")>=0){let B=_.split("=~");return n.create(B[0].trim(),this._deserializeRegexValue(B[1],R))}if(_.indexOf(" in ")>=0){let B=_.split(" in ");return a.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const B=_.split(">=");return c.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const B=_.split(">");return o.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const B=_.split("<=");return t.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const B=_.split("<");return m.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(_)?E.create(_.substr(1).trim()):g.create(_)}static _deserializeValue(_,R){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let B=/^'([^']*)'$/.exec(_);return B?B[1].trim():_}static _deserializeRegexValue(_,R){if((0,v.isFalsyOrWhitespace)(_)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let B=_.indexOf("/"),z=_.lastIndexOf("/");if(B===z||B<0){if(R)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let he=_.slice(B+1,z),de=_[z+1]==="i"?"i":"";try{return new RegExp(he,de)}catch(W){if(R)throw new Error(`bad regexp-value '${_}', parse error: ${W}`);return console.warn(`bad regexp-value '${_}', parse error: ${W}`),null}}}e.ContextKeyExpr=k;function i(h,_){return h.cmp(_)}class P{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class d{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class g{constructor(_){this.key=_,this.type=2}static create(_){const R=y.get(_);return typeof R=="boolean"?R?d.INSTANCE:P.INSTANCE:new g(_)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=g;class r{constructor(_,R){this.key=_,this.value=R,this.type=4}static create(_,R){if(typeof R=="boolean")return R?g.create(_):E.create(_);const B=y.get(_);return typeof B=="boolean"?R===(B?"true":"false")?d.INSTANCE:P.INSTANCE:new r(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class a{constructor(_,R){this.key=_,this.valueKey=R,this.type=10}static create(_,R){return new a(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}evaluate(_){const R=_.getValue(this.valueKey),B=_.getValue(this.key);return Array.isArray(R)?R.indexOf(B)>=0:typeof B=="string"&&typeof R=="object"&&R!==null?C.call(R,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=a;class p{constructor(_){this._actual=_,this.type=11}static create(_){return new p(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new p(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class f{constructor(_,R){this.key=_,this.value=R,this.type=5}static create(_,R){if(typeof R=="boolean")return R?E.create(_):g.create(_);const B=y.get(_);return typeof B=="boolean"?R===(B?"true":"false")?P.INSTANCE:d.INSTANCE:new f(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=f;class E{constructor(_){this.key=_,this.type=3}static create(_){const R=y.get(_);return typeof R=="boolean"?R?P.INSTANCE:d.INSTANCE:new E(_)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=E;class o{constructor(_,R){this.key=_,this.value=R,this.type=12}static create(_,R){return new o(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=o;class c{constructor(_,R){this.key=_,this.value=R,this.type=13}static create(_,R){return new c(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class m{constructor(_,R){this.key=_,this.value=R,this.type=14}static create(_,R){return new m(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=m;class t{constructor(_,R){this.key=_,this.value=R,this.type=15}static create(_,R){return new t(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(_,R){this.key=_,this.regexp=R,this.type=7}static create(_,R){return new n(_,R)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const R=this.regexp?this.regexp.source:"",B=_.regexp?_.regexp.source:"";return R<B?-1:R>B?1:0}equals(_){if(_.type===this.type){const R=this.regexp?this.regexp.source:"",B=_.regexp?_.regexp.source:"";return this.key===_.key&&R===B}return!1}evaluate(_){let R=_.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return l.create(this)}}e.ContextKeyRegexExpr=n;class l{constructor(_){this._actual=_,this.type=8}static create(_){return new l(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new l(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;class s{constructor(_){this.expr=_,this.type=6}static create(_){return s._normalizeArr(_)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let R=0,B=this.expr.length;R<B;R++){const z=i(this.expr[R],_.expr[R]);if(z!==0)return z}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let R=0,B=this.expr.length;R<B;R++)if(!this.expr[R].equals(_.expr[R]))return!1;return!0}return!1}evaluate(_){for(let R=0,B=this.expr.length;R<B;R++)if(!this.expr[R].evaluate(_))return!1;return!0}static _normalizeArr(_){const R=[];let B=!1;for(const z of _)if(!!z){if(z.type===1){B=!0;continue}if(z.type===0)return P.INSTANCE;if(z.type===6){R.push(...z.expr);continue}R.push(z)}if(R.length===0&&B)return d.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const z=R[R.length-1];if(z.type!==9)break;R.pop();const he=R.pop(),de=u.create(z.expr.map(W=>s.create([W,he])));de&&(R.push(de),R.sort(i))}return R.length===1?R[0]:new s(R)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let R of this.expr)_.push(...R.keys());return _}map(_){return new s(this.expr.map(R=>R.map(_)))}negate(){let _=[];for(let R of this.expr)_.push(R.negate());return u.create(_)}}e.ContextKeyAndExpr=s;class u{constructor(_){this.expr=_,this.type=9}static create(_){const R=u._normalizeArr(_);if(R.length!==0)return R.length===1?R[0]:new u(R)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let R=0,B=this.expr.length;R<B;R++){const z=i(this.expr[R],_.expr[R]);if(z!==0)return z}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let R=0,B=this.expr.length;R<B;R++)if(!this.expr[R].equals(_.expr[R]))return!1;return!0}return!1}evaluate(_){for(let R=0,B=this.expr.length;R<B;R++)if(this.expr[R].evaluate(_))return!0;return!1}static _normalizeArr(_){let R=[],B=!1;if(_){for(let z=0,he=_.length;z<he;z++){const de=_[z];if(!!de){if(de.type===0){B=!0;continue}if(de.type===1)return[d.INSTANCE];if(de.type===9){R=R.concat(de.expr);continue}R.push(de)}}if(R.length===0&&B)return[P.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let R of this.expr)_.push(...R.keys());return _}map(_){return new u(this.expr.map(R=>R.map(_)))}negate(){let _=[];for(let B of this.expr)_.push(B.negate());const R=B=>B.type===9?B.expr:[B];for(;_.length>1;){const B=_.shift(),z=_.shift(),he=[];for(const de of R(B))for(const W of R(z))he.push(k.and(de,W));_.unshift(k.or(...he))}return _[0]}}e.ContextKeyOrExpr=u;class w extends g{constructor(_,R,B){super(_);this._defaultValue=R,typeof B=="object"?w._info.push(Object.assign(Object.assign({},B),{key:_})):B!==!0&&w._info.push({key:_,description:B,type:R!=null?typeof R:void 0})}static all(){return w._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(_){return k.equals(this.key,_)}notEqualsTo(_){return k.notEquals(this.key,_)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(h,_){return h<_?-1:h>_?1:0}function I(h,_,R,B){return h<R?-1:h>R?1:_<B?-1:_>B?1:0}}),define(ve[150],be([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[26],be([0,1,8,4]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,P){if(typeof i=="undefined"||i===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof i=="string"||typeof P=="string"){let d=typeof i=="string"?i:i.value,g=typeof P=="string"?P:P.value;return v.equalsIgnoreCase(d,g)}return i._lower===P._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function C(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function S(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[151],be([0,1,8,26]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(g,r){return g.uuid&&r.uuid?g.uuid===r.uuid:g.id===r.id?!0:(0,v.compareIgnoreCase)(g.id,r.id)===0}e.areSameExtensions=D;class A{constructor(r,a){this.version=a,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof A?D(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(g,r){return`${g}.${r}`}e.getExtensionId=y;function C(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function S(g,r){return C(y(g,r))}e.getGalleryExtensionId=S;function k(g,r){const a=[],p=f=>{for(const E of a)if(E.some(o=>D(r(o),r(f))))return E;return null};for(const f of g){const E=p(f);E?E.push(f):a.push([f])}return a}e.groupByExtension=k;function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function d(g){const r=new Set;for(const a of g)a.malicious&&r.add(a.id.id);return r}e.getMaliciousExtensionsSet=d}),define(ve[64],be([0,1,127,14,2,4,8,10,22]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function k(W){return W.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(W){W[W.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var d;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=g;function r(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=r;function a(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function p(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=p;var f;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(j,U){super(j);this.code=U}}e.FileSystemProviderError=E;function o(W,j){const U=new E(W.toString(),j);return m(U,j),U}e.createFileSystemProviderError=o;function c(W){return W||o((0,v.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=c;function m(W,j){return W.name=j?`${j} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=m;function t(W){if(!W)return f.Unknown;if(W instanceof E)return W.code;const j=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!j)return f.Unknown;switch(j[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=t;function n(W){if(W instanceof I)return W.fileOperationResult;switch(t(W)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var l;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(l=e.FileOperation||(e.FileOperation={}));class s{constructor(j,U,F){this.resource=j,this.operation=U,this.target=F}isOperation(j){return this.operation===j}}e.FileOperationEvent=s;var u;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class w{constructor(j,U){this.ignorePathCasing=U,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const F of j)switch(F.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(F.resource,F);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(F.resource,F);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(F.resource,F);break}}contains(j,...U){return this.doContains(j,{includeChildren:!1},...U)}affects(j,...U){return this.doContains(j,{includeChildren:!0},...U)}doContains(j,U,...F){var L,M,x,G,J,te;if(!j)return!1;const me=F.length>0;return!!((!me||F.includes(1))&&(((L=this.added)===null||L===void 0?void 0:L.get(j))||U.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(j)))||(!me||F.includes(0))&&(((x=this.updated)===null||x===void 0?void 0:x.get(j))||U.includeChildren&&((G=this.updated)===null||G===void 0?void 0:G.findSuperstr(j)))||(!me||F.includes(2))&&(((J=this.deleted)===null||J===void 0?void 0:J.findSubstr(j))||U.includeChildren&&((te=this.deleted)===null||te===void 0?void 0:te.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const U=[],F=j===1?this.added:j===0?this.updated:this.deleted;if(F)for(const[,L]of F)U.push(L);return U}filter(j){return new w(this.changes.filter(U=>j(U)),this.ignorePathCasing)}}e.FileChangesEvent=w;function b(W,j,U){return!W||!j||W===j||j.length>W.length?!1:(j.charAt(j.length-1)!==T.sep&&(j+=T.sep),U?(0,y.startsWithIgnoreCase)(W,j):W.indexOf(j)===0)}e.isParent=b;class I extends Error{constructor(j,U,F){super(j);this.fileOperationResult=U,this.options=F}static isFileOperationError(j){return j instanceof Error&&!(0,C.isUndefinedOrNull)(j.fileOperationResult)}}e.FileOperationError=I;var h;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(h=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=R;async function B(W,j){if(!j.canHandleResource(D.URI.from({scheme:W.scheme})))return new Promise(U=>{const F=j.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===W.scheme&&L.added&&(F.dispose(),U())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(j){return(0,C.isNumber)(j)||(j=0),j<z.KB?(0,v.localize)(1,null,j.toFixed(0)):j<z.MB?(0,v.localize)(2,null,(j/z.KB).toFixed(2)):j<z.GB?(0,v.localize)(3,null,(j/z.MB).toFixed(2)):j<z.TB?(0,v.localize)(4,null,(j/z.GB).toFixed(2)):(0,v.localize)(5,null,(j/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var he;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(he=e.Arch||(e.Arch={}));function de(W){return{maxFileSize:W===0?300*z.MB:16*z.GB,maxHeapSize:W===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=de}),define(ve[65],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[A,y]of D)this.set(A,y)}set(D,A){const y=this._entries.get(D);return this._entries.set(D,A),y}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(ve[152],be([0,1,12,146,90,4,65,11]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class k extends Error{constructor(r){var a;super("cyclic dependency between services");this.message=(a=r.findCycleSlow())!==null&&a!==void 0?a:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class i{constructor(r=new y.ServiceCollection,a=!1,p){this._activeInstantiations=new Set,this._services=r,this._strict=a,this._parent=p,this._services.set(A.IInstantiationService,this)}createChild(r){return new i(r,this._strict,this)}invokeFunction(r,...a){let p=d.traceInvocation(r),f=!1;try{return r({get:(o,c)=>{if(f)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(o,p);if(!m&&c!==A.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return m}},...a)}finally{f=!0,p.stop()}}createInstance(r,...a){let p,f;return r instanceof D.SyncDescriptor?(p=d.traceCreation(r.ctor),f=this._createInstance(r.ctor,r.staticArguments.concat(a),p)):(p=d.traceCreation(r),f=this._createInstance(r,a,p)),p.stop(),f}_createInstance(r,a=[],p){let f=A._util.getServiceDependencies(r).sort((c,m)=>c.index-m.index),E=[];for(const c of f){let m=this._getOrCreateServiceInstance(c.id,p);if(!m&&this._strict&&!c.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${c.id}.`);E.push(m)}let o=f.length>0?f[0].index:a.length;if(a.length!==o){console.warn(`[createInstance] First service dependency of ${r.name} at position ${o+1} conflicts with ${a.length} static arguments`);let c=o-a.length;c>0?a=a.concat(new Array(c)):a=a.slice(0,o)}return new r(...[...a,...E])}_setServiceInstance(r,a){if(this._services.get(r)instanceof D.SyncDescriptor)this._services.set(r,a);else if(this._parent)this._parent._setServiceInstance(r,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let a=this._services.get(r);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):a}_getOrCreateServiceInstance(r,a){let p=this._getServiceInstanceOrDescriptor(r);return p instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,p,a.branch(r,!0)):(a.branch(r,!1),p)}_safeCreateAndCacheServiceInstance(r,a,p){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,a,p)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,a,p){const f=new T.Graph(c=>c.id.toString());let E=0;const o=[{id:r,desc:a,_trace:p}];for(;o.length;){const c=o.pop();if(f.lookupOrInsertNode(c),E++>1e3)throw new k(f);for(let m of A._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(m.id);if(!t&&!m.optional&&console.warn(`[createInstance] ${r} depends on ${m.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const n={id:m.id,desc:t,_trace:c._trace.branch(m.id,!0)};f.insertEdge(c,n),o.push(n)}}}for(;;){const c=f.roots();if(c.length===0){if(!f.isEmpty())throw new k(f);break}for(const{data:m}of c){if(this._getServiceInstanceOrDescriptor(m.id)instanceof D.SyncDescriptor){const n=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,n)}f.removeNode(m)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,a,p=[],f,E){if(this._services.get(r)instanceof D.SyncDescriptor)return this._createServiceInstance(a,p,f,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,a,p,f,E);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(r,a=[],p,f){if(p){const E=new C.IdleValue(()=>this._createInstance(r,a,f));return new Proxy(Object.create(null),{get(o,c){if(c in o)return o[c];let m=E.value,t=m[c];return typeof t!="function"||(t=t.bind(m),o[c]=t),t},set(o,c,m){return E.value[c]=m,!0}})}else return this._createInstance(r,a,f)}}e.InstantiationService=i;var P;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(P||(P={}));class d{constructor(r,a){this.type=r,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return S?new d(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(r){return S?new d(0,r.name):d._None}branch(r,a){let p=new d(2,r.toString());return this._dep.push([r,a,p]),p}stop(){let r=Date.now()-this._start;d._totals+=r;let a=!1;function p(E,o){let c=[],m=new Array(E+1).join("	");for(const[t,n,l]of o._dep)if(n&&l){a=!0,c.push(`${m}CREATES -> ${t}`);let s=p(E+1,l);s&&c.push(s)}else c.push(`${m}uses -> ${t}`);return c.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(r>2||a)&&console.log(f.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(ve[18],be([0,1,4,6,21,3,60]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function C(){return new Date().toISOString()}var S;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class k extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(S.Error))if(t instanceof Error){const l=Array.prototype.slice.call(arguments);l[0]=t.stack,this.log(S.Error,this.format(l))}else this.log(S.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let l=0;l<t.length;l++){let s=t[l];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}n+=(l>0?" ":"")+s}return n}}e.AbstractMessageLogger=i;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...n){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}debug(t,...n){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}info(t,...n){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}warn(t,...n){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...n):console.warn(`[main ${C()}]`,t,...n))}error(t,...n){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}critical(t,...n){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class d extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class g extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class r extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const l of this.logServices)l.trace(t,...n)}debug(t,...n){for(const l of this.logServices)l.debug(t,...n)}info(t,...n){for(const l of this.logServices)l.info(t,...n)}warn(t,...n){for(const l of this.logServices)l.warn(t,...n)}error(t,...n){for(const l of this.logServices)l.error(t,...n)}critical(t,...n){for(const l of this.logServices)l.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class a extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=a;class p extends T.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(l=>{this.logLevel=l,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(l))}))}createLogger(t,n){let l=this.loggers.get(t.toString());return l||(l=this.doCreateLogger(t,(n==null?void 0:n.always)?S.Trace:this.logLevel,n),this.loggers.set(t.toString(),l),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(l)),l}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class f{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=f;function E(m){if(m.verbose)return S.Trace;if(typeof m.logLevel=="string"){const t=o(m.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function o(m){switch(m){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=o;function c(m){switch(m){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=c}),define(ve[91],be([0,1,4,128,47]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(r,a){return a-r}S.compare=k;const i=Object.create(null);i[S.Error]=(0,T.localize)(0,null),i[S.Warning]=(0,T.localize)(1,null),i[S.Info]=(0,T.localize)(2,null);function P(r){return i[r]||""}S.toString=P;function d(r){switch(r){case D.default.Error:return S.Error;case D.default.Warning:return S.Warning;case D.default.Info:return S.Info;case D.default.Ignore:return S.Hint}}S.fromSeverity=d;function g(r){switch(r){case S.Error:return D.default.Error;case S.Warning:return D.default.Warning;case S.Info:return D.default.Info;case S.Hint:return D.default.Ignore}}S.toSeverity=g}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(S){const k="";function i(d){return P(d,!0)}S.makeKey=i;function P(d,g){let r=[k];return d.source?r.push(d.source.replace("\xA6","\\\xA6")):r.push(k),d.code?typeof d.code=="string"?r.push(d.code.replace("\xA6","\\\xA6")):r.push(d.code.value.replace("\xA6","\\\xA6")):r.push(k),d.severity!==void 0&&d.severity!==null?r.push(y.toString(d.severity)):r.push(k),d.message&&g?r.push(d.message.replace("\xA6","\\\xA6")):r.push(k),d.startLineNumber!==void 0&&d.startLineNumber!==null?r.push(d.startLineNumber.toString()):r.push(k),d.startColumn!==void 0&&d.startColumn!==null?r.push(d.startColumn.toString()):r.push(k),d.endLineNumber!==void 0&&d.endLineNumber!==null?r.push(d.endLineNumber.toString()):r.push(k),d.endColumn!==void 0&&d.endColumn!==null?r.push(d.endColumn.toString()):r.push(k),r.push(k),r.join("\xA6")}S.makeKeyOptionalMessage=P})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,v.createDecorator)("markerService")}),define(ve[153],be([0,1,47,4,3]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=(0,T.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new S,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=C;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S});var je=this&&this.__decorate||function(Y,e,v,T){var D=arguments.length,A=D<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,v):T,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Y,e,v,T);else for(var C=Y.length-1;C>=0;C--)(y=Y[C])&&(A=(D<3?y(A):D>3?y(e,v,A):y(e,v))||A);return D>3&&A&&Object.defineProperty(e,v,A),A},qe=this&&this.__param||function(Y,e){return function(v,T){e(v,T,Y)}};define(ve[154],be([0,1,4,20,6,11]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,v.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let S=class extends D.Disposable{constructor(P,d){super();this.deferred=new A.DeferredPromise,d.withProgress(P,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};S=je([qe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends D.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(P){this.stop();const d=++this.currentOperationId,g=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:g.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,v.createDecorator)("editorProgressService")}),define(ve[29],be([0,1,10,42]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(y,C){T.ok(v.isString(y)),T.ok(v.isObject(C)),T.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,C)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new D}),define(ve[92],be([0,1,29,3]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class A{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,k){this.schemasById[D(S)]=k,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;v.Registry.add(e.Extensions.JSONContribution,y)}),define(ve[66],be([0,1,125,3,29,10,92]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=D.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(f,E=!0){this.registerConfigurations([f],E)}registerConfigurations(f,E=!0){const o=[];f.forEach(c=>{o.push(...this.validateAndRegisterProperties(c,E,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(f){const E=[],o=c=>{if(c.properties)for(const m in c.properties)E.push(m),delete this.configurationProperties[m],this.removeFromSchema(m,c.properties[m]);c.allOf&&c.allOf.forEach(m=>o(m))};for(const c of f){o(c);const m=this.configurationContributors.indexOf(c);m!==-1&&this.configurationContributors.splice(m,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(f){const E=[],o=[];for(const c of f)for(const m in c)if(E.push(m),e.OVERRIDE_PROPERTY_PATTERN.test(m)){this.defaultValues[m]=Object.assign(Object.assign({},this.defaultValues[m]||{}),c[m]);const t={type:"object",default:this.defaultValues[m],description:v.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId};o.push(P(m)),this.configurationProperties[m]=t,this.defaultLanguageConfigurationOverridesNode.properties[m]=t}else{this.defaultValues[m]=c[m];const t=this.configurationProperties[m];t&&(this.updatePropertyDefaultValue(m,t),this.updateSchema(m,t))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(f){const E=[];for(const o of f)for(const c in o)if(E.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const m=this.configurationProperties[c];m&&(this.updatePropertyDefaultValue(c,m),this.updateSchema(c,m))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const E of f)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(f,E=!0,o,c=3){var m;c=A.isUndefinedOrNull(f.scope)?c:f.scope;let t=[],n=f.properties;if(n)for(let s in n){if(E&&r(s)){delete n[s];continue}const u=n[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=A.isUndefinedOrNull(u.scope)?c:u.scope,u.restricted=A.isUndefinedOrNull(u.restricted)?!!((m=o==null?void 0:o.restrictedConfigurations)===null||m===void 0?void 0:m.includes(s)):u.restricted),n[s].hasOwnProperty("included")&&!n[s].included){this.excludedConfigurationProperties[s]=n[s],delete n[s];continue}else this.configurationProperties[s]=n[s];!n[s].deprecationMessage&&n[s].markdownDeprecationMessage&&(n[s].deprecationMessage=n[s].markdownDeprecationMessage),t.push(s)}let l=f.allOf;if(l)for(let s of l)t.push(...this.validateAndRegisterProperties(s,E,o,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(f){const E=o=>{let c=o.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let m=o.allOf;m&&m.forEach(E)};E(f)}updateSchema(f,E){switch(e.allSettings.properties[f]=E,E.scope){case 1:e.applicationSettings.properties[f]=E;break;case 2:e.machineSettings.properties[f]=E;break;case 6:e.machineOverridableSettings.properties[f]=E;break;case 3:e.windowSettings.properties[f]=E;break;case 4:e.resourceSettings.properties[f]=E;break;case 5:e.resourceSettings.properties[f]=E,this.resourceLanguageSettingsSchema.properties[f]=E;break}}removeFromSchema(f,E){switch(delete e.allSettings.properties[f],E.scope){case 1:delete e.applicationSettings.properties[f];break;case 2:delete e.machineSettings.properties[f];break;case 6:delete e.machineOverridableSettings.properties[f];break;case 3:delete e.windowSettings.properties[f];break;case 4:case 5:delete e.resourceSettings.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const E=`[${f}]`,o={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,o),e.allSettings.properties[E]=o,e.applicationSettings.properties[E]=o,e.machineSettings.properties[E]=o,e.machineOverridableSettings.properties[E]=o,e.windowSettings.properties[E]=o,e.resourceSettings.properties[E]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,E){let o=this.defaultValues[f];A.isUndefined(o)&&(o=E.default),A.isUndefined(o)&&(o=d(E.type)),E.default=o}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function P(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=P;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new k;D.Registry.add(e.Extensions.Configuration,g);function r(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?v.localize(5,null,p):g.getConfigurationProperties()[p]!==void 0?v.localize(6,null,p):null:v.localize(4,null)}e.validateProperty=r;function a(){const p=[],f=g.getConfigurationProperties();for(const E of Object.keys(f))p.push([E,f[E].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=a}),define(ve[93],be([0,1,23,10,2,29,4,66]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function S(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof D.URI)}e.isConfigurationOverrides=S;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(n,l){const s=l?n?l.keys.filter(R=>n.keys.indexOf(R)===-1):[...l.keys]:[],u=n?l?n.keys.filter(R=>l.keys.indexOf(R)===-1):[...n.keys]:[],w=[];if(l&&n){for(const R of n.keys)if(l.keys.indexOf(R)!==-1){const B=f(n.contents,R),z=f(l.contents,R);v.equals(B,z)||w.push(R)}}const b=[],I=R=>{const B={};for(const z of R)for(const he of z.identifiers)B[m(he)]=z;return B},h=l?I(l.overrides):{},_=n?I(n.overrides):{};if(Object.keys(h).length)for(const R of s){const B=h[R];B&&b.push([(0,C.overrideIdentifierFromKey)(R),B.keys])}if(Object.keys(_).length)for(const R of u){const B=_[R];B&&b.push([(0,C.overrideIdentifierFromKey)(R),B.keys])}if(Object.keys(h).length&&Object.keys(_).length)for(const R of w){const B=_[R],z=h[R];if(B&&z){const he=P({contents:B.contents,keys:B.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});b.push([(0,C.overrideIdentifierFromKey)(R),[...he.added,...he.removed,...he.updated]])}}return{added:s,removed:u,updated:w,overrides:b}}e.compare=P;function d(n,l){const s=[];for(const u of Object.keys(n))if(C.OVERRIDE_PROPERTY_PATTERN.test(u)){const w={};for(const b in n[u])w[b]=n[u][b];s.push({identifiers:[(0,C.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(w),contents:g(w,l)})}return s}e.toOverrides=d;function g(n,l){const s=Object.create(null);for(let u in n)r(s,u,n[u],l);return s}e.toValuesTree=g;function r(n,l,s,u){const w=l.split("."),b=w.pop();let I=n;for(let h=0;h<w.length;h++){let _=w[h],R=I[_];switch(typeof R){case"undefined":R=I[_]=Object.create(null);break;case"object":break;default:u(`Ignoring ${l} as ${w.slice(0,h+1).join(".")} is ${JSON.stringify(R)}`);return}I=R}if(typeof I=="object"&&I!==null)try{I[b]=s}catch(h){u(`Ignoring ${l} as ${w.join(".")} is ${JSON.stringify(I)}`)}else u(`Ignoring ${l} as ${w.join(".")} is ${JSON.stringify(I)}`)}e.addToValueTree=r;function a(n,l){const s=l.split(".");p(n,s)}e.removeFromValueTree=a;function p(n,l){const s=l.shift();if(l.length===0){delete n[s];return}if(Object.keys(n).indexOf(s)!==-1){const u=n[s];typeof u=="object"&&!Array.isArray(u)&&(p(u,l),Object.keys(u).length===0&&delete n[s])}}function f(n,l,s){function u(I,h){let _=I;for(const R of h){if(typeof _!="object"||_===null)return;_=_[R]}return _}const w=l.split("."),b=u(n,w);return typeof b=="undefined"?s:b}e.getConfigurationValue=f;function E(n,l,s){Object.keys(l).forEach(u=>{u!=="__proto__"&&(u in n?T.isObject(n[u])&&T.isObject(l[u])?E(n[u],l[u],s):s&&(n[u]=l[u]):n[u]=l[u])})}e.merge=E;function o(){const n=A.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=o;function c(){const n=Object.create(null),l=A.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let s in l){let u=l[s].default;r(n,s,u,w=>console.error(`Conflict in default settings: ${w}`))}return n}e.getDefaultValues=c;function m(n){return`[${n}]`}e.keyFromOverrideIdentifier=m;function t(n,l,s){const u=n.inspect(l),w=n.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:u.defaultValue}e.getMigratedSettingValue=t}),define(ve[155],be([0,1,44,22,13,10,23,2,66,93,29,6,3]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},n=[],l=[]){this._contents=t,this._keys=n,this._overrides=l,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const l=this.getContentsForOverrideIdentifer(n);return l?t?(0,k.getConfigurationValue)(l,t):l:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let l={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[s],w=n[s];w&&(typeof u=="object"&&typeof w=="object"?(u=y.deepClone(u),this.mergeContents(u,w)):u=w),l[s]=u}return new g(l,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),l=y.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(n,u.contents);for(const w of u.overrides){const[b]=l.filter(I=>D.equals(I.identifiers,w.identifiers));b?this.mergeContents(b.contents,w.contents):l.push(y.deepClone(w))}for(const w of u.keys)s.indexOf(w)===-1&&s.push(w)}return new g(n,s,l)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const l of Object.keys(n)){if(l in t&&A.isObject(t[l])&&A.isObject(n[l])){this.mergeContents(t[l],n[l]);continue}t[l]=y.deepClone(n[l])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,l=>{throw new Error(l)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let l=0;l<n;l++)t.indexOf(this.keys[l])===0&&(n=l);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=g;class r extends g{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),l=[];for(const s of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(s)&&l.push({identifiers:[(0,S.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,k.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,n,l)}}e.DefaultConfigurationModel=r;class a{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const l=this.doParseContent(t);this.parseRaw(l,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:l,keys:s,overrides:u,restricted:w}=this.doParseRaw(t,n);this._configurationModel=new g(l,s,u),this._restrictedConfigurations=w||[]}doParseContent(t){let n={},l=null,s=[],u=[],w=[];function b(h){Array.isArray(s)?s.push(h):l&&(s[l]=h)}let I={onObjectBegin:()=>{let h={};b(h),u.push(s),s=h,l=null},onObjectProperty:h=>{l=h},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let h=[];b(h),u.push(s),s=h,l=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:b,onError:(h,_,R)=>{w.push({error:h,offset:_,length:R})}};if(t)try{v.visit(t,I),n=s[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return n}doParseRaw(t,n){const l=i.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,l,!0,n);t=s.raw;const u=(0,k.toValuesTree)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),w=Object.keys(t),b=(0,k.toOverrides)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:u,keys:w,overrides:b,restricted:s.restricted}}filter(t,n,l,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:t,restricted:[]};const u={},w=[];for(let b in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(b)&&l){const I=this.filter(t[b],n,!1,s);u[b]=I.raw,w.push(...I.restricted)}else{const I=n[b],h=I?typeof I.scope!="undefined"?I.scope:3:void 0;(I==null?void 0:I.restricted)&&w.push(b),(h===void 0||s.scopes===void 0||s.scopes.includes(h))&&(s.skipRestricted&&(I==null?void 0:I.restricted)||(u[b]=t[b]))}return{raw:u,restricted:w}}}e.ConfigurationModelParser=a;class p extends P.Disposable{constructor(t,n,l,s){super();this.userSettingsResource=t,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class f{constructor(t,n,l=new g,s=new g,u=new T.ResourceMap,w=new g,b=new T.ResourceMap,I=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=l,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=w,this._memoryConfigurationByResource=b,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,n,l){return this.getConsolidateConfigurationModel(n,l).getValue(t)}updateValue(t,n,l={}){let s;l.resource?(s=this._memoryConfigurationByResource.get(l.resource),s||(s=new g,this._memoryConfigurationByResource.set(l.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(t):s.setValue(t,n),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,l){const s=this.getConsolidateConfigurationModel(n,l),u=this.getFolderConfigurationModelForResource(n.resource,l),w=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,b=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),I=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),h=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=l?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,B=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,z=n.overrideIdentifier?w.override(n.overrideIdentifier).getValue(t):w.getValue(t),he=s.getValue(t),de=D.distinct(D.flatten(s.overrides.map(W=>W.identifiers))).filter(W=>s.getOverrideValue(t,W)!==void 0);return{defaultValue:b,userValue:I,userLocalValue:h,userRemoteValue:_,workspaceValue:R,workspaceFolderValue:B,memoryValue:z,value:he,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:n.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:w.getValue(t),override:n.overrideIdentifier?w.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:de.length?de:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const l=n.filter(s=>S.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,S.overrideIdentifierFromKey)(s),w=this._defaultConfiguration.getKeysForOverrideIdentifier(u),b=t.getKeysForOverrideIdentifier(u),I=[...b.filter(h=>w.indexOf(h)===-1),...w.filter(h=>b.indexOf(h)===-1),...w.filter(h=>!y.equals(this._defaultConfiguration.override(u).getValue(h),t.override(u).getValue(h)))];return[u,I]});return this.updateDefaultConfiguration(t),{keys:n,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:l,removed:s,overrides:u}=(0,k.compare)(this.localUserConfiguration,t),w=[...n,...l,...s];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:l,removed:s,overrides:u}=(0,k.compare)(this.remoteUserConfiguration,t);let w=[...n,...l,...s];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:l,removed:s,overrides:u}=(0,k.compare)(this.workspaceConfiguration,t);let w=[...n,...l,...s];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const l=this.folderConfigurations.get(t),{added:s,updated:u,removed:w,overrides:b}=(0,k.compare)(l,n);let I=[...s,...u,...w];return(I.length||!l)&&this.updateFolderConfiguration(t,n),{keys:I,overrides:b}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:l,updated:s,removed:u,overrides:w}=(0,k.compare)(n,void 0);return{keys:[...l,...s,...u],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let l=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?l.override(t.overrideIdentifier):l}getConsolidatedConfigurationModelForResource({resource:t},n){let l=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const s=n.getFolder(t);s&&(l=this.getFolderConsolidatedConfiguration(s.uri)||l);const u=this._memoryConfigurationByResource.get(t);u&&(l=l.merge(u))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const l=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(n=l.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=l}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const l=n.getFolder(t);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:l,overrides:s,keys:u}=this._folderConfigurations.get(n);return t.push([n,{contents:l,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(l=>t.add(l))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),l=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((w,b)=>(w.set(C.URI.revive(b[0]),this.parseConfigurationModel(b[1])),w),new T.ResourceMap);return new f(n,l,new g,s,u,new g,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=f;function E(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const t=new Set,n=new Map;for(const s of m)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,w])=>{const b=(0,T.getOrSet)(n,u,new Set);w.forEach(I=>b.add(I))});const l=[];return n.forEach((s,u)=>l.push([u,[...s.values()]])),{keys:[...t.values()],overrides:l}}e.mergeChanges=E;class o{constructor(t,n,l,s){this.change=t,this.previous=n,this.currentConfiguraiton=l,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(b=>u.add(b)),t.overrides.forEach(([,b])=>b.forEach(I=>u.add(I))),this.affectedKeys=[...u.values()];const w=new g;this.affectedKeys.forEach(b=>w.setValue(b,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var l;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(l=this.previous)===null||l===void 0?void 0:l.workspace):void 0,u=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let l=(0,k.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof l=="object"&&(s=Object.keys(l)[0]);){if(t=t[s],!t)return!1;l=l[s]}return!0}}e.ConfigurationChangeEvent=o;class c extends o{constructor(t,n,l,s){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=l,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=c}),define(ve[67],be([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var T;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(T=e.RemoteTrustOption||(e.RemoteTrustOption={}));var D;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(C,S=D.Unknown,k){super(C);this._message=C,this._code=S,this._detail=k,this.isHandled=S===D.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(C){return C instanceof A&&C._code===D.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof A&&C._code===D.NoResolverFound}static isHandled(C){return C instanceof A&&C.isHandled}}e.RemoteAuthorityResolverError=A}),define(ve[94],be([0,1,19]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function T(S){return S.scheme===v.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=T;function D(S){if(!!S){const k=S.indexOf("+");return k<0?S:S.substr(0,k)}}e.getRemoteName=D;function A(S){return S.scheme!==v.Schemas.file&&S.scheme!==v.Schemas.vscodeRemote}function y(S){if(S.folders.length)return S.folders.every(k=>A(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&A(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function C(S){var k;return(k=y(S))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=C}),define(ve[156],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,A,y=5){let C;return C=A(S=>{const k=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(D);if(i){i.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(D),y);i={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(D),C.dispose()}},this._terminalBufferMap.set(D,i)}),C}stopBuffering(D){const A=this._terminalBufferMap.get(D);A&&A.dispose()}flushBuffer(D){const A=this._terminalBufferMap.get(D);A&&(this._terminalBufferMap.delete(D),this._callback(D,A.data.join("")))}}e.TerminalDataBufferer=v}),define(ve[157],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(ve[158],be([0,1,4,6,29,3,157,36]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var S;(function(p){function f(E){return E&&typeof E=="object"&&typeof E.id=="string"}p.isThemeColor=f})(S=e.ThemeColor||(e.ThemeColor={}));function k(p){return{id:p}}e.themeColorFromId=k;var i;(function(p){function f(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}p.isThemeIcon=f;const E=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function o(t){const n=E.exec(t);if(!!n){let[,l]=n;return{id:l}}}p.fromString=o;function c(t,n){let l=t.id;const s=l.lastIndexOf("~");return s!==-1&&(l=l.substring(0,s)),n&&(l=`${l}~${n}`),{id:l}}p.modify=c;function m(t,n){var l,s;return t.id===n.id&&((l=t.color)===null||l===void 0?void 0:l.id)===((s=n.color)===null||s===void 0?void 0:s.id)}p.isEqual=m,p.asClassNameArray=C.CSSIcon.asClassNameArray,p.asClassName=C.CSSIcon.asClassName,p.asCSSSelector=C.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function P(p){switch(p){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,T.toDisposable)(()=>{const E=this.themingParticipants.indexOf(f);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new d;D.Registry.add(e.Extensions.ThemingContribution,g);function r(p){return g.onColorThemeChange(p)}e.registerThemingParticipant=r;class a extends T.Disposable{constructor(f){super();this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,E){let o=this.theme.getColor(f);return o&&E&&(o=E(o,this.theme)),o?o.toString():null}}e.Themable=a}),define(ve[159],be([0,1,29,158,3,129,92,11,36]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${S.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(f,E,o,c){const m=this.iconsById[f];if(m){if(o&&!m.description){m.description=o,this.iconSchema.properties[f].markdownDescription=`${o} $(${f})`;const l=this.iconReferenceSchema.enum.indexOf(f);l!==-1&&(this.iconReferenceSchema.enumDescriptions[l]=o),this._onDidChange.fire()}return m}let t={id:f,description:o,defaults:E,deprecationMessage:c};this.iconsById[f]=t;let n={$ref:"#/definitions/icons"};return c&&(n.deprecationMessage=c),o&&(n.markdownDescription=`${o}: $(${f})`),this.iconSchema.properties[f]=n,this.iconReferenceSchema.enum.push(f),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:f}}deregisterIcon(f){delete this.iconsById[f],delete this.iconSchema.properties[f];const E=this.iconReferenceSchema.enum.indexOf(f);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(f=>this.iconsById[f])}getIcon(f){return this.iconsById[f]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(f,E){const o=this.iconFontsById[f];if(o)return o;let c={id:f,definition:E};return this.iconFontsById[f]=c,this._onDidChange.fire(),c}deregisterIconFont(f){delete this.iconFontsById[f]}getIconFonts(){return Object.keys(this.iconFontsById).map(f=>this.iconFontsById[f])}getIconFont(f){return this.iconFontsById[f]}toString(){const f=(m,t)=>m.id.localeCompare(t.id),E=m=>{for(;T.ThemeIcon.isThemeIcon(m.defaults);)m=this.iconsById[m.defaults.id];return`codicon codicon-${m?m.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(m=>this.iconsById[m]);for(const m of c.filter(t=>!!t.description).sort(f))o.push(`|<i class="${E(m)}"></i>|${m.id}|${T.ThemeIcon.isThemeIcon(m.defaults)?m.defaults.id:m.id}|${m.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const m of c.filter(t=>!T.ThemeIcon.isThemeIcon(t.defaults)).sort(f))o.push(`|<i class="${E(m)}"></i>|${m.id}|`);return o.join(`
`)}}const i=new k;v.Registry.add(e.Extensions.IconContribution,i);function P(p,f,E,o){return i.registerIcon(p,f,E,o)}e.registerIcon=P;function d(){return i}e.getIconRegistry=d;function g(){for(const p of S.iconRegistry.all)i.registerIcon(p.id,p.definition,p.description);S.iconRegistry.onDidRegister(p=>i.registerIcon(p.id,p.definition,p.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let r=v.Registry.as(y.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,i.getIconSchema());const a=new C.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=P("widget-close",S.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",S.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",S.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=T.ThemeIcon.modify(S.Codicon.sync,"spin")}),define(ve[48],be([0,1,2,25,4,22]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var y;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function C(d){const g=d;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=C;function S(d){const g=d;return!!(g&&typeof g=="object"&&v.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=S;class k{constructor(g,r,a,p){this._id=g,this._configuration=a,this._ignorePathCasing=p,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(g,r){this.raw=r,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,T.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(d){return new i({uri:d,index:0,name:(0,T.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=P}),define(ve[160],be([0,1,4,130,48,2,21,14,25,108,44,19,58,37,94]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(j){return(typeof j=="string"?(0,C.extname)(j):(0,S.extname)(j))===a}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function f(j){return j.hasOwnProperty("workspace")}e.isRecentWorkspace=f;function E(j){return j.hasOwnProperty("folderUri")}e.isRecentFolder=E;function o(j){return j.hasOwnProperty("fileUri")}e.isRecentFile=o;function c(j){const U=j;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=c;function m(j){if(j.configuration)return{id:j.id,configPath:j.configuration};if(j.folders.length===1)return{id:j.id,uri:j.folders[0].uri}}e.toWorkspaceIdentifier=m;function t(j){const U=j;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function n(j){const U=j;if(U==null?void 0:U.uri)return{id:U.id,uri:A.URI.revive(U.uri)};const F=j;if(F==null?void 0:F.configPath)return{id:F.id,configPath:A.URI.revive(F.configPath)};if(j==null?void 0:j.id)return{id:j.id}}e.reviveIdentifier=n;function l(j,U){return S.extUriBiasedIgnorePathCase.isEqualOrParent(j,U.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function s(j){return u(j)||w(j)}e.isStoredWorkspaceFolder=s;function u(j){const U=j;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=u;function w(j){const U=j;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=w;function b(j,U,F,L,M=!y.isWindows,x){if(j.scheme!==L.scheme)return{name:F,uri:j.toString(!0)};let G=U?void 0:x.relativePath(L,j);if(G!==void 0)G.length===0?G=".":y.isWindows&&j.scheme===P.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(j.scheme===P.Schemas.file)G=j.fsPath,y.isWindows&&(G=(0,d.normalizeDriveLetter)(G),M&&(G=(0,g.toSlashes)(G)));else{if(!x.isEqualAuthority(j.authority,L.authority))return{name:F,uri:j.toString(!0)};G=j.path}return{name:F,path:G}}e.getStoredWorkspaceFolder=b;function I(j,U,F){let L=[],M=new Set;const x=F.dirname(U);for(let G of j){let J;if(u(G))G.path&&(J=F.resolvePath(x,G.path));else if(w(G))try{J=A.URI.parse(G.uri),J.path[0]!=="/"&&(J=J.with({path:"/"+J.path}))}catch(te){console.warn(te)}if(J){let te=F.getComparisonKey(J);if(!M.has(te)){M.add(te);const me=G.name||F.basenameOrAuthority(J);L.push(new D.WorkspaceFolder({uri:J,name:me,index:L.length},G))}}}return L}e.toWorkspaceFolders=I;function h(j,U,F,L,M){let x=_(U,j);const G=M.dirname(U),J=M.dirname(L),te=[],me=R(x.folders);for(const ze of x.folders){const H=u(ze)?M.resolvePath(G,ze.path):A.URI.parse(ze.uri);let q;F?q=!1:q=!u(ze)||(0,C.isAbsolute)(ze.path),te.push(b(H,q,ze.name,J,me,M))}const Le={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},We=k.setProperty(j,["folders"],te,Le);let Fe=k.applyEdits(j,We);return x.remoteAuthority===(0,r.getRemoteAuthority)(L)&&(Fe=k.applyEdits(Fe,k.removeProperty(Fe,["remoteAuthority"],Le))),Fe}e.rewriteWorkspaceFileForNewLocation=h;function _(j,U){let F=i.parse(U);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(L=>s(L));else throw new Error(`${j} looks like an invalid workspace file.`);return F}function R(j){return y.isWindows?j.some(U=>u(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function B(j){return j.workspace&&typeof j.workspace=="object"&&typeof j.workspace.id=="string"&&typeof j.workspace.configPath=="string"}function z(j){return typeof j.folderUri=="string"}function he(j){return typeof j.fileUri=="string"}function de(j,U){const F={workspaces:[],files:[]};if(j){const L=function(x,G){for(let J=0;J<x.length;J++)try{G(x[J],J)}catch(te){U.warn(`Error restoring recent entry ${JSON.stringify(x[J])}: ${te.toString()}. Skip entry.`)}},M=j;if(Array.isArray(M.entries))L(M.entries,x=>{const G=x.label,J=x.remoteAuthority;B(x)?F.workspaces.push({label:G,remoteAuthority:J,workspace:{id:x.workspace.id,configPath:A.URI.parse(x.workspace.configPath)}}):z(x)?F.workspaces.push({label:G,remoteAuthority:J,folderUri:A.URI.parse(x.folderUri)}):he(x)&&F.files.push({label:G,remoteAuthority:J,fileUri:A.URI.parse(x.fileUri)})});else{const x=j;Array.isArray(x.workspaces3)&&L(x.workspaces3,(G,J)=>{const te=Array.isArray(x.workspaceLabels)&&x.workspaceLabels[J]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?F.workspaces.push({label:te,workspace:{id:G.id,configPath:A.URI.parse(G.configURIPath)}}):typeof G=="string"&&F.workspaces.push({label:te,folderUri:A.URI.parse(G)})}),Array.isArray(x.files2)&&L(x.files2,(G,J)=>{const te=Array.isArray(x.fileLabels)&&x.fileLabels[J]||void 0;typeof G=="string"&&F.files.push({label:te,fileUri:A.URI.parse(G)})})}}return F}e.restoreRecentlyOpened=de;function W(j){const U={entries:[]};for(const F of j.workspaces)E(F)?U.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):U.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of j.files)U.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return U}e.toStoreData=W}),define(ve[68],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const A=this._idPool++;return this._data.set(A,D),this.logDebugInfo(),A}get(D,A){return this._data.has(D)?this._data.get(D)[A]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(ve[69],be([0,1,2,3,4]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class A{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(S=>({name:S.name,group:S.group,resource:v.URI.revive(S.resource),isActive:S.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(ve[49],be([0,1,19,4]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,C){C===null?this._providerInfo.delete(y):this._providerInfo.set(y,C)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,T.createDecorator)("IExtHostFileSystemInfo")}),define(ve[27],be([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,v.createDecorator)("IExtHostInitDataService")}),define(ve[161],be([0,1,11]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(y,C,S){this._deferredPromises=new Map,this._id=y,this._shared=C,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const P of k.values())P.error(i)}})()},0)}get whenReady(){return this._init}get(y,C){let S=this._value[y];return typeof S=="undefined"&&(S=C),S}update(y,C){this._value[y]=C;let S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const k=new v.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class D extends T{constructor(y,C){super(y.identifier.value,!0,C);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=D}),define(ve[15],be([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class T{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=T});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[162],be([0,1,26,3]),function(Y,e,v,T){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(C,S){D.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(C.identifier),it(this,D,S,"f"),Ue(this,D,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(C){return Ue(this,D,"f").get(this._id,C)}store(C,S){return Ue(this,D,"f").store(this._id,C,S)}delete(C){return Ue(this,D,"f").delete(this._id,C)}}e.ExtensionSecrets=A,D=new WeakMap}),define(ve[95],be([0,1,4,3]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,v.createDecorator)("IExtHostTelemetry")}),define(ve[70],be([0,1,3]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const D=new WeakMap,A=y=>{let C=D.get(y);return C||(C={children:new Map,bus:new v.Emitter},D.set(y,C)),C};e.getPrivateApiFor=A}),define(ve[71],be([0,1,4,3,15]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(C){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}C.fromApiTunnel=S;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}C.fromServiceTunnel=k})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,v.createDecorator)("IExtHostTunnelService");let y=class{constructor(S){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,k){return{dispose:()=>{}}}async $providePortAttributes(S,k,i,P,d){return[]}async $forwardPort(S,k){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=je([qe(0,D.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)},Gt=this&&this.__rest||function(Y,e){var v={};for(var T in Y)Object.prototype.hasOwnProperty.call(Y,T)&&e.indexOf(T)<0&&(v[T]=Y[T]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Y);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Y,T[D])&&(v[T[D]]=Y[T[D]]);return v};define(ve[7],be([0,1,13,12,84,22,8,10,2,31,64,67,70]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d){"use strict";var g,r,a,p,f,E,o,c,m,t,n,l,s,u,w,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I($){function O(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(O,$),Object.setPrototypeOf(O.prototype,$.prototype),O}let h=a=class{constructor(O){g.set(this,void 0),it(this,g,O,"f")}static from(...O){let ne=O;return new a(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}dispose(){typeof Ue(this,g,"f")=="function"&&(Ue(this,g,"f").call(this),it(this,g,void 0,"f"))}};g=new WeakMap,h=a=je([I],h),e.Disposable=h;let _=p=class{constructor(O,ne){if(O<0)throw(0,T.illegalArgument)("line must be non-negative");if(ne<0)throw(0,T.illegalArgument)("character must be non-negative");this._line=O,this._character=ne}static Min(...O){if(O.length===0)throw new TypeError;let ne=O[0];for(let Se=1;Se<O.length;Se++){const Ge=O[Se];Ge.isBefore(ne)&&(ne=Ge)}return ne}static Max(...O){if(O.length===0)throw new TypeError;let ne=O[0];for(let Se=1;Se<O.length;Se++){const Ge=O[Se];Ge.isAfter(ne)&&(ne=Ge)}return ne}static isPosition(O){if(!O)return!1;if(O instanceof p)return!0;let{line:ne,character:Se}=O;return typeof ne=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ne=0){if(O===null||ne===null)throw(0,T.illegalArgument)();let Se;return typeof O=="undefined"?Se=0:typeof O=="number"?Se=O:(Se=typeof O.lineDelta=="number"?O.lineDelta:0,ne=typeof O.characterDelta=="number"?O.characterDelta:0),Se===0&&ne===0?this:new p(this.line+Se,this.character+ne)}with(O,ne=this.character){if(O===null||ne===null)throw(0,T.illegalArgument)();let Se;return typeof O=="undefined"?Se=this.line:typeof O=="number"?Se=O:(Se=typeof O.line=="number"?O.line:this.line,ne=typeof O.character=="number"?O.character:this.character),Se===this.line&&ne===this.character?this:new p(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};_=p=je([I],_),e.Position=_;let R=f=class{constructor(O,ne,Se,Ge){let nt,ot;if(typeof O=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"?(nt=new _(O,ne),ot=new _(Se,Ge)):O instanceof _&&ne instanceof _&&(nt=O,ot=ne),!nt||!ot)throw new Error("Invalid arguments");nt.isBefore(ot)?(this._start=nt,this._end=ot):(this._start=ot,this._end=nt)}static isRange(O){return O instanceof f?!0:O?_.isPosition(O.start)&&_.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof f?this.contains(O._start)&&this.contains(O._end):O instanceof _?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ne=_.Max(O.start,this._start),Se=_.Min(O.end,this._end);if(!ne.isAfter(Se))return new f(ne,Se)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ne=_.Min(O.start,this._start),Se=_.Max(O.end,this.end);return new f(ne,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ne=this.end){if(O===null||ne===null)throw(0,T.illegalArgument)();let Se;return O?_.isPosition(O)?Se=O:(Se=O.start||this.start,ne=O.end||this.end):Se=this.start,Se.isEqual(this._start)&&ne.isEqual(this.end)?this:new f(Se,ne)}toJSON(){return[this.start,this.end]}};R=f=je([I],R),e.Range=R;let B=E=class extends R{constructor(O,ne,Se,Ge){let nt,ot;if(typeof O=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"?(nt=new _(O,ne),ot=new _(Se,Ge)):O instanceof _&&ne instanceof _&&(nt=O,ot=ne),!nt||!ot)throw new Error("Invalid arguments");super(nt,ot);this._anchor=nt,this._active=ot}static isSelection(O){return O instanceof E?!0:O?R.isRange(O)&&_.isPosition(O.anchor)&&_.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};B=E=je([I],B),e.Selection=B;class z{constructor(O,ne,Se){if(typeof O!="string"||O.length===0)throw(0,T.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,T.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,T.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ne),this.connectionToken=Se}}e.ResolvedAuthority=z;class he extends Error{constructor(O,ne=P.RemoteAuthorityResolverErrorCode.Unknown,Se){super(O);this._message=O,this._code=ne,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,he.prototype)}static NotAvailable(O,ne){return new he(O,P.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(O){return new he(O,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=he;var de;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(de=e.EndOfLine||(e.EndOfLine={}));var W;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=o=class{constructor(O,ne){this._range=O,this._newText=ne}static isTextEdit(O){return O instanceof o?!0:O?R.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ne){return new o(O,ne)}static insert(O,ne){return o.replace(new R(O,O),ne)}static delete(O){return o.replace(O,"")}static setEndOfLine(O){const ne=new o(new R(new _(0,0),new _(0,0)),"");return ne.newEol=O,ne}get range(){return this._range}set range(O){if(O&&!R.isRange(O))throw(0,T.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,T.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,T.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=o=je([I],j),e.TextEdit=j;var U;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellOutput=4]="CellOutput",$[$.CellReplace=5]="CellReplace",$[$.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ne,Se,Ge){this._edits.push({_type:1,from:O,to:ne,options:Se,metadata:Ge})}createFile(O,ne,Se){this._edits.push({_type:1,from:void 0,to:O,options:ne,metadata:Se})}deleteFile(O,ne,Se){this._edits.push({_type:1,from:O,to:void 0,options:ne,metadata:Se})}replaceNotebookMetadata(O,ne,Se){this._edits.push({_type:3,metadata:Se,uri:O,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(O,ne,Se,Ge,nt){let ot,dt,St=[],kt;if(xt.isNotebookRange(ne)&&Pt.isNotebookCellDataArray(Se)&&!Pt.isNotebookCellDataArray(Ge)?(ot=ne.start,dt=ne.end,St=Se,kt=Ge):typeof ne=="number"&&typeof Se=="number"&&Pt.isNotebookCellDataArray(Ge)&&(ot=ne,dt=Se,St=Ge,kt=nt),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||St.length>0)&&this._edits.push({_type:5,uri:O,index:ot,count:dt-ot,cells:St,metadata:kt})}replaceNotebookCellMetadata(O,ne,Se,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ne,metadata:Se}})}replace(O,ne,Se,Ge){this._edits.push({_type:2,uri:O,edit:new j(ne,Se),metadata:Ge})}insert(O,ne,Se,Ge){this.replace(O,new R(ne,ne),Se,Ge)}delete(O,ne,Se){this.replace(O,ne,"",Se)}has(O){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===O.toString())}set(O,ne){if(ne)for(const Se of ne)Se&&this._edits.push({_type:2,uri:O,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ge=this._edits[Se];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[Se]=void 0)}(0,v.coalesceInPlace)(this._edits)}}get(O){const ne=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===O.toString()&&ne.push(Se.edit);return ne}entries(){const O=new A.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Se=O.get(ne.uri);Se||(Se=[ne.uri,[]],O.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=je([I],F),e.WorkspaceEdit=F;let L=c=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof c?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=c._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ne=this._tabstop++){if(typeof O=="function"){const Se=new c;Se._tabstop=this._tabstop,O(Se),this._tabstop=Se._tabstop,O=Se.value}else O=c._escape(O);return this.value+="${",this.value+=ne,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ne=this._tabstop++){const Se=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(O,ne){if(typeof ne=="function"){const Se=new c;Se._tabstop=this._tabstop,ne(Se),this._tabstop=Se._tabstop,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};L=c=je([I],L),e.SnippetString=L;var M;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var x;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(x=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=m=class{constructor(O,ne){if(this.uri=O,ne)if(ne instanceof R)this.range=ne;else if(ne instanceof _)this.range=new R(ne,ne);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof m?!0:O?R.isRange(O.range)&&S.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=m=je([I],G),e.Location=G;let J=class{constructor(O,ne){this.location=O,this.message=ne}static is(O){return O?typeof O.message=="string"&&O.location&&R.isRange(O.location.range)&&S.URI.isUri(O.location.uri):!1}static isEqual(O,ne){return O===ne?!0:!O||!ne?!1:O.message===ne.message&&O.location.range.isEqual(ne.location.range)&&O.location.uri.toString()===ne.location.uri.toString()}};J=je([I],J),e.DiagnosticRelatedInformation=J;let te=class{constructor(O,ne,Se=x.Error){if(!R.isRange(O))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=O,this.message=ne,this.severity=Se}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ne){return O===ne?!0:!O||!ne?!1:O.message===ne.message&&O.severity===ne.severity&&O.code===ne.code&&O.severity===ne.severity&&O.source===ne.source&&O.range.isEqual(ne.range)&&(0,v.equals)(O.tags,ne.tags)&&(0,v.equals)(O.relatedInformation,ne.relatedInformation,J.isEqual)}};te=je([I],te),e.Diagnostic=te;let me=class{constructor(O,ne){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:(0,D.isMarkdownString)(O)?this.contents=[O]:this.contents=[O],this.range=ne}};me=je([I],me),e.Hover=me;var Le;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(O,ne=Le.Text){this.range=O,this.kind=ne}toJSON(){return{range:this.range,kind:Le[this.kind]}}};We=je([I],We),e.DocumentHighlight=We;var Fe;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(Fe=e.SymbolKind||(e.SymbolKind={}));var ze;(function($){$[$.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let H=t=class{constructor(O,ne,Se,Ge,nt){this.name=O,this.kind=ne,this.containerName=nt,typeof Se=="string"&&(this.containerName=Se),Ge instanceof G?this.location=Ge:Se instanceof R&&(this.location=new G(Ge,Se)),t.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};H=t=je([I],H),e.SymbolInformation=H;let q=n=class{constructor(O,ne,Se,Ge,nt){this.name=O,this.detail=ne,this.kind=Se,this.range=Ge,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};q=n=je([I],q),e.DocumentSymbol=q;var ee;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(O,ne){this.title=O,this.kind=ne}};se=je([I],se),e.CodeAction=se;let ce=l=class{constructor(O){this.value=O}append(O){return new l(this.value?this.value+l.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+l.sep)}};ce.sep=".",ce=l=je([I],ce),e.CodeActionKind=ce,ce.Empty=new ce(""),ce.QuickFix=ce.Empty.append("quickfix"),ce.Refactor=ce.Empty.append("refactor"),ce.RefactorExtract=ce.Refactor.append("extract"),ce.RefactorInline=ce.Refactor.append("inline"),ce.RefactorRewrite=ce.Refactor.append("rewrite"),ce.Source=ce.Empty.append("source"),ce.SourceOrganizeImports=ce.Source.append("organizeImports"),ce.SourceFixAll=ce.Source.append("fixAll");let _e=class{constructor(O,ne){if(this.range=O,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};_e=je([I],_e),e.SelectionRange=_e;class $e{constructor(O,ne,Se,Ge,nt,ot){this.kind=O,this.name=ne,this.detail=Se,this.uri=Ge,this.range=nt,this.selectionRange=ot}}e.CallHierarchyItem=$e;class fe{constructor(O,ne){this.fromRanges=ne,this.from=O}}e.CallHierarchyIncomingCall=fe;class De{constructor(O,ne){this.fromRanges=ne,this.to=O}}e.CallHierarchyOutgoingCall=De;let Re=class{constructor(O,ne){this.range=O,this.command=ne}get isResolved(){return!!this.command}};Re=je([I],Re),e.CodeLens=Re;let He=s=class{constructor(O,ne=!1){r.set(this,void 0),it(this,r,new D.MarkdownString(O,{supportThemeIcons:ne}),"f")}static isMarkdownString(O){return O instanceof s?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ue(this,r,"f").value}set value(O){Ue(this,r,"f").value=O}get isTrusted(){return Ue(this,r,"f").isTrusted}set isTrusted(O){Ue(this,r,"f").isTrusted=O}get supportThemeIcons(){return Ue(this,r,"f").supportThemeIcons}appendText(O){return Ue(this,r,"f").appendText(O),this}appendMarkdown(O){return Ue(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,ne){return Ue(this,r,"f").appendCodeblock(ne!=null?ne:"",O),this}};r=new WeakMap,He=s=je([I],He),e.MarkdownString=He;let we=class{constructor(O,ne){this.label=O,this.documentation=ne}};we=je([I],we),e.ParameterInformation=we;let Ke=class{constructor(O,ne){this.label=O,this.documentation=ne,this.parameters=[]}};Ke=je([I],Ke),e.SignatureInformation=Ke;let V=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};V=je([I],V),e.SignatureHelp=V;var Z;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(Z=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function($){$[$.Other=0]="Other",$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(O,ne,Se){this.text=O,this.position=ne,this.kind=Se}};Ne=je([I],Ne),e.InlayHint=Ne;var Ve;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var xe;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(xe=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function($){$[$.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let ye=class{constructor(O,ne){this.label=O,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ye=je([I],ye),e.CompletionItem=ye;let Ee=class{constructor(O=[],ne=!1){this.items=O,this.isIncomplete=ne}};Ee=je([I],Ee),e.CompletionList=Ee;var Ce;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(Ce=e.ViewColumn||(e.ViewColumn={}));var ie;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(ie=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ae;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var N;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(N=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Q=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ke;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(ke=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function O(ne){switch(ne){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=O}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ie=class{constructor(O,ne){if(ne&&!S.URI.isUri(ne))throw(0,T.illegalArgument)("target");if(!R.isRange(O)||O.isEmpty)throw(0,T.illegalArgument)("range");this.range=O,this.target=ne}};Ie=je([I],Ie),e.DocumentLink=Ie;let Ae=class{constructor(O,ne,Se,Ge){this.red=O,this.green=ne,this.blue=Se,this.alpha=Ge}};Ae=je([I],Ae),e.Color=Ae;let Be=class{constructor(O,ne){if(ne&&!(ne instanceof Ae))throw(0,T.illegalArgument)("color");if(!R.isRange(O)||O.isEmpty)throw(0,T.illegalArgument)("range");this.range=O,this.color=ne}};Be=je([I],Be),e.ColorInformation=Be;let Ye=class{constructor(O){if(!O||typeof O!="string")throw(0,T.illegalArgument)("label");this.label=O}};Ye=je([I],Ye),e.ColorPresentation=Ye;var rt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var tt;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Qe;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(Qe=e.TaskRevealKind||(e.TaskRevealKind={}));var gt;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(gt=e.TaskPanelKind||(e.TaskPanelKind={}));let bt=u=class{constructor(O,ne){if(typeof O!="string"||typeof ne!="string")throw(0,T.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};bt.Clean=new u("clean","Clean"),bt.Build=new u("build","Build"),bt.Rebuild=new u("rebuild","Rebuild"),bt.Test=new u("test","Test"),bt=u=je([I],bt),e.TaskGroup=bt;function pe($){let O="";for(let ne=0;ne<$.length;ne++)O+=$[ne].replace(/,/g,",,")+",";return O}let ue=class{constructor(O,ne,Se){if(typeof O!="string")throw(0,T.illegalArgument)("process");this._args=[],this._process=O,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Se):this._options=ne)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,T.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)O.push(ne);return pe(O)}};ue=je([I],ue),e.ProcessExecution=ue;let re=class{constructor(O,ne,Se){if(this._args=[],Array.isArray(ne)){if(!O)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,T.illegalArgument)("command");this._command=O,this._args=ne,this._options=Se}else{if(typeof O!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=O,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,T.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)O.push(typeof ne=="string"?ne:ne.value);return pe(O)}};re=je([I],re),e.ShellExecution=re;var K;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(K=e.ShellQuoting||(e.ShellQuoting={}));var Me;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(Me=e.TaskScope||(e.TaskScope={}));class Te{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Te;let Je=w=class{constructor(O,ne,Se,Ge,nt,ot){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Se,this.execution=Ge,dt=nt,this.__deprecated=!0):ne===Me.Global||ne===Me.Workspace?(this.target=ne,this._name=this.name=Se,this._source=this.source=Ge,this.execution=nt,dt=ot):(this.target=ne,this._name=this.name=Se,this._source=this.source=Ge,this.execution=nt,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof re?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,T.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ne=this._definition.type;(w.EmptyType===ne||w.ProcessType===ne||w.ShellType===ne||w.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};Je.ExtensionCallbackType="customExecution",Je.ProcessType="process",Je.ShellType="shell",Je.EmptyType="$empty",Je=w=je([I],Je),e.Task=Je;var et;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(et=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,ne=ct.None){this.collapsibleState=ne,S.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=je([I],ut),e.TreeItem=ut;var ct;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ze=class{constructor(O,ne){this.id=O,this.color=ne}};Ze=je([I],Ze),e.ThemeIcon=Ze,Ze.File=new Ze("file"),Ze.Folder=new Ze("folder");let mt=class{constructor(O){this.id=O}};mt=je([I],mt),e.ThemeColor=mt;var ht;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ft=class{constructor(O,ne){if(typeof O!="string"&&(!O||!S.URI.isUri(O)&&!S.URI.isUri(O.uri)))throw(0,T.illegalArgument)("base");if(typeof ne!="string")throw(0,T.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=S.URI.file(O),this.base=O):S.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ne}};ft=je([I],ft),e.RelativePattern=ft;let at=class{constructor(O,ne,Se,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};at=je([I],at),e.Breakpoint=at;let yt=class extends at{constructor(O,ne,Se,Ge,nt){super(ne,Se,Ge,nt);if(O===null)throw(0,T.illegalArgument)("location");this.location=O}};yt=je([I],yt),e.SourceBreakpoint=yt;let Et=class extends at{constructor(O,ne,Se,Ge,nt){super(ne,Se,Ge,nt);this.functionName=O}};Et=je([I],Et),e.FunctionBreakpoint=Et;let Ot=class extends at{constructor(O,ne,Se,Ge,nt,ot,dt){super(Ge,nt,ot,dt);if(!ne)throw(0,T.illegalArgument)("dataId");this.label=O,this.dataId=ne,this.canPersist=Se}};Ot=je([I],Ot),e.DataBreakpoint=Ot;let Tt=class{constructor(O,ne,Se){this.command=O,this.args=ne||[],this.options=Se}};Tt=je([I],Tt),e.DebugAdapterExecutable=Tt;let _t=class{constructor(O,ne){this.port=O,this.host=ne}};_t=je([I],_t),e.DebugAdapterServer=_t;let Qt=class{constructor(O){this.path=O}};Qt=je([I],Qt),e.DebugAdapterNamedPipeServer=Qt;let Yt=class{constructor(O){this.implementation=O}};Yt=je([I],Yt),e.DebugAdapterInlineImplementation=Yt;let pt=class{constructor(O,ne){this.range=O,this.expression=ne}};pt=je([I],pt),e.EvaluatableExpression=pt;let Jt=class{constructor(O,ne){this.range=O,this.text=ne}};Jt=je([I],Jt),e.InlineValueText=Jt;let Dt=class{constructor(O,ne,Se=!0){this.range=O,this.variableName=ne,this.caseSensitiveLookup=Se}};Dt=je([I],Dt),e.InlineValueVariableLookup=Dt;let Vt=class{constructor(O,ne){this.range=O,this.expression=ne}};Vt=je([I],Vt),e.InlineValueEvaluatableExpression=Vt;let Xt=class{constructor(O,ne){this.frameId=O,this.stoppedLocation=ne}};Xt=je([I],Xt),e.InlineValueContext=Xt;var jt;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let lt=b=class extends Error{constructor(O,ne=i.FileSystemProviderErrorCode.Unknown,Se){var Ge;super(S.URI.isUri(O)?O.toString(!0):O);this.code=(Ge=Se==null?void 0:Se.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,i.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(O){return new b(O,i.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(O){return new b(O,i.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(O){return new b(O,i.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(O){return new b(O,i.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(O){return new b(O,i.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(O){return new b(O,i.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};lt=b=je([I],lt),e.FileSystemError=lt;let Zt=class{constructor(O,ne,Se){this.start=O,this.end=ne,this.kind=Se}};Zt=je([I],Zt),e.FoldingRange=Zt;var Rt;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $t;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})($t=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var cn;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(cn=e.CommentMode||(e.CommentMode={}));class wn{constructor(O,ne=[]){this.tokenTypes=O,this.tokenModifiers=ne}}e.SemanticTokensLegend=wn;function dn($){return typeof $=="undefined"||(0,C.isStringArray)($)}class en{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ne=0,Se=O.tokenTypes.length;ne<Se;ne++)this._tokenTypeStrToInt.set(O.tokenTypes[ne],ne);for(let ne=0,Se=O.tokenModifiers.length;ne<Se;ne++)this._tokenModifierStrToInt.set(O.tokenModifiers[ne],ne)}}push(O,ne,Se,Ge,nt){if(typeof O=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ne,Se,Ge,nt);if(R.isRange(O)&&typeof ne=="string"&&dn(Se))return this._push(O,ne,Se);throw(0,T.illegalArgument)()}_push(O,ne,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,nt=O.start.character,ot=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(ne);let St=0;if(Se)for(const kt of Se){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(kt);St|=1<<It>>>0}this._pushEncoded(Ge,nt,ot,dt,St)}_pushEncoded(O,ne,Se,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let kt=0,It=0;for(let At=0;At<St;At++){let Lt=this._data[5*At],ln=this._data[5*At+1];Lt===0?(Lt=kt,ln+=It):Lt+=kt,this._data[5*At]=Lt,this._data[5*At+1]=ln,kt=Lt,It=ln}}let ot=O,dt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ne}static _sortAndDeltaEncode(O){let ne=[];const Se=O.length/5|0;for(let dt=0;dt<Se;dt++)ne[dt]=dt;ne.sort((dt,St)=>{const kt=O[5*dt],It=O[5*St];if(kt===It){const At=O[5*dt+1],Lt=O[5*St+1];return At-Lt}return kt-It});const Ge=new Uint32Array(O.length);let nt=0,ot=0;for(let dt=0;dt<Se;dt++){const St=5*ne[dt],kt=O[St+0],It=O[St+1],At=O[St+2],Lt=O[St+3],ln=O[St+4],Tn=kt-nt,On=Tn===0?It-ot:It,un=5*dt;Ge[un+0]=Tn,Ge[un+1]=On,Ge[un+2]=At,Ge[un+3]=Lt,Ge[un+4]=ln,nt=kt,ot=It}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(en._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=en;class qt{constructor(O,ne){this.resultId=ne,this.data=O}}e.SemanticTokens=qt;class Nt{constructor(O,ne,Se){this.start=O,this.deleteCount=ne,this.data=Se}}e.SemanticTokensEdit=Nt;class _n{constructor(O,ne){this.resultId=ne,this.edits=O}}e.SemanticTokensEdits=_n;var tn;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(tn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var nn;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(nn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new Ze("arrow-left")},Kt=je([I],Kt),e.QuickInputButtons=Kt;var En;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(En=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(O,ne,Se){this.badge=O,this.tooltip=ne,this.color=Se}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let rn=class{constructor(O){this.kind=O}};rn=je([I],rn),e.ColorTheme=rn;var yn;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast"})(yn=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(O,ne){if(O<0)throw(0,T.illegalArgument)("start must be positive");if(ne<0)throw(0,T.illegalArgument)("end must be positive");O<=ne?(this._start=O,this._end=ne):(this._start=ne,this._end=O)}static isNotebookRange(O){return O instanceof xt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ne=this._start,Se=this._end;return O.start!==void 0&&(ne=O.start),O.end!==void 0&&(Se=O.end),ne===this._start&&Se===this._end?this:new xt(ne,Se)}}e.NotebookRange=xt;class sn{constructor(O,ne){typeof O=="object"?Object.assign(this,O):(this.inputCollapsed=O,this.outputCollapsed=ne)}with(O){let{inputCollapsed:ne,outputCollapsed:Se}=O,Ge=Gt(O,["inputCollapsed","outputCollapsed"]);return ne===void 0?ne=this.inputCollapsed:ne===null&&(ne=void 0),Se===void 0?Se=this.outputCollapsed:Se===null&&(Se=void 0),ne===this.inputCollapsed&&Se===this.outputCollapsed&&Object.keys(Ge).length===0?this:new sn(Object.assign({inputCollapsed:ne,outputCollapsed:Se},Ge))}}e.NotebookCellMetadata=sn;class Ut{constructor(O={}){Object.assign(this,O)}with(O){return new Ut(O)}}e.NotebookDocumentMetadata=Ut;class Pt{constructor(O,ne,Se,Ge,nt,ot){this.kind=O,this.value=ne,this.languageId=Se,this.outputs=Ge!=null?Ge:[],this.metadata=nt,this.latestExecutionSummary=ot,Pt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ne=>Pt.isNotebookCellData(ne))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Pt;class hn{constructor(O,ne){this.cells=O,this.metadata=ne!=null?ne:new Ut}}e.NotebookData=hn;class Wt{constructor(O,ne,Se){if(this.mime=O,this.value=ne,this.metadata=Se,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(O){return O instanceof Wt?!0:O?typeof O.mime=="string":!1}}e.NotebookCellOutputItem=Wt;class Oe{constructor(O,ne,Se){this.outputs=O,typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,k.generateUuid)(),this.metadata=ne!=null?ne:Se)}}e.NotebookCellOutput=Oe;var on;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(on=e.NotebookCellKind||(e.NotebookCellKind={}));var an;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(an=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var vt;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(vt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Sn;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Sn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Dn{constructor(O,ne,Se,Ge,nt,ot){this.text=O,this.alignment=ne,this.command=Se,this.tooltip=Ge,this.priority=nt,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=Dn;var fn;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class mn{constructor(O,ne=[]){this.uri=O,this.provides=typeof ne=="string"?[ne]:ne}}e.NotebookKernelPreload=mn;let Ht=class{constructor(O,ne){this.label=O,this.timestamp=ne}};Ht=je([I],Ht),e.TimelineItem=Ht;var Cn;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(Cn=e.ExtensionMode||(e.ExtensionMode={}));var kn;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(kn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var In;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=4]="RegEx"})(In=e.StandardTokenType||(e.StandardTokenType={}));class gn{constructor(O,ne){this.ranges=O,this.wordPattern=ne}}e.LinkedEditingRanges=gn;class Pn{constructor(O,ne){this._port=O,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Pn;var An;(function($){$[$.Unset=0]="Unset",$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var pn;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information",$[$.Hint=3]="Hint"})(pn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var vn;(function($){$[$.Pending=0]="Pending",$[$.Resolved=1]="Resolved"})(vn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=($,O,ne,Se)=>{let Ge=ne;return{enumerable:!0,configurable:!1,get(){return Ge},set(nt){Se(Ge,nt)||(Ge=nt,$.bus.fire([3,O,nt]))}}},X=($,O)=>$===O,le=($,O)=>$===O?!0:!$||!O?!1:$.isEqual(O);class Pe{constructor(O,ne,Se,Ge){this.label=ne,this.data=Ge;const nt=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>nt.parent},children:{value:new A.ReadonlyMapView(nt.children),enumerable:!0,writable:!1},range:Bt(nt,"range",void 0,le),description:Bt(nt,"description",void 0,X),runnable:Bt(nt,"runnable",!0,X),debuggable:Bt(nt,"debuggable",!1,X),status:Bt(nt,"status",vn.Resolved,X),error:Bt(nt,"error",void 0,X)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const O=(0,d.getPrivateApiFor)(this);O.parent&&(0,d.getPrivateApiFor)(O.parent).children.delete(this.id),O.bus.fire([1])}addChild(O){if(!(O instanceof Pe))throw new Error("Test child must be created through vscode.test.createTestItem()");const ne=(0,d.getPrivateApiFor)(this);if(ne.children.has(O.id))throw new Error(`Attempted to insert a duplicate test item ID ${O.id}`);ne.children.set(O.id,O),ne.bus.fire([0,O])}}e.TestItemImpl=Pe;class st{constructor(O){this.message=O,this.severity=pn.Error}static diff(O,ne,Se){const Ge=new st(O);return Ge.expectedOutput=ne,Ge.actualOutput=Se,Ge}}e.TestMessage=st;var wt;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(wt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ct;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(Ct=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Mn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore"})(Mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ve[96],be([0,1,42,19,8,121,87,7,13]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(r,a){a?k.set(r,a):k.delete(r)}e.setWordDefinitionFor=i;function P(r){return k.get(r)}e.getWordDefinitionFor=P;class d extends A.MirrorTextModel{constructor(a,p,f,E,o,c,m,t){super(p,f,E,o);this._proxy=a,this._languageId=c,this._isDirty=m,this._notebook=t,this._isDisposed=!1}dispose(){(0,v.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,S.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===T.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(p){return p?a._getTextInRange(p):a.getText()},get eol(){return a._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(p){return a._lineAt(p)},offsetAt(p){return a._offsetAt(p)},positionAt(p){return a._positionAt(p)},validateRange(p){return a._validateRange(p)},validatePosition(p){return a._validatePosition(p)},getWordRangeAtPosition(p,f){return a._getWordRangeAtPosition(p,f)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,v.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,v.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const p=this._validateRange(a);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const f=this._eol,E=p.start.line,o=p.end.line,c=[];c.push(this._lines[E].substring(p.start.character));for(let m=E+1;m<o;m++)c.push(this._lines[m]);return c.push(this._lines[o].substring(0,p.end.character)),c.join(f)}_lineAt(a){let p;if(a instanceof C.Position?p=a.line:typeof a=="number"&&(p=a),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new g(p,this._lines[p],p===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(a),f=this._lines[p.index].length;return new C.Position(p.index,Math.min(p.remainder,f))}_validateRange(a){if(!(a instanceof C.Range))throw new Error("Invalid argument");const p=this._validatePosition(a.start),f=this._validatePosition(a.end);return p===a.start&&f===a.end?a:new C.Range(p.line,p.character,f.line,f.character)}_validatePosition(a){if(!(a instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:p,character:f}=a,E=!1;if(p<0)p=0,f=0,E=!0;else if(p>=this._lines.length)p=this._lines.length-1,f=this._lines[p].length,E=!0;else{const o=this._lines[p].length;f<0?(f=0,E=!0):f>o&&(f=o,E=!0)}return E?new C.Position(p,f):a}_getWordRangeAtPosition(a,p){const f=this._validatePosition(a);if(!p)p=P(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const E=(0,y.getWordAtText)(f.character+1,(0,y.ensureValidWordDefinition)(p),this._lines[f.line],0);if(E)return new C.Range(f.line,E.startColumn-1,f.line,E.endColumn-1)}}e.ExtHostDocumentData=d;class g{constructor(a,p,f){this._line=a,this._text=p,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ve[163],be([0,1,7,3,89,6,59,22,2,31]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(d,g,r,a){this._notebook=r,this._selector=a,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(f=>{const E=this._cellUris.get(f.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=f=>{f===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(f=>p(f.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const d=[],g=[];for(const r of this._notebook.getCells())r.kind===v.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),d.push(r.document.getText().length+1),g.push(r.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(d){var g,r;if(!d){let o="";for(const c of this._cells)o+=c.document.getText()+`
`;return o=o.slice(0,-1),o}if(d.isEmpty)return"";const a=this.locationAt(d.start),p=this.locationAt(d.end),f=this._cells[(g=this._cellUris.get(a.uri))!==null&&g!==void 0?g:-1],E=this._cells[(r=this._cellUris.get(p.uri))!==null&&r!==void 0?r:-1];if(!f||!E)return"";if(f===E)return f.document.getText(new v.Range(a.range.start,p.range.end));{const o=f.document.getText(new v.Range(a.range.start,new v.Position(f.document.lineCount,0))),c=E.document.getText(new v.Range(new v.Position(0,0),p.range.end));return o+`
`+c}}offsetAt(d){const g=this._cellLines.getIndexOf(d.line),r=this._cellLengths.getAccumulatedValue(g.index-1),a=this._cells[g.index].document.offsetAt(d.with(g.remainder));return r+a}positionAt(d){if(typeof d=="number"){const r=this._cellLengths.getIndexOf(d),a=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(a)}const g=this._cellUris.get(d.uri);if(g!==void 0){const r=this._cellLines.getAccumulatedValue(g-1);return new v.Position(r+d.range.start.line,d.range.start.character)}return new v.Position(0,0)}locationAt(d){v.Range.isRange(d)||(d=new v.Range(d,d));const g=this._cellLines.getIndexOf(d.start.line);let r=g;d.isEmpty||(r=this._cellLines.getIndexOf(d.end.line));const a=new v.Position(g.remainder,d.start.character),p=new v.Position(r.remainder,d.end.character),f=new v.Range(a,p),E=this._cells[g.index];return new v.Location(E.document.uri,E.document.validateRange(f))}contains(d){return this._cellUris.has(d)}validateRange(d){const g=this.validatePosition(d.start),r=this.validatePosition(d.end);return d.with(g,r)}validatePosition(d){const g=this._cellLines.getIndexOf(d.line),r=new v.Position(g.remainder,d.character),a=this._cells[g.index].document.validatePosition(r),p=this._cellLines.getAccumulatedValue(g.index-1);return new v.Position(p+a.line,a.character)}}e.ExtHostNotebookConcatDocument=i}),define(ve[164],be([0,1,7,15,3]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(C){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let S=C==="light"?v.ColorThemeKind.Light:C==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([qe(0,T.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ve[72],be([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,v.createDecorator)("IURITransformerService");class T{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=T}),define(ve[165],be([0,1,24]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function D(C,S){if(S.serializeBuffersForPostMessage){const k=new T,i=(g,r)=>{if(r instanceof ArrayBuffer){const a=k.add(r);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(r)){const a=A(r);if(a){const p=k.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},P=JSON.stringify(C,i),d=k.buffers.map(g=>{const r=new Uint8Array(g);return v.VSBuffer.wrap(r)});return{message:P,buffers:d}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=D;function A(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(C,S){const k=S.map(d=>{const g=new ArrayBuffer(d.byteLength);return new Uint8Array(g).set(d.buffer),g}),i=S.length?(d,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const r=g,{index:a}=r,p=k[a];if(r.view)switch(r.view.type){case 1:return new Int8Array(p,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return g}:void 0;return{message:JSON.parse(C,i),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(ve[73],be([0,1,2]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function T(D,A,y){var C;const S=D.webviewResourceRoot.replace("{{resource}}",((C=D.remote.authority)!==null&&C!==void 0?C:"")+"/"+y.scheme+"/"+encodeURIComponent(y.authority)+y.path).replace("{{uuid}}",A);return v.URI.parse(S).with({fragment:y.fragment,query:y.query})}e.asWebviewUri=T}),define(ve[166],be([0,1,3,6,73,31]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(S,k,i){this._proxy=S,this._editors=k,this._initData=i,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const d of this._insets.values())P.indexOf(d.editor)<0&&d.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,k,i,P,d){let g;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===S){g=c;break}if(!g)throw new Error("not a visible editor");const r=this,a=this._handlePool++,p=new v.Emitter,f=new v.Emitter,E=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,D.asWebviewUri)(r._initData,this._uuid,c)}get cspSource(){return r._initData.webviewCspSource}set options(c){this._options=c,r._proxy.$setOptions(a,c)}get options(){return this._options}set html(c){this._html=c,r._proxy.$setHtml(a,c)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(c){return r._proxy.$postMessage(a,c)}},o=new class{constructor(){this.editor=S,this.line=k,this.height=i,this.webview=E,this.onDidDispose=f.event}dispose(){r._insets.has(a)&&(r._insets.delete(a),r._proxy.$disposeEditorInset(a),f.fire(),f.dispose(),p.dispose())}};return this._proxy.$createEditorInset(a,g.id,g.value.document.uri,k+1,i,P||{},d.identifier,d.extensionLocation),this._insets.set(a,{editor:S,inset:o,onDidReceiveMessage:p}),o}$onDidDispose(S){const k=this._insets.get(S);k&&k.inset.dispose()}$onDidReceiveMessage(S,k){const i=this._insets.get(S);i&&i.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(ve[167],be([0,1,3,63,139,4,6,22,29,13,51,23,36,159]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",d.Codicon.window,(0,D.localize)(0,null));var r;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var a;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function f(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=f;class E extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new v.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new v.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(w,b,I){var h;const _=this.get(w.id);if(_)return _;const R=w;return R.openCommandActionDescriptor=(I==null?void 0:I.donotRegisterOpenCommand)?void 0:(h=R.openCommandActionDescriptor)!==null&&h!==void 0?h:{id:R.id},(0,C.getOrSet)(this.viewContainers,b,[]).push(R),(I==null?void 0:I.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:b}),R}deregisterViewContainer(w){for(const b of this.viewContainers.keys()){const I=this.viewContainers.get(b),h=I==null?void 0:I.indexOf(w);if(h!==-1){I==null||I.splice(h,1),I.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:w,viewContainerLocation:b});return}}}get(w){return this.all.filter(b=>b.id===w)[0]}getViewContainers(w){return[...this.viewContainers.get(w)||[]]}getViewContainerLocation(w){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(I=>(I==null?void 0:I.id)===w.id).length>0)[0]}getDefaultViewContainer(w){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===w)}}S.Registry.add(r.ViewContainersRegistry,new E);var o;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function c(u,w){var b,I,h,_;const R=(b=u.group)!==null&&b!==void 0?b:o.More,B=(I=w.group)!==null&&I!==void 0?I:o.More;return R!==B?R.localeCompare(B):((h=u.order)!==null&&h!==void 0?h:5)-((_=w.order)!==null&&_!==void 0?_:5)}class m extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new v.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new v.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new v.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new v.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(w,b){this.registerViews2([{views:w,viewContainer:b}])}registerViews2(w){w.forEach(({views:b,viewContainer:I})=>this.addViews(b,I)),this._onViewsRegistered.fire(w)}deregisterViews(w,b){const I=this.removeViews(w,b);I.length&&this._onViewsDeregistered.fire({views:I,viewContainer:b})}moveViews(w,b){for(const I of this._views.keys())if(I!==b){const h=this.removeViews(w,I);h.length&&(this.addViews(h,b),this._onDidChangeContainer.fire({views:h,from:I,to:b}))}}getViews(w){return this._views.get(w)||[]}getView(w){for(const b of this._viewContainers){const I=(this._views.get(b)||[]).filter(h=>h.id===w)[0];if(I)return I}return null}getViewContainer(w){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(h=>h.id===w)[0])return b;return null}registerViewWelcomeContent(w,b){return this._viewWelcomeContents.add(w,b),this._onDidChangeViewWelcomeContent.fire(w),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(w,b),this._onDidChangeViewWelcomeContent.fire(w)})}registerViewWelcomeContent2(w,b){const I=new Map;for(const[h,_]of b)this._viewWelcomeContents.add(w,_),I.set(h,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(w,_),this._onDidChangeViewWelcomeContent.fire(w)}));return this._onDidChangeViewWelcomeContent.fire(w),I}getViewWelcomeContent(w){const b=[];return this._viewWelcomeContents.forEach(w,I=>b.push(I)),b.sort(c)}addViews(w,b){let I=this._views.get(b);I||(I=[],this._views.set(b,I),this._viewContainers.push(b));for(const h of w){if(this.getView(h.id)!==null)throw new Error((0,D.localize)(1,null,h.id));I.push(h)}}removeViews(w,b){const I=this._views.get(b);if(!I)return[];const h=[],_=[];for(const R of I)w.includes(R)?h.push(R):_.push(R);return h.length&&(_.length?this._views.set(b,_):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),h}}S.Registry.add(r.ViewsRegistry,new m),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new T.RawContextKey("focusedView","",(0,D.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var l;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(l=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(w,b){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,w),this._hasResolve=!!b,this.resolve=async I=>{var h,_;if(b&&!this.resolved){const R=await b(I);R&&(this.tooltip=(h=this.tooltip)!==null&&h!==void 0?h:R.tooltip,this.command=(_=this.command)!==null&&_!==void 0?_:R.command)}I.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s}),define(ve[168],be([0,1,2,149,160,18,150,167]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function S(a){return(p,...f)=>a(p.get(T.ICommandService),...f)}class k{static execute(p,f){const E={forceReuseWindow:f&&f.reuseWindow,remoteAuthority:f&&f.remoteAuthority};return p.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",T.CommandsRegistry.registerCommand({id:k.ID,handler:S(k.execute),description:{description:"Opens an new window",args:[]}}),T.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(a,p){return a.get(D.IWorkspacesService).removeRecentlyOpened([p])});class i{static execute(p,f){return typeof f=="string"?f=f.match(/^[^:/?#]+:\/\//)?v.URI.parse(f):v.URI.file(f):f=v.URI.revive(f),p.executeCommand("_workbench.removeFromRecentlyOpened",f)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",T.CommandsRegistry.registerCommand(i.ID,S(i.execute));class P{static execute(p,f){const E=typeof f=="string"?{extensionId:f}:f;return p.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=P,P.ID="vscode.openIssueReporter",T.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(a,p){const f=a.get(D.IWorkspacesService);let E;const o=p.uri,c=p.label,m=p.remoteAuthority;return p.type==="workspace"?E={workspace:await f.getWorkspaceIdentifier(o),label:c,remoteAuthority:m}:p.type==="folder"?E={folderUri:o,label:c,remoteAuthority:m}:E={fileUri:o,label:c,remoteAuthority:m},f.addRecentlyOpened([E])}),T.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(a){return a.get(D.IWorkspacesService).getRecentlyOpened()}),T.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(a,p){const f=a.get(A.ILogService),E=a.get(y.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&f.setLevel(p)}),T.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(a){return a.get(A.ILogService).getLevel()}),T.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(a,p){const f=a.get(C.IViewDescriptorService),E=f.getViewContainerById(p.destinationId);if(!!E){for(const o of p.viewIds){const c=f.getViewDescriptorById(o);(c==null?void 0:c.canMoveView)&&f.moveViewsToContainer([c],E,C.ViewVisibilityState.Default)}await a.get(C.IViewsService).openViewContainer(E.id,!0)}});class d{static execute(p,f){return!Array.isArray(f==null?void 0:f.viewIds)||typeof(f==null?void 0:f.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",f)}}e.MoveViewsAPICommand=d,d.ID="vscode.moveViews",T.CommandsRegistry.registerCommand({id:d.ID,handler:S(d.execute),description:{description:"Move Views",args:[]}});class g{static execute(p,f){return p.executeCommand("_workbench.open",f)}}g.ID="vscode.open",T.CommandsRegistry.registerCommand(g.ID,S(g.execute));class r{static execute(p,f,E,o,c){return p.executeCommand("_workbench.diff",[f,E,o])}}r.ID="vscode.diff",T.CommandsRegistry.registerCommand(r.ID,S(r.execute))}),define(ve[169],be([0,1,3,11,140]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,S,k,i){const P={command:C};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.internalSend("request",P),typeof i=="number"){const d=setTimeout(()=>{clearTimeout(d);const g=this.pendingRequests.get(P.seq);if(g){this.pendingRequests.delete(P.seq);const r={type:"response",seq:0,request_seq:P.seq,success:!1,command:C,message:(0,D.localize)(0,null,i,C)};g(r)}},i)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,S){return C.type!=="event"||S.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,T.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const S=C,k=this.pendingRequests.get(S.request_seq);k&&(this.pendingRequests.delete(S.request_seq),k(S));break}}}internalSend(C,S){S.type=C,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((S,k)=>C.set(k,S)),await(0,T.timeout)(500),C.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ve[170],be([0,1,8,2,14,23,19]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function S(n,l,s){return n.replace(C,function(u,w){return l&&w.length>0&&w[0]!=="_"?u:s&&s.hasOwnProperty(w)?s[w]:u})}e.formatPII=S;function k(n){const l={};for(const s of Object.keys(n))s.startsWith("!")||(l[s]=n[s]);return l}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!P(n)}e.isSessionAttach=i;function P(n){let l=n.configuration.type;if(!!l)return l==="vslsShare"&&(l=n.configuration.adapterProxy.configuration.type),(0,v.equalsIgnoreCase)(l,"extensionhost")||(0,v.equalsIgnoreCase)(l,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function d(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=d;function g(n,l,s){let u,w=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,I=null;for(;I=b.exec(n);){let h=I.index+1,_=h+I[0].length;if(h<=l&&_>=s){u=I[0],w=h;break}}if(u){let h=/\w+/g,_=null;for(;(_=h.exec(u))&&!(_.index+1+w+_[0].length>=s););_&&(u=u.substring(0,h.lastIndex))}return u?{start:w,end:w+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(n){return!!(n&&n.match(r))}e.isUri=a;function p(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(a(n.path))return T.URI.parse(n.path);if((0,D.isAbsolute)(n.path))return T.URI.file(n.path)}return n.path}function f(n){if(typeof n.path=="object"){const l=T.URI.revive(n.path);if(l)return l.scheme===y.Schemas.file?l.fsPath:l.toString()}return n.path}function E(n,l){const s=l?p:f,u=(0,A.deepClone)(n);return c(u,(w,b)=>{w&&b&&(b.path=s(b))}),u}e.convertToDAPaths=E;function o(n,l){const s=l?p:f,u=(0,A.deepClone)(n);return c(u,(w,b)=>{!w&&b&&(b.path=s(b))}),u}e.convertToVSCPaths=o;function c(n,l){switch(n.type){case"event":const s=n;switch(s.event){case"output":l(!1,s.body.source);break;case"loadedSource":l(!1,s.body.source);break;case"breakpoint":l(!1,s.body.breakpoint.source);break;default:break}break;case"request":const u=n;switch(u.command){case"setBreakpoints":l(!0,u.arguments.source);break;case"breakpointLocations":l(!0,u.arguments.source);break;case"source":l(!0,u.arguments.source);break;case"gotoTargets":l(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(b=>l(!1,b));break;default:break}break;case"response":const w=n;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(b=>l(!1,b.source));break;case"loadedSources":w.body.sources.forEach(b=>l(!1,b));break;case"scopes":w.body.scopes.forEach(b=>l(!1,b.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(b=>l(!1,b.source));break;case"setBreakpoints":w.body.breakpoints.forEach(b=>l(!1,b.source));break;default:break}break}}function m(n){return n.filter(l=>{var s;return!((s=l.presentation)===null||s===void 0?void 0:s.hidden)}).sort((l,s)=>l.presentation?s.presentation?l.presentation.group?s.presentation.group?l.presentation.group!==s.presentation.group?l.presentation.group.localeCompare(s.presentation.group):t(l.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(l.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=m;function t(n,l){return typeof n!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:n-l}}),define(ve[74],be([0,1,28,19,14,21,63]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(h){h[h.Markup=1]="Markup",h[h.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(h){h[h.Running=1]="Running",h[h.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(h){h[h.Idle=1]="Idle",h[h.Pending=2]="Pending",h[h.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(h){h[h.WithHardKernelDependency=0]="WithHardKernelDependency",h[h.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",h[h.Pure=2]="Pure",h[h.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(h){h[h.ModelChange=1]="ModelChange",h[h.Move=2]="Move",h[h.CellClearOutput=3]="CellClearOutput",h[h.CellsClearOutput=4]="CellsClearOutput",h[h.ChangeLanguage=5]="ChangeLanguage",h[h.Initialize=6]="Initialize",h[h.ChangeCellMetadata=7]="ChangeCellMetadata",h[h.Output=8]="Output",h[h.OutputItem=9]="OutputItem",h[h.ChangeCellContent=10]="ChangeCellContent",h[h.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",h[h.Unknown=12]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(h){h[h.Handle=0]="Handle",h[h.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(h){h[h.Replace=1]="Replace",h[h.Output=2]="Output",h[h.Metadata=3]="Metadata",h[h.CellLanguage=4]="CellLanguage",h[h.DocumentMetadata=5]="DocumentMetadata",h[h.Move=6]="Move",h[h.OutputItems=7]="OutputItems",h[h.PartialMetadata=8]="PartialMetadata"})(g=e.CellEditType||(e.CellEditType={}));function r(h){const _=a.parse(h);return _?_.notebook.toString():h.toString()}e.getCellUndoRedoComparisonKey=r;var a;(function(h){h.scheme=T.Schemas.vscodeNotebookCell;const _=/^ch(\d{7,})/;function R(W,j){return W.with({scheme:h.scheme,fragment:`ch${j.toString().padStart(7,"0")}${W.scheme!==T.Schemas.file?W.scheme:""}`})}h.generate=R;function B(W){if(W.scheme===h.scheme){const j=_.exec(W.fragment);if(!!j)return{handle:Number(j[1]),notebook:W.with({scheme:W.fragment.substr(j[0].length)||T.Schemas.file,fragment:null})}}}h.parse=B;function z(W){if(W.scheme===T.Schemas.vscodeNotebookCellMetadata){const j=_.exec(W.fragment);if(!!j)return{handle:Number(j[1]),notebook:W.with({scheme:W.fragment.substr(j[0].length)||T.Schemas.file,fragment:null})}}}h.parseCellMetadataUri=z;function he(W,j,U){return W.with({scheme:U,fragment:`ch${j.toString().padStart(7,"0")}${W.scheme!==T.Schemas.file?W.scheme:""}`})}h.generateCellUri=he;function de(W,j){if(W.scheme===j){const U=_.exec(W.fragment);if(!!U)return{handle:Number(U[1]),notebook:W.with({scheme:W.fragment.substr(U[0].length)||T.Schemas.file,fragment:null})}}}h.parseCellUri=de})(a=e.CellUri||(e.CellUri={}));const p=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function f(h){var _,R;return(R=(_=p.get(h))===null||_===void 0?void 0:_.alwaysSecure)!==null&&R!==void 0?R:!1}e.mimeTypeIsAlwaysSecure=f;function E(h){var _,R;return(R=(_=p.get(h))===null||_===void 0?void 0:_.supportedByCore)!==null&&R!==void 0?R:!1}e.mimeTypeSupportedByCore=E;function o(h){var _,R;return(R=(_=p.get(h))===null||_===void 0?void 0:_.mergeable)!==null&&R!==void 0?R:!1}e.mimeTypeIsMergeable=o;function c(h,_){return A.isWindows&&(h=h.replace(/\//g,"\\"),_=_.replace(/\//g,"\\")),v.match(h,_)}function m(h,_,R){let B=0;for(let z=0;z<_.length;z++){if(c(_[z],h))return B;B++}for(let z=0;z<R.length;z++){if(c(R[z],h))return B;B++}return B}function t(h,_,R){return h.sort((B,z)=>m(B,_,R)-m(z,_,R))}e.sortMimeTypes=t;function n(h,_,R,B=(z,he)=>z===he){const z=[];function he(j,U,F){if(!(U===0&&F.length===0)){const L=z[z.length-1];L&&L.start+L.deleteCount===j?(L.deleteCount+=U,L.toInsert.push(...F)):z.push({start:j,deleteCount:U,toInsert:F})}}let de=0,W=0;for(;;){if(de===h.length){he(de,0,_.slice(W));break}if(W===_.length){he(de,h.length-de,[]);break}const j=h[de],U=_[W];if(B(j,U)){de+=1,W+=1;continue}R(U)?(he(de,1,[]),de+=1):(he(de,0,[U]),W+=1)}return z}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var l;(function(h){h.default="default",h.option="option"})(l=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(h){const _=h;return!!((typeof _.include=="string"||v.isRelativePattern(_.include))&&(typeof _.exclude=="string"||v.isRelativePattern(_.exclude)))}e.isDocumentExcludePattern=s;function u(h,_,R){if(Array.isArray(h.viewType)&&h.viewType.indexOf(_)>=0||h.viewType===_)return!0;if(h.filenamePattern){let B=s(h.filenamePattern)?h.filenamePattern.include:h.filenamePattern,z=s(h.filenamePattern)?h.filenamePattern.exclude:void 0;if(v.match(B,(0,D.basename)(R.fsPath).toLowerCase()))return!(z&&v.match(z,(0,D.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class w{constructor(_){this.textModel=_}getElements(){const _=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)_[R]=this.textModel.cells[R].getHashValue();return _}}e.CellSequence=w,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var b;(function(h){h[h.Left=1]="Left",h[h.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class I{static create(_){return`${I._prefix}/${_}`}static parse(_){if(_.startsWith(I._prefix))return _.substr(I._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=I,I._prefix="notebook/"}),define(ve[171],be([0,1,142,4,63]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=(0,T.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[172],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=v;function T(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=T}),define(ve[97],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(S,k)=>{k.expand!==void 0&&(S.expand=k.expand),k.item!==void 0&&(S.item=S.item?Object.assign(S.item,k.item):k.item)};e.applyTestItemUpdate=T;var D;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",S[S.Retire=4]="Retire"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(S,k)=>`${S}:${k.toString()}`;e.getTestSubscriptionKey=A;class y{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=y;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const d=P[1];if(d.parent){if(this.items.has(d.parent)){const g=this.items.get(d.parent);g.children.add(d.item.extId);const r=this.createItem(d,g);this.items.set(d.item.extId,r),i.add(r)}}else{this.roots.add(d.item.extId);const g=this.createItem(d);this.items.set(d.item.extId,g),i.add(g)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=P[1],g=this.items.get(d.extId);if(!g)break;d.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,d),i.update(g);break}case 2:{const d=this.items.get(P[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const g=[[P[1]]];for(;g.length;)for(const r of g.pop()){const a=this.items.get(r);a&&(g.push(a.children),this.items.delete(r),i.remove(a,a!==d),a.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}i.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=C}),define(ve[173],be([0,1,14,46,10,23,21,58,143]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,d,g){this._contributedVariables=new Map,this._context=P,this._labelService=d,g&&(this._envVariablesPromise=g.then(r=>this.prepareEnv(r)))}prepareEnv(P){if(y.isWindows){const d=Object.create(null);return Object.keys(P).forEach(g=>{d[g.toLowerCase()]=P[g]}),d}return P}resolveWithEnvironment(P,d,g){return this.recursiveResolve(this.prepareEnv(P),d?d.uri:void 0,g)}async resolveAsync(P,d){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,d)}async resolveAnyBase(P,d,g,r){const a=A.deepClone(d);return y.isWindows&&a.windows?Object.keys(a.windows).forEach(p=>a[p]=a.windows[p]):y.isMacintosh&&a.osx?Object.keys(a.osx).forEach(p=>a[p]=a.osx[p]):y.isLinux&&a.linux&&Object.keys(a.linux).forEach(p=>a[p]=a.linux[p]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,a,g,r)}async resolveAnyAsync(P,d,g){return this.resolveAnyBase(P,d,g)}async resolveAnyMap(P,d,g){const r=new Map;return{newConfig:await this.resolveAnyBase(P,d,g,r),resolvedVariables:r}}resolveWithInteractionReplace(P,d,g,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,d,g,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,d){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,d)}recursiveResolve(P,d,g,r,a){if(D.isString(g))return this.resolveString(P,d,g,r,a);if(D.isArray(g))return g.map(p=>this.recursiveResolve(P,d,p,r,a));if(D.isObject(g)){let p=Object.create(null);return Object.keys(g).forEach(f=>{const E=this.resolveString(P,d,f,r,a);p[E]=this.recursiveResolve(P,d,g[f],r,a)}),p}return g}resolveString(P,d,g,r,a){return g.replace(k.VARIABLE_REGEXP,(f,E)=>{if(E.includes(k.VARIABLE_LHS))return f;let o=this.evaluateSingleVariable(P,f,E,d,r);return a&&a.set(E,o),o})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,d,g,r,a){let p;const f=g.split(":");f.length>1&&(g=f[0],p=f[1]);const E=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,S.localize)(0,null,d))},o=()=>{const m=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,d,v.basename(m)))},c=()=>{if(p){const m=this._context.getFolderUri(p);if(m)return m;throw new Error((0,S.localize)(2,null,d,p))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,d)):new Error((0,S.localize)(4,null,d))};switch(g){case"env":if(p){if(P){const m=P[y.isWindows?p.toLowerCase():p];if(D.isString(m))return m}return""}throw new Error((0,S.localize)(5,null,d));case"config":if(p){const m=this._context.getConfigurationValue(r,p);if(D.isUndefinedOrNull(m))throw new Error((0,S.localize)(6,null,d,p));if(D.isObject(m))throw new Error((0,S.localize)(7,null,d,p));return m}throw new Error((0,S.localize)(8,null,d));case"command":return this.resolveFromMap(d,p,a,"command");case"input":return this.resolveFromMap(d,p,a,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return r||p?(0,C.normalizeDriveLetter)(this.fsPath(c())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(c()));case"lineNumber":const m=this._context.getLineNumber();if(m)return m;throw new Error((0,S.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,d));case"file":return E();case"fileWorkspaceFolder":return o();case"relativeFile":return r||p?v.relative(this.fsPath(c()),E()):E();case"relativeFileDirname":const n=v.dirname(E());if(r||p){const w=v.relative(this.fsPath(c()),n);return w.length===0?".":w}return n;case"fileDirname":return v.dirname(E());case"fileExtname":return v.extname(E());case"fileBasename":return v.basename(E());case"fileBasenameNoExtension":const l=v.basename(E());return l.slice(0,l.length-v.extname(l).length);case"fileDirnameBasename":return v.basename(v.dirname(E()));case"execPath":const s=this._context.getExecPath();return s||d;case"execInstallFolder":const u=this._context.getAppRoot();return u||d;case"pathSeparator":return v.sep;default:try{const w=p?`${g}:${p}`:g;return this.resolveFromMap(d,w,a,void 0)}catch(w){return d}}}}resolveFromMap(P,d,g,r){if(d&&g){const a=r===void 0?g[d]:g[r+":"+d];if(typeof a=="string")return a;throw new Error((0,S.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[174],be([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var T;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var D;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var S;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function P(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(ve[175],be([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ve[9],be([0,1,13,84,229,57,23,10,2,32,62,144,91,74,175,7]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(pe){function ue(K){const{selectionStartLineNumber:Me,selectionStartColumn:Te,positionLineNumber:Je,positionColumn:et}=K,ut=new a.Position(Me-1,Te-1),ct=new a.Position(Je-1,et-1);return new a.Selection(ut,ct)}pe.to=ue;function re(K){const{anchor:Me,active:Te}=K;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}pe.from=re})(p=e.Selection||(e.Selection={}));var f;(function(pe){function ue(K){if(!!K){const{start:Me,end:Te}=K;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}pe.from=ue;function re(K){if(!!K){const{startLineNumber:Me,startColumn:Te,endLineNumber:Je,endColumn:et}=K;return new a.Range(Me-1,Te-1,Je-1,et-1)}}pe.to=re})(f=e.Range||(e.Range={}));var E;(function(pe){function ue(re){switch(re){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 4:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}pe.to=ue})(E=e.TokenType||(e.TokenType={}));var o;(function(pe){function ue(K){return new a.Position(K.lineNumber-1,K.column-1)}pe.to=ue;function re(K){return{lineNumber:K.line+1,column:K.character+1}}pe.from=re})(o=e.Position||(e.Position={}));var c;(function(pe){function ue(K){switch(K){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}pe.from=ue;function re(K){switch(K){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}pe.to=re})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(pe){function ue(K){let Me;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?Me=String(K.code):Me={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},f.from(K.range)),{message:K.message,source:K.source,code:Me,severity:n.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,v.coalesce)(K.tags.map(c.from)):void 0})}pe.from=ue;function re(K){var Me;const Te=new a.Diagnostic(f.to(K),K.message,n.to(K.severity));return Te.source=K.source,Te.code=(0,C.isString)(K.code)?K.code:(Me=K.code)===null||Me===void 0?void 0:Me.value,Te.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),Te.tags=K.tags&&(0,v.coalesce)(K.tags.map(c.to)),Te}pe.to=re})(m=e.Diagnostic||(e.Diagnostic={}));var t;(function(pe){function ue(K){return Object.assign(Object.assign({},f.from(K.location.range)),{message:K.message,resource:K.location.uri})}pe.from=ue;function re(K){return new a.DiagnosticRelatedInformation(new a.Location(K.resource,f.to(K)),K.message)}pe.to=re})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(pe){function ue(K){switch(K){case a.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}pe.from=ue;function re(K){switch(K){case d.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}pe.to=re})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(pe){function ue(K){return typeof K=="number"&&K>=a.ViewColumn.One?K-1:K===a.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}pe.from=ue;function re(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=re})(l=e.ViewColumn||(e.ViewColumn={}));function s(pe){return typeof pe.range!="undefined"}function u(pe){return pe.length===0?!0:!!s(pe[0])}e.isDecorationOptionsArr=u;var w;(function(pe){function ue(et){return et.map(pe.from)}pe.fromMany=ue;function re(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function K(et){let ut;if(re(et)){const{language:ht,value:ft}=et;ut={value:"```"+ht+`
`+ft+"\n```\n"}}else a.MarkdownString.isMarkdownString(et)?ut={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ut={value:et}:ut={value:""};const ct=Object.create(null);ut.uris=ct;const Ze=ht=>{try{let ft=S.URI.parse(ht,!0);ft=ft.with({query:Me(ft.query,ct)}),ct[ht]=ft}catch(ft){}return""},mt=new D.Renderer;return mt.link=Ze,mt.image=ht=>Ze(T.parseHrefAndDimensions(ht).href),D(ut.value,{renderer:mt}),ut}pe.from=K;function Me(et,ut){if(!et)return et;let ct;try{ct=(0,A.parse)(et)}catch(mt){}if(!ct)return et;let Ze=!1;return ct=(0,y.cloneAndChange)(ct,mt=>{if(S.URI.isUri(mt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ht]=mt,Ze=!0,ht}else return}),Ze?JSON.stringify(ct):et}function Te(et){const ut=new a.MarkdownString(et.value,et.supportThemeIcons);return ut.isTrusted=et.isTrusted,ut}pe.to=Te;function Je(et){if(!!et)return typeof et=="string"?et:pe.from(et)}pe.fromStrict=Je})(w=e.MarkdownString||(e.MarkdownString={}));function b(pe){return u(pe)?pe.map(ue=>({range:f.from(ue.range),hoverMessage:Array.isArray(ue.hoverMessage)?w.fromMany(ue.hoverMessage):ue.hoverMessage?w.from(ue.hoverMessage):void 0,renderOptions:ue.renderOptions})):pe.map(ue=>({range:f.from(ue)}))}e.fromRangeOrRangeWithMessage=b;function I(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?S.URI.file(pe):pe}e.pathOrURIToURI=I;var h;(function(pe){function ue(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?I(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}pe.from=ue})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var _;(function(pe){function ue(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?I(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?h.from(re.before):void 0,after:re.after?h.from(re.after):void 0}}pe.from=ue})(_=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(pe){function ue(re){if(typeof re=="undefined")return re;switch(re){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=ue})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(pe){function ue(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?R.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?_.from(re.light):void 0,dark:re.dark?_.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?I(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?h.from(re.before):void 0,after:re.after?h.from(re.after):void 0}}pe.from=ue})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(pe){function ue(K){return{text:K.newText,eol:K.newEol&&Z.from(K.newEol),range:f.from(K.range)}}pe.from=ue;function re(K){const Me=new a.TextEdit(f.to(K.range),K.text);return Me.newEol=typeof K.eol=="undefined"?void 0:Z.to(K.eol),Me}pe.to=re})(z=e.TextEdit||(e.TextEdit={}));var he;(function(pe){function ue(K,Me,Te){var Je,et,ut;const ct={edits:[]};if(K instanceof a.WorkspaceEdit)for(let Ze of K._allEntries())if(Ze._type===1)ct.edits.push({_type:1,oldUri:Ze.from,newUri:Ze.to,options:Ze.options,metadata:Ze.metadata});else if(Ze._type===2){const mt=Me==null?void 0:Me.getDocument(Ze.uri);ct.edits.push({_type:2,resource:Ze.uri,edit:z.from(Ze.edit),modelVersionId:mt==null?void 0:mt.version,metadata:Ze.metadata})}else Ze._type===3?ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:Ze.edit,notebookMetadata:Ze.notebookMetadata,notebookVersionId:(Je=Te==null?void 0:Te.getNotebookDocument(Ze.uri,!0))===null||Je===void 0?void 0:Je.apiNotebook.version}):Ze._type===4?(Ze.newOutputs&&ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:2,index:Ze.index,append:Ze.append,outputs:Ze.newOutputs.map(ke.from)}}),Ze.newMetadata&&ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:8,index:Ze.index,metadata:Ze.newMetadata}})):Ze._type===5?ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,notebookVersionId:(et=Te==null?void 0:Te.getNotebookDocument(Ze.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:Ze.index,count:Ze.count,cells:Ze.cells.map(Q.from)}}):Ze._type===6&&ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:7,outputId:Ze.outputId,items:((ut=Ze.newOutputItems)===null||ut===void 0?void 0:ut.map(oe.from))||[],append:Ze.append}});return ct}pe.from=ue;function re(K){const Me=new a.WorkspaceEdit;for(const Te of K.edits)Te.edit?Me.replace(S.URI.revive(Te.resource),f.to(Te.edit.range),Te.edit.text):Me.renameFile(S.URI.revive(Te.oldUri),S.URI.revive(Te.newUri),Te.options);return Me}pe.to=re})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var de;(function(pe){const ue=Object.create(null);ue[a.SymbolKind.File]=0,ue[a.SymbolKind.Module]=1,ue[a.SymbolKind.Namespace]=2,ue[a.SymbolKind.Package]=3,ue[a.SymbolKind.Class]=4,ue[a.SymbolKind.Method]=5,ue[a.SymbolKind.Property]=6,ue[a.SymbolKind.Field]=7,ue[a.SymbolKind.Constructor]=8,ue[a.SymbolKind.Enum]=9,ue[a.SymbolKind.Interface]=10,ue[a.SymbolKind.Function]=11,ue[a.SymbolKind.Variable]=12,ue[a.SymbolKind.Constant]=13,ue[a.SymbolKind.String]=14,ue[a.SymbolKind.Number]=15,ue[a.SymbolKind.Boolean]=16,ue[a.SymbolKind.Array]=17,ue[a.SymbolKind.Object]=18,ue[a.SymbolKind.Key]=19,ue[a.SymbolKind.Null]=20,ue[a.SymbolKind.EnumMember]=21,ue[a.SymbolKind.Struct]=22,ue[a.SymbolKind.Event]=23,ue[a.SymbolKind.Operator]=24,ue[a.SymbolKind.TypeParameter]=25;function re(Me){return typeof ue[Me]=="number"?ue[Me]:6}pe.from=re;function K(Me){for(const Te in ue)if(ue[Te]===Me)return Number(Te);return a.SymbolKind.Property}pe.to=K})(de=e.SymbolKind||(e.SymbolKind={}));var W;(function(pe){function ue(K){switch(K){case a.SymbolTag.Deprecated:return 1}}pe.from=ue;function re(K){switch(K){case 1:return a.SymbolTag.Deprecated}}pe.to=re})(W=e.SymbolTag||(e.SymbolTag={}));var j;(function(pe){function ue(K){return{name:K.name,kind:de.from(K.kind),tags:K.tags&&K.tags.map(W.from),containerName:K.containerName,location:x.from(K.location)}}pe.from=ue;function re(K){const Me=new a.SymbolInformation(K.name,de.to(K.kind),K.containerName,x.to(K.location));return Me.tags=K.tags&&K.tags.map(W.to),Me}pe.to=re})(j=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(pe){function ue(K){var Me,Te;const Je={name:K.name||"!!MISSING: name!!",detail:K.detail,range:f.from(K.range),selectionRange:f.from(K.selectionRange),kind:de.from(K.kind),tags:(Te=(Me=K.tags)===null||Me===void 0?void 0:Me.map(W.from))!==null&&Te!==void 0?Te:[]};return K.children&&(Je.children=K.children.map(ue)),Je}pe.from=ue;function re(K){const Me=new a.DocumentSymbol(K.name,K.detail,de.to(K.kind),f.to(K.range),f.to(K.selectionRange));return(0,v.isNonEmptyArray)(K.tags)&&(Me.tags=K.tags.map(W.to)),K.children&&(Me.children=K.children.map(re)),Me}pe.to=re})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(pe){function ue(re){const K=new a.CallHierarchyItem(de.to(re.kind),re.name,re.detail||"",S.URI.revive(re.uri),f.to(re.range),f.to(re.selectionRange));return K._sessionId=re._sessionId,K._itemId=re._itemId,K}pe.to=ue})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(pe){function ue(re){return new a.CallHierarchyIncomingCall(F.to(re.from),re.fromRanges.map(K=>f.to(K)))}pe.to=ue})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(pe){function ue(re){return new a.CallHierarchyOutgoingCall(F.to(re.to),re.fromRanges.map(K=>f.to(K)))}pe.to=ue})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var x;(function(pe){function ue(K){return{range:K.range&&f.from(K.range),uri:K.uri}}pe.from=ue;function re(K){return new a.Location(S.URI.revive(K.uri),f.to(K.range))}pe.to=re})(x=e.location||(e.location={}));var G;(function(pe){function ue(K){const Me=K,Te=K;return{originSelectionRange:Me.originSelectionRange?f.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Te.uri,range:f.from(Me.targetRange?Me.targetRange:Te.range),targetSelectionRange:Me.targetSelectionRange?f.from(Me.targetSelectionRange):void 0}}pe.from=ue;function re(K){return{targetUri:S.URI.revive(K.uri),targetRange:f.to(K.range),targetSelectionRange:K.targetSelectionRange?f.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?f.to(K.originSelectionRange):void 0}}pe.to=re})(G=e.DefinitionLink||(e.DefinitionLink={}));var J;(function(pe){function ue(K){return{range:f.from(K.range),contents:w.fromMany(K.contents)}}pe.from=ue;function re(K){return new a.Hover(K.contents.map(w.to),f.to(K.range))}pe.to=re})(J=e.Hover||(e.Hover={}));var te;(function(pe){function ue(K){return{range:f.from(K.range),expression:K.expression}}pe.from=ue;function re(K){return new a.EvaluatableExpression(f.to(K.range),K.expression)}pe.to=re})(te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var me;(function(pe){function ue(K){if(K instanceof a.InlineValueText)return{type:"text",range:f.from(K.range),text:K.text};if(K instanceof a.InlineValueVariableLookup)return{type:"variable",range:f.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:f.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=ue;function re(K){switch(K.type){case"text":return{range:f.to(K.range),text:K.text};case"variable":return{range:f.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:f.to(K.range),expression:K.expression}}}pe.to=re})(me=e.InlineValue||(e.InlineValue={}));var Le;(function(pe){function ue(K){return{frameId:K.frameId,stoppedLocation:f.from(K.stoppedLocation)}}pe.from=ue;function re(K){return new a.InlineValueContext(K.frameId,f.to(K.stoppedLocation))}pe.to=re})(Le=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(pe){function ue(K){return{range:f.from(K.range),kind:K.kind}}pe.from=ue;function re(K){return new a.DocumentHighlight(f.to(K.range),K.kind)}pe.to=re})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(pe){function ue(re){switch(re){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}pe.to=ue})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(pe){function ue(re){return{triggerKind:Fe.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}pe.to=ue})(ze=e.CompletionContext||(e.CompletionContext={}));var H;(function(pe){function ue(K){switch(K){case a.CompletionItemTag.Deprecated:return 1}}pe.from=ue;function re(K){switch(K){case 1:return a.CompletionItemTag.Deprecated}}pe.to=re})(H=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(pe){const ue=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function re(Te){var Je;return(Je=ue.get(Te))!==null&&Je!==void 0?Je:9}pe.from=re;const K=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Me(Te){var Je;return(Je=K.get(Te))!==null&&Je!==void 0?Je:a.CompletionItemKind.Property}pe.to=Me})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(pe){function ue(re,K){var Me;const Te=new a.CompletionItem(typeof re.label=="string"?re.label:re.label.name);return typeof re.label!="string"&&(Te.label2=re.label),Te.insertText=re.insertText,Te.kind=q.to(re.kind),Te.tags=(Me=re.tags)===null||Me===void 0?void 0:Me.map(H.to),Te.detail=re.detail,Te.documentation=T.isMarkdownString(re.documentation)?w.to(re.documentation):re.documentation,Te.sortText=re.sortText,Te.filterText=re.filterText,Te.preselect=re.preselect,Te.commitCharacters=re.commitCharacters,k.Range.isIRange(re.range)?Te.range=f.to(re.range):typeof re.range=="object"&&(Te.range={inserting:f.to(re.range.insert),replacing:f.to(re.range.replace)}),Te.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?Te.insertText=new a.SnippetString(re.insertText):(Te.insertText=re.insertText,Te.textEdit=Te.range instanceof a.Range?new a.TextEdit(Te.range,Te.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(Te.additionalTextEdits=re.additionalTextEdits.map(Je=>z.to(Je))),Te.command=K&&re.command?K.fromInternal(re.command):void 0,Te}pe.to=ue})(ee=e.CompletionItem||(e.CompletionItem={}));var se;(function(pe){function ue(K){return{label:K.label,documentation:K.documentation?w.fromStrict(K.documentation):void 0}}pe.from=ue;function re(K){return{label:K.label,documentation:T.isMarkdownString(K.documentation)?w.to(K.documentation):K.documentation}}pe.to=re})(se=e.ParameterInformation||(e.ParameterInformation={}));var ce;(function(pe){function ue(K){return{label:K.label,documentation:K.documentation?w.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(se.from):[],activeParameter:K.activeParameter}}pe.from=ue;function re(K){return{label:K.label,documentation:T.isMarkdownString(K.documentation)?w.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(se.to):[],activeParameter:K.activeParameter}}pe.to=re})(ce=e.SignatureInformation||(e.SignatureInformation={}));var _e;(function(pe){function ue(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ce.from):[]}}pe.from=ue;function re(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ce.to):[]}}pe.to=re})(_e=e.SignatureHelp||(e.SignatureHelp={}));var $e;(function(pe){function ue(K){var Me;return{text:K.text,position:o.from(K.position),kind:fe.from((Me=K.kind)!==null&&Me!==void 0?Me:a.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}pe.from=ue;function re(K){const Me=new a.InlayHint(K.text,o.to(K.position),fe.to(K.kind));return Me.whitespaceAfter=K.whitespaceAfter,Me.whitespaceBefore=K.whitespaceBefore,Me}pe.to=re})($e=e.InlayHint||(e.InlayHint={}));var fe;(function(pe){function ue(K){return K}pe.from=ue;function re(K){return K}pe.to=re})(fe=e.InlayHintKind||(e.InlayHintKind={}));var De;(function(pe){function ue(K){return{range:f.from(K.range),url:K.target,tooltip:K.tooltip}}pe.from=ue;function re(K){let Me;if(K.url)try{Me=typeof K.url=="string"?S.URI.parse(K.url,!0):S.URI.revive(K.url)}catch(Te){}return new a.DocumentLink(f.to(K.range),Me)}pe.to=re})(De=e.DocumentLink||(e.DocumentLink={}));var Re;(function(pe){function ue(K){const Me=new a.ColorPresentation(K.label);return K.textEdit&&(Me.textEdit=z.to(K.textEdit)),K.additionalTextEdits&&(Me.additionalTextEdits=K.additionalTextEdits.map(Te=>z.to(Te))),Me}pe.to=ue;function re(K){return{label:K.label,textEdit:K.textEdit?z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Me=>z.from(Me)):void 0}}pe.from=re})(Re=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(pe){function ue(K){return new a.Color(K[0],K[1],K[2],K[3])}pe.to=ue;function re(K){return[K.red,K.green,K.blue,K.alpha]}pe.from=re})(He=e.Color||(e.Color={}));var we;(function(pe){function ue(K){return{range:f.from(K.range)}}pe.from=ue;function re(K){return new a.SelectionRange(f.to(K.range))}pe.to=re})(we=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(pe){function ue(re){switch(re){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}pe.to=ue})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(pe){function ue(K){switch(K){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=ue;function re(K){switch(K){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}pe.to=re})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(pe){function ue(K){if(K===a.EndOfLine.CRLF)return 1;if(K===a.EndOfLine.LF)return 0}pe.from=ue;function re(K){if(K===1)return a.EndOfLine.CRLF;if(K===0)return a.EndOfLine.LF}pe.to=re})(Z=e.EndOfLine||(e.EndOfLine={}));var ge;(function(pe){function ue(re){if(typeof re=="object")return re.viewId;switch(re){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=ue})(ge=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(pe){function ue(re){const K={start:re.start+1,end:re.end+1};return re.kind&&(K.kind=Ve.from(re.kind)),K}pe.from=ue})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(pe){function ue(re){if(re)switch(re){case a.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}pe.from=ue})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xe;(function(pe){function ue(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?f.from(re.selection):void 0,override:typeof re.override=="boolean"?P.EditorOverride.DISABLED:void 0}}pe.from=ue})(xe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(pe){function ue(K){return K instanceof a.RelativePattern||typeof K=="string"?K:re(K)?new a.RelativePattern(K.base,K.pattern):K}pe.from=ue;function re(K){const Me=K;return Me&&typeof Me.base=="string"&&typeof Me.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var ye;(function(pe){function ue(re){if(re){if(Array.isArray(re))return re.map(ue);if(typeof re=="string")return re;{const K=re;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Xe.from(K.pattern),exclusive:K.exclusive}}}else return}pe.from=ue})(ye=e.LanguageSelector||(e.LanguageSelector={}));var Ee;(function(pe){function ue(K){return{start:K.start,end:K.end}}pe.from=ue;function re(K){return new a.NotebookRange(K.start,K.end)}pe.to=re})(Ee=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(pe){function ue(re){return new a.NotebookCellMetadata().with(Object.assign(Object.assign({},re),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}pe.to=ue})(Ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var ie;(function(pe){function ue(K){return K}pe.from=ue;function re(K){return new a.NotebookDocumentMetadata().with(K)}pe.to=re})(ie=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ae;(function(pe){function ue(K){return{startTime:K.runStartTime,endTime:K.runEndTime,executionOrder:K.executionOrder,success:K.lastRunSuccess}}pe.to=ue;function re(K){return{lastRunSuccess:K.success,runStartTime:K.startTime,runEndTime:K.endTime,executionOrder:K.executionOrder}}pe.from=re})(ae=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var N;(function(pe){function ue(K){switch(K){case a.NotebookCellKind.Markup:return g.CellKind.Markup;case a.NotebookCellKind.Code:default:return g.CellKind.Code}}pe.from=ue;function re(K){switch(K){case g.CellKind.Markup:return a.NotebookCellKind.Markup;case g.CellKind.Code:default:return a.NotebookCellKind.Code}}pe.to=re})(N=e.NotebookCellKind||(e.NotebookCellKind={}));var Q;(function(pe){function ue(K){var Me;return{cellKind:N.from(K.kind),language:K.languageId,source:K.value,metadata:Object.assign(Object.assign({},K.metadata),ae.from((Me=K.latestExecutionSummary)!==null&&Me!==void 0?Me:{})),outputs:K.outputs?K.outputs.map(ke.from):[]}}pe.from=ue;function re(K){return new a.NotebookCellData(N.to(K.cellKind),K.source,K.language,K.outputs?K.outputs.map(ke.to):void 0,K.metadata?Ce.to(K.metadata):void 0)}pe.to=re})(Q=e.NotebookCellData||(e.NotebookCellData={}));var oe;(function(pe){function ue(K){return{mime:K.mime,value:K.value,metadata:K.metadata}}pe.from=ue;function re(K){return new a.NotebookCellOutputItem(K.mime,K.value,K.metadata)}pe.to=re})(oe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ke;(function(pe){function ue(K){return{outputId:K.id,outputs:K.outputs.map(oe.from),metadata:K.metadata}}pe.from=ue;function re(K){const Me=K.outputs.map(oe.to);return new a.NotebookCellOutput(Me,K.outputId,K.metadata)}pe.to=re})(ke=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(pe){function ue(Te){if(Te!=null){if(Te instanceof a.RelativePattern||typeof Te=="string")return Te;if(Me(Te))return new a.RelativePattern(Te.base,Te.pattern);if(K(Te))return{include:Xe.from(Te.include)||void 0,exclude:Xe.from(Te.exclude)||void 0}}}pe.from=ue;function re(Te){return typeof Te=="string"?Te:Me(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}pe.to=re;function K(Te){const Je=Te,et=Xe.from(Je.include);if(!(et&&et instanceof a.RelativePattern||typeof et=="string"))return!1;const ut=Xe.from(Je.exclude);return!!(ut&&ut instanceof a.RelativePattern||typeof ut=="string")}function Me(Te){const Je=Te;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ae;(function(pe){function ue(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?h.from(re.top):void 0}}pe.from=ue})(Ae=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Be;(function(pe){function ue(re,K,Me){const Te=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Te,Me),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}pe.from=ue})(Be=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ye;(function(pe){function ue(re){var K,Me;return{transientOutputs:(K=re==null?void 0:re.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:Object.assign(Object.assign({},re==null?void 0:re.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Me=re==null?void 0:re.transientDocumentMetadata)!==null&&Me!==void 0?Me:{}}}pe.from=ue})(Ye=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(pe){function ue(K){var Me;return{uri:K.uri,provides:typeof K.provides=="string"?[K.provides]:(Me=K.provides)!==null&&Me!==void 0?Me:[]}}pe.from=ue;function re(K){return new a.NotebookKernelPreload(S.URI.revive(K.uri),K.provides)}pe.to=re})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var tt;(function(pe){function ue(K){return{message:w.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?x.from(K.location):void 0}}pe.from=ue;function re(K){const Me=new a.TestMessage(typeof K.message=="string"?K.message:w.to(K.message));return Me.severity=K.severity,Me.actualOutput=K.actualOutput,Me.expectedOutput=K.expectedOutput,Me}pe.to=re})(tt=e.TestMessage||(e.TestMessage={}));var Qe;(function(pe){function ue(Te){var Je,et;return{extId:Te.id,label:Te.label,uri:Te.uri,range:f.from(Te.range)||null,debuggable:(Je=Te.debuggable)!==null&&Je!==void 0?Je:!1,description:Te.description||null,runnable:(et=Te.runnable)!==null&&et!==void 0?et:!0,error:Te.error&&w.fromStrict(Te.error)||null}}pe.from=ue;function re(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:f.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}pe.fromResultSnapshot=re;function K(Te){return{id:Te.extId,label:Te.label,uri:S.URI.revive(Te.uri),range:f.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:a.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}pe.toPlain=K;function Me(Te){const Je=new a.TestItemImpl(Te.extId,Te.label,S.URI.revive(Te.uri),void 0);return Je.range=f.to(Te.range||void 0),Je.debuggable=Te.debuggable,Je.description=Te.description||void 0,Je.runnable=Te.runnable,Je}pe.to=Me})(Qe=e.TestItem||(e.TestItem={}));var gt;(function(pe){const ue=(K,Me)=>Object.assign(Object.assign({},Qe.toPlain(K.item)),{taskStates:K.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(tt.to)})),children:K.children.map(Te=>Me.get(Te)).filter(C.isDefined).map(Te=>ue(Te,Me))});function re(K){const Me=[],Te=new Map;for(const Je of K.items)Te.set(Je.item.extId,Je),Je.direct&&Me.push(Je);return{completedAt:K.completedAt,results:Me.map(Je=>ue(Je,Te))}}pe.to=re})(gt=e.TestResults||(e.TestResults={}));var bt;(function(pe){function ue(re){switch(re){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}pe.to=ue})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ve[176],be([0,1,2,12,7,9,45]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(k,i,P,d={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=d,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,P,d)=>{const r={dispose:this._callbacks.push([i,P,k])};return Array.isArray(d)&&d.push(r),r}}async $participateInSave(k,i){const P=v.URI.revive(k);let d=!1;const g=setTimeout(()=>d=!0,this._thresholds.timeout),r=[];try{for(let a of[...this._callbacks]){if(d)break;const p=this._documents.getDocument(P),f=await this._deliverEventAsyncAndBlameBadListeners(a,{document:p,reason:A.TextDocumentSaveReason.to(i)});r.push(f)}}finally{clearTimeout(g)}return r}_deliverEventAsyncAndBlameBadListeners([k,i,P],d){const g=this._badListeners.get(k);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,i,d).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this._badListeners.get(k);this._badListeners.set(k,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,P,d){const g=[],r=Date.now(),{document:a,reason:p}=d,{version:f}=a,E=Object.freeze({document:a,reason:p,waitUntil(o){if(Object.isFrozen(g))throw(0,T.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(o))}});try{i.apply(P,[E])}catch(o){return Promise.reject(o)}return Object.freeze(g),new Promise((o,c)=>{const m=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(m),o(t)}).catch(t=>{clearTimeout(m),c(t)})}).then(o=>{const c={edits:[]};for(const m of o)if(Array.isArray(m)&&m.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:n,range:l}of m)c.edits.push({_type:2,resource:a.uri,edit:{range:l&&A.Range.from(l),text:t,eol:n&&A.EndOfLine.from(n)}});if(c.edits.length!==0)return f===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(ve[177],be([0,1,3,11,28,2,9,7]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(P,d,g,r,a){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,g&&(this._config+=1),r&&(this._config+=2),a&&(this._config+=4);const p=(0,D.parse)(d),f=P(E=>{if(!g)for(let o of E.created){const c=A.URI.revive(o);p(c.fsPath)&&this._onDidCreate.fire(c)}if(!r)for(let o of E.changed){const c=A.URI.revive(o);p(c.fsPath)&&this._onDidChange.fire(c)}if(!a)for(let o of E.deleted){const c=A.URI.revive(o);p(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,f)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,d,g){this._logService=d,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,d,g,r){return new S(this._onFileSystemEvent.event,P,d,g,r)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,d){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(g=>A.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,d){return(g,r,a)=>{const p=function(E){g.call(r,E)};return p.extension=P,d.event(p,void 0,a)}}async $onWillRunFileOperation(P,d,g,r){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(a=>({oldUri:A.URI.revive(a.source),newUri:A.URI.revive(a.target)}))},g,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(a=>A.URI.revive(a.target))},g,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(a=>A.URI.revive(a.target))},g,r)}}async _fireWillEvent(P,d,g,r){const a=new Set,p=[];if(await P.fireAsync(d,r,async(E,o)=>{var c;const m=Date.now(),t=await Promise.resolve(E);t instanceof C.WorkspaceEdit&&(p.push(t),a.add((c=o.extension.displayName)!==null&&c!==void 0?c:o.extension.identifier.value)),Date.now()-m>g&&this._logService.warn("SLOW file-participant",o.extension.identifier)}),!r.isCancellationRequested&&p.length!==0){const f={edits:[]};for(let E of p){let{edits:o}=y.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);f.edits=f.edits.concat(o)}return{edit:f,extensionNames:Array.from(a)}}}}e.ExtHostFileSystemEventService=k}),define(ve[178],be([0,1,19,23,2,9,7,74]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(d,g,r,a){this.start=d,this.deletedCount=g,this.deletedItems=r,this.items=a}static asApiEvents(d){return d.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(r=>r.apiCell)}))}}class k{constructor(d,g,r){var a;this.notebook=d,this._extHostDocument=g,this._cellData=r,this.handle=r.handle,this.uri=D.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(a=r.metadata)!==null&&a!==void 0?a:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(d,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get latestExecutionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(A.NotebookCellOutput.to)}setOutputItems(d,g,r){const a=r.map(A.NotebookCellOutputItem.to),p=this._outputs.find(f=>f.id===d);p&&(g||(p.outputs.length=0),p.outputs.push(...a))}setMetadata(d){this._internalMetadata=d,this._metadata=A.NotebookCellMetadata.to(d),this._previousResult=A.NotebookCellPreviousExecutionResult.to(d)}}e.ExtHostCell=k;class i{constructor(d,g,r,a,p,f,E){this._proxy=d,this._textDocumentsAndEditors=g,this._textDocuments=r,this._emitter=a,this._viewType=p,this._metadata=f,this.uri=E,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===v.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(g){return g=d._validateIndex(g),d._cells[g].apiCell},getCells(g){return(g?d._getCells(g):d._cells).map(a=>a.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,g){this._versionId=d.versionId,this._isDirty=g;for(const r of d.rawEvents)r.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===C.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===C.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let g=d.start|0,r=d.end|0;return g<0&&(g=0),r>this._cells.length&&(r=this._cells.length),d.with({start:g,end:r})}_getCells(d){d=this._validateRange(d);const g=[];for(let r=d.start;r<d.end;r++)g.push(this._cells[r]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(d,g){if(!this._disposed){const r=[],a=[],p=[];d.reverse().forEach(f=>{const o=f[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return g||a.push(k.asModelAddData(this.apiNotebook,t)),n}),c=new S(f[0],f[1],[],o),m=this._cells.splice(f[0],f[1],...o);for(const t of m)p.push(t.uri),c.deletedItems.push(t.apiCell);r.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:p}),g||this._emitter.emitModelChange((0,T.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(r)}))}}_moveCell(d,g){const r=this._cells.splice(d,1);this._cells.splice(g,0,...r);const a=[new S(d,1,r.map(p=>p.apiCell),[]),new S(g,0,[],r)];this._emitter.emitModelChange((0,T.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(a)}))}_setCellOutputs(d,g){const r=this._cells[d];r.setOutputs(g),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(d,g,r,a){const p=this._cells[d];p.setOutputItems(g,r,a),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(d,g){const r=this._cells[d];r.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(r.uri,g)}_changeCellMetadata(d,g){var r;const a=this._cells[d],p=a.internalMetadata,f=a.apiCell.metadata;a.setMetadata(g);const E=a.apiCell.metadata;if((0,T.equals)(f,E)||this._emitter.emitCellMetadataChange((0,T.deepFreeze)({document:this.apiNotebook,cell:a.apiCell})),p.runState!==g.runState){const o=(r=g.runState)!==null&&r!==void 0?r:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,T.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,executionState:o}))}}getCellFromApiCell(d){return this._cells.find(g=>g.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(g=>g.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(ve[179],be([0,1,7,9]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,S){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:S})}replaceCells(C,S,k){this._throwIfFinalized(),!(C===S&&k.length===0)&&this._collectedEdits.push({editType:1,index:C,count:S-C,cells:k.map(T.NotebookCellData.from)})}}class A{constructor(C,S,k,i,P,d){this.id=C,this._proxy=S,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=i,this._viewColumn=d}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(S,k){C._proxy.$tryRevealRange(C.id,T.NotebookRange.from(S),k!=null?k:v.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(S){const k=new D(this.document.version);return S(k),C._applyEdit(k.finalize())},setDecorations(S,k){return C.setDecorations(S,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const S=[];let k=-1;for(let i=0;i<C.cellEdits.length;i++){if(k<0){S.push(C.cellEdits[i]),k++;continue}const d=S[k],g=C.cellEdits[i];if(d.editType===1&&g.editType===1&&d.index===g.index){d.cells.push(...C.cellEdits[i].cells),d.count+=C.cellEdits[i].count;continue}S.push(C.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,S)}setDecorations(C,S){if(!(S.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return S.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(S),C.key)}}e.ExtHostNotebookEditor=A}),define(ve[180],be([0,1,9,154,134,20,52]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,d,g){const r=this._handles++,{title:a,location:p,cancellable:f}=d,E={label:(0,D.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(r,{location:v.ProgressLocation.from(p),title:a,source:E,cancellable:f},P),this._withProgress(r,g,!!f)}_withProgress(P,d,g){let r;g&&(r=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,r));const a=f=>{this._proxy.$progressEnd(f),this._mapHandleToCancellationSource.delete(f),r&&r.dispose()};let p;try{p=d(new k(this._proxy,P),g&&r?r.token:A.CancellationToken.None)}catch(f){throw a(P),f}return p.then(f=>a(P),f=>a(P)),p}$acceptProgressCanceled(P){const d=this._mapHandleToCancellationSource.get(P);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=C;function S(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class k extends T.Progress{constructor(P,d){super(g=>this.throttledReport(g));this._proxy=P,this._handle=d}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}je([(0,y.throttle)(100,(i,P)=>S(i,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ve[98],be([0,1,42,12,54,9,7]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(d,g){const r=C._Keys.nextId();d.$registerTextEditorDecorationType(r,A.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=C,C._Keys=new D.IdGenerator("TextEditorDecorationType");class S{constructor(d,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,g){this._throwIfFinalized();let r=null;if(d instanceof y.Position)r=new y.Range(d,d);else if(d instanceof y.Range)r=d;else throw new Error("Unrecognized location");this._pushEdit(r,g,!1)}insert(d,g){this._throwIfFinalized(),this._pushEdit(new y.Range(d,d),g,!0)}delete(d){this._throwIfFinalized();let g=null;if(d instanceof y.Range)g=d;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(d,g,r){const a=this._document.validateRange(d);this._collectedEdits.push({range:a,text:g,forceMoveMarkers:r})}setEndOfLine(d){if(this._throwIfFinalized(),d!==y.EndOfLine.LF&&d!==y.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=S;class k{constructor(d,g,r,a){this._proxy=d,this._id=g,this._accept(r),this._logService=a;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(f){p._setTabSize(f)},get insertSpaces(){return p._insertSpaces},set insertSpaces(f){p._setInsertSpaces(f)},get cursorStyle(){return p._cursorStyle},set cursorStyle(f){p._setCursorStyle(f)},get lineNumbers(){return p._lineNumbers},set lineNumbers(f){p._setLineNumbers(f)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const g=Math.floor(d);return g>0?g:null}if(typeof d=="string"){const g=parseInt(d,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(d){const g=this._validateTabSize(d);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const g=this._validateInsertSpaces(d);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(d)})))}assign(d){const g={};let r=!1;if(typeof d.tabSize!="undefined"){const a=this._validateTabSize(d.tabSize);a==="auto"?(r=!0,g.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,r=!0,g.tabSize=a)}if(typeof d.insertSpaces!="undefined"){const a=this._validateInsertSpaces(d.insertSpaces);a==="auto"?(r=!0,g.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,r=!0,g.insertSpaces=a)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,r=!0,g.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,r=!0,g.lineNumbers=A.TextEditorLineNumbersStyle.from(d.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(d){d.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=k;class i{constructor(d,g,r,a,p,f,E,o){this.id=d,this._proxy=g,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new k(this._proxy,this.id,f,r),this._visibleRanges=E,this._viewColumn=o;const c=this;this.value=Object.freeze({get document(){return a.getValue()},set document(m){throw(0,T.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(m){if(!(m instanceof y.Selection))throw(0,T.illegalArgument)("selection");c._selections=[m],c._trySetSelection()},get selections(){return c._selections},set selections(m){if(!Array.isArray(m)||m.some(t=>!(t instanceof y.Selection)))throw(0,T.illegalArgument)("selections");c._selections=m,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(m){throw(0,T.readonly)("visibleRanges")},get options(){return c._options.value},set options(m){c._disposed||c._options.assign(m)},get viewColumn(){return c._viewColumn},set viewColumn(m){throw(0,T.readonly)("viewColumn")},edit(m,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new S(a.getValue(),t);return m(n),c._applyEdit(n)},insertSnippet(m,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!t||Array.isArray(t)&&t.length===0)l=c._selections.map(s=>A.Range.from(s));else if(t instanceof y.Position){const{lineNumber:s,column:u}=A.Position.from(t);l=[{startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u}]}else if(t instanceof y.Range)l=[A.Range.from(t)];else{l=[];for(const s of t)if(s instanceof y.Range)l.push(A.Range.from(s));else{const{lineNumber:u,column:w}=A.Position.from(s);l.push({startLineNumber:u,startColumn:w,endLineNumber:u,endColumn:w})}}return g.$tryInsertSnippet(d,m.value,l,n)},setDecorations(m,t){const n=t.length===0;n&&!c._hasDecorationsForKey.has(m.key)||(n?c._hasDecorationsForKey.delete(m.key):c._hasDecorationsForKey.add(m.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return g.$trySetDecorations(d,m.key,A.fromRangeOrRangeWithMessage(t));{const l=new Array(4*t.length);for(let s=0,u=t.length;s<u;s++){const w=t[s];l[4*s]=w.start.line+1,l[4*s+1]=w.start.character+1,l[4*s+2]=w.end.line+1,l[4*s+3]=w.end.character+1}return g.$trySetDecorationsFast(d,m.key,l)}}))},revealRange(m,t){c._runOnProxy(()=>g.$tryRevealRange(d,A.Range.from(m),t||y.TextEditorRevealType.Default))},show(m){g.$tryShowEditor(d,A.ViewColumn.from(m))},hide(){g.$tryHideEditor(d)}})}dispose(){(0,v.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,v.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,v.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,v.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,v.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const g=d.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const r=g.edits.map(p=>p.range);r.sort((p,f)=>p.end.line===f.end.line?p.end.character===f.end.character?p.start.line===f.start.line?p.start.character-f.start.character:p.start.line-f.start.line:p.end.character-f.end.character:p.end.line-f.end.line);for(let p=0,f=r.length-1;p<f;p++){const E=r[p].end;if(r[p+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=g.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,a,{setEndOfLine:typeof g.setEndOfLine=="number"?A.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=i}),define(ve[181],be([0,1,137,25,2,3,6,11,7,10,13,9,20]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(p,f){if((0,k.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let E;return Array.isArray(p.highlights)&&(E=p.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),E=E.length?E:void 0),{label:p.label,highlights:E}}}class r{constructor(f,E,o){this._proxy=f,this.commands=E,this.logService=o,this.treeViews=new Map;function c(m){return m&&m.$treeViewId&&m.$treeItemHandle}E.registerArgumentProcessor({processArgument:m=>c(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(t=>c(t)?this.convertArgument(t):t):m})}registerTreeDataProvider(f,E,o){const c=this.createTreeView(f,{treeDataProvider:E},o);return{dispose:()=>c.dispose()}}createTreeView(f,E,o){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(f,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:!!E.canDragAndDrop}),m=this.createExtHostTreeView(f,E,o);return{get onDidCollapseElement(){return m.onDidCollapseElement},get onDidExpandElement(){return m.onDidExpandElement},get selection(){return m.selectedElements},get onDidChangeSelection(){return m.onDidChangeSelection},get visible(){return m.visible},get onDidChangeVisibility(){return m.onDidChangeVisibility},get message(){return m.message},set message(t){m.message=t},get title(){return m.title},set title(t){m.title=t},get description(){return m.description},set description(t){m.description=t},reveal:(t,n)=>m.reveal(t,n),dispose:async()=>{await c,this.treeViews.delete(f),m.dispose()}}}$getChildren(f,E){const o=this.treeViews.get(f);return o?o.getChildren(E):Promise.reject(new Error((0,v.localize)(0,null,f)))}$setParent(f,E,o){const c=this.treeViews.get(f);return c?c.setParent(E,o):Promise.reject(new Error((0,v.localize)(1,null,f)))}async $hasResolve(f){const E=this.treeViews.get(f);if(!E)throw new Error((0,v.localize)(2,null,f));return E.hasResolve}$resolve(f,E,o){const c=this.treeViews.get(f);if(!c)throw new Error((0,v.localize)(3,null,f));return c.resolveTreeItem(E,o)}$setExpanded(f,E,o){const c=this.treeViews.get(f);if(!c)throw new Error((0,v.localize)(4,null,f));c.setExpanded(E,o)}$setSelection(f,E){const o=this.treeViews.get(f);if(!o)throw new Error((0,v.localize)(5,null,f));o.setSelection(E)}$setVisible(f,E){const o=this.treeViews.get(f);if(!o)throw new Error((0,v.localize)(6,null,f));o.setVisible(E)}createExtHostTreeView(f,E,o){const c=new a(f,E,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(f,c),c}convertArgument(f){const E=this.treeViews.get(f.$treeViewId);return E?E.getExtensionElement(f.$treeItemHandle):null}}e.ExtHostTreeViews=r;class a extends y.Disposable{constructor(f,E,o,c,m,t){super();if(this.viewId=f,this.proxy=o,this.commands=c,this.logService=m,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const s in t.contributes.views)for(const u of t.contributes.views[s])u.id===f&&(this._title=u.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let n,l;this._register(A.Event.debounce(this._onDidChangeData.event,(s,u)=>(s||(s={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(w=>l=w),this.refreshPromise=this.refreshPromise.then(()=>n)),s.elements.push(u.element)),u.message&&(s.message=!0),s),200,!0)(({message:s,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=l;return n=null,this.refresh(u).then(()=>w())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(f=>this.getExtensionElement(f)).filter(f=>!(0,k.isUndefinedOrNull)(f))}getChildren(f){const E=f?this.getExtensionElement(f):void 0;if(f&&!E)return this.logService.error(`No tree item with id '${f}' found.`),Promise.resolve([]);const o=this.getChildrenNodes(f);return(o?Promise.resolve(o):this.fetchChildrenNodes(E)).then(c=>c.map(m=>m.item))}getExtensionElement(f){return this.elements.get(f)}reveal(f,E){E=E||{select:!0,focus:!1};const o=(0,k.isUndefinedOrNull)(E.select)?!0:E.select,c=(0,k.isUndefinedOrNull)(E.focus)?!1:E.focus,m=(0,k.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.refreshPromise.then(()=>this.resolveUnknownParentChain(f)).then(t=>this.resolveTreeNode(f,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(l=>l.item)},{select:o,focus:c,expand:m})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:c,expand:m})}get message(){return this._message}set message(f){this._message=f,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(f){this._title=f,this.proxy.$setTitle(this.viewId,f,this._description)}get description(){return this._description}set description(f){this._description=f,this.proxy.$setTitle(this.viewId,this._title,f)}setExpanded(f,E){const o=this.getExtensionElement(f);o&&(E?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(f){(0,i.equals)(this._selectedHandles,f)||(this._selectedHandles=f,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(f){f!==this._visible&&(this._visible=f,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(f,E){const o=f.map(m=>this.getExtensionElement(m)).filter(m=>!(0,k.isUndefinedOrNull)(m)),c=this.getExtensionElement(E);return this.dataProvider.setParent&&o&&c?(0,C.asPromise)(()=>this.dataProvider.setParent(o,c)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(f,E){var o;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(f);if(c){const m=this.nodes.get(c);if(m){const t=(o=await this.dataProvider.resolveTreeItem(m.extensionItem,c,E))!==null&&o!==void 0?o:m.extensionItem;return m.item.tooltip=this.getTooltip(t.tooltip),m.item.command=this.getCommand(m.disposableStore,t.command),m.item}}}}resolveUnknownParentChain(f){return this.resolveParent(f).then(E=>E?this.resolveUnknownParentChain(E).then(o=>this.resolveTreeNode(E,o[o.length-1]).then(c=>(o.push(c),o))):Promise.resolve([]))}resolveParent(f){const E=this.nodes.get(f);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(f))}resolveTreeNode(f,E){const o=this.nodes.get(f);return o?Promise.resolve(o):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(c=>this.createHandle(f,c,E,!0)).then(c=>this.getChildren(E?E.item.handle:void 0).then(()=>{const m=this.getExtensionElement(c);if(m){const t=this.nodes.get(m);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(f){if(f){let E;if(typeof f=="string"){const o=this.getExtensionElement(f);E=o?this.nodes.get(o):void 0}else E=f;return E&&E.children||null}return this.roots}async fetchChildrenNodes(f){this.clearChildren(f);const E=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=f?this.nodes.get(f):void 0,c=await this.dataProvider.getChildren(f);if(E.token.isCancellationRequested)return[];const m=await Promise.all((0,i.coalesce)(c||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,o):null}));return E.token.isCancellationRequested?[]:(0,i.coalesce)(m)}finally{E.dispose()}}refresh(f){if(f.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(f);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(f){const E=new Set,o=f.map(m=>this.nodes.get(m));for(const m of o)if(m&&!E.has(m.item.handle)){let t=m;for(;t&&t.parent&&o.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&E.add(m.item.handle)}const c=[];return E.forEach(m=>{const t=this.elements.get(m);if(t){const n=this.nodes.get(t);n&&(!n.parent||!E.has(n.parent.item.handle))&&c.push(m)}}),c}refreshHandles(f){const E={};return Promise.all(f.map(o=>this.refreshNode(o).then(c=>{c&&(E[o]=c.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(f){const E=this.getExtensionElement(f);if(E){const o=this.nodes.get(E);if(o)return this.clearChildren(E),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(c=>{if(c){const m=this.createTreeNode(E,c,o.parent);return this.updateNodeCache(E,m,o,o.parent),o.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(f,E,o){const c=this.createTreeNode(f,E,o);if(E.id&&this.elements.has(c.item.handle))throw new Error((0,v.localize)(7,null,E.id));return this.addNodeToCache(f,c),this.addNodeToParentCache(c,o),c}getTooltip(f){return S.MarkdownString.isMarkdownString(f)?P.MarkdownString.from(f):f}getCommand(f,E){return E?this.commands.toInternal(E,f):void 0}createTreeNode(f,E,o){const c=new y.DisposableStore,m=this.createHandle(f,E,o),t=this.getLightIconPath(E);return{item:{handle:m,parentHandle:o?o.item.handle:void 0,label:g(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(c,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,k.isUndefinedOrNull)(E.collapsibleState)?S.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:o,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(f){return f.iconPath instanceof S.ThemeIcon?f.iconPath:void 0}createHandle(f,{id:E,label:o,resourceUri:c},m,t){if(E)return`${a.ID_HANDLE_PREFIX}/${E}`;const n=g(o,this.extension),l=m?m.item.handle:a.LABEL_HANDLE_PREFIX;let s=n?n.label:c?(0,T.basename)(c):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const u=this.nodes.has(f)?this.nodes.get(f).item.handle:void 0,w=this.getChildrenNodes(m)||[];let b,I=0;do{if(b=`${l}/${I}:${s}`,t||!this.elements.has(b)||u===b)break;I++}while(I<=w.length);return b}getLightIconPath(f){if(f.iconPath&&!(f.iconPath instanceof S.ThemeIcon))return typeof f.iconPath=="string"||D.URI.isUri(f.iconPath)?this.getIconPath(f.iconPath):this.getIconPath(f.iconPath.light)}getDarkIconPath(f){if(f.iconPath&&!(f.iconPath instanceof S.ThemeIcon)&&f.iconPath.dark)return this.getIconPath(f.iconPath.dark)}getIconPath(f){return D.URI.isUri(f)?f:D.URI.file(f)}addNodeToCache(f,E){this.elements.set(E.item.handle,f),this.nodes.set(f,E)}updateNodeCache(f,E,o,c){this.elements.delete(E.item.handle),this.nodes.delete(f),E.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(f,E);const m=this.getChildrenNodes(c)||[],t=m.filter(n=>n.item.handle===o.item.handle)[0];t&&m.splice(m.indexOf(t),1,E)}addNodeToParentCache(f,E){E?(E.children||(E.children=[]),E.children.push(f)):(this.roots||(this.roots=[]),this.roots.push(f))}clearChildren(f){if(f){const E=this.nodes.get(f);if(E){if(E.children)for(const o of E.children){const c=this.elements.get(o.item.handle);c&&this.clear(c)}E.children=void 0}}else this.clearAll()}clear(f){const E=this.nodes.get(f);if(E){if(E.children)for(const o of E.children){const c=this.elements.get(o.item.handle);c&&this.clear(c)}this.nodes.delete(f),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(f=>f.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}a.LABEL_HANDLE_PREFIX="0",a.ID_HANDLE_PREFIX="1"}),define(ve[182],be([0,1,13,11,20,10,70,9,7,97]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(p,f){if(f!==void 0){const E=this.testIdsToInternal.get(f),o=E==null?void 0:E.get(p);if(o)return[E,o]}return(0,v.mapFind)(this.testIdsToInternal.values(),E=>{const o=E.get(p);return o&&[E,o]})}createForHierarchy(p=()=>{}){return new r(this.createIdMap(d++),p)}createIdMap(p){const f=new g(p);return this.testIdsToInternal.set(f.id,f),{object:f,dispose:()=>this.testIdsToInternal.delete(f.id)}}}e.OwnedTestCollection=i;var P;(function(a){a[a.Disconnected=0]="Disconnected",a[a.IsChild=1]="IsChild",a[a.IsParent=2]="IsParent",a[a.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let d=0;class g{constructor(p){this.id=p,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(p){if(this.map.has(p.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${p.item.extId}`);this.map.set(p.item.extId,p),p.parent||this._roots.add(p)}has(p){return this.map.has(p)}delete(p){const f=this.map.get(p);return f?(this.map.delete(p),this._roots.delete(f),!0):!1}get(p){return this.map.get(p)}comparePositions(p,f){const E=typeof p=="string"?this.map.get(p):p,o=typeof f=="string"?this.map.get(f):f;if(!E||!o)return 0;if(E===o)return 3;for(let c=this.map.get(o.parent);c;c=this.map.get(c.parent))if(c===E)return 1;for(let c=this.map.get(E.parent);c;c=this.map.get(c.parent))if(c===o)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class r{constructor(p,f){this.testIdToInternal=p,this.publishDiff=f,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new T.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(p,f){this.addItem(p,f,null)}getTestByReference(p){return this.testItemToInternal.get(p)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const f=this.diff[this.diff.length-1];if(f&&p[0]===1){if(f[0]===1&&f[1].extId===p[1].extId){(0,k.applyTestItemUpdate)(f[1],p[1]);return}if(f[0]===0&&f[1].item.extId===p[1].extId){(0,k.applyTestItemUpdate)(f[1],p[1]);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,f){var E;const o=this.testIdToInternal.object.get(p);if(!!o){if((o.expandLevels===void 0||f>o.expandLevels)&&(o.expandLevels=f),o.expand===1){const c=this.refreshChildren(o);return c.isSettled?this.expandChildren(o,f-1):c.p.then(()=>this.expandChildren(o,f-1))}else if(o.expand===3)return((E=o.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?o.initialExpand.p.then(()=>this.expandChildren(o,f-1)):this.expandChildren(o,f-1)}}dispose(){var p;for(const f of this.testItemToInternal.values())(p=f.discoverCts)===null||p===void 0||p.dispose(!0),(0,y.getPrivateApiFor)(f.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(p,f){const E=p==null?void 0:p.actual.id;switch(f[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(p);break;case 0:this.addItem(f[1],p.src.controller,p);break;case 3:const[o,c,m]=f;switch(c){case"status":this.updateExpandability(p);break;case"range":this.pushDiff([1,{extId:E,item:{range:C.Range.from(m)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:C.MarkdownString.fromStrict(m)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[c]:m!=null?m:null}}]);break}break;default:(0,A.assertNever)(f[0])}}addItem(p,f,E){if(!(p instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${p.id} did not`);if(this.testItemToInternal.has(p))throw new Error(`Attempted to add a single TestItem ${p.id} multiple times to the tree`);if(this.testIdToInternal.object.has(p.id))throw new Error(`Attempted to insert a duplicate test item ID ${p.id}`);const o=E?E.item.extId:null,c=p.resolveHandler?1:0,m=E?E.expandLevels:1,t={controller:f,tree:this.testIdToInternal.object.id},n={actual:p,parent:o,item:C.TestItem.from(p),expandLevels:m?m-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(p,n),this.pushDiff([0,{parent:o,src:t,expand:c,item:n.item}]);const l=(0,y.getPrivateApiFor)(p);l.parent=E==null?void 0:E.actual,l.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const s of l.children.values())this.testItemToInternal.has(s)||this.addItem(s,f,n)}updateExpandability(p){var f;let E;p.actual.resolveHandler?p.actual.status===S.TestItemStatus.Pending?E=p.discoverCts?2:1:((f=p.initialExpand)===null||f===void 0||f.complete(),E=3):E=0,E!==p.expand&&(p.expand=E,this.pushDiff([1,{extId:p.actual.id,expand:E}]),E===1&&p.expandLevels!==void 0&&this.refreshChildren(p))}expandChildren(p,f){if(!(f<0)){const E=[...p.actual.children.values()].map(o=>this.expand(o.id,f)).filter(T.isThenable);if(E.length)return Promise.all(E).then(()=>{})}}refreshChildren(p){if(p.discoverCts&&p.discoverCts.dispose(!0),!p.actual.resolveHandler){const f=new T.DeferredPromise;return f.complete(),f}return p.expand=2,p.discoverCts=new D.CancellationTokenSource,this.pushExpandStateUpdate(p),p.initialExpand=new T.DeferredPromise,p.actual.resolveHandler(p.discoverCts.token),p.initialExpand}pushExpandStateUpdate(p){this.pushDiff([1,{extId:p.actual.id,expand:p.expand}])}removeItem(p){var f;this.pushDiff([2,p.actual.id]);const E=[p];for(;E.length;){const o=E.pop();if(!!o){(f=o.discoverCts)===null||f===void 0||f.dispose(!0),this.testIdToInternal.object.delete(o.item.extId),this.testItemToInternal.delete(o.actual);for(const c of o.actual.children.values())E.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const p=this.collectDiff();p.length&&this.publishDiff(p)}}e.SingleUseTestCollection=r}),define(ve[183],be([0,1,26,3,14]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=A;class y{constructor(i){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${v.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(d=>P.add(v.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>P.has(v.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const d=y._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(d.map(g=>g.identifier)),P.length>0){const g=new Set;P.forEach(r=>g.add(v.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!g.has(v.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(d)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,f){this.addNode(p),this.addNode(f),this._arcs.has(p)?this._arcs.get(p).push(f):this._arcs.set(p,[f])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,f){const E=P.getArcs(p);for(let o=0;o<E.length;o++)if(!f.has(E[o]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let p of i){const f=v.ExtensionIdentifier.toKey(p.identifier);if(d.set(f,p),p.extensionDependencies)for(let E of p.extensionDependencies){const o=v.ExtensionIdentifier.toKey(E);P.addArc(f,o)}}let g=new Set;P.getNodes().filter(p=>P.getArcs(p).length===0).forEach(p=>g.add(p));let r=P.getNodes().filter(p=>!g.has(p)),a;do{a=!1;for(let p=0;p<r.length;p++){const f=r[p];P.hasOnlyGoodArcs(f,g)&&(r.splice(p,1),p--,g.add(f),a=!0)}}while(a);return r.map(p=>d.get(p))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(v.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=y;var C;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(C||(C={}));function S(k,i){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==d)return P-d;const g=D.posix.basename(k.extensionLocation.path),r=D.posix.basename(i.extensionLocation.path);return g<r?-1:g>r?1:0}}),define(ve[184],be([0,1,24]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function A(C){const S=v.VSBuffer.alloc(1);switch(C){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=A;function y(C,S){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=y}),define(ve[33],be([0,1,3,2,4,26,151]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class C{constructor(E){this.dependency=E}}e.MissingExtensionDependency=C;var S;(function(f){f[f.LocalProcess=0]="LocalProcess",f[f.LocalWebWorker=1]="LocalWebWorker",f[f.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(E,o,c,m){this.codeLoadingTime=E,this.activateCallTime=o,this.activateResolvedTime=c,this.activationReason=m}}e.ActivationTimes=k;class i{constructor(E,o){this.description=E,this.value=o}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function d(f){f.enableProposedApi||g(f)}e.checkProposedApiEnabled=d;function g(f){throw new Error(`[${f.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.throwProposedApiError=g;function r(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation}}e.toExtension=r;function a(f){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(f.identifier.id),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!1,extensionLocation:f.location},f.manifest),{uuid:f.identifier.uuid})}e.toExtensionDescription=a;class p{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,o){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,o,c,m,t){}_onDidActivateExtensionError(E,o){}_onExtensionRuntimeError(E,o){}_onExtensionHostExit(E){}}e.NullExtensionService=p}),define(ve[185],be([0,1,26,33,18]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class y{constructor(r,a,p,f){this.startup=r,this.codeLoadingTime=a,this.activateCallTime=p,this.activateResolvedTime=f}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class C{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,a){return r===-1||a===-1?-1:a-r}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class S{constructor(r,a,p,f,E,o){this.activationFailed=r,this.activationFailedError=a,this.activationTimes=p,this.module=f,this.exports=E,this.subscriptions=o}}e.ActivatedExtension=S;class k extends S{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends S{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class P extends S{constructor(r){super(!0,r,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let d=class{constructor(r,a,p,f,E){this._logService=E,this._registry=r,this._resolvedExtensionsSet=new Set,a.forEach(o=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,p.forEach(o=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(o),o)),this._host=f,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const a=v.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(a)}getActivatedExtension(r){const a=v.ExtensionIdentifier.toKey(r),p=this._activatedExtensions.get(a);if(!p)throw new Error("Extension `"+r.value+"` is not known or not activated");return p}activateByEvent(r,a){if(this._alreadyActivatedEvents[r])return A;const p=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(p.map(f=>({id:f.identifier,reason:{startup:a,extensionId:f.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,a){const p=this._registry.getExtensionDescription(r);if(!p)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:p.identifier,reason:a}])}_handleActivateRequest(r,a,p){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(r.id))){a[v.ExtensionIdentifier.toKey(r.id)]=r;return}const f=this._registry.getExtensionDescription(r.id);if(!f){const c=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,c,new T.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(r.id),new P(c));return}const E=typeof f.extensionDependencies=="undefined"?[]:f.extensionDependencies;let o=!0;for(let c=0,m=E.length;c<m;c++){const t=E[c];if(!this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const w=f.displayName||f.identifier.value,b=this._registry.getExtensionDescription(t),I=b&&b.displayName||t,h=new Error(`Cannot activate the '${w}' extension because its dependency '${I}' failed to activate`);h.detail=n.activationFailedError,this._host.onExtensionActivationError(f.identifier,h,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(f.identifier),new P(h));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){o=!1,a[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:r.reason};continue}const l=this._registry.getExtensionDescription(t);if(l){o=!1,a[v.ExtensionIdentifier.toKey(t)]={id:l.identifier,reason:r.reason};continue}const s=f.displayName||f.identifier.value,u=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(f.identifier,u,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(f.identifier),new P(u));return}}}o?a[v.ExtensionIdentifier.toKey(f.identifier)]=r:p.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(E=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(E.id))),r.length===0))return Promise.resolve(void 0);const a=Object.create(null),p=[];for(let E=0,o=r.length;E<o;E++)this._handleActivateRequest(r[E],a,p);for(let E=0,o=p.length;E<o;E++){const c=v.ExtensionIdentifier.toKey(p[E].id);a[c]&&delete a[c]}const f=Object.keys(a).map(E=>a[E]);return p.length===0?Promise.all(f.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(f).then(E=>this._activateExtensions(p))}_activateExtension(r,a){const p=v.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const f=this._activatingExtensions.get(p);if(f)return f;const E=this._host.actualActivateExtension(r,a).then(void 0,o=>{const c=new Error;return o&&o.name&&(c.name=o.name),o&&o.message?c.message=`Activating extension '${r.value}' failed: ${o.message}.`:c.message=`Activating extension '${r.value}' failed: ${o}.`,o&&o.stack&&(c.stack=o.stack),this._host.onExtensionActivationError(r,c,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(o),new P(o)}).then(o=>{this._activatedExtensions.set(p,o),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,E),E}};d=je([qe(4,D.ILogService)],d),e.ExtensionsActivator=d}),define(ve[186],be([0,1,12]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,v.onUnexpectedError)(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=T}),define(ve[99],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(S,k){this.isMain=S,this.sid=k,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const T=[];function D(C){const S=new v(!0,C);return T[S.nid]=S,S}e.createMainContextProxyIdentifier=D;function A(C){const S=new v(!1,C);return T[S.nid]=S,S}e.createExtHostContextProxyIdentifier=A;function y(C){return T[C].sid}e.getStringIdentifierForProxy=y}),define(ve[5],be([0,1,57,2,99]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(o){o.name="$ident";function c(t,n){return Object.defineProperty(t,o.name,{value:n,enumerable:!0}),t}o.mixin=c;function m(t){return t[o.name]}o.of=m})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(c){return c._id=g._n++,c}}e.IdObject=g,g._n=0;var r;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n",o.label2="o"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var a;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(a=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function f(o){if(o&&o.edits)for(const c of o.edits)typeof c.resource=="object"?c.resource=T.URI.revive(c.resource):(c.newUri=T.URI.revive(c.newUri),c.oldUri=T.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,v.revive)(c.metadata));return o}e.reviveWorkspaceEditDto=f;var E;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[75],be([0,1,5,3,4]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(C){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,S){return this._proxy.$getPassword(C,S)}store(C,S,k){return this._proxy.$setPassword(C,S,k)}delete(C,S){return this._proxy.$deletePassword(C,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(ve[76],be([0,1,4,18,5,15]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,v.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,k,i){const P=this.getUsageKey(S,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}getUsageKey(S,k){return`${S}-${k.identifier.value}`}};y=je([qe(0,A.IExtHostRpcService),qe(1,T.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(C,S,k){}})}),define(ve[187],be([0,1,3,5,7,26]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(S,k,i,P={}){const d=A.ExtensionIdentifier.toKey(S.identifier),g=this._inFlightRequests.get(d)||[],r=i.sort().join(" ");let a=g.find(p=>p.scopes===r);if(a)return a.result;{const p=this._getSession(S,d,k,i,P);a={scopes:r,result:p},g.push(a),this._inFlightRequests.set(d,g);try{await p}finally{const f=g.findIndex(E=>E.scopes===r);f>-1&&(g.splice(f),this._inFlightRequests.set(d,g))}return p}}async _getSession(S,k,i,P,d={}){await this._proxy.$ensureProvider(i);const g=S.displayName||S.name;return this._proxy.$getSession(i,P,k,g,d)}async removeSession(S,k){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(k):this._proxy.$removeSession(S,k)}registerAuthenticationProvider(S,k,i,P){var d;if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:k,provider:i,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===S)||this._providers.push({id:S,label:k});const g=i.onDidChangeSessions(r=>{var a,p,f;this._proxy.$sendDidChangeSessions(S,{added:(a=r.added)!==null&&a!==void 0?a:[],changed:(p=r.changed)!==null&&p!==void 0?p:[],removed:(f=r.removed)!==null&&f!==void 0?f:[]})});return this._proxy.$registerAuthenticationProvider(S,k,(d=P==null?void 0:P.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new D.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(S);const r=this._providers.findIndex(a=>a.id===S);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this._onDidChangeSessions.fire({provider:{id:S,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(S,k){return S.forEach(i=>{this._providers.some(P=>P.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const P=this._providers.findIndex(d=>d.id===i.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:S,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ve[188],be([0,1,5,15,9]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(C,S){this._extHostDocumentsAndEditors=S,this._proxy=C.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const S=D.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};A=je([qe(0,T.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ve[189],be([0,1,5]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(A){const y=A.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(C){return y.$writeText(C)}})}}e.ExtHostClipboard=T}),define(ve[77],be([0,1,10,7,9,23,5,13,18,57,32,38,2,6,4,15]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new f(this,l=>{const s=this._apiCommands.get(l);return(s==null?void 0:s.result)===o.Void?s:void 0},n),this._argumentProcessors=[{processArgument(l){return(0,k.revive)(l)}},{processArgument(l){return(0,A.cloneAndChange)(l,function(s){if(i.Range.isIRange(s))return D.Range.to(s);if(P.Position.isIPosition(s))return D.Position.to(s);if(i.Range.isIRange(s.range)&&d.URI.isUri(s.uri))return D.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...l)=>{const s=t.args.map((w,b)=>{if(!w.validate(l[b]))throw new Error(`Invalid argument '${w.name}' when running '${t.id}', received: ${l[b]}`);return w.convert(l[b])}),u=await this.executeCommand(t.internalId,...s);return t.result.convert(u,l,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,l,s,u){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:l,thisArg:s,description:u}),t&&this._proxy.$registerCommand(n),new T.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,l){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const s=(0,A.cloneAndChange)(n,function(u){if(u instanceof T.Position)return D.Position.from(u);if(u instanceof T.Range)return D.Range.from(u);if(u instanceof T.Location)return D.location.from(u);if(T.NotebookRange.isNotebookRange(u))return D.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,s,l);return(0,k.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw u}}}async _executeContributedCommand(t,n){const l=this._commands.get(t);if(!l)throw new Error("Unknown command");let{callback:s,thisArg:u,description:w}=l;if(w)for(let b=0;b<w.args.length;b++)try{(0,v.validateConstraint)(n[b],w.args[b].constraint)}catch(I){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${w.args[b].name}' - ${w.args[b].description}`)}try{return await s.apply(u,n)}catch(b){if(t===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...n);I&&(t=I.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(l=>this._argumentProcessors.reduce((s,u)=>u.processArgument(s),l)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(l=>l[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,l]of this._commands){let{description:s}=l;s&&(t[n]=s)}return Promise.resolve(t)}};p=je([qe(0,a.IExtHostRpcService),qe(1,S.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class f{constructor(t,n,l){this._commands=t,this._lookupApiCommand=n,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const l={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return l;const s=this._lookupApiCommand(t.command);if(s)l.id=s.internalId,l.arguments=s.args.map((u,w)=>u.convert(t.arguments&&t.arguments[w]));else if((0,C.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),n.add((0,g.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),l.$ident=u,l.id=this.delegatingCommandId,l.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return l}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=f;class E{constructor(t,n,l,s){this.name=t,this.description=n,this.validate=l,this.convert=s}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new E(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",m=>d.URI.isUri(m),m=>m),E.Position=new E("position","A position in a text document",m=>T.Position.isPosition(m),D.Position.from),E.Range=new E("range","A range in a text document",m=>T.Range.isRange(m),D.Range.from),E.Selection=new E("selection","A selection in a text document",m=>T.Selection.isSelection(m),D.Selection.from),E.Number=new E("number","",m=>typeof m=="number",m=>m),E.String=new E("string","",m=>typeof m=="string",m=>m),E.CallHierarchyItem=new E("item","A call hierarchy item",m=>m instanceof T.CallHierarchyItem,D.CallHierarchyItem.to);class o{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=o,o.Void=new o("no result",m=>m);class c{constructor(t,n,l,s,u){this.id=t,this.internalId=n,this.description=l,this.args=s,this.result=u}}e.ApiCommand=c}),define(ve[190],be([0,1,6,9,7,62,77,168,13,88]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(T.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if(!(0,S.isFalsyOrEmpty)(r)){class p extends D.SymbolInformation{static to(E){const o=new p(E.name,T.SymbolKind.to(E.kind),E.containerName||"",new D.Location(a[0],T.Range.to(E.range)));return o.detail=E.detail,o.range=o.location.range,o.selectionRange=T.Range.to(E.selectionRange),o.children=E.children?E.children.map(p.to):[],o}}return r.map(p.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(T.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(T.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(T.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(T.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(T.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>D.Position.isPosition(a)),r=>r.map(T.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(a=>{let p;for(const f of a.reverse())p=new D.SelectionRange(T.Range.to(f),p);return p}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const a=[];if(Array.isArray(r))for(let p of r)a.push(...p[1].map(T.WorkspaceSymbol.to));return a})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(T.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(T.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(T.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return T.WorkspaceEdit.to(r)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(T.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new D.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new D.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,a,p)=>{if(!r)return new D.CompletionList([]);const f=r.suggestions.map(E=>T.CompletionItem.to(E,p));return new D.CompletionList(f,r.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return T.SignatureHelp.to(r)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,a,p)=>d(f=>new D.CodeLens(T.Range.to(f.range),f.command&&p.fromInternal(f.command)))(r))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>D.Range.isRange(r),r=>D.Selection.isSelection(r)?T.Selection.from(r):T.Range.from(r)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,a,p)=>d(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(f.command)}else{const E=new D.CodeAction(f.title,f.kind?new D.CodeActionKind(f.kind):void 0);return f.edit&&(E.edit=T.WorkspaceEdit.to(f.edit)),f.command&&(E.command=p.fromInternal(f.command)),E.isPreferred=f.isPreferred,E}})(r))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new D.ColorInformation(T.Range.to(a.range),T.Color.to(a.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",r=>r instanceof D.Color,T.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:T.Range.from(r.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(T.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(T.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>T.NotebookExclusiveDocumentPattern.to(a))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(T.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[T.ViewColumn.from(r.viewColumn),T.TextEditorOpenOptions.from(r)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[T.ViewColumn.from(r.viewColumn),T.TextEditorOpenOptions.from(r)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[T.ViewColumn.from(r.viewColumn),T.TextEditorOpenOptions.from(r)]).optional()],y.ApiCommandResult.Void)];class P{constructor(a){this._disposables=new v.DisposableStore,this._commands=a}static register(a){return i.forEach(a.registerApiCommand,a),new P(a).registerCommands()}registerCommands(){const a=p=>(...f)=>p(this._commands,...f);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,a(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(C.OpenIssueReporter.ID,a(C.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(a,p,f){const E=this._commands.registerCommand(!1,a,p,this,f);this._disposables.add(E)}}e.ExtHostApiCommands=P;function d(r){return a=>{if(Array.isArray(a))return a.map(r)}}function g(r){if(!!Array.isArray(r)){const a=[];for(const p of r)A.isLocationLink(p)?a.push(T.DefinitionLink.to(p)):a.push(T.location.to(p));return a}}}),define(ve[191],be([0,1,11,52,3,6,2,62,26,9,7,5]),function(Y,e,v,T,D,A,y,C,S,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(c,m,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(P.MainContext.MainThreadComments),m.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const l=this._commentControllers.get(n.handle);return l||n}else if(n&&n.$mid===7){const l=this._commentControllers.get(n.commentControlHandle);if(!l)return n;const s=l.getCommentThread(n.commentThreadHandle);return s||n}else if(n&&n.$mid===8){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const s=l.getCommentThread(n.thread.commentThreadHandle);return s?{thread:s,text:n.text}:n}else if(n&&n.$mid===9){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const s=l.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let u=n.commentUniqueId,w=s.getCommentByUniqueId(u);return w||n}else if(n&&n.$mid===10){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const s=l.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let u=n.text,w=n.commentUniqueId,b=s.getCommentByUniqueId(w);return b?(b.body=u,b):n}return n}})}createCommentController(c,m,t){const n=d.handlePool++,l=new r(c,n,this._proxy,m,t);this._commentControllers.set(l.handle,l);const s=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(c.identifier))||[];return s.push(l),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(c.identifier),s),l}$createCommentThreadTemplate(c,m,t){const n=this._commentControllers.get(c);!n||n.$createCommentThreadTemplate(m,t)}async $updateCommentThreadTemplate(c,m,t){const n=this._commentControllers.get(c);!n||n.$updateCommentThreadTemplate(m,t)}$deleteCommentThread(c,m){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(m)}$provideCommentingRanges(c,m,t){const n=this._commentControllers.get(c);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const l=this._documents.getDocument(y.URI.revive(m));return(0,v.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(l,t)).then(s=>s?s.map(u=>k.Range.from(u)):void 0)}$toggleReaction(c,m,t,n,l){const s=this._commentControllers.get(c);return!s||!s.reactionHandler?Promise.resolve(void 0):(0,v.asPromise)(()=>{const u=s.getCommentThread(m);if(u){const w=u.getCommentByUniqueId(n.uniqueIdInThread);if(s!==void 0&&w&&s.reactionHandler)return s.reactionHandler(w,f(l))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class g{constructor(c,m,t,n,l,s,u){this._proxy=c,this._commentController=m,this._id=t,this._uri=n,this._range=l,this._comments=s,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${m.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=s}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),m={};c("range")&&(m.range=k.Range.from(this._range)),c("label")&&(m.label=this.label),c("contextValue")&&(m.contextValue=this.contextValue),c("comments")&&(m.comments=this._comments.map(t=>a(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(m.collapseState=E(this._collapseState)),c("canReply")&&(m.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,m)}}getCommentByUniqueId(c){for(let m of this._commentsMap){let t=m[0],n=m[1];if(c===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,je([(0,T.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class r{constructor(c,m,t,n,l){this._extension=c,this._handle=m,this._proxy=t,this._id=n,this._label=l,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,l)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,m,t,n){if(typeof c=="string"){const l=new g(this._proxy,this,c,m,t,n,this._extension.identifier);return this._threads.set(l.handle,l),l}else{const l=new g(this._proxy,this,void 0,c,m,t,this._extension.identifier);return this._threads.set(l.handle,l),l}}$createCommentThreadTemplate(c,m){const t=new g(this._proxy,this,void 0,y.URI.revive(c),k.Range.to(m),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,m){let t=this._threads.get(c);t&&(t.range=k.Range.to(m))}$deleteCommentThread(c){let m=this._threads.get(c);m&&m.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function a(o,c,m,t){let n=t.get(m);n||(n=++o.commentHandle,t.set(m,n));const l=m.author&&m.author.iconPath?m.author.iconPath.toString():void 0;return{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(m.body),userName:m.author.name,userIconPath:l,label:m.label,commentReactions:m.reactions?m.reactions.map(s=>p(s)):void 0}}function p(o){return{label:o.label,iconPath:o.iconPath?k.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function f(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?y.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function E(o){if(o!==void 0)switch(o){case i.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(ve[100],be([0,1,2,5,7,4,15,18,13,8,14]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class bn{constructor(g,r){this._logService=r,this._provider=new Map,this._proxy=g.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,r){const a=bn._handlePool++;this._provider.set(a,{provider:g,extensionId:r}),this._proxy.$registerDecorationProvider(a,r.value);const p=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(a,null);return}let E=(0,S.asArray)(f);if(E.length<=bn._maxEventSize){this._proxy.$onDidChange(a,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,E.length);const o=E.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),c=(0,S.groupBy)(o,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let m=[];e:for(let t of c){let n;for(let l of t){let s=(0,i.dirname)(l.uri.path);if(n!==s&&(n=s,m.push(l.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(a,m)});return new D.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(g,r,a){if(!this._provider.has(g))return Object.create(null);const p=Object.create(null),{provider:f,extensionId:E}=this._provider.get(g);return await Promise.all(r.map(async o=>{try{const{uri:c,id:m}=o,t=await Promise.resolve(f.provideFileDecoration(v.URI.revive(c),a));if(!t)return;try{D.FileDecoration.validate(t),p[m]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${E.value}': ${n}`)}}catch(c){this._logService.error(c)}})),p}};P._handlePool=0,P._maxEventSize=250,P=je([qe(0,y.IExtHostRpcService),qe(1,C.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(ve[192],be([0,1,132,91,2,5,7,9,3,18,22]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(r,a,p,f,E){this._name=r,this._owner=a,this._maxDiagnosticsPerFile=p,this._proxy=f,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,a){if(!r){this.clear();return}this._checkDisposed();let p=[];if(D.URI.isUri(r)){if(!a){this.delete(r);return}this._data.set(r,a.slice()),p=[r]}else if(Array.isArray(r)){p=[];let E;r=[...r].sort(P._compareIndexedTuplesByUri);for(const o of r){const[c,m]=o;if((!E||c.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=c,p.push(c),this._data.set(c,[])),m){const t=this._data.get(c);t&&t.push(...m)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const f=[];for(let E of p){let o=[];const c=this._data.get(E);if(c)if(c.length>this._maxDiagnosticsPerFile){o=[];const m=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of c)if(n.severity===m[t]&&o.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;o.push({severity:T.MarkerSeverity.Info,message:(0,v.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=c.map(m=>C.Diagnostic.from(m));f.push([E,o])}this._proxy.$changeMany(this._owner,f)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,a){this._checkDisposed();for(let p of this._data.keys())r.apply(a,[p,this.get(p),this])}get(r){this._checkDisposed();const a=this._data.get(r);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,a){return r[0].toString()<a[0].toString()?-1:r[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=P;let d=class zt{constructor(r,a){this._logService=a,this._collections=new Map,this._onDidChangeDiagnostics=new S.Emitter,this.onDidChangeDiagnostics=S.Event.map(S.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=r.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(r,a){return r?r.concat(a):a}static _mapper(r){const a=new i.ResourceMap;for(const p of r)a.set(p,p);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(r,a){const{_collections:p,_proxy:f,_onDidChangeDiagnostics:E,_logService:o}=this,c=new class{$changeMany(n,l){f.$changeMany(n,l),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,n,l.length===0?"CLEARING":l)}$clear(n){f.$clear(n),o.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,n)}dispose(){f.dispose()}};let m;if(!a)a="_generated_diagnostic_collection_name_#"+zt._idPool++,m=a;else if(!p.has(a))m=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do m=a+zt._idPool++;while(p.has(m))}return new class extends P{constructor(){super(a,m,zt._maxDiagnosticsPerFile,c,E);p.set(m,this)}dispose(){super.dispose(),p.delete(m)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const a=new Map,p=[];for(const f of this._collections.values())f.forEach((E,o)=>{let c=a.get(E.toString());typeof c=="undefined"&&(c=p.length,a.set(E.toString(),c),p.push([E,[]])),p[c][1]=p[c][1].concat(...o)});return p}}_getDiagnostics(r){let a=[];for(let p of this._collections.values())p.has(r)&&(a=a.concat(p.get(r)));return a}$acceptMarkersChange(r){if(!this._mirrorCollection){const a="_generated_mirror",p=new P(a,a,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(a,p),this._mirrorCollection=p}for(const[a,p]of r)this._mirrorCollection.set(D.URI.revive(a),p.map(C.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=je([qe(1,k.ILogService)],d),e.ExtHostDiagnostics=d}),define(ve[193],be([0,1,2,5]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(y){this._proxy=y.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(C=>C?C.map(S=>v.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(C=>C?v.URI.revive(C):void 0)}}e.ExtHostDialogs=D}),define(ve[194],be([0,1,12,2,7,5,19,20,8]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,d,g){this._documentsAndEditors=d,this._logService=g,this._documentContentProviders=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,d){if(Object.keys(y.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const g=k._handlePool++;this._documentContentProviders.set(g,d),this._proxy.$registerTextContentProvider(g,P);let r;return typeof d.onDidChange=="function"&&(r=d.onDidChange(a=>{if(a.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(g,a).then(p=>{if(!(!p&&typeof p!="string")){const f=this._documentsAndEditors.getDocument(a);if(!!f){const E=(0,S.splitLines)(p);if(!f.equalLines(E))return this._proxy.$onVirtualDocumentChange(a,p)}}},v.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(P,d){const g=this._documentContentProviders.get(P);return g?Promise.resolve(g.provideTextDocumentContent(T.URI.revive(d),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(ve[195],be([0,1,3,6,2,5,96,9,10,23]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(d,g){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const a of r)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const a of r)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!!d){const g=this._documentsAndEditors.getDocument(d);if(g)return g}}getDocument(d){const g=this.getDocumentData(d);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return g.document}ensureDocumentData(d){const g=this._documentsAndEditors.getDocument(d);if(g)return Promise.resolve(g);let r=this._documentLoader.get(d.toString());return r||(r=this._proxy.$tryOpenDocument(d).then(a=>{this._documentLoader.delete(d.toString());const p=D.URI.revive(a);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(p))},a=>(this._documentLoader.delete(d.toString()),Promise.reject(a))),this._documentLoader.set(d.toString(),r)),r}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(g=>D.URI.revive(g))}$acceptModelModeChanged(d,g){const r=D.URI.revive(d),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(g),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(d){const g=D.URI.revive(d),r=this._documentsAndEditors.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(d,g){const r=D.URI.revive(d),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(g),this._onDidChangeDocument.fire({document:a.document,contentChanges:[]})}$acceptModelChanged(d,g,r){const a=D.URI.revive(d),p=this._documentsAndEditors.getDocument(a);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),p.onEvents(g),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:p.document,contentChanges:g.changes.map(f=>({range:C.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text}))}))}setWordDefinitionFor(d,g){(0,y.setWordDefinitionFor)(d,g)}}e.ExtHostDocuments=i}),define(ve[39],be([0,1,42,3,6,2,4,5,96,15,98,9,18,22,19,43,109]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(c,m){this._extHostRpc=c,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const m=[],t=[],n=[];if(c.removedDocuments)for(const l of c.removedDocuments){const s=A.URI.revive(l),u=this._documents.get(s);(u==null?void 0:u.unref())&&(this._documents.delete(s),m.push(u.value))}if(c.addedDocuments)for(const l of c.addedDocuments){const s=A.URI.revive(l.uri);let u=this._documents.get(s);if(u&&s.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${s} already exists!'`);u||(u=new f(new S.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),s,l.lines,l.EOL,l.versionId,l.modeId,l.isDirty,l.notebook)),this._documents.set(s,u),t.push(u.value)),u.ref()}if(c.removedEditors)for(const l of c.removedEditors){const s=this._editors.get(l);this._editors.delete(l),s&&n.push(s)}if(c.addedEditors)for(const l of c.addedEditors){const s=A.URI.revive(l.documentUri);v.ok(this._documents.has(s),`document '${s}' does not exist`),v.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const u=this._documents.get(s).value,w=new i.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>u.document),l.selections.map(P.Selection.to),l.options,l.visibleRanges.map(b=>P.Range.to(b)),typeof l.editorPosition=="number"?P.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,w)}c.newActiveEditor!==void 0&&(v.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,D.dispose)(m),(0,D.dispose)(n),c.removedDocuments&&this._onDidRemoveDocuments.fire(m),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var m;return(m=this._documents.get(c))===null||m===void 0?void 0:m.value}allDocuments(){return a.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const m=this._editors.get(this._activeEditorId);return c?m:m==null?void 0:m.value}}allEditors(){return[...this._editors.values()]}};E=je([qe(0,k.IExtHostRpcService),qe(1,d.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[196],be([0,1,2,5,6,7,9,119,8,24]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const r=this._schemes.indexOf(g);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),r=[];let a,p,f=14,E=14;for(const o of g){let c=a?(0,S.commonPrefixLength)(a,o):0;for(c===0?p=1:p=E;c<o.length;c++)c+1===o.length?(f=E,E=9):E+=1,r.push([p,o.toUpperCase().charCodeAt(c),E]),r.push([p,o.toLowerCase().charCodeAt(c),E]),p=E;a=o,E=f}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new C.StateMachine(r)}}provideDocumentLinks(g){this._initStateMachine();const r=[],a=C.LinkComputer.computeLinks({getLineContent(p){return g.lineAt(p-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const p of a){const f=y.DocumentLink.to(p);f.target&&r.push(f)}return r}}class P{constructor(g,r){this._extHostLanguageFeatures=r,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,r,a,p={},f){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(E,a),this._enableProposedApi.set(E,f!=null?f:!1);let o=2;p.isCaseSensitive&&(o+=1024),p.isReadonly&&(o+=2048),typeof a.copy=="function"&&(o+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(o+=4),this._proxy.$registerFileSystemProvider(E,r,o).catch(m=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${r}`),console.error(m)});const c=a.onDidChangeFile(m=>{const t=[];for(const n of m){let{uri:l,type:s}=n;if(l.scheme===r){let u;switch(s){case A.FileChangeType.Changed:u=0;break;case A.FileChangeType.Created:u=1;break;case A.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:l,type:u})}}this._proxy.$onFileSystemChange(E,t)});return(0,D.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(g,r){const{type:a,ctime:p,mtime:f,size:E,permissions:o}=g;return r?{type:a,ctime:p,mtime:f,size:E,permissions:o}:{type:a,ctime:p,mtime:f,size:E}}$stat(g,r){return Promise.resolve(this._getFsProvider(g).stat(v.URI.revive(r))).then(a=>{var p;return P._asIStat(a,(p=this._enableProposedApi.get(g))!==null&&p!==void 0?p:!1)})}$readdir(g,r){return Promise.resolve(this._getFsProvider(g).readDirectory(v.URI.revive(r)))}$readFile(g,r){return Promise.resolve(this._getFsProvider(g).readFile(v.URI.revive(r))).then(a=>k.VSBuffer.wrap(a))}$writeFile(g,r,a,p){return Promise.resolve(this._getFsProvider(g).writeFile(v.URI.revive(r),a.buffer,p))}$delete(g,r,a){return Promise.resolve(this._getFsProvider(g).delete(v.URI.revive(r),a))}$rename(g,r,a,p){return Promise.resolve(this._getFsProvider(g).rename(v.URI.revive(r),v.URI.revive(a),p))}$copy(g,r,a,p){const f=this._getFsProvider(g);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(v.URI.revive(r),v.URI.revive(a),p))}$mkdir(g,r){return Promise.resolve(this._getFsProvider(g).createDirectory(v.URI.revive(r)))}$watch(g,r,a,p){const f=this._getFsProvider(g).watch(v.URI.revive(a),p);this._watches.set(r,f)}$unwatch(g,r){const a=this._watches.get(r);a&&(a.dispose(),this._watches.delete(r))}$open(g,r,a){const p=this._getFsProvider(g);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(v.URI.revive(r),a))}$close(g,r){const a=this._getFsProvider(g);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(r))}$read(g,r,a,p){const f=this._getFsProvider(g);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(p);return Promise.resolve(f.read(r,a,E.buffer,0,p)).then(o=>E.slice(0,o))}$write(g,r,a,p){const f=this._getFsProvider(g);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(r,a,p.buffer,0,p.byteLength))}_getFsProvider(g){const r=this._fsProvider.get(g);if(!r){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return r}}e.ExtHostFileSystem=P}),define(ve[78],be([0,1,5,64,7,24,4,15,49]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Mt{constructor(P,d){const g=P.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return g.$stat(r).catch(Mt._handleError)},readDirectory(r){return g.$readdir(r).catch(Mt._handleError)},createDirectory(r){return g.$mkdir(r).catch(Mt._handleError)},async readFile(r){return g.$readFile(r).then(a=>a.buffer).catch(Mt._handleError)},writeFile(r,a){return g.$writeFile(r,A.VSBuffer.wrap(a)).catch(Mt._handleError)},delete(r,a){return g.$delete(r,Object.assign({recursive:!1,useTrash:!1},a)).catch(Mt._handleError)},rename(r,a,p){return g.$rename(r,a,Object.assign({overwrite:!1},p)).catch(Mt._handleError)},copy(r,a,p){return g.$copy(r,a,Object.assign({overwrite:!1},p)).catch(Mt._handleError)},isWritableFileSystem(r){const a=d.getCapabilities(r);if(typeof a=="number")return!(a&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new D.FileSystemError(String(P));if(P.name==="ENOPRO")throw D.FileSystemError.Unavailable(P.message);switch(P.name){case T.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(P.message);case T.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(P.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(P.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(P.message);case T.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(P.message);case T.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(P.message);default:throw new D.FileSystemError(P.message,P.name)}}};k=je([qe(0,C.IExtHostRpcService),qe(1,S.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[197],be([0,1,6,5]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(y){this._handlePool=0,this._proxy=y.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,y),(0,v.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=D}),define(ve[198],be([0,1,2,23,9,7,11,5,8,32,13,10,116,6,88,54,68,55,12]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(H,q){this._documents=H,this._provider=q}provideDocumentSymbols(H,q){const ee=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,q)).then(se=>{if(!(0,i.isFalsyOrEmpty)(se))return se[0]instanceof A.DocumentSymbol?se.map(D.DocumentSymbol.from):o._asDocumentSymbolTree(se)})}static _asDocumentSymbolTree(H){var q;H=H.slice(0).sort((ce,_e)=>{let $e=ce.location.range.start.compareTo(_e.location.range.start);return $e===0&&($e=_e.location.range.end.compareTo(ce.location.range.end)),$e});const ee=[],se=[];for(const ce of H){const _e={name:ce.name||"!!MISSING: name!!",kind:D.SymbolKind.from(ce.kind),tags:((q=ce.tags)===null||q===void 0?void 0:q.map(D.SymbolTag.from))||[],detail:"",containerName:ce.containerName,range:D.Range.from(ce.location.range),selectionRange:D.Range.from(ce.location.range),children:[]};for(;;){if(se.length===0){se.push(_e),ee.push(_e);break}const $e=se[se.length-1];if(k.Range.containsRange($e.range,_e.range)&&!k.Range.equalsRange($e.range,_e.range)){$e.children&&$e.children.push(_e),se.push(_e);break}se.pop()}}return ee}}class c{constructor(H,q,ee){this._documents=H,this._commands=q,this._provider=ee,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,q){const ee=this._documents.getDocument(H),se=await this._provider.provideCodeLenses(ee,q);if(!(!se||q.isCancellationRequested)){const ce=this._cache.add(se),_e=new g.DisposableStore;this._disposables.set(ce,_e);const $e={cacheId:ce,lenses:[]};for(let fe=0;fe<se.length;fe++)$e.lenses.push({cacheId:[ce,fe],range:D.Range.from(se[fe].range),command:this._commands.toInternal(se[fe].command,_e)});return $e}}async resolveCodeLens(H,q){var ee;const se=H.cacheId&&this._cache.get(...H.cacheId);if(!!se){let ce;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?ce=se:ce=await this._provider.resolveCodeLens(se,q),ce||(ce=se),!q.isCancellationRequested){const _e=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!_e)return H.command=this._commands.toInternal((ee=ce.command)!==null&&ee!==void 0?ee:c._badCmd,_e),H}}}releaseCodeLenses(H){var q;(q=this._disposables.get(H))===null||q===void 0||q.dispose(),this._disposables.delete(H),this._cache.delete(H)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function m(ze){return Array.isArray(ze)?ze.map(D.DefinitionLink.from):ze?[D.DefinitionLink.from(ze)]:[]}class t{constructor(H,q){this._documents=H,this._provider=q}provideDefinition(H,q,ee){const se=this._documents.getDocument(H),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDefinition(se,ce,ee)).then(m)}}class n{constructor(H,q){this._documents=H,this._provider=q}provideDeclaration(H,q,ee){const se=this._documents.getDocument(H),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDeclaration(se,ce,ee)).then(m)}}class l{constructor(H,q){this._documents=H,this._provider=q}provideImplementation(H,q,ee){const se=this._documents.getDocument(H),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideImplementation(se,ce,ee)).then(m)}}class s{constructor(H,q){this._documents=H,this._provider=q}provideTypeDefinition(H,q,ee){const se=this._documents.getDocument(H),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(se,ce,ee)).then(m)}}class u{constructor(H,q){this._documents=H,this._provider=q}provideHover(H,q,ee){const se=this._documents.getDocument(H),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideHover(se,ce,ee)).then(_e=>{if(!(!_e||(0,i.isFalsyOrEmpty)(_e.contents)))return _e.range||(_e.range=se.getWordRangeAtPosition(ce)),_e.range||(_e.range=new A.Range(ce,ce)),D.Hover.from(_e)})}}class w{constructor(H,q){this._documents=H,this._provider=q}provideEvaluatableExpression(H,q,ee){const se=this._documents.getDocument(H),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(se,ce,ee)).then(_e=>{if(_e)return D.EvaluatableExpression.from(_e)})}}class b{constructor(H,q){this._documents=H,this._provider=q}provideInlineValues(H,q,ee,se){const ce=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideInlineValues(ce,D.Range.to(q),D.InlineValueContext.to(ee),se)).then(_e=>{if(Array.isArray(_e))return _e.map($e=>D.InlineValue.from($e))})}}class I{constructor(H,q){this._documents=H,this._provider=q}provideDocumentHighlights(H,q,ee){const se=this._documents.getDocument(H),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(se,ce,ee)).then(_e=>{if(Array.isArray(_e))return _e.map(D.DocumentHighlight.from)})}}class h{constructor(H,q){this._documents=H,this._provider=q}provideLinkedEditingRanges(H,q,ee){const se=this._documents.getDocument(H),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(se,ce,ee)).then(_e=>{if(_e&&Array.isArray(_e.ranges))return{ranges:(0,i.coalesce)(_e.ranges.map(D.Range.from)),wordPattern:_e.wordPattern}})}}class _{constructor(H,q){this._documents=H,this._provider=q}provideReferences(H,q,ee,se){const ce=this._documents.getDocument(H),_e=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideReferences(ce,_e,ee,se)).then($e=>{if(Array.isArray($e))return $e.map(D.location.from)})}}class R{constructor(H,q,ee,se,ce,_e,$e){this._documents=H,this._commands=q,this._diagnostics=ee,this._provider=se,this._logService=ce,this._extension=_e,this._apiDeprecation=$e,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(H,q,ee,se){const ce=this._documents.getDocument(H),_e=d.Selection.isISelection(q)?D.Selection.to(q):D.Range.to(q),$e=[];for(const De of this._diagnostics.getDiagnostics(H))if(_e.intersection(De.range)&&$e.push(De)>R._maxCodeActionsPerFile)break;const fe={diagnostics:$e,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(ce,_e,fe,se)).then(De=>{var Re;if(!(!(0,i.isNonEmptyArray)(De)||se.isCancellationRequested)){const He=this._cache.add(De),we=new g.DisposableStore;this._disposables.set(He,we);const Ke=[];for(let V=0;V<De.length;V++){const Z=De[V];!Z||(R._isCommand(Z)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:Z.title,command:this._commands.toInternal(Z,we)})):(fe.only&&(Z.kind?fe.only.contains(Z.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${fe.only.value} 'requested but returned code action is of kind '${Z.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[He,V],title:Z.title,command:Z.command&&this._commands.toInternal(Z.command,we),diagnostics:Z.diagnostics&&Z.diagnostics.map(D.Diagnostic.from),edit:Z.edit&&D.WorkspaceEdit.from(Z.edit),kind:Z.kind&&Z.kind.value,isPreferred:Z.isPreferred,disabled:(Re=Z.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:He,actions:Ke}}})}async resolveCodeAction(H,q){var ee;const[se,ce]=H,_e=this._cache.get(se,ce);if(!(!_e||R._isCommand(_e))&&!!this._provider.resolveCodeAction){const $e=(ee=await this._provider.resolveCodeAction(_e,q))!==null&&ee!==void 0?ee:_e;return($e==null?void 0:$e.edit)?D.WorkspaceEdit.from($e.edit):void 0}}releaseCodeActions(H){var q;(q=this._disposables.get(H))===null||q===void 0||q.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}R._maxCodeActionsPerFile=1e3;class B{constructor(H,q){this._documents=H,this._provider=q}provideDocumentFormattingEdits(H,q,ee){const se=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(se,q,ee)).then(ce=>{if(Array.isArray(ce))return ce.map(D.TextEdit.from)})}}class z{constructor(H,q){this._documents=H,this._provider=q}provideDocumentRangeFormattingEdits(H,q,ee,se){const ce=this._documents.getDocument(H),_e=D.Range.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(ce,_e,ee,se)).then($e=>{if(Array.isArray($e))return $e.map(D.TextEdit.from)})}}class he{constructor(H,q){this._documents=H,this._provider=q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(H,q,ee,se,ce){const _e=this._documents.getDocument(H),$e=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(_e,$e,ee,se,ce)).then(fe=>{if(Array.isArray(fe))return fe.map(D.TextEdit.from)})}}class de{constructor(H,q){this._provider=H,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(H,q){const ee=C.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(H,q)).then(se=>{if((0,i.isNonEmptyArray)(se)){for(const ce of se)if(!!ce){if(!ce.name){this._logService.warn("INVALID SymbolInformation, lacks name",ce);continue}const _e=C.IdObject.mixin(D.WorkspaceSymbol.from(ce));this._symbolCache.set(_e._id,ce),ee.symbols.push(_e)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(H,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const ee=this._symbolCache.get(H._id);if(ee){const se=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,q));return se&&(0,T.mixin)(H,D.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(H){const q=this._resultCache.get(H);if(q){for(let[ee,se]=q;ee<=se;ee++)this._symbolCache.delete(ee);this._resultCache.delete(H)}}}class W{constructor(H,q,ee){this._documents=H,this._provider=q,this._logService=ee}static supportsResolving(H){return typeof H.prepareRename=="function"}provideRenameEdits(H,q,ee,se){const ce=this._documents.getDocument(H),_e=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(ce,_e,ee,se)).then($e=>{if(!!$e)return D.WorkspaceEdit.from($e)},$e=>{const fe=W._asMessage($e);return fe?{rejectReason:fe,edits:void 0}:Promise.reject($e)})}resolveRenameLocation(H,q,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(H),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.prepareRename(se,ce,ee)).then(_e=>{let $e,fe;if(A.Range.isRange(_e)?($e=_e,fe=se.getText(_e)):(0,P.isObject)(_e)&&($e=_e.range,fe=_e.placeholder),!!$e){if($e.start.line>ce.line||$e.end.line<ce.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from($e),text:fe}}},_e=>{const $e=W._asMessage(_e);return $e?{rejectReason:$e,range:void 0,text:void 0}:Promise.reject(_e)})}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class j{constructor(H,q){this.resultId=H,this.tokens=q}}class U{constructor(H,q){this._documents=H,this._provider=q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(H,q,ee){const se=this._documents.getDocument(H),ce=q!==0?this._previousResults.get(q):null;return(0,y.asPromise)(()=>ce&&typeof ce.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(se,ce.resultId,ee):this._provider.provideDocumentSemanticTokens(se,ee)).then(_e=>(ce&&this._previousResults.delete(q),_e?(_e=U._fixProvidedSemanticTokens(_e),this._send(U._convertToEdits(ce,_e),_e)):null))}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return U._isSemanticTokens(H)?U._isCorrectSemanticTokens(H)?H:new A.SemanticTokens(new Uint32Array(H.data),H.resultId):U._isSemanticTokensEdits(H)?U._isCorrectSemanticTokensEdits(H)?H:new A.SemanticTokensEdits(H.edits.map(q=>new A.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const q of H.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,q){if(!U._isSemanticTokens(q)||!H||!H.tokens)return q;const ee=H.tokens,se=ee.length,ce=q.data,_e=ce.length;let $e=0;const fe=Math.min(se,_e);for(;$e<fe&&ee[$e]===ce[$e];)$e++;if($e===se&&$e===_e)return new A.SemanticTokensEdits([],q.resultId);let De=0;const Re=fe-$e;for(;De<Re&&ee[se-De-1]===ce[_e-De-1];)De++;return new A.SemanticTokensEdits([{start:$e,deleteCount:se-$e-De,data:ce.subarray($e,_e-De)}],q.resultId)}_send(H,q){if(U._isSemanticTokens(H)){const ee=this._nextResultId++;return this._previousResults.set(ee,new j(H.resultId,H.data)),(0,r.encodeSemanticTokensDto)({id:ee,type:"full",data:H.data})}if(U._isSemanticTokensEdits(H)){const ee=this._nextResultId++;return U._isSemanticTokens(q)?this._previousResults.set(ee,new j(q.resultId,q.data)):this._previousResults.set(ee,new j(H.resultId)),(0,r.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(H.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class F{constructor(H,q){this._documents=H,this._provider=q}provideDocumentRangeSemanticTokens(H,q,ee){const se=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(se,D.Range.to(q),ee)).then(ce=>ce?this._send(ce):null)}_send(H){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=F;class L{constructor(H,q,ee,se,ce){this._documents=H,this._commands=q,this._provider=ee,this._apiDeprecation=se,this._extension=ce,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,q,ee,se){const ce=this._documents.getDocument(H),_e=D.Position.to(q),$e=ce.getWordRangeAtPosition(_e)||new A.Range(_e,_e),fe=$e.with({end:_e}),De=new f.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(ce,_e,se,D.CompletionContext.to(ee)));if(!!Re&&!se.isCancellationRequested){const He=Array.isArray(Re)?new A.CompletionList(Re):Re,we=L.supportsResolving(this._provider)?this._cache.add(He.items):this._cache.add([]),Ke=new g.DisposableStore;this._disposables.set(we,Ke);const V=[],Z={x:we,b:V,a:{replace:D.Range.from($e),insert:D.Range.from(fe)},c:He.isIncomplete||void 0,d:De.elapsed()};for(let ge=0;ge<He.items.length;ge++){const Ne=He.items[ge],Ve=this._convertCompletionItem(Ne,[we,ge],fe,$e);V.push(Ve)}return Z}}async resolveCompletionItem(H,q){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...H);if(!!ee){const se=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,q));if(!!se)return this._convertCompletionItem(se,H)}}}releaseCompletionItems(H){var q;(q=this._disposables.get(H))===null||q===void 0||q.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,q,ee,se){var ce;const _e=this._disposables.get(q[0]);if(!_e)throw Error("DisposableStore is missing...");const $e={x:q,a:(ce=H.label)!==null&&ce!==void 0?ce:"",o:H.label2,b:H.kind!==void 0?D.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(D.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(H.command,_e)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),$e.h=H.textEdit.newText):typeof H.insertText=="string"?$e.h=H.insertText:H.insertText instanceof A.SnippetString&&($e.h=H.insertText.value,$e.i|=4);let fe;return H.textEdit?fe=H.textEdit.range:H.range&&(fe=H.range),A.Range.isRange(fe)?$e.j=D.Range.from(fe):fe&&(!(ee==null?void 0:ee.isEqual(fe.inserting))||!(se==null?void 0:se.isEqual(fe.replacing)))&&($e.j={insert:D.Range.from(fe.inserting),replace:D.Range.from(fe.replacing)}),$e}}class M{constructor(H,q){this._documents=H,this._provider=q,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(H,q,ee,se){const ce=this._documents.getDocument(H),_e=D.Position.to(q),$e=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(ce,_e,se,$e)).then(fe=>{if(fe){const De=this._cache.add([fe]);return Object.assign(Object.assign({},D.SignatureHelp.from(fe)),{id:De})}})}reviveContext(H){let q;if(H.activeSignatureHelp){const ee=D.SignatureHelp.to(H.activeSignatureHelp),se=this._cache.get(H.activeSignatureHelp.id,0);se?(q=se,q.activeSignature=ee.activeSignature,q.activeParameter=ee.activeParameter):q=ee}return Object.assign(Object.assign({},H),{activeSignatureHelp:q})}releaseSignatureHelp(H){this._cache.delete(H)}}class x{constructor(H,q){this._documents=H,this._provider=q}provideInlayHints(H,q,ee){const se=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideInlayHints(se,D.Range.to(q),ee)).then(ce=>ce?{hints:ce.map(D.InlayHint.from)}:void 0)}}class G{constructor(H,q){this._documents=H,this._provider=q,this._cache=new p.Cache("DocumentLink")}provideLinks(H,q){const ee=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,q)).then(se=>{if(!(!Array.isArray(se)||se.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.map(D.DocumentLink.from)};{const ce=this._cache.add(se),_e={links:[],id:ce};for(let $e=0;$e<se.length;$e++){const fe=D.DocumentLink.from(se[$e]);fe.cacheId=[ce,$e],_e.links.push(fe)}return _e}}})}resolveLink(H,q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...H);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,q)).then(se=>se&&D.DocumentLink.from(se)||void 0):Promise.resolve(void 0)}releaseLinks(H){this._cache.delete(H)}}class J{constructor(H,q){this._documents=H,this._provider=q}provideColors(H,q){const ee=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,q)).then(se=>Array.isArray(se)?se.map(_e=>({color:D.Color.from(_e.color),range:D.Range.from(_e.range)})):[])}provideColorPresentations(H,q,ee){const se=this._documents.getDocument(H),ce=D.Range.to(q.range),_e=D.Color.to(q.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(_e,{document:se,range:ce},ee)).then($e=>{if(!!Array.isArray($e))return $e.map(D.ColorPresentation.from)})}}class te{constructor(H,q){this._documents=H,this._provider=q}provideFoldingRanges(H,q,ee){const se=this._documents.getDocument(H);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(se,q,ee)).then(ce=>{if(!!Array.isArray(ce))return ce.map(D.FoldingRange.from)})}}class me{constructor(H,q,ee){this._documents=H,this._provider=q,this._logService=ee}provideSelectionRanges(H,q,ee){const se=this._documents.getDocument(H),ce=q.map(D.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(se,ce,ee)).then(_e=>{if(!(0,i.isNonEmptyArray)(_e))return[];if(_e.length!==ce.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const $e=[];for(let fe=0;fe<ce.length;fe++){const De=[];$e.push(De);let Re=ce[fe],He=_e[fe];for(;;){if(!He.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(De.push(D.SelectionRange.from(He)),!He.parent)break;Re=He.range,He=He.parent}}return $e})}}class Le{constructor(H,q){this._documents=H,this._provider=q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(H,q,ee){const se=this._documents.getDocument(H),ce=D.Position.to(q),_e=await this._provider.prepareCallHierarchy(se,ce,ee);if(!!_e){const $e=this._idPool.nextId();return this._cache.set($e,new Map),Array.isArray(_e)?_e.map(fe=>this._cacheAndConvertItem($e,fe)):[this._cacheAndConvertItem($e,_e)]}}async provideCallsTo(H,q,ee){const se=this._itemFromCache(H,q);if(!se)throw new Error("missing call hierarchy item");const ce=await this._provider.provideCallHierarchyIncomingCalls(se,ee);if(!!ce)return ce.map(_e=>({from:this._cacheAndConvertItem(H,_e.from),fromRanges:_e.fromRanges.map($e=>D.Range.from($e))}))}async provideCallsFrom(H,q,ee){const se=this._itemFromCache(H,q);if(!se)throw new Error("missing call hierarchy item");const ce=await this._provider.provideCallHierarchyOutgoingCalls(se,ee);if(!!ce)return ce.map(_e=>({to:this._cacheAndConvertItem(H,_e.to),fromRanges:_e.fromRanges.map($e=>D.Range.from($e))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,q){var ee;const se=this._cache.get(H),ce={_sessionId:H,_itemId:se.size.toString(36),name:q.name,detail:q.detail,kind:D.SymbolKind.from(q.kind),uri:q.uri,range:D.Range.from(q.range),selectionRange:D.Range.from(q.selectionRange),tags:(ee=q.tags)===null||ee===void 0?void 0:ee.map(D.SymbolTag.from)};return se.set(ce._itemId,q),ce}_itemFromCache(H,q){const ee=this._cache.get(H);return ee==null?void 0:ee.get(q)}}class We{constructor(H,q){this.adapter=H,this.extension=q}}class Fe{constructor(H,q,ee,se,ce,_e,$e){this._adapter=new Map,this._uriTransformer=q,this._proxy=H.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=se,this._diagnostics=ce,this._logService=_e,this._apiDeprecation=$e}_transformDocumentSelector(H){return(0,i.coalesce)((0,i.asArray)(H).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(H){if(typeof H=="string")return{$serialized:!0,language:H};if(H)return{$serialized:!0,language:H.language,scheme:this._transformScheme(H.scheme),pattern:typeof H.pattern=="undefined"?void 0:D.GlobPattern.from(H.pattern),exclusive:H.exclusive}}_transformScheme(H){return this._uriTransformer&&typeof H=="string"?this._uriTransformer.transformOutgoingScheme(H):H}_createDisposable(H){return new A.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Fe._handlePool++}_withAdapter(H,q,ee,se,ce=!1){const _e=this._adapter.get(H);if(!_e)return Promise.resolve(se);if(_e.adapter instanceof q){let $e;_e.extension&&($e=Date.now(),this._logService.trace(`[${_e.extension.identifier.value}] INVOKE provider '${q.name}'`));const fe=ee(_e.adapter,_e.extension),De=_e.extension;return De&&Promise.resolve(fe).then(()=>this._logService.trace(`[${De.identifier.value}] provider DONE after ${Date.now()-$e}ms`),Re=>{ce&&Re instanceof E.CancellationError||(this._logService.error(`[${De.identifier.value}] provider FAILED`),this._logService.error(Re))}),fe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,q){const ee=this._nextHandle();return this._adapter.set(ee,new We(H,q)),ee}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,q,ee,se){const ce=this._addNewAdapter(new o(this._documents,ee),H),_e=se&&se.label||Fe._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(ce,this._transformDocumentSelector(q),_e),this._createDisposable(ce)}$provideDocumentSymbols(H,q,ee){return this._withAdapter(H,o,se=>se.provideDocumentSymbols(v.URI.revive(q),ee),void 0)}registerCodeLensProvider(H,q,ee){const se=this._nextHandle(),ce=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new We(new c(this._documents,this._commands.converter,ee),H)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(q),ce);let _e=this._createDisposable(se);if(ce!==void 0){const $e=ee.onDidChangeCodeLenses(fe=>this._proxy.$emitCodeLensEvent(ce));_e=A.Disposable.from(_e,$e)}return _e}$provideCodeLenses(H,q,ee){return this._withAdapter(H,c,se=>se.provideCodeLenses(v.URI.revive(q),ee),void 0)}$resolveCodeLens(H,q,ee){return this._withAdapter(H,c,se=>se.resolveCodeLens(q,ee),void 0)}$releaseCodeLenses(H,q){this._withAdapter(H,c,ee=>Promise.resolve(ee.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(H,q,ee){const se=this._addNewAdapter(new t(this._documents,ee),H);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDefinition(H,q,ee,se){return this._withAdapter(H,t,ce=>ce.provideDefinition(v.URI.revive(q),ee,se),[])}registerDeclarationProvider(H,q,ee){const se=this._addNewAdapter(new n(this._documents,ee),H);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDeclaration(H,q,ee,se){return this._withAdapter(H,n,ce=>ce.provideDeclaration(v.URI.revive(q),ee,se),[])}registerImplementationProvider(H,q,ee){const se=this._addNewAdapter(new l(this._documents,ee),H);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideImplementation(H,q,ee,se){return this._withAdapter(H,l,ce=>ce.provideImplementation(v.URI.revive(q),ee,se),[])}registerTypeDefinitionProvider(H,q,ee){const se=this._addNewAdapter(new s(this._documents,ee),H);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideTypeDefinition(H,q,ee,se){return this._withAdapter(H,s,ce=>ce.provideTypeDefinition(v.URI.revive(q),ee,se),[])}registerHoverProvider(H,q,ee,se){const ce=this._addNewAdapter(new u(this._documents,ee),H);return this._proxy.$registerHoverProvider(ce,this._transformDocumentSelector(q)),this._createDisposable(ce)}$provideHover(H,q,ee,se){return this._withAdapter(H,u,ce=>ce.provideHover(v.URI.revive(q),ee,se),void 0)}registerEvaluatableExpressionProvider(H,q,ee,se){const ce=this._addNewAdapter(new w(this._documents,ee),H);return this._proxy.$registerEvaluatableExpressionProvider(ce,this._transformDocumentSelector(q)),this._createDisposable(ce)}$provideEvaluatableExpression(H,q,ee,se){return this._withAdapter(H,w,ce=>ce.provideEvaluatableExpression(v.URI.revive(q),ee,se),void 0)}registerInlineValuesProvider(H,q,ee,se){const ce=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,_e=this._addNewAdapter(new b(this._documents,ee),H);this._proxy.$registerInlineValuesProvider(_e,this._transformDocumentSelector(q),ce);let $e=this._createDisposable(_e);if(ce!==void 0){const fe=ee.onDidChangeInlineValues(De=>this._proxy.$emitInlineValuesEvent(ce));$e=A.Disposable.from($e,fe)}return $e}$provideInlineValues(H,q,ee,se,ce){return this._withAdapter(H,b,_e=>_e.provideInlineValues(v.URI.revive(q),ee,se,ce),void 0)}registerDocumentHighlightProvider(H,q,ee){const se=this._addNewAdapter(new I(this._documents,ee),H);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDocumentHighlights(H,q,ee,se){return this._withAdapter(H,I,ce=>ce.provideDocumentHighlights(v.URI.revive(q),ee,se),void 0)}registerLinkedEditingRangeProvider(H,q,ee){const se=this._addNewAdapter(new h(this._documents,ee),H);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideLinkedEditingRanges(H,q,ee,se){return this._withAdapter(H,h,async ce=>{const _e=await ce.provideLinkedEditingRanges(v.URI.revive(q),ee,se);if(_e)return{ranges:_e.ranges,wordPattern:_e.wordPattern?Fe._serializeRegExp(_e.wordPattern):void 0}},void 0)}registerReferenceProvider(H,q,ee){const se=this._addNewAdapter(new _(this._documents,ee),H);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideReferences(H,q,ee,se,ce){return this._withAdapter(H,_,_e=>_e.provideReferences(v.URI.revive(q),ee,se,ce),void 0)}registerCodeActionProvider(H,q,ee,se){var ce,_e;const $e=new g.DisposableStore,fe=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(fe,this._transformDocumentSelector(q),{providedKinds:(ce=se==null?void 0:se.providedCodeActionKinds)===null||ce===void 0?void 0:ce.map(De=>De.value),documentation:(_e=se==null?void 0:se.documentation)===null||_e===void 0?void 0:_e.map(De=>({kind:De.kind.value,command:this._commands.converter.toInternal(De.command,$e)}))},Fe._extLabel(H),Boolean(ee.resolveCodeAction)),$e.add(this._createDisposable(fe)),$e}$provideCodeActions(H,q,ee,se,ce){return this._withAdapter(H,R,_e=>_e.provideCodeActions(v.URI.revive(q),ee,se,ce),void 0)}$resolveCodeAction(H,q,ee){return this._withAdapter(H,R,se=>se.resolveCodeAction(q,ee),void 0)}$releaseCodeActions(H,q){this._withAdapter(H,R,ee=>Promise.resolve(ee.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(H,q,ee){const se=this._addNewAdapter(new B(this._documents,ee),H);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(q),H.identifier,H.displayName||H.name),this._createDisposable(se)}$provideDocumentFormattingEdits(H,q,ee,se){return this._withAdapter(H,B,ce=>ce.provideDocumentFormattingEdits(v.URI.revive(q),ee,se),void 0)}registerDocumentRangeFormattingEditProvider(H,q,ee){const se=this._addNewAdapter(new z(this._documents,ee),H);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(q),H.identifier,H.displayName||H.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(H,q,ee,se,ce){return this._withAdapter(H,z,_e=>_e.provideDocumentRangeFormattingEdits(v.URI.revive(q),ee,se,ce),void 0)}registerOnTypeFormattingEditProvider(H,q,ee,se){const ce=this._addNewAdapter(new he(this._documents,ee),H);return this._proxy.$registerOnTypeFormattingSupport(ce,this._transformDocumentSelector(q),se,H.identifier),this._createDisposable(ce)}$provideOnTypeFormattingEdits(H,q,ee,se,ce,_e){return this._withAdapter(H,he,$e=>$e.provideOnTypeFormattingEdits(v.URI.revive(q),ee,se,ce,_e),void 0)}registerWorkspaceSymbolProvider(H,q){const ee=this._addNewAdapter(new de(q,this._logService),H);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(H,q,ee){return this._withAdapter(H,de,se=>se.provideWorkspaceSymbols(q,ee),{symbols:[]})}$resolveWorkspaceSymbol(H,q,ee){return this._withAdapter(H,de,se=>se.resolveWorkspaceSymbol(q,ee),void 0)}$releaseWorkspaceSymbols(H,q){this._withAdapter(H,de,ee=>ee.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(H,q,ee){const se=this._addNewAdapter(new W(this._documents,ee,this._logService),H);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(q),W.supportsResolving(ee)),this._createDisposable(se)}$provideRenameEdits(H,q,ee,se,ce){return this._withAdapter(H,W,_e=>_e.provideRenameEdits(v.URI.revive(q),ee,se,ce),void 0)}$resolveRenameLocation(H,q,ee,se){return this._withAdapter(H,W,ce=>ce.resolveRenameLocation(v.URI.revive(q),ee,se),void 0)}registerDocumentSemanticTokensProvider(H,q,ee,se){const ce=this._nextHandle(),_e=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ce,new We(new U(this._documents,ee),H)),this._proxy.$registerDocumentSemanticTokensProvider(ce,this._transformDocumentSelector(q),se,_e);let $e=this._createDisposable(ce);if(_e){const fe=ee.onDidChangeSemanticTokens(De=>this._proxy.$emitDocumentSemanticTokensEvent(_e));$e=A.Disposable.from($e,fe)}return $e}$provideDocumentSemanticTokens(H,q,ee,se){return this._withAdapter(H,U,ce=>ce.provideDocumentSemanticTokens(v.URI.revive(q),ee,se),null,!0)}$releaseDocumentSemanticTokens(H,q){this._withAdapter(H,U,ee=>ee.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(H,q,ee,se){const ce=this._addNewAdapter(new F(this._documents,ee),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ce,this._transformDocumentSelector(q),se),this._createDisposable(ce)}$provideDocumentRangeSemanticTokens(H,q,ee,se){return this._withAdapter(H,F,ce=>ce.provideDocumentRangeSemanticTokens(v.URI.revive(q),ee,se),null,!0)}registerCompletionItemProvider(H,q,ee,se){const ce=this._addNewAdapter(new L(this._documents,this._commands.converter,ee,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(ce,this._transformDocumentSelector(q),se,L.supportsResolving(ee),`${H.identifier.value}(${se.join("")})`),this._createDisposable(ce)}$provideCompletionItems(H,q,ee,se,ce){return this._withAdapter(H,L,_e=>_e.provideCompletionItems(v.URI.revive(q),ee,se,ce),void 0)}$resolveCompletionItem(H,q,ee){return this._withAdapter(H,L,se=>se.resolveCompletionItem(q,ee),void 0)}$releaseCompletionItems(H,q){this._withAdapter(H,L,ee=>ee.releaseCompletionItems(q),void 0)}registerSignatureHelpProvider(H,q,ee,se){const ce=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,_e=this._addNewAdapter(new M(this._documents,ee),H);return this._proxy.$registerSignatureHelpProvider(_e,this._transformDocumentSelector(q),ce),this._createDisposable(_e)}$provideSignatureHelp(H,q,ee,se,ce){return this._withAdapter(H,M,_e=>_e.provideSignatureHelp(v.URI.revive(q),ee,se,ce),void 0)}$releaseSignatureHelp(H,q){this._withAdapter(H,M,ee=>ee.releaseSignatureHelp(q),void 0)}registerInlayHintsProvider(H,q,ee){const se=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new x(this._documents,ee),H);this._proxy.$registerInlayHintsProvider(ce,this._transformDocumentSelector(q),se);let _e=this._createDisposable(ce);if(se!==void 0){const $e=ee.onDidChangeInlayHints(fe=>this._proxy.$emitInlayHintsEvent(se));_e=A.Disposable.from(_e,$e)}return _e}$provideInlayHints(H,q,ee,se){return this._withAdapter(H,x,ce=>ce.provideInlayHints(v.URI.revive(q),ee,se),void 0)}registerDocumentLinkProvider(H,q,ee){const se=this._addNewAdapter(new G(this._documents,ee),H);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(q),typeof ee.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(H,q,ee){return this._withAdapter(H,G,se=>se.provideLinks(v.URI.revive(q),ee),void 0)}$resolveDocumentLink(H,q,ee){return this._withAdapter(H,G,se=>se.resolveLink(q,ee),void 0)}$releaseDocumentLinks(H,q){this._withAdapter(H,G,ee=>ee.releaseLinks(q),void 0)}registerColorProvider(H,q,ee){const se=this._addNewAdapter(new J(this._documents,ee),H);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDocumentColors(H,q,ee){return this._withAdapter(H,J,se=>se.provideColors(v.URI.revive(q),ee),[])}$provideColorPresentations(H,q,ee,se){return this._withAdapter(H,J,ce=>ce.provideColorPresentations(v.URI.revive(q),ee,se),void 0)}registerFoldingRangeProvider(H,q,ee){const se=this._nextHandle(),ce=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new We(new te(this._documents,ee),H)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(q),ce);let _e=this._createDisposable(se);if(ce!==void 0){const $e=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ce));_e=A.Disposable.from(_e,$e)}return _e}$provideFoldingRanges(H,q,ee,se){return this._withAdapter(H,te,ce=>ce.provideFoldingRanges(v.URI.revive(q),ee,se),void 0)}registerSelectionRangeProvider(H,q,ee){const se=this._addNewAdapter(new me(this._documents,ee,this._logService),H);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideSelectionRanges(H,q,ee,se){return this._withAdapter(H,me,ce=>ce.provideSelectionRanges(v.URI.revive(q),ee,se),[])}registerCallHierarchyProvider(H,q,ee){const se=this._addNewAdapter(new Le(this._documents,ee),H);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$prepareCallHierarchy(H,q,ee,se){return this._withAdapter(H,Le,ce=>Promise.resolve(ce.prepareSession(v.URI.revive(q),ee,se)),void 0)}$provideCallHierarchyIncomingCalls(H,q,ee,se){return this._withAdapter(H,Le,ce=>ce.provideCallsTo(q,ee,se),void 0)}$provideCallHierarchyOutgoingCalls(H,q,ee,se){return this._withAdapter(H,Le,ce=>ce.provideCallsFrom(q,ee,se),void 0)}$releaseCallHierarchy(H,q){this._withAdapter(H,Le,ee=>Promise.resolve(ee.releaseSession(q)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,S.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Fe._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Fe._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Fe._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Fe._serializeRegExp(H.beforeText),afterText:H.afterText?Fe._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Fe._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Fe._serializeOnEnterRule)}setLanguageConfiguration(H,q,ee){let{wordPattern:se}=ee;if(se&&(0,S.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(q,se):this._documents.setWordDefinitionFor(q,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const ce=this._nextHandle(),_e={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Fe._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Fe._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Fe._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ce,q,_e),this._createDisposable(ce)}$setWordDefinitions(H){for(const q of H)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(ve[199],be([0,1,5,9,7]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(C,S){this._proxy=C.getProxy(v.MainContext.MainThreadLanguages),this._documents=S}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,S){await this._proxy.$changeLanguage(C,S);const k=this._documents.getDocumentData(C);if(!k)throw new Error(`document '${C.toString}' NOT found`);return k.document}async tokenAtPosition(C,S){var k;const i=C.version,P=T.Position.from(S),d=await this._proxy.$tokensAtPosition(C.uri,P),g={type:D.StandardTokenType.Other,range:(k=C.getWordRangeAtPosition(S))!==null&&k!==void 0?k:new D.Range(S.line,S.character,S.line,S.character)};if(!d)return g;const r={range:T.Range.to(d.range),type:T.TokenType.to(d.type)};return!r.range.contains(S)||i!==C.version?g:r}}e.ExtHostLanguages=A}),define(ve[200],be([0,1,5,18,33]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(C){return C&&C.title}let y=class{constructor(S,k){this._logService=k,this._proxy=S.getProxy(v.MainContext.MainThreadMessageService)}showMessage(S,k,i,P,d){const g={extension:S};let r;typeof P=="string"||A(P)?r=[P,...d]:(g.modal=P&&P.modal,g.useCustom=P&&P.useCustom,r=d),g.useCustom&&(0,D.checkProposedApiEnabled)(S);const a=[];for(let p=0;p<r.length;p++){const f=r[p];if(typeof f=="string")a.push({title:f,handle:p,isCloseAffordance:!1});else if(typeof f=="object"){let{title:E,isCloseAffordance:o}=f;a.push({title:E,isCloseAffordance:!!o,handle:p})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(k,i,g,a).then(p=>{if(typeof p=="number")return r[p]})}};y=je([qe(1,T.ILogService)],y),e.ExtHostMessageService=y}),define(ve[201],be([0,1,24,3,56,54,6,22,8,10,2,68,5,9,7,74,178,179]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class E{constructor(m,t){const n=E._Keys.nextId();m.$registerNotebookEditorDecorationType(n,g.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){m.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=E,E._Keys=new A.IdGenerator("NotebookEditorDecorationType");class o{constructor(m,t,n,l,s,u){this._textDocumentsAndEditors=n,this._textDocuments=l,this.logService=s,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=m.getProxy(d.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(d.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(d.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:w=>{var b;if(w&&w.$mid===12){const I=(b=w.notebookEditor)===null||b===void 0?void 0:b.notebookUri,h=w.cell.handle,_=this._documents.get(I),R=_==null?void 0:_.getCell(h);if(R)return R.apiCell}return w}})}get activeNotebookEditor(){var m;return(m=this._activeNotebookEditor)===null||m===void 0?void 0:m.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}getEditorById(m){return this._editors.get(m)}getIdByEditor(m){for(const[t,n]of this._editors)if(n.apiEditor===m)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,t){const n=this._documents.get(m);if(!n&&!t)throw new Error(`NO notebook document for '${m}'`);return n}_getProviderData(m){const t=this._notebookContentProviders.get(m);if(!t)throw new Error(`NO provider for '${m}'`);return t}registerNotebookContentProvider(m,t,n,l,s){if((0,S.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:m,provider:n});let u;return n.onDidChangeNotebookContentOptions&&(u=n.onDidChangeNotebookContentOptions(()=>{const w=g.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,w)})),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},t,g.NotebookDocumentContentOptions.from(l),o._convertNotebookRegistrationData(m,s)),new r.Disposable(()=>{u==null||u.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(m,t){if(!!t){const n=t.filenamePattern.map(l=>g.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(m,t,n){const l=o._notebookStatusBarItemProviderHandlePool++,s=typeof n.onDidChangeCellStatusBarItems=="function"?o._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,s,t);let u;return s!==void 0&&(u=n.onDidChangeCellStatusBarItems(w=>this._notebookProxy.$emitCellStatusBarEvent(s))),new r.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,s),u&&u.dispose()})}createNotebookEditorDecorationType(m){return new E(this._notebookEditorsProxy,m).value}async openNotebookDocument(m){const t=this._documents.get(m);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenDocument(m),l=this._documents.get(i.URI.revive(n));return(0,k.assertIsDefined)(l==null?void 0:l.apiNotebook)}async showNotebookDocument(m,t){var n;i.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let l;typeof t=="object"?l={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:l={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.viewType,l),u=s&&((n=this._editors.get(s))===null||n===void 0?void 0:n.apiEditor);if(u)return u;throw s?new Error(`Could NOT open editor for "${m.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.toString()}".`)}async $provideNotebookCellStatusBarItems(m,t,n,l){var s;const u=this._notebookStatusBarItemProviders.get(m),w=i.URI.revive(t),b=this._documents.get(w);if(!(!b||!u)){const I=b.getCellFromIndex(n);if(!!I){const h=await u.provideCellStatusBarItems(I.apiCell,l);if(!!h){const _=new y.DisposableStore,R=this._statusBarCache.add([_]),B=(s=h&&h.map(z=>g.NotebookStatusBarItem.from(z,this._commandsConverter,_)))!==null&&s!==void 0?s:void 0;return{cacheId:R,items:B}}}}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,t,n,l,s){if((0,S.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,n),this._notebookProxy.$registerNotebookSerializer(u,{id:m.identifier,location:m.extensionLocation},t,g.NotebookDocumentContentOptions.from(l),o._convertNotebookRegistrationData(m,s)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(m,t,n){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const s=await l.deserializeNotebook(t.buffer,n),u={metadata:g.NotebookDocumentMetadata.from(s.metadata),cells:[]};for(let w of s.cells)r.NotebookCellData.validate(w),u.cells.push(g.NotebookCellData.from(w));return u}async $notebookToData(m,t,n){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const s=await l.serializeNotebook({metadata:g.NotebookDocumentMetadata.to(t.metadata),cells:t.cells.map(g.NotebookCellData.to)},n);return v.VSBuffer.wrap(s)}async $openNotebook(m,t,n,l,s){const{provider:u}=this._getProviderData(m),w=await u.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:l==null?void 0:l.buffer},s);return{metadata:g.NotebookDocumentMetadata.from(w.metadata),cells:w.cells.map(g.NotebookCellData.from)}}async $saveNotebook(m,t,n){const l=this.getNotebookDocument(i.URI.revive(t)),{provider:s}=this._getProviderData(m);return await s.saveNotebook(l.apiNotebook,n),!0}async $saveNotebookAs(m,t,n,l){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:u}=this._getProviderData(m);return await u.saveNotebookAs(i.URI.revive(n),s.apiNotebook,l),!0}async $backupNotebook(m,t,n){var l;const s=this.getNotebookDocument(i.URI.revive(t)),u=this._getProviderData(m),w=(l=this._extensionStoragePaths.workspaceValue(u.extension))!==null&&l!==void 0?l:this._extensionStoragePaths.globalValue(u.extension),b=String((0,D.hash)([s.uri.toString(),this._backupIdPool++])),I=i.URI.joinPath(w,b),h=await u.provider.backupNotebook(s.apiNotebook,{destination:I},n);return s.updateBackup(h),h.id}$acceptModelChanged(m,t,n){this.getNotebookDocument(i.URI.revive(m)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(m,t){const n=this.getNotebookDocument(i.URI.revive(m));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(m){const t=this.getNotebookDocument(i.URI.revive(m));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(m,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,t);const n=this._editors.get(m);if(!n)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const t in m){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(g.ViewColumn.to(m[t]))}}$acceptDocumentPropertiesChanged(m,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",m.path,t);const n=this.getNotebookDocument(i.URI.revive(m));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(m,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const l=new f.ExtHostNotebookEditor(t,this._notebookEditorsProxy,m,n.visibleRanges.map(g.NotebookRange.to),n.selections.map(g.NotebookRange.to),typeof n.viewColumn=="number"?g.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,l)}$acceptDocumentAndEditorsDelta(m){var t,n,l;if(m.removedDocuments)for(const u of m.removedDocuments){const w=i.URI.revive(u),b=this._documents.get(w);b&&(b.dispose(),this._documents.delete(w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(I=>I.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const I of this._editors.values())I.notebookData.uri.toString()===w.toString()&&this._editors.delete(I.id)}if(m.addedDocuments){const u=[];for(const w of m.addedDocuments){const b=i.URI.revive(w.uri),I=w.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const h=this,_=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(R){h._onDidChangeNotebookCells.fire(R)},emitCellOutputsChange(R){h._onDidChangeCellOutputs.fire(R)},emitCellMetadataChange(R){h._onDidChangeCellMetadata.fire(R)},emitCellExecutionStateChange(R){h._onDidChangeCellExecutionState.fire(R)}},I,w.metadata?g.NotebookDocumentMetadata.to(w.metadata):new r.NotebookDocumentMetadata,b);_.acceptModelChanged({versionId:w.versionId,rawEvents:[{kind:a.NotebookCellsChangeType.Initialize,changes:[[0,0,w.cells]]}]},!1),u.push(...w.cells.map(R=>p.ExtHostCell.asModelAddData(_.apiNotebook,R))),(t=this._documents.get(b))===null||t===void 0||t.dispose(),this._documents.set(b,_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(_.apiNotebook)}}if(m.addedEditors)for(const u of m.addedEditors){if(this._editors.has(u.id))return;const w=i.URI.revive(u.documentUri),b=this._documents.get(w);b&&this._createExtHostEditor(b,u.id,u)}const s=[];if(m.removedEditors)for(const u of m.removedEditors){const w=this._editors.get(u);w&&(this._editors.delete(u),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===w.id&&(this._activeNotebookEditor=void 0),s.push(w))}if(m.visibleEditors){this._visibleNotebookEditors=m.visibleEditors.map(w=>this._editors.get(w)).filter(w=>!!w);const u=new Set;this._visibleNotebookEditors.forEach(w=>u.add(w.id));for(const w of this._editors.values()){const b=u.has(w.id);w._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(w=>w).filter(w=>w.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.newActiveEditor===null?this._activeNotebookEditor=void 0:m.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.newActiveEditor)),m.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((l=this._activeNotebookEditor)===null||l===void 0?void 0:l.apiEditor)}}e.ExtHostNotebookController=o,o._notebookStatusBarItemProviderHandlePool=0}),define(ve[202],be([0,1,3,6,5,26,2,9,73,22,11,20,7,13]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class r{constructor(o,c,m){this._mainContext=o,this._initData=c,this._extHostNotebook=m,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=o.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(o,c,m,t,n,l){for(let U of this._kernelData.values())if(U.controller.id===c&&A.ExtensionIdentifier.equals(o.identifier,U.extensionId))throw new Error(`notebook controller with id '${c}' ALREADY exist`);const s=this._handlePool++,u=this,w=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${o.identifier}'`);let b=!1;const I=new T.DisposableStore,h=new v.Emitter,_=new v.Emitter,R={id:`${o.identifier.value}/${c}`,viewType:m,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:t||o.identifier.value,preloads:l?l.map(C.NotebookKernelPreload.from):[]};let B=n!=null?n:w,z;this._proxy.$addKernel(s,R).catch(U=>{console.log(U),b=!0});let he=0;const de=()=>{if(!b){const U=++he;Promise.resolve().then(()=>{U===he&&this._proxy.$updateKernel(s,R)})}},W=new k.ResourceMap,j={get id(){return c},get viewType(){return R.viewType},onDidChangeNotebookAssociation:h.event,get label(){return R.label},set label(U){var F;R.label=(F=U!=null?U:o.displayName)!==null&&F!==void 0?F:o.name,de()},get detail(){var U;return(U=R.detail)!==null&&U!==void 0?U:""},set detail(U){R.detail=U,de()},get description(){var U;return(U=R.description)!==null&&U!==void 0?U:""},set description(U){R.description=U,de()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(U){R.supportedLanguages=U,de()},get hasExecutionOrder(){var U;return(U=R.hasExecutionOrder)!==null&&U!==void 0?U:!1},set hasExecutionOrder(U){R.hasExecutionOrder=U,de()},get preloads(){return R.preloads?R.preloads.map(C.NotebookKernelPreload.to):[]},get executeHandler(){return B},set executeHandler(U){B=U!=null?U:w},get interruptHandler(){return z},set interruptHandler(U){z=U,R.supportsInterrupt=Boolean(U),de()},createNotebookCellExecutionTask(U){if(b)throw new Error("notebook controller is DISPOSED");if(!W.has(U.notebook.uri))throw new Error(`notebook controller is NOT associated to notebook: ${U.notebook.uri.toString()}`);return u._createNotebookCellExecution(U)},dispose:()=>{b||(b=!0,this._kernelData.delete(s),I.dispose(),h.dispose(),_.dispose(),this._proxy.$removeKernel(s))},onDidReceiveMessage:_.event,postMessage(U,F){return u._proxy.$postMessage(s,F&&u._extHostNotebook.getIdByEditor(F),U)},asWebviewUri(U){return(0,S.asWebviewUri)(Object.assign(Object.assign({},u._initData.environment),{remote:u._initData.remote}),String(s),U)},updateNotebookAffinity(U,F){u._proxy.$updateNotebookPriority(s,U.uri,F)}};return this._kernelData.set(s,{extensionId:o.identifier,controller:j,onDidReceiveMessage:_,onDidChangeSelection:h,associatedNotebooks:W}),j}$acceptNotebookAssociation(o,c,m){const t=this._kernelData.get(o);if(t){const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));m?t.associatedNotebooks.set(n.uri,!0):t.associatedNotebooks.delete(n.uri),t.onDidChangeSelection.fire({selected:m,notebook:n.apiNotebook})}}async $executeCells(o,c,m){const t=this._kernelData.get(o);if(!!t){const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(c)),l=[];for(let s of m){const u=n.getCell(s);u&&l.push(u.apiCell)}try{await t.controller.executeHandler.call(t.controller,l,n.apiNotebook,t.controller)}catch(s){console.error(s)}}}async $cancelCells(o,c,m){var t;const n=this._kernelData.get(o);if(!!n){const l=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));n.controller.interruptHandler&&await n.controller.interruptHandler.call(n.controller,l.apiNotebook);for(let s of m){const u=l.getCell(s);u&&((t=this._activeExecutions.get(u.uri))===null||t===void 0||t.cancel())}}}$acceptKernelMessageFromRenderer(o,c,m){const t=this._kernelData.get(o);if(!!t){const n=this._extHostNotebook.getEditorById(c);if(!n)throw new Error(`send message for UNKNOWN editor: ${c}`);t.onDidReceiveMessage.fire(Object.freeze({editor:n.apiEditor,message:m}))}}_createNotebookCellExecution(o){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!m)throw new Error("invalid cell");if(this._activeExecutions.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const t=new p(m.notebook,m,this._mainContext.getProxy(D.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(m.uri,t);const n=t.onDidChangeState(()=>{t.state===a.Resolved&&(t.dispose(),n.dispose(),this._activeExecutions.delete(m.uri))});return t.asApiObject()}}e.ExtHostNotebookKernels=r;var a;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(a||(a={}));class p extends T.Disposable{constructor(o,c,m){super();this._document=o,this._cell=c,this._proxy=m,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._collector=new f(10,t=>this.applyEdits(t)),this._executionOrder=c.internalMetadata.executionOrder,this.mixinMetadata({runState:d.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(o){await this._collector.addItem(o)}async applyEdits(o){return this._proxy.$applyEdits(this._document.uri,o,!1)}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(o){const c={editType:8,handle:this._cell.handle,metadata:o};this.applyEdits([c])}cellIndexToHandle(o){if(typeof o!="number")return this._cell.handle;const c=this._document.getCellFromIndex(o);if(!c)throw new Error("INVALID cell index");return c.handle}asApiObject(){const o=this;return Object.freeze({get document(){return o._document.apiNotebook},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(c){o._executionOrder=c,o.mixinMetadata({executionOrder:c})},start(c){var m;if(o._state===a.Resolved||o._state===a.Started)throw new Error("Cannot call start again");o._state=a.Started,o._onDidChangeState.fire(),o.mixinMetadata({runState:d.NotebookCellExecutionState.Executing,runStartTime:(m=c==null?void 0:c.startTime)!==null&&m!==void 0?m:null})},end(c){var m,t;if(o._state===a.Resolved)throw new Error("Cannot call resolve twice");o._state=a.Resolved,o._onDidChangeState.fire(),o.mixinMetadata({runState:d.NotebookCellExecutionState.Idle,lastRunSuccess:(m=c==null?void 0:c.success)!==null&&m!==void 0?m:null,runEndTime:(t=c==null?void 0:c.endTime)!==null&&t!==void 0?t:null})},clearOutput(c){return o.verifyStateForOutput(),this.replaceOutput([],c)},async appendOutput(c,m){o.verifyStateForOutput();const t=o.cellIndexToHandle(m);return c=(0,g.asArray)(c),o.applyEditSoon({editType:2,handle:t,append:!0,outputs:c.map(C.NotebookCellOutput.from)})},async replaceOutput(c,m){o.verifyStateForOutput();const t=o.cellIndexToHandle(m);return c=(0,g.asArray)(c),o.applyEditSoon({editType:2,handle:t,outputs:c.map(C.NotebookCellOutput.from)})},async appendOutputItems(c,m){return o.verifyStateForOutput(),c=(0,g.asArray)(c),o.applyEditSoon({editType:7,append:!0,items:c.map(C.NotebookCellOutputItem.from),outputId:m})},async replaceOutputItems(c,m){return o.verifyStateForOutput(),c=(0,g.asArray)(c),o.applyEditSoon({editType:7,items:c.map(C.NotebookCellOutputItem.from),outputId:m})},token:o._tokenSource.token})}}class f{constructor(o,c){this.delay=o,this.callback=c,this.batch=[]}addItem(o){return this.batch.push(o),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const c=this.batch;return this.batch=[],this.callback(c)})),this.waitPromise}}}),define(ve[101],be([0,1,5,3,6,24,4,15]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends D.Disposable{constructor(r,a,p,f){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=f,this._id=f.$register(this.name,a,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?A.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(a=>this._proxy.$clear(a,r))}show(r,a){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof r=="boolean"?r:a)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class k extends S{constructor(r,a){super(r,!1,void 0,a)}append(r){super.append(r),this._id.then(a=>this._proxy.$append(a,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends S{constructor(r,a,p){super(r,!0,a,p)}append(r){throw new Error("Not supported")}}class P{constructor(r,a){this.name=r,this._channel=a}append(r){this._channel.then(a=>a.append(r))}appendLine(r){this._channel.then(a=>a.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,a){this._channel.then(p=>p.show(r,a))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=P;let d=class{constructor(r){this._proxy=r.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new k(r,this._proxy)}createOutputChannelFromLogFile(r,a){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new i(r,a,this._proxy)}};d=je([qe(0,C.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ve[203],be([0,1,11,20,3,6,5,2,7,12,13,47]),function(Y,e,v,T,D,A,y,C,S,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(g,r,a){const p=g.getProxy(y.MainContext.MainThreadQuickOpen);class f{constructor(s,u){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=u}showQuickPick(s,u,w,b=T.CancellationToken.None){this._onDidSelectItem=void 0;const I=Promise.resolve(s),h=++this._instances,_=p.$show(h,{title:w==null?void 0:w.title,placeHolder:w==null?void 0:w.placeHolder,matchOnDescription:w==null?void 0:w.matchOnDescription,matchOnDetail:w==null?void 0:w.matchOnDetail,ignoreFocusLost:w==null?void 0:w.ignoreFocusOut,canPickMany:w==null?void 0:w.canPickMany},b),R={},B=_.then(()=>R);return Promise.race([B,I]).then(z=>{if(z!==R)return I.then(he=>{const de=[];for(let W=0;W<he.length;W++){const j=he[W];let U,F,L,M,x;typeof j=="string"?U=j:(U=j.label,F=j.description,L=j.detail,M=j.picked,x=j.alwaysShow),de.push({label:U,description:F,handle:W,detail:L,picked:M,alwaysShow:x})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{w.onDidSelectItem(he[W])}),p.$setItems(h,de),_.then(W=>{if(typeof W=="number")return he[W];if(Array.isArray(W))return W.map(j=>he[j])})})}).then(void 0,z=>{if(!(0,k.isPromiseCanceledError)(z))return p.$setError(h,z),Promise.reject(z)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,u=T.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,p.$input(s,typeof this._validateInput=="function",u).then(void 0,w=>{if(!(0,k.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(s){return this._validateInput?(0,v.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,u=T.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!!w){const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(I=>I.uri.toString()===w.uri.toString())}}createQuickPick(s,u){const w=new t(s,u,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(s){const u=new n(s,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(s,u){const w=this._sessions.get(s);w&&w._fireDidChangeValue(u)}$onDidAccept(s){const u=this._sessions.get(s);u&&u._fireDidAccept()}$onDidChangeActive(s,u){const w=this._sessions.get(s);w instanceof t&&w._fireDidChangeActive(u)}$onDidChangeSelection(s,u){const w=this._sessions.get(s);w instanceof t&&w._fireDidChangeSelection(u)}$onDidTriggerButton(s,u){const w=this._sessions.get(s);w&&w._fireDidTriggerButton(u)}$onDidHide(s){const u=this._sessions.get(s);u&&u._fireDidHide()}}class E{constructor(s,u){this._extensionId=s,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((u,w)=>{const b=u===S.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(b,u)}),this.update({buttons:s.map((u,w)=>({iconPath:o(u.iconPath),tooltip:u.tooltip,handle:u===S.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const u=this._handlesToButtons.get(s);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(s){if(!this._disposed){for(const u of Object.keys(s)){const w=s[u];this._pendingUpdate[u]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function o(l){if(l instanceof S.ThemeIcon)return{id:l.id};const s=m(l),u=c(l);return{dark:typeof s=="string"?C.URI.file(s):s,light:typeof u=="string"?C.URI.file(u):u}}function c(l){return typeof l=="object"&&"light"in l?l.light:l}function m(l){return typeof l=="object"&&"dark"in l?l.dark:l}class t extends E{constructor(s,u,w){super(s,w);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((u,w)=>{this._handlesToItems.set(w,u),this._itemsToHandles.set(u,w)}),this.update({items:s.map((u,w)=>({label:u.label,description:u.description,handle:w,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(s){const u=(0,i.coalesce)(s.map(w=>this._handlesToItems.get(w)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(s){const u=(0,i.coalesce)(s.map(w=>this._handlesToItems.get(w)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class n extends E{constructor(s,u){super(s,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?P.default.Error:P.default.Ignore})}}return new f(r,a)}e.createExtHostQuickOpen=d}),define(ve[204],be([0,1,2,3,52,6,11,5,13,113,18,26,33]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(s){if(s)return typeof s.iconPath=="string"?v.URI.file(s.iconPath):s.iconPath}function r(s,u){if(!s.iconPath&&!u.iconPath)return 0;if(s.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath,b=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return(0,k.comparePaths)(w,b)}function a(s,u){let w=0;if(s.strikeThrough!==u.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==u.faded)return s.faded?1:-1;if(s.tooltip!==u.tooltip)return(s.tooltip||"").localeCompare(u.tooltip||"");if(w=r(s,u),w!==0)return w;if(s.light&&u.light)w=r(s.light,u.light);else{if(s.light)return 1;if(u.light)return-1}if(w!==0)return w;if(s.dark&&u.dark)w=r(s.dark,u.dark);else{if(s.dark)return 1;if(u.dark)return-1}return w}function p(s,u){if(s.command!==u.command)return s.command<u.command?-1:1;if(s.title!==u.title)return s.title<u.title?-1:1;if(s.tooltip!==u.tooltip){if(s.tooltip!==void 0&&u.tooltip!==void 0)return s.tooltip<u.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(s.arguments===u.arguments)return 0;if(s.arguments)if(u.arguments){if(s.arguments.length!==u.arguments.length)return s.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<s.arguments.length;w++){const b=s.arguments[w],I=u.arguments[w];if(b!==I)return b<I?-1:1}return 0}function f(s,u){let w=(0,k.comparePaths)(s.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(s.command&&u.command)w=p(s.command,u.command);else{if(s.command)return 1;if(u.command)return-1}if(w!==0)return w;if(s.decorations&&u.decorations)w=a(s.decorations,u.decorations);else{if(s.decorations)return 1;if(u.decorations)return-1}return w}function E(s,u){for(let w=0;w<s.length;w++)if(s[w]!==u[w])return!1;return!0}function o(s,u){return s.command===u.command&&s.title===u.title&&s.tooltip===u.tooltip&&(s.arguments&&u.arguments?E(s.arguments,u.arguments):s.arguments===u.arguments)}function c(s,u){return(0,S.equals)(s,u,o)}class m{constructor(u,w,b){this._extension=u,this._proxy=w,this._sourceControlHandle=b,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,d.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,w){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=m;class t{constructor(u,w,b,I,h){this._proxy=u,this._commands=w,this._sourceControlHandle=b,this._id=I,this._label=h,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const b=this._resourceStatesCommandsMap.get(u);return b?(0,y.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const w=[...this._resourceStates].sort(f),I=(0,S.sortedDiff)(this._resourceSnapshot,w,f).map(R=>{const B=R.toInsert.map(z=>{const he=this._resourceHandlePool++;this._resourceStatesMap.set(he,z);const de=z.resourceUri,W=g(z.decorations),j=z.decorations&&g(z.decorations.light)||W,U=z.decorations&&g(z.decorations.dark)||W,F=[];let L;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const me=new A.DisposableStore;L=this._commands.converter.toInternal(z.command,me),this._resourceStatesDisposablesMap.set(he,me)}else this._resourceStatesCommandsMap.set(he,z.command);j&&F.push(j),U&&U.toString()!==(j==null?void 0:j.toString())&&F.push(U);const M=z.decorations&&z.decorations.tooltip||"",x=z.decorations&&!!z.decorations.strikeThrough,G=z.decorations&&!!z.decorations.faded,J=z.contextValue||"";return{rawResource:[he,de,F,M,x,G,J,L],handle:he}});return{start:R.start,deleteCount:R.deleteCount,toInsert:B}}),h=I.map(({start:R,deleteCount:B,toInsert:z})=>[R,B,z.map(he=>he.rawResource)]),_=I.reverse();for(const{start:R,deleteCount:B,toInsert:z}of _){const he=z.map(W=>W.handle),de=this._handlesSnapshot.splice(R,B,...he);for(const W of de)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),(u=this._resourceStatesDisposablesMap.get(W))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=w,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(u,w,b,I,h,_){this._proxy=w,this._commands=b,this._id=I,this._label=h,this._rootUri=_,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new m(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,I,h,_)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(!(this._statusBarCommands&&u&&c(this._statusBarCommands,u))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}}get selected(){return this._selected}createResourceGroup(u,w){const b=new t(this._proxy,this._commands,this.handle,u,w),I=T.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,I),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const u=[],w=[];for(const[b,I]of this.createdResourceGroups){I.dispose();const h=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});T.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),h.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),u.push([b.handle,b.id,b.label,b.features]);const _=b._takeResourceStateSnapshot();_.length>0&&w.push([b.handle,_]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const b=w._takeResourceStateSnapshot();b.length!==0&&u.push([w.handle,b])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,D.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,D.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let l=class Rn{constructor(u,w,b){this._commands=w,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=u.getProxy(C.MainContext.MainThreadSCM),this._telemetry=u.getProxy(C.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const h=this._sourceControls.get(I.sourceControlHandle);if(!h)return I;const _=h.getResourceGroup(I.groupHandle);return _?_.getResourceState(I.handle):I}else if(I&&I.$mid===4){const h=this._sourceControls.get(I.sourceControlHandle);return h?h.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const h=this._sourceControls.get(I.handle);return h||I}return I}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,b,I){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,b,I),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const h=Rn._handlePool++,_=new n(u,this._proxy,this._commands,w,b,I);this._sourceControls.set(h,_);const R=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(u.identifier))||[];return R.push(_),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(u.identifier),R),_}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(u.identifier)),b=w&&w[w.length-1];return b&&b.inputBox}$provideOriginalResource(u,w,b){const I=v.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,I.toString());const h=this._sourceControls.get(u);return!h||!h.quickDiffProvider||!h.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>h.quickDiffProvider.provideOriginalResource(I,b)).then(_=>_||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const b=this._sourceControls.get(u);return b&&b.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,b,I){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,b);const h=this._sourceControls.get(u);if(!h)return Promise.resolve(void 0);const _=h.getResourceGroup(w);return _?_.$executeResourceCommand(b,I):Promise.resolve(void 0)}$validateInput(u,w,b){this.logService.trace("ExtHostSCM#$validateInput",u);const I=this._sourceControls.get(u);return!I||!I.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>I.inputBox.validateInput(w,b)).then(h=>h?Promise.resolve([h.message,h.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var w,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((w=this._sourceControls.get(u))===null||w===void 0||w.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};l._handlePool=0,l=je([qe(2,i.ILogService)],l),e.ExtHostSCM=l});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[205],be([0,1,7,5,135,6]),function(Y,e,v,T,D,A){"use strict";var y,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class S{constructor(d,g,r,a,p=v.StatusBarAlignment.Left,f,E){y.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,it(this,y,d,"f"),it(this,C,g,"f"),this._id=S.ID_GEN++,this._statusId=r,this._statusName=a,this._alignment=p,this._priority=f,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!S.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Ue(this,C,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Ue(this,C,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let g=this._color;this._backgroundColor&&(g=S.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,g,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=S,y=new WeakMap,C=new WeakMap,S.ID_GEN=0,S.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry("status.extensionMessage",(0,D.localize)(0,null),v.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const g={message:d};return this._messages.unshift(g),this._update(),new v.Disposable(()=>{const r=this._messages.indexOf(g);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(d,g){this._proxy=d.getProxy(T.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(d,g,r,a,p){return new S(this._proxy,this._commands,d,g,r,a,p)}setStatusBarMessage(d,g){const r=this._statusMessage.setMessage(d);let a;return typeof g=="number"?a=setTimeout(()=>r.dispose(),g):typeof g!="undefined"&&g.then(()=>r.dispose(),()=>r.dispose()),new v.Disposable(()=>{r.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=i}),define(ve[79],be([0,1,5,3,4]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(C){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,S){this._proxy.$registerExtensionStorageKeysToSync(C,S)}getValue(C,S,k){return this._proxy.$getValue(C,S).then(i=>i||k)}setValue(C,S,k){return this._proxy.$setValue(C,S,k)}$acceptValue(C,S,k){this._onDidChangeStorage.fire({shared:C,key:S,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(ve[80],be([0,1,4,27,18,78,2]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,v.createDecorator)("IExtensionStoragePaths");let C=class{constructor(k,i,P){var d;this._logService=i,this._extHostFileSystem=P,this._workspace=(d=k.workspace)!==null&&d!==void 0?d:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,P=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};C=je([qe(0,T.IExtHostInitDataService),qe(1,D.ILogService),qe(2,A.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(ve[40],be([0,1,3,5,4,2,15,6,7,136,12,172,20,31,156]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class a{constructor(t,n,l,s){this._proxy=t,this._id=n,this._creationOptions=l,this._name=s,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(w=>this._pidPromiseComplete=w);const u=this;this.value={get name(){return u._name||""},get processId(){return u._pidPromise},get creationOptions(){return u._creationOptions},get exitStatus(){return u._exitStatus},sendText(w,b=!0){u._checkDisposed(),u._proxy.$sendText(u._id,w,b)},show(w){u._checkDisposed(),u._proxy.$show(u._id,w)},hide(){u._checkDisposed(),u._proxy.$hide(u._id)},dispose(){u._disposed||(u._disposed=!0,u._proxy.$dispose(u._id))},get dimensions(){if(!(u._cols===void 0||u._rows===void 0))return{columns:u._cols,rows:u._rows}}}}async create(t,n,l,s,u,w,b,I,h,_,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:l,env:s,icon:u,initialText:w,waitOnExit:b,strictEnv:I,hideFromUser:h,isFeatureTerminal:_,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=a;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let f=1,E=class extends C.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=n.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,s]of this._terminalProcesses)s.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new a(this._proxy,(0,g.generateUuid)(),t,t.name),l=new p(t.pty);return n.createExtensionTerminal().then(s=>{const u=this._setupExtHostProcessListeners(s,l);this._terminalProcessDisposables[s]=u}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const s=new p(n),u=this._setupExtHostProcessListeners(t,s);this._terminalProcessDisposables[t]=u}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:n})}async $acceptTerminalDimensions(t,n,l){const s=this._getTerminalById(t);s&&s.setDimensions(n,l)&&this._onDidChangeTerminalDimensions.fire({terminal:s.value,dimensions:s.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,l){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(n,l)}async $acceptTerminalTitleChange(t,n){const l=this._getTerminalById(t);l&&(l.name=n)}async $acceptTerminalClosed(t,n){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const s=this._terminals.splice(l,1)[0];s.setExitCode(n),this._onDidCloseTerminal.fire(s.value)}}$acceptTerminalOpened(t,n,l,s){if(n){const b=this._getTerminalObjectIndexById(this._terminals,n);if(b!==null){this._terminals[b]._id=t,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const u={name:s.name,shellPath:s.executable,shellArgs:s.args,cwd:typeof s.cwd=="string"?s.cwd:A.URI.revive(s.cwd),env:s.env,hideFromUser:s.hideFromUser},w=new a(this._proxy,t,u,l);this._terminals.push(w),this._onDidOpenTerminal.fire(w.value),w.isOpen=!0}async $acceptTerminalProcessId(t,n){const l=this._getTerminalById(t);l&&l._setProcessId(n)}async $startExtensionTerminal(t,n){const l=this._getTerminalById(t);if(!l)return{message:(0,k.localize)(0,null,t)};l.isOpen||await new Promise(u=>{const w=this.onDidOpenTerminal(async b=>{b===l.value&&(w.dispose(),u())})});const s=this._terminalProcesses.get(t);s?s.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const l=new C.DisposableStore;l.add(n.onProcessReady(u=>this._proxy.$sendProcessReady(t,u.pid,u.cwd))),l.add(n.onProcessTitleChanged(u=>this._proxy.$sendProcessTitle(t,u))),this._bufferer.startBuffering(t,n.onProcessData),l.add(n.onProcessExit(u=>this._onProcessExit(t,u))),n.onProcessOverrideDimensions&&l.add(n.onProcessOverrideDimensions(u=>this._proxy.$sendOverrideDimensions(t,u))),this._terminalProcesses.set(t,n);const s=this._extensionTerminalAwaitingStart[t];return s&&n instanceof p&&(n.startSendingEvents(s.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,n){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.input(n)}$acceptProcessResize(t,n,l){var s;try{(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(n,l)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(t,n){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(t,l))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(l=>this._proxy.$sendProcessCwd(t,l))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t);const s=this._terminalLinkCancellationSource.get(t);s&&s.dispose(!0);const u=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,u);const w=[],b={terminal:l.value,line:n},I=[];for(const R of this._linkProviders)I.push(new Promise(async B=>{u.token.onCancellationRequested(()=>B({provider:R,links:[]}));const z=await R.provideTerminalLinks(b,u.token)||[];u.token.isCancellationRequested||B({provider:R,links:z})}));const h=await Promise.all(I);if(u.token.isCancellationRequested)return[];const _=new Map;for(const R of h)R&&R.links.length>0&&w.push(...R.links.map(B=>{const z={id:f++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return _.set(z.id,{provider:R.provider,link:B}),z}));return this._terminalLinkCache.set(t,_),w}$activateLink(t,n){var l;const s=(l=this._terminalLinkCache.get(t))===null||l===void 0?void 0:l.get(n);!s||s.provider.handleTerminalLink(s.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const l=this._getTerminalObjectIndexById(t,n);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,n){let l=null;return t.some((s,u)=>s._id===n?(l=u,!0):!1),l}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new o,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const l=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const l=n[0],s=new o(n[1]);this._setEnvironmentVariableCollection(l,s)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};E=je([qe(1,y.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class o{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const l=this.map.get(t);(!l||l.value!==n.value||l.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((l,s)=>t.call(n,s,l,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let c=class extends E{constructor(t){super(!1,t)}createTerminal(t,n,l){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}async getDefaultShellAndArgs(t){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}};c=je([qe(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(ve[206],be([0,1,3,13,5,98,9,7]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(d=>d.value)}async showTextDocument(i,P,d){let g;typeof P=="number"?g={position:y.ViewColumn.from(P),preserveFocus:d}:typeof P=="object"?g={position:y.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?y.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:g={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(i.uri,g),a=r&&this._extHostDocumentsAndEditors.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new A.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,P){const d=this._extHostDocumentsAndEditors.getEditor(i);if(!d)throw new Error("unknown text editor");if(P.options&&d._acceptOptions(P.options),P.selections){const g=P.selections.selections.map(y.Selection.to);d._acceptSelections(g)}if(P.visibleRanges){const g=T.coalesce(P.visibleRanges.map(y.Range.to));d._acceptVisibleRanges(g)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const g=C.TextEditorSelectionChangeKind.fromValue(P.selections.source),r=P.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:r,kind:g})}if(P.visibleRanges){const g=T.coalesce(P.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:g})}}$acceptEditorPositionData(i){for(const P in i){const d=this._extHostDocumentsAndEditors.getEditor(P);if(!d)throw new Error("Unknown text editor");const g=y.ViewColumn.to(i[P]);d.value.viewColumn!==g&&(d._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:g}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S});var Gt=this&&this.__rest||function(Y,e){var v={};for(var T in Y)Object.prototype.hasOwnProperty.call(Y,T)&&e.indexOf(T)<0&&(v[T]=Y[T]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Y);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Y,T[D])&&(v[T[D]]=Y[T[D]]);return v};define(ve[207],be([0,1,2,4,5,6,7]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class C{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(D.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:d=>{var g,r;if(d&&d.$mid===11){const a=d.uri===void 0?void 0:v.URI.revive(d.uri);return(r=(g=this._itemsBySourceAndUriMap.get(d.source))===null||g===void 0?void 0:g.get(S(a)))===null||r===void 0?void 0:r.get(d.handle)}return d}})}async $getTimeline(i,P,d,g,r){const a=this._providers.get(i);return a==null?void 0:a.provideTimeline(v.URI.revive(P),d,g,r)}registerTimelineProvider(i,P,d,g){const r=new A.DisposableStore,a=this.convertTimelineItem(P.id,g,r).bind(this);let p;P.onDidChange&&(p=P.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:P.id})),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:i,onDidChange:void 0,async provideTimeline(E,o,c,m){var t;(m==null?void 0:m.resetCache)&&(r.clear(),(t=f.get(P.id))===null||t===void 0||t.clear());const n=await P.provideTimeline(E,o,c);if(n!=null){const l=a(E,m);return Object.assign(Object.assign({},n),{source:P.id,items:n.items.map(l)})}},dispose(){var E;for(const o of f.values())(E=o.get(P.id))===null||E===void 0||E.clear();p==null||p.dispose(),r.dispose()}}))}convertTimelineItem(i,P,d){return(g,r)=>{let a;if(r==null?void 0:r.cacheResults){let p=this._itemsBySourceAndUriMap.get(i);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(i,p));const f=S(g);a=p.get(f),a===void 0&&(a=new Map,p.set(f,a))}return p=>{var f,E;const{iconPath:o}=p,c=Gt(p,["iconPath"]),m=`${i}|${(f=p.id)!==null&&f!==void 0?f:p.timestamp}`;a==null||a.set(m,p);let t,n,l;return p.iconPath&&(o instanceof y.ThemeIcon?l={id:o.id}:v.URI.isUri(o)?(t=o,n=o):{light:t,dark:n}=o),Object.assign(Object.assign({},c),{id:(E=c.id)!==null&&E!==void 0?E:void 0,handle:m,source:i,command:p.command?P.toInternal(p.command,d):void 0,icon:t,iconDark:n,themeIcon:l,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,A.toDisposable)(()=>{var d;for(const g of this._itemsBySourceAndUriMap.values())(d=g.get(i.id))===null||d===void 0||d.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=C;function S(k){return k==null?void 0:k.toString()}}),define(ve[208],be([0,1,6,19,2,5]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,i,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const d=P.schemes.find(g=>!y.supportedSchemes.has(g));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,P.schemes,S,P.label),(0,v.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(S,k,i){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const d=D.URI.revive(k);return P.canOpenExternalUri(d,i)}async $openUri(S,k,i){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(D.URI.revive(k.resolvedUri),{sourceUri:D.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(ve[209],be([0,1,5,2,6,12,26]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=C.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,k),(0,D.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,i){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(T.URI.revive(i))}catch(d){(0,A.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=C,C.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[50],be([0,1,3,2,145,165,73,5]),function(Y,e,v,T,D,A,y,C){"use strict";var S,k,i,P,d,g,r,a,p,f,E,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class c{constructor(b,I,h,_,R,B,z){S.set(this,void 0),k.set(this,void 0),i.set(this,void 0),P.set(this,void 0),d.set(this,void 0),g.set(this,void 0),r.set(this,""),a.set(this,void 0),p.set(this,!1),f.set(this,!1),E.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new v.Emitter),this._onDidDispose=Ue(this,o,"f").event,it(this,S,b,"f"),it(this,k,I,"f"),it(this,a,h,"f"),it(this,P,_,"f"),it(this,d,R,"f"),it(this,g,B,"f"),it(this,E,m(B),"f"),it(this,i,z,"f")}dispose(){it(this,p,!0,"f"),Ue(this,o,"f").fire(),Ue(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return it(this,f,!0,"f"),(0,y.asWebviewUri)(Ue(this,P,"f"),Ue(this,S,"f"),b)}get cspSource(){return Ue(this,P,"f").webviewCspSource.replace("{{uuid}}",Ue(this,S,"f"))}get html(){return this.assertNotDisposed(),Ue(this,r,"f")}set html(b){this.assertNotDisposed(),Ue(this,r,"f")!==b&&(it(this,r,b,"f"),!Ue(this,f,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(it(this,f,!0,"f"),Ue(this,i,"f").report("Webview vscode-resource: uris",Ue(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,k,"f").$setHtml(Ue(this,S,"f"),b))}get options(){return this.assertNotDisposed(),Ue(this,a,"f")}set options(b){this.assertNotDisposed(),Ue(this,k,"f").$setOptions(Ue(this,S,"f"),l(Ue(this,g,"f"),Ue(this,d,"f"),b)),it(this,a,b,"f")}async postMessage(b){if(Ue(this,p,"f"))return!1;const I=(0,A.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Ue(this,E,"f")});return Ue(this,k,"f").$postMessage(Ue(this,S,"f"),I.message,...I.buffers)}assertNotDisposed(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=c,S=new WeakMap,k=new WeakMap,i=new WeakMap,P=new WeakMap,d=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,f=new WeakMap,E=new WeakMap,o=new WeakMap;function m(w){try{const b=(0,D.normalizeVersion)((0,D.parseVersion)(w.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch(b){return!1}}e.shouldSerializeBuffersForPostMessage=m;class t{constructor(b,I,h,_,R){this.initData=I,this.workspace=h,this._logService=_,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,I,...h){const _=this.getWebview(b);if(_){const{message:R}=(0,A.deserializeWebviewMessage)(I,h);_._onMessageEmitter.fire(R)}}$onMissingCsp(b,I){this._logService.warn(`${I} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,I,h){const _=new c(b,this._webviewProxy,s(I),this.initData,this.workspace,h,this._deprecationService);return this._webviews.set(b,_),_._onDidDispose(()=>{this._webviews.delete(b)}),_}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=t;function n(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=n;function l(w,b,I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots||u(w,b)}}e.serializeWebviewOptions=l;function s(w){var b;return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:(b=w.localResourceRoots)===null||b===void 0?void 0:b.map(I=>T.URI.from(I))}}e.reviveOptions=s;function u(w,b){return[...((b==null?void 0:b.getWorkspaceFolders())||[]).map(I=>I.uri),w.extensionLocation]}}),define(ve[210],be([0,1,20,56,6,19,25,2,9,50,68,5,7]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class r{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,l){const s=this.key(t,n.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const u=new g(n,l);return this._documents.set(s,u),u}delete(t,n){const l=this.key(t,n.uri);this._documents.delete(l)}key(t,n){return`${t}@@@${n}`}}var a;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(a||(a={}));class p{constructor(){this._providers=new Map}addTextProvider(t,n,l){return this.add(0,t,n,l)}addCustomProvider(t,n,l){return this.add(1,t,n,l)}get(t){return this._providers.get(t)}add(t,n,l,s){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:l,provider:s}),new d.Disposable(()=>this._providers.delete(n))}}class f{constructor(t,n,l,s,u){this._extHostDocuments=n,this._extensionStoragePaths=l,this._extHostWebview=s,this._extHostWebviewPanels=u,this._editorProviders=new p,this._documents=new r,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,l,s){const u=new D.DisposableStore;return E(l)?(u.add(this._editorProviders.addTextProvider(n,t,l)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,s.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(n,t,l)),this.supportEditing(l)&&u.add(l.onDidChangeCustomDocument(w=>{const b=this.getCustomDocumentEntry(n,w.document.uri);if(o(w)){const I=b.addEdit(w);this._proxy.$onDidEdit(w.document.uri,n,I,w.label)}else this._proxy.$onContentChange(w.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(u,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,l,s,u){var w;const b=this._editorProviders.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${n}'`);const I=C.URI.revive(t),h=await b.provider.openCustomDocument(I,{backupId:l,untitledDocumentData:s==null?void 0:s.buffer},u);let _;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(_=(w=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&w!==void 0?w:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(n,h,_),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,n){const l=this._editorProviders.get(n);if(!l)throw new Error(`No provider found for '${n}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${n}'`);const s=C.URI.revive(t),{document:u}=this.getCustomDocumentEntry(n,s);this._documents.delete(n,u),u.dispose()}async $resolveWebviewEditor(t,n,l,s,u,w){const b=this._editorProviders.get(l);if(!b)throw new Error(`No provider found for '${l}'`);const I=S.ViewColumn.to(u),h=this._extHostWebview.createNewWebview(n,s.webviewOptions,b.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(n,l,s.title,I,s.panelOptions,h),R=C.URI.revive(t);switch(b.type){case 1:{const{document:B}=this.getCustomDocumentEntry(l,R);return b.provider.resolveCustomEditor(B,_,w)}case 0:{const B=this._extHostDocuments.getDocument(R);return b.provider.resolveCustomTextEditor(B,_,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,l){this.getCustomDocumentEntry(n,t).disposeEdits(l)}async $onMoveCustomEditor(t,n,l){const s=this._editorProviders.get(l);if(!s)throw new Error(`No provider found for '${l}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const w=C.URI.revive(n),b=this._extHostDocuments.getDocument(w);await s.provider.moveCustomTextEditor(b,u,v.CancellationToken.None)}async $undo(t,n,l,s){return this.getCustomDocumentEntry(n,t).undo(l,s)}async $redo(t,n,l,s){return this.getCustomDocumentEntry(n,t).redo(l,s)}async $revert(t,n,l){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(s.document,l),s.disposeBackup()}async $onSave(t,n,l){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(s.document,l),s.disposeBackup()}async $onSaveAs(t,n,l,s){const u=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(u.document,C.URI.revive(l),s)}async $backup(t,n,l){const s=this.getCustomDocumentEntry(n,t),w=await this.getCustomEditorProvider(n).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},l);return s.updateBackup(w),w.id}getCustomDocumentEntry(t,n){const l=this._documents.get(t,C.URI.revive(n));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(t){const n=this._editorProviders.get(t),l=n==null?void 0:n.provider;if(!l||!this.supportEditing(l))throw new Error("Custom document is not editable");return l}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=f;function E(m){return typeof m.resolveCustomTextEditor=="function"}function o(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function c(m){const t=m.scheme===A.Schemas.file||m.scheme===A.Schemas.untitled?m.fsPath:m.toString();return(0,T.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[211],be([0,1,3,6,2,31,9,50,5,7]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";var i,P,d,g,r,a,p,f,E,o,c,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends T.Disposable{constructor(w,b,I,h,_,R,B){super();i.set(this,void 0),P.set(this,void 0),d.set(this,void 0),g.set(this,void 0),r.set(this,void 0),a.set(this,void 0),p.set(this,void 0),f.set(this,void 0),E.set(this,!0),o.set(this,!0),c.set(this,!1),m.set(this,this._register(new v.Emitter)),this.onDidDispose=Ue(this,m,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,it(this,i,w,"f"),it(this,P,b,"f"),it(this,d,I,"f"),it(this,r,R,"f"),it(this,f,_,"f"),it(this,a,h,"f"),it(this,g,B,"f")}dispose(){Ue(this,c,"f")||(it(this,c,!0,"f"),Ue(this,m,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,g,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,d,"f")}get title(){return this.assertNotDisposed(),Ue(this,a,"f")}set title(w){this.assertNotDisposed(),Ue(this,a,"f")!==w&&(it(this,a,w,"f"),Ue(this,P,"f").$setTitle(Ue(this,i,"f"),w))}get iconPath(){return this.assertNotDisposed(),Ue(this,p,"f")}set iconPath(w){this.assertNotDisposed(),Ue(this,p,"f")!==w&&(it(this,p,w,"f"),Ue(this,P,"f").$setIconPath(Ue(this,i,"f"),D.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return Ue(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,f,"f")=="number"&&Ue(this,f,"f")<0))return Ue(this,f,"f")}get active(){return this.assertNotDisposed(),Ue(this,o,"f")}get visible(){return this.assertNotDisposed(),Ue(this,E,"f")}_updateViewState(w){Ue(this,c,"f")||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(it(this,o,w.active,"f"),it(this,E,w.visible,"f"),it(this,f,w.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(w,b){this.assertNotDisposed(),Ue(this,P,"f").$reveal(Ue(this,i,"f"),{viewColumn:w?y.ViewColumn.from(w):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Ue(this,c,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,d=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,f=new WeakMap,E=new WeakMap,o=new WeakMap,c=new WeakMap,m=new WeakMap,t=new WeakMap;class l{constructor(w,b,I){this.webviews=b,this.workspace=I,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=w.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(w,b,I,h,_={}){const R=typeof h=="object"?h.viewColumn:h,B={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},z=(0,C.shouldSerializeBuffersForPostMessage)(w),he=l.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(w),he,b,{title:I,panelOptions:s(_),webviewOptions:(0,C.serializeWebviewOptions)(w,this.workspace,_),serializeBuffersForPostMessage:z},B);const de=this.webviews.createNewWebview(he,_,w);return this.createNewWebviewPanel(he,b,I,R,_,de)}$onDidChangeWebviewPanelViewStates(w){const b=Object.keys(w);b.sort((I,h)=>{const _=w[I],R=w[h];return _.active?1:R.active?-1:+_.visible-+R.visible});for(const I of b){const h=this.getWebviewPanel(I);if(!!h){const _=w[I];h._updateViewState({active:_.active,visible:_.visible,viewColumn:y.ViewColumn.to(_.position)})}}}async $onDidDisposeWebviewPanel(w){const b=this.getWebviewPanel(w);b==null||b.dispose(),this._webviewPanels.delete(w),this.webviews.deleteWebview(w)}registerWebviewPanelSerializer(w,b,I){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:I,extension:w}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(w)}),new k.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(w,b,I,h){const _=this._serializers.get(b);if(!_)throw new Error(`No serializer found for '${b}'`);const{serializer:R,extension:B}=_,z=this.webviews.createNewWebview(w,I.webviewOptions,B),he=this.createNewWebviewPanel(w,b,I.title,h,I.panelOptions,z);await R.deserializeWebviewPanel(he,I.state)}createNewWebviewPanel(w,b,I,h,_,R){const B=new n(w,this._proxy,b,I,h,_,R);return this._webviewPanels.set(w,B),B}getWebviewPanel(w){return this._webviewPanels.get(w)}}e.ExtHostWebviewPanels=l;function s(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[212],be([0,1,3,6,50,5,7]),function(Y,e,v,T,D,A,y){"use strict";var C,S,k,i,P,d,g,r,a,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends T.Disposable{constructor(c,m,t,n,l,s){super();C.set(this,void 0),S.set(this,void 0),k.set(this,void 0),i.set(this,void 0),P.set(this,!1),d.set(this,void 0),g.set(this,void 0),r.set(this,void 0),a.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=Ue(this,a,"f").event,p.set(this,this._register(new v.Emitter)),this.onDidDispose=Ue(this,p,"f").event,it(this,k,t,"f"),it(this,g,n,"f"),it(this,C,c,"f"),it(this,S,m,"f"),it(this,i,l,"f"),it(this,d,s,"f")}dispose(){Ue(this,P,"f")||(it(this,P,!0,"f"),Ue(this,p,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(c){this.assertNotDisposed(),Ue(this,g,"f")!==c&&(it(this,g,c,"f"),Ue(this,S,"f").$setWebviewViewTitle(Ue(this,C,"f"),c))}get description(){return this.assertNotDisposed(),Ue(this,r,"f")}set description(c){this.assertNotDisposed(),Ue(this,r,"f")!==c&&(it(this,r,c,"f"),Ue(this,S,"f").$setWebviewViewDescription(Ue(this,C,"f"),c))}get visible(){return Ue(this,d,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(c){c===Ue(this,d,"f")||Ue(this,P,"f")||(it(this,d,c,"f"),Ue(this,a,"f").fire())}show(c){this.assertNotDisposed(),Ue(this,S,"f").$show(Ue(this,C,"f"),!!c)}assertNotDisposed(){if(Ue(this,P,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,S=new WeakMap,k=new WeakMap,i=new WeakMap,P=new WeakMap,d=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap;class E{constructor(c,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,m,t,n){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(c),m,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(c,m,t,n,l){const s=this._viewProviders.get(m);if(!s)throw new Error(`No view provider found for '${m}'`);const{provider:u,extension:w}=s,b=this._extHostWebview.createNewWebview(c,{},w),I=new f(c,this._proxy,m,t,b,!0);this._webviewViews.set(c,I),await u.resolveWebviewView(I,{state:n},l)}async $onDidChangeWebviewViewVisibility(c,m){this.getWebviewView(c)._setVisible(m)}async $disposeWebviewView(c){const m=this.getWebviewView(c);this._webviewViews.delete(c),m.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const m=this._webviewViews.get(c);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=E}),define(ve[102],be([0,1,3,5,2,19,8,4,15]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Fn{constructor(P){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Fn.InitialState,this._proxy=P.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,d){let g;if(typeof P=="string"){g=P;try{P=D.URI.parse(P)}catch(r){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,y.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,g,d)}async asExternalUri(P,d){if((0,y.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(P.scheme))return Promise.reject(`Invalid scheme '${P.scheme}'`);const g=await this._proxy.$asExternalUri(P,d);return D.URI.from(g)}};k.InitialState={focused:!0},k=je([qe(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(ve[213],be([0,1,18,5,27,15]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends v.AbstractLogger{constructor(S,k){super();this._proxy=S.getProxy(T.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...k){this.getLevel()<=v.LogLevel.Trace&&this._proxy.$log(this._logFile,v.LogLevel.Trace,Array.from(arguments))}debug(S,...k){this.getLevel()<=v.LogLevel.Debug&&this._proxy.$log(this._logFile,v.LogLevel.Debug,Array.from(arguments))}info(S,...k){this.getLevel()<=v.LogLevel.Info&&this._proxy.$log(this._logFile,v.LogLevel.Info,Array.from(arguments))}warn(S,...k){this.getLevel()<=v.LogLevel.Warning&&this._proxy.$log(this._logFile,v.LogLevel.Warning,Array.from(arguments))}error(S,...k){this.getLevel()<=v.LogLevel.Error&&this._proxy.$log(this._logFile,v.LogLevel.Error,Array.from(arguments))}critical(S,...k){this.getLevel()<=v.LogLevel.Critical&&this._proxy.$log(this._logFile,v.LogLevel.Critical,Array.from(arguments))}flush(){}};y=je([qe(0,A.IExtHostRpcService),qe(1,D.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(ve[214],be([0,1,11,20,12,3,6,114,186,99,24]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(s,u){try{return JSON.stringify(s,u)}catch(w){return"null"}}function g(s,u){return JSON.stringify(s,u)}function r(s){return s?(u,w)=>w&&w.$mid===1?s.transformOutgoing(w):w:null}var a;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const f=()=>{},E=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(u,w=null,b=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=w,this._uriTransformer=b,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let I=0,h=k.ProxyIdentifier.count;I<h;I++)this._locals[I]=null,this._proxies[I]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(I=>this._receiveOneMessage(I))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?(0,C.transformIncomingURIs)(u,this._uriTransformer):u}getProxy(u){const{nid:w,sid:b}=u;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,b)),this._proxies[w]}_createProxy(u,w){let b={get:(I,h)=>(typeof h=="string"&&!I[h]&&h.charCodeAt(0)===36&&(I[h]=(..._)=>this._remoteCall(u,h,_)),h===o?w:I[h])};return new Proxy(Object.create(null),b)}set(u,w){return this._locals[u.nid]=w,w}assertRegistered(u){for(let w=0,b=u.length;w<b;w++){const I=u[w];if(!this._locals[I.nid])throw new Error(`Missing actor ${I.sid} (isMain: ${I.isMain})`)}}_receiveOneMessage(u){if(!this._isDisposed){const w=u.byteLength,b=m.read(u,0),I=b.readUInt8(),h=b.readUInt32();switch(I){case 1:case 2:{let{rpcId:_,method:R,args:B}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(B=(0,C.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(w,h,_,R,B,I===2);break}case 3:case 4:{let{rpcId:_,method:R,args:B}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(B=(0,C.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(w,h,_,R,B,I===4);break}case 5:{this._logger&&this._logger.logIncoming(w,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(w,h);break}case 7:{this._receiveReply(w,h,void 0);break}case 9:{let _=t.deserializeReplyOKJSON(b);this._uriTransformer&&(_=(0,C.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReply(w,h,_);break}case 8:{let _=t.deserializeReplyOKVSBuffer(b);this._receiveReply(w,h,_);break}case 10:{let _=t.deserializeReplyErrError(b);this._uriTransformer&&(_=(0,C.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReplyErr(w,h,_);break}case 11:{this._receiveReplyErr(w,h,void 0);break}default:console.error("received unexpected message"),console.error(u)}}}_receiveRequest(u,w,b,I,h,_){this._logger&&this._logger.logIncoming(u,w,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(b)}.${I}(`,h);const R=String(w);let B,z;if(_){const de=new T.CancellationTokenSource;h.push(de.token),B=this._invokeHandler(b,I,h),z=()=>de.cancel()}else B=this._invokeHandler(b,I,h),z=f;this._cancelInvokedHandlers[R]=z;const he=t.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(he.byteLength,w,1,"ack"),this._protocol.send(he),B.then(de=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyOK(w,de,this._uriReplacer);this._logger&&this._logger.logOutgoing(W.byteLength,w,1,"reply:",de),this._protocol.send(W)},de=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyErr(w,de);this._logger&&this._logger.logOutgoing(W.byteLength,w,1,"replyErr:",de),this._protocol.send(W)})}_receiveCancel(u,w){this._logger&&this._logger.logIncoming(u,w,1,"receiveCancel");const b=String(w);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(u,w,b){this._logger&&this._logger.logIncoming(u,w,0,"receiveReply:",b);const I=String(w);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const h=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I],h.resolveOk(b)}}_receiveReplyErr(u,w,b){this._logger&&this._logger.logIncoming(u,w,0,"receiveReplyErr:",b);const I=String(w);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const h=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I];let _;b&&(b.$isError?(_=new Error,_.name=b.name,_.message=b.message,_.stack=b.stack):_=b),h.resolveErr(_)}}_invokeHandler(u,w,b){try{return Promise.resolve(this._doInvokeHandler(u,w,b))}catch(I){return Promise.reject(I)}}_doInvokeHandler(u,w,b){const I=this._locals[u];if(!I)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(u));let h=I[w];if(typeof h!="function")throw new Error("Unknown method "+w+" on actor "+(0,k.getStringIdentifierForProxy)(u));return h.apply(I,b)}_remoteCall(u,w,b){if(this._isDisposed)return Promise.reject(D.canceled());let I=null;if(b.length>0&&T.CancellationToken.isCancellationToken(b[b.length-1])&&(I=b.pop()),I&&I.isCancellationRequested)return Promise.reject(D.canceled());const h=t.serializeRequestArguments(b,this._uriReplacer),_=++this._lastMessageId,R=String(_),B=new S.LazyPromise;I&&I.onCancellationRequested(()=>{const he=t.serializeCancel(_);this._logger&&this._logger.logOutgoing(he.byteLength,_,0,"cancel"),this._protocol.send(t.serializeCancel(_))}),this._pendingRPCReplies[R]=B,this._onWillSendRequest(_);const z=t.serializeRequest(_,u,w,h,!!I);return this._logger&&this._logger.logOutgoing(z.byteLength,_,0,`request: ${(0,k.getStringIdentifierForProxy)(u)}.${w}(`,b),this._protocol.send(z),B}}e.RPCProtocol=c,P=E,c.UNRESPONSIVE_TIME=3*1e3;class m{constructor(u,w){this._buff=u,this._offset=w}static alloc(u,w,b){let I=new m(i.VSBuffer.alloc(b+1+4),0);return I.writeUInt8(u),I.writeUInt32(w),I}static read(u,w){return new m(u,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,w}static sizeMixedArray(u,w){let b=0;b+=1;for(let I=0,h=u.length;I<h;I++){const _=u[I],R=w[I];switch(b+=1,R){case 1:b+=this.sizeLongString(_);break;case 2:b+=this.sizeVSBuffer(_);break;case 3:break}}return b}writeMixedArray(u,w){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let b=0,I=u.length;b<I;b++){const h=u[b];switch(w[b]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(u);for(let b=0;b<u;b++)switch(this.readUInt8()){case 1:w[b]=this.readLongString();break;case 2:w[b]=this.readVSBuffer();break;case 3:w[b]=void 0;break}return w}}class t{static _arrayContainsBufferOrUndefined(u){for(let w=0,b=u.length;w<b;w++)if(u[w]instanceof i.VSBuffer||typeof u[w]=="undefined")return!0;return!1}static serializeRequestArguments(u,w){if(this._arrayContainsBufferOrUndefined(u)){let b=[],I=[];for(let h=0,_=u.length;h<_;h++){const R=u[h];R instanceof i.VSBuffer?(b[h]=R,I[h]=2):typeof R=="undefined"?(b[h]=i.VSBuffer.alloc(0),I[h]=3):(b[h]=i.VSBuffer.fromString(g(R,w)),I[h]=1)}return{type:"mixed",args:b,argsType:I}}return{type:"simple",args:g(u,w)}}static serializeRequest(u,w,b,I,h){return I.type==="mixed"?this._requestMixedArgs(u,w,b,I.args,I.argsType,h):this._requestJSONArgs(u,w,b,I.args,h)}static _requestJSONArgs(u,w,b,I,h){const _=i.VSBuffer.fromString(b),R=i.VSBuffer.fromString(I);let B=0;B+=m.sizeUInt8(),B+=m.sizeShortString(_),B+=m.sizeLongString(R);let z=m.alloc(h?2:1,u,B);return z.writeUInt8(w),z.writeShortString(_),z.writeLongString(R),z.buffer}static deserializeRequestJSONArgs(u){const w=u.readUInt8(),b=u.readShortString(),I=u.readLongString();return{rpcId:w,method:b,args:JSON.parse(I)}}static _requestMixedArgs(u,w,b,I,h,_){const R=i.VSBuffer.fromString(b);let B=0;B+=m.sizeUInt8(),B+=m.sizeShortString(R),B+=m.sizeMixedArray(I,h);let z=m.alloc(_?4:3,u,B);return z.writeUInt8(w),z.writeShortString(R),z.writeMixedArray(I,h),z.buffer}static deserializeRequestMixedArgs(u){const w=u.readUInt8(),b=u.readShortString(),I=u.readMixedArray(),h=new Array(I.length);for(let _=0,R=I.length;_<R;_++){const B=I[_];typeof B=="string"?h[_]=JSON.parse(B):h[_]=B}return{rpcId:w,method:b,args:h}}static serializeAcknowledged(u){return m.alloc(5,u,0).buffer}static serializeCancel(u){return m.alloc(6,u,0).buffer}static serializeReplyOK(u,w,b){return typeof w=="undefined"?this._serializeReplyOKEmpty(u):w instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(u,w):this._serializeReplyOKJSON(u,d(w,b))}static _serializeReplyOKEmpty(u){return m.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,w){let b=0;b+=m.sizeVSBuffer(w);let I=m.alloc(8,u,b);return I.writeVSBuffer(w),I.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,w){const b=i.VSBuffer.fromString(w);let I=0;I+=m.sizeLongString(b);let h=m.alloc(9,u,I);return h.writeLongString(b),h.buffer}static deserializeReplyOKJSON(u){const w=u.readLongString();return JSON.parse(w)}static serializeReplyErr(u,w){return w?this._serializeReplyErrEror(u,w):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,w){const b=i.VSBuffer.fromString(d(D.transformErrorForSerialization(w),null));let I=0;I+=m.sizeLongString(b);let h=m.alloc(10,u,I);return h.writeLongString(b),h.buffer}static deserializeReplyErrError(u){const w=u.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(u){return m.alloc(11,u,0).buffer}}var n;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var l;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(l||(l={}))}),define(ve[215],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const v=function(A){const y=C=>{self.removeEventListener("message",y);const S=C.data;Object.defineProperties(self,{postMessage:{value(k,i){S.postMessage(k,i)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",y)}.toString();class T extends EventTarget{constructor(A,y,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${v})('${y}'))`,k=new Blob([S],{type:"application/javascript"}),i=URL.createObjectURL(k),P=new MessageChannel,d=i,g={type:"_newWorker",id:d,port:P.port2,url:i,options:C};A(g,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:d};P.port1.postMessage(r),URL.revokeObjectURL(i),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(r){P.port1.onmessage=r}},onmessageerror:{get(){return P.port1.onmessageerror},set(r){P.port1.onmessageerror=r}}}),P.port1.addEventListener("messageerror",r=>{const a=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(a)}),P.port1.addEventListener("message",r=>{const a=new MessageEvent("message",{data:r.data});this.dispatchEvent(a)}),P.port1.start()}}e.NestedWorker=T}),define(ve[216],be([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(ve[217],be([0,1,19,14,21,2,4,216]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let S=class{constructor(i,P){this.localUserHome=i,this.remoteAgentService=P,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||D.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?T.win32:T.posix)}async fileURI(i){let P="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const g=i.indexOf("/",2);g===-1?(P=i.substring(2),i="/"):(P=i.substring(2,g),i=i.substring(g)||"/")}return A.URI.from({scheme:v.Schemas.file,authority:P,path:i,query:"",fragment:""})}};S=je([qe(1,C.IRemoteAgentService)],S),e.AbstractPathService=S}),define(ve[103],be([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(y,C){this.line=y,this.character=C}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,C){return new v(0,0)}with(y){return new v(0,0)}}e.Position=v;class T{constructor(y,C,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(y,C),this.end=new v(S,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new T(0,0,0,0)}with(y){return new T(0,0,0,0)}}e.Range=T;var D;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[41],be([0,1,13,28,23,37,8,4,14,12,103]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",d=" characters skipped \u27EB",g=(P.length+d.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var r;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function p(F){return!!F.preview}e.resultIsMatch=p;function f(F){return!!F.resource}e.isFileMatch=f;function E(F){return!!F.message}e.isProgressMessage=E;var o;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(L){this.resource=L,this.results=[]}}e.FileMatch=c;class m{constructor(L,M,x){this.ranges=M;const G=Array.isArray(M)?M:[M];if(x&&x.matchLines===1&&t(G)){L=(0,y.getNLines)(L,x.matchLines);let J="",te=0,me=0;const Le=Math.floor(x.charsPerLine/5),We=[];for(const Fe of G){const ze=Math.max(Fe.startColumn-Le,0),H=Fe.startColumn+x.charsPerLine;if(ze>me+Le+g){const q=P+(ze-me)+d;J+=q+L.slice(ze,H),te+=ze-(me+q.length)}else J+=L.slice(me,H);We.push(new l(0,Fe.startColumn-te,Fe.endColumn-te)),me=H}this.preview={text:J,matches:Array.isArray(this.ranges)?We:We[0]}}else{const J=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:L,matches:(0,v.mapArrayOrNot)(M,te=>new n(te.startLineNumber-J,te.startColumn,te.endLineNumber-J,te.endColumn))}}}}e.TextSearchMatch=m;function t(F){const L=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==L||M.endLineNumber!==L)return!1;return!0}class n{constructor(L,M,x,G){this.startLineNumber=L,this.startColumn=M,this.endLineNumber=x,this.endColumn=G}}e.SearchRange=n;class l extends n{constructor(L,M,x){super(L,M,L,x)}}e.OneLineRange=l;var s;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function u(F,L=!0){const M=F&&F.files&&F.files.exclude,x=L&&F&&F.search&&F.search.exclude;if(!(!M&&!x)){if(!M||!x)return M||x;let G=Object.create(null);return G=D.mixin(G,D.deepClone(M)),G=D.mixin(G,D.deepClone(x),!0),G}}e.getExcludes=u;function w(F,L){return F.excludePattern&&T.match(F.excludePattern,L)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&T.match(F.includePattern,L)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const x=M.folder.fsPath;if(A.isEqualOrParent(L,x)){const G=S.relative(x,L);return!M.includePattern||!!T.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=w;var b;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class I extends Error{constructor(L,M){super(L);this.code=M}}e.SearchError=I;function h(F){const L=F.message;if((0,k.isPromiseCanceledError)(F))return new I(L,b.canceled);try{const M=JSON.parse(L);return new I(M.message,M.code)}catch(M){return new I(L,b.other)}}e.deserializeSearchError=h;function _(F){const L={message:F.message,code:F.code};return new Error(JSON.stringify(L))}e.serializeSearchError=_;function R(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=R;function B(F){return F.type==="success"}e.isSerializedSearchSuccess=B;function z(F){return!!F.path}e.isSerializedFileMatch=z;function he(F,L){const M=F.searchPath?F.searchPath:F.relativePath;return(0,y.fuzzyContains)(M,L)}e.isFilePatternMatch=he;class de{constructor(L){this.path=L,this.results=[]}addMatch(L){this.results.push(L)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=de;function W(F,L){const M=Object.assign(Object.assign({},F||{}),L||{});return Object.keys(M).filter(x=>{const G=M[x];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=W;class j{constructor(L,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},L.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let x=L.includePattern;M.includePattern&&(x?x=Object.assign(Object.assign({},x),M.includePattern):x=M.includePattern),x&&(this._parsedIncludeExpression=T.parse(x))}includedInQuerySync(L,M,x){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(L,M,x)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(L,M,x))}includedInQuery(L,M,x){return Promise.resolve(this._parsedExcludeExpression(L,M,x)).then(J=>!!J).then(J=>J?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(L,M,x)).then(te=>!!te):Promise.resolve(!0)).then(J=>J)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=j;function U(F){for(const L in F)if(typeof F[L]!="boolean")return!0;return!1}}),define(ve[30],be([0,1,13,11,20,3,22,19,82,25,8,10,2,138,4,18,153,48,49,27,15,7,41,5]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f,E,o,c,m,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(R,B,z){return new k.ExtUri(he=>b(he,z)).isEqual(R,B)}function s(R,B,z){return l(R.uri,B.uri,z)?0:(0,i.compare)(R.uri.toString(),B.uri.toString())}function u(R,B,z){return R.index!==B.index?R.index<B.index?-1:1:l(R.uri,B.uri,z)?(0,i.compare)(R.name,B.name):(0,i.compare)(R.uri.toString(),B.uri.toString())}function w(R,B,z,he){const de=R.slice(0).sort((j,U)=>z(j,U,he)),W=B.slice(0).sort((j,U)=>z(j,U,he));return(0,v.delta)(de,W,(j,U)=>z(j,U,he))}function b(R,B){const z=B.getCapabilities(R.scheme);return!(z&&z&1024)}class I extends f.Workspace{constructor(B,z,he,de,W,j){super(B,he.map(U=>new f.WorkspaceFolder(U)),de,j);this._name=z,this._isUntitled=W,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(j),he.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(B,z,he,de){if(!B)return{workspace:null,added:[],removed:[]};const{id:W,name:j,folders:U,configuration:F,isUntitled:L}=B,M=[],x=z;z?U.forEach((me,Le)=>{const We=d.URI.revive(me.uri),Fe=I._findFolder(he||z,We,de);Fe?(Fe.name=me.name,Fe.index=me.index,M.push(Fe)):M.push({uri:We,name:me.name,index:Le})}):M.push(...U.map(({uri:me,name:Le,index:We})=>({uri:d.URI.revive(me),name:Le,index:We}))),M.sort((me,Le)=>me.index<Le.index?-1:1);const G=new I(W,j,M,F?d.URI.revive(F):null,!!L,me=>b(me,de)),{added:J,removed:te}=w(x?x.workspaceFolders:[],G.workspaceFolders,s,de);return{workspace:G,added:J,removed:te}}static _findFolder(B,z,he){for(let de=0;de<B.folders.length;de++){const W=B.workspaceFolders[de];if(l(W.uri,z,he))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(B,z){return z&&this._structure.get(B)&&(B=(0,k.dirname)(B)),this._structure.findSubstr(B)}resolveWorkspaceFolder(B){return this._structure.get(B)}}let h=class{constructor(B,z,he,de){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=de,this._extHostFileSystemInfo=he,this._requestIdProvider=new S.Counter,this._barrier=new T.Barrier,this._proxy=B.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=B.getProxy(n.MainContext.MainThreadMessageService);const W=z.workspace;this._confirmedWorkspace=W?new I(W.id,W.name,[],W.configuration?d.URI.revive(W.configuration):null,!!W.isUntitled,j=>b(j,he)):void 0}$initializeWorkspace(B,z){this._trusted=z,this.$acceptWorkspaceData(B),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:C.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(B,z,he,...de){const W=[];if(Array.isArray(de)&&de.forEach(M=>{d.URI.isUri(M.uri)&&!W.some(x=>l(x.uri,M.uri,this._extHostFileSystemInfo))&&W.push({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[z,he].some(M=>typeof M!="number"||M<0)||he===0&&W.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+he>j.length)return!1;const U=j.slice(0);U.splice(z,he,...W.map(M=>({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<U.length;M++){const x=U[M];if(U.some((G,J)=>J!==M&&l(x.uri,G.uri,this._extHostFileSystemInfo)))return!1}U.forEach((M,x)=>M.index=x);const{added:F,removed:L}=w(j,U,u,this._extHostFileSystemInfo);if(F.length===0&&L.length===0)return!1;if(this._proxy){const M=B.displayName||B.name;this._proxy.$updateWorkspaceFolders(M,z,he,W).then(void 0,x=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,g.localize)(0,null,M,x.toString()),{extension:B},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(B,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(B,z)}async getWorkspaceFolder2(B,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(B,z)}async resolveWorkspaceFolder(B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(B)}getPath(){if(!!this._actualWorkspace){const{folders:B}=this._actualWorkspace;if(B.length!==0)return B[0].uri.fsPath}}getRelativePath(B,z){let he,de="";if(typeof B=="string"?(he=d.URI.file(B),de=B):typeof B!="undefined"&&(he=B,de=B.fsPath),!he)return de;const W=this.getWorkspaceFolder(he,!0);if(!W)return de;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let j=(0,k.relativePath)(W.uri,he);return z&&W.name&&(j=`${W.name}/${j}`),j}trySetWorkspaceFolders(B){this._actualWorkspace&&(this._unconfirmedWorkspace=I.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:B,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(B){const{workspace:z,added:he,removed:de}=I.toExtHostWorkspace(B,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:he,removed:de}))}findFiles(B,z,he,de,W=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${de.value}, entryPoint: findFiles`);let j;if(z===null?j=!1:z&&(typeof z=="string"?j=z:j=z.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:F}=_(B);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(U),(0,P.withUndefinedAsNull)(F),(0,P.withUndefinedAsNull)(j),(0,P.withUndefinedAsNull)(he),W).then(L=>Array.isArray(L)?L.map(M=>d.URI.revive(M)):[])}async findTextInFiles(B,z,he,de,W=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${de.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),U=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:F,folder:L}=_(z.include),M=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,x={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:U,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:F,excludePattern:M},G=!1;if(this._activeSearchCallbacks[j]=J=>{if(!G){const te=d.URI.revive(J.resource);J.results.forEach(me=>{(0,t.resultIsMatch)(me)?he({uri:te,preview:{text:me.preview.text,matches:(0,v.mapArrayOrNot)(me.preview.matches,Le=>new m.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))},ranges:(0,v.mapArrayOrNot)(me.ranges,Le=>new m.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))}):he({uri:te,text:me.text,lineNumber:me.lineNumber})})}},W.isCancellationRequested)return{};try{const J=await this._proxy.$startTextSearch(B,(0,P.withUndefinedAsNull)(L),x,j,W);return delete this._activeSearchCallbacks[j],J||{}}catch(J){throw delete this._activeSearchCallbacks[j],J}}$handleTextSearchResult(B,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](B)}saveAll(B){return this._proxy.$saveAll(B)}resolveProxy(B){return this._proxy.$resolveProxy(B)}get trusted(){return this._trusted}requestWorkspaceTrust(B){return this._proxy.$requestWorkspaceTrust(B)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=je([qe(0,c.IExtHostRpcService),qe(1,o.IExtHostInitDataService),qe(2,E.IExtHostFileSystemInfo),qe(3,a.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function _(R){let B,z;return R&&(typeof R=="string"?B=R:(B=R.pattern,z=R.baseFolder||d.URI.file(R.base))),{includePattern:B,folder:z}}}),define(ve[34],be([0,1,23,3,30,5,7,155,66,10,11,4,15,18,2]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(n,l){if(l){const s=l.split(".");let u=n;for(let w=0;u&&w<s.length;w++)u=u[s[w]];return u}}function p(n){return n instanceof r.URI}function f(n){return n&&n.uri instanceof r.URI&&n.languageId&&typeof n.languageId=="string"}function E(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function o(n){return n&&n.uri instanceof r.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function c(n){if(p(n))return{resource:n};if(f(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(E(n))return{overrideIdentifier:n.languageId};if(o(n))return{resource:n.uri};if(n===null)return{resource:null}}let m=class{constructor(l,s,u){this._proxy=l.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=u,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new t(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,s){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(l,s))}};m=je([qe(0,d.IExtHostRpcService),qe(1,D.IExtHostWorkspace),qe(2,g.ILogService)],m),e.ExtHostConfiguration=m;class t{constructor(l,s,u,w){this._onDidChangeConfiguration=new T.Emitter,this._proxy=l,this._logService=w,this._extHostWorkspace=s,this._configuration=C.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,s){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,u))}getConfiguration(l,s,u){const w=c(s)||{},b=this._toReadonlyValue(l?a(this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,w,u==null?void 0:u.identifier);function I(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(_){return typeof a(b,_)!="undefined"},get:(_,R)=>{this._validateConfigurationAccess(l?`${l}.${_}`:_,w,u==null?void 0:u.identifier);let B=a(b,_);if(typeof B=="undefined")B=R;else{let z;const he=(de,W)=>{let j;const U=()=>{z=z||(0,v.deepClone)(b),j=j||a(z,W)};return(0,k.isObject)(de)?new Proxy(de,{get:(F,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return U(),()=>j;if(z)return j=j||a(z,W),j[L];const M=F[L];return typeof L=="string"?he(M,`${W}.${L}`):M},set:(F,L,M)=>(U(),j&&(j[L]=M),!0),deleteProperty:(F,L)=>(U(),j&&delete j[L],!0),defineProperty:(F,L,M)=>(U(),j&&Object.defineProperty(j,L,M),!0)}):de};B=he(B,_)}return B},update:(_,R,B,z)=>{_=l?`${l}.${_}`:_;const he=I(B);return R!==void 0?this._proxy.$updateConfigurationOption(he,_,R,w,z):this._proxy.$removeConfigurationOption(he,_,w,z)},inspect:_=>{var R,B,z,he,de,W,j,U;_=l?`${l}.${_}`:_;const F=(0,v.deepClone)(this._configuration.inspect(_,w,this._extHostWorkspace.workspace));if(F)return{key:_,defaultValue:(R=F.default)===null||R===void 0?void 0:R.value,globalValue:(B=F.user)===null||B===void 0?void 0:B.value,workspaceValue:(z=F.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(he=F.workspaceFolder)===null||he===void 0?void 0:he.value,defaultLanguageValue:(de=F.default)===null||de===void 0?void 0:de.override,globalLanguageValue:(W=F.user)===null||W===void 0?void 0:W.override,workspaceLanguageValue:(j=F.workspace)===null||j===void 0?void 0:j.override,workspaceFolderLanguageValue:(U=F.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:F.overrideIdentifiers}}};return typeof b=="object"&&(0,v.mixin)(h,b,!1),Object.freeze(h)}_toReadonlyValue(l){const s=u=>(0,k.isObject)(u)?new Proxy(u,{get:(w,b)=>s(w[b]),set:(w,b,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(w,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(w,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return s(l)}_validateConfigurationAccess(l,s,u){const w=S.OVERRIDE_PROPERTY_PATTERN.test(l)?4:this._configurationScopes.get(l),b=u?`[${u.value}] `:"";if(w===4){typeof(s==null?void 0:s.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){(s==null?void 0:s.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,s){const u=new C.ConfigurationChangeEvent(l,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(w,b)=>u.affectsConfiguration(w,c(b))})}_toMap(l){return l.reduce((s,u)=>(s.set(u[0],u[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[104],be([0,1,2,11,3,5,7,30,39,34,20,40,15,27,4,19,21,18,76,171,12]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f,E,o,c){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(de){function W(U){if(U!=null)return U}de.from=W;function j(U){if(U!=null)return U}de.to=j})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(de){function W(U){if(U!=null)return U}de.from=W;function j(U){if(U!=null)return U}de.to=j})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var l;(function(de){function W(U){if(U!=null)return U}de.from=W;function j(U){if(U!=null)return U}de.to=j})(l=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(de){function W(F){if(F){const L=F;return L&&!!L.process}else return!1}de.is=W;function j(F){if(F!=null){const L={process:F.process,args:F.args};return F.options&&(L.options=l.from(F.options)),L}}de.from=j;function U(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}de.to=U})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(de){function W(U){if(U!=null)return U}de.from=W;function j(U){if(U!=null)return U}de.to=j})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var w;(function(de){function W(F){if(F){const L=F;return L&&(!!L.commandLine||!!L.command)}else return!1}de.is=W;function j(F){if(F!=null){const L={};return F.commandLine!==void 0?L.commandLine=F.commandLine:(L.command=F.command,L.args=F.args),F.options&&(L.options=u.from(F.options)),L}}de.from=j;function U(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}de.to=U})(w=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(de){function W(F){if(F){let L=F;return L&&L.customExecution==="customExecution"}else return!1}de.is=W;function j(F){return{customExecution:"customExecution"}}de.from=j;function U(F,L){return L.get(F)}de.to=U})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var I;(function(de){function W(j,U){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?F=U.workspaceFile:F=o.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:F}}de.from=W})(I=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(de){function W(F,L){if(F==null)return[];const M=[];for(let x of F){const G=j(x,L);G&&M.push(G)}return M}de.fromMany=W;function j(F,L){if(F!=null){let M;F.execution instanceof y.ProcessExecution?M=s.from(F.execution):F.execution instanceof y.ShellExecution?M=w.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&(M=b.from(F.execution));const x=t.from(F.definition);let G;if(F.scope?typeof F.scope=="number"?G=F.scope:G=F.scope.uri:G=y.TaskScope.Workspace,!(!x||!G)){const J=F.group?F.group.id:void 0;return{_id:F._id,definition:x,name:F.name,source:{extensionId:L.identifier.value,label:F.source,scope:G},execution:M,isBackground:F.isBackground,group:J,presentationOptions:n.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}}}de.from=j;async function U(F,L,M){if(F!=null){let x;s.is(F.execution)?x=s.to(F.execution):w.is(F.execution)?x=w.to(F.execution):b.is(F.execution)&&(x=b.to(F._id,M));const G=t.to(F.definition);let J;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?J=F.source.scope:J=await L.resolveWorkspaceFolder(v.URI.revive(F.source.scope)):J=y.TaskScope.Workspace),!(!G||!J)){const te=new y.Task(G,J,F.name,F.source.label,x,F.problemMatchers);return F.isBackground!==void 0&&(te.isBackground=F.isBackground),F.group!==void 0&&(te.group=y.TaskGroup.from(F.group)),F.presentationOptions&&(te.presentationOptions=n.to(F.presentationOptions)),F._id&&(te._id=F._id),F.detail&&(te.detail=F.detail),te}}}de.to=U})(h=e.TaskDTO||(e.TaskDTO={}));var _;(function(de){function W(U){return U}de.from=W;function j(U){if(!!U)return Object.assign(Object.create(null),U)}de.to=j})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(W,j,U){this._id=j,this._task=U,m.set(this,void 0),it(this,m,W,"f")}get task(){return this._task}terminate(){Ue(this,m,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}m=new WeakMap;var B;(function(de){function W(j){return{id:j._id,task:void 0}}de.from=W})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(W,j,U,F,L,M,x,G){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=F,this._configurationService=L,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=x,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,j,U){if(!U)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:j,provider:U,extension:W}),this._proxy.$registerTaskProvider(F,j),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(W,j){this._proxy.$registerTaskSystem(W,j)}fetchTasks(W){return this._proxy.$fetchTasks(_.from(W)).then(async j=>{const U=[];for(let F of j){const L=await h.to(F,this._workspaceProvider,this._providedCustomExecutions2);L&&U.push(L)}return U})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(j=>W.push(j)),W}terminateTask(W){if(!(W instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,j,U){const F=this._providedCustomExecutions2.get(W.id);if(F){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,F),this._terminalService.attachPtyToTerminal(j,await F.callback(U))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const j=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const j=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:j,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const j=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:W.exitCode})}$provideTasks(W,j){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));const F=[],L=(0,T.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(j,F,U,M));return new Promise(M=>{L.then(x=>{Promise.all(F).then(()=>{M(x)})})})}async $resolveTask(W,j){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const F=await h.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const L=await U.provider.resolveTask(F,i.CancellationToken.None);if(!!L){this.checkDeprecation(L,U);const M=h.from(L,U.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(M.execution)&&await this.addCustomExecution(M,L,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(W,j,U){const F=await this._proxy.$createTaskId(W);!U&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,j.execution)}async getTaskExecution(W,j){if(typeof W=="string"){const L=this._taskExecutionPromises.get(W);if(!L)throw new Error("Unexpected: The specified task is missing an execution");return L}let U=this._taskExecutionPromises.get(W.id);if(U)return U;const F=new Promise(async(L,M)=>{const x=j||await h.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);x?L(new R(this,W.id,x)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,F),F.then(L=>(this._taskExecutions.set(W.id,L),L),L=>Promise.reject(L))}checkDeprecation(W,j){W._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let U=this._notProvidedCustomExecutions.values(),F=U.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=U.next()}};z=je([qe(0,d.IExtHostRpcService),qe(1,g.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,S.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,f.ILogService),qe(7,E.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let he=class extends z{constructor(W,j,U,F,L,M,x,G){super(W,j,U,F,L,M,x,G);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(W,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=h.from(j,W);if(U===void 0)throw new Error("Task is not valid");if(b.is(U.execution))await this.addCustomExecution(U,j,!1);else throw new c.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),j);return this._proxy.$executeTask(U).catch(L=>{throw new Error(L)}),F}provideTasksInternal(W,j,U,F){const L=[];if(F)for(let M of F){this.checkDeprecation(M,U),(!M.definition||!W[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const x=h.from(M,U.extension);x&&b.is(x.execution)?(L.push(x),j.push(this.addCustomExecution(x,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:L,extension:U.extension}}async resolveTaskInternal(W){if(b.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,j){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(W,j,U){}};he=je([qe(0,d.IExtHostRpcService),qe(1,g.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,S.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,f.ILogService),qe(7,E.IExtHostApiDeprecationService)],he),e.WorkerExtHostTask=he,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)},Gt=this&&this.__rest||function(Y,e){var v={};for(var T in Y)Object.prototype.hasOwnProperty.call(Y,T)&&e.indexOf(T)<0&&(v[T]=Y[T]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Y);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Y,T[D])&&(v[T[D]]=Y[T[D]]);return v};define(ve[218],be([0,1,13,11,24,20,3,53,43,6,23,10,2,31,5,39,15,70,9,7,30,182,97]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f,E,o,c,m,t){"use strict";var n,l,s,u;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const w=(U,F)=>`${U}:${F.toString()}`;let b=class{constructor(F,L,M){this.documents=L,this.workspace=M,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new m.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new I(this.proxy),this.workspaceObservers=new W(this.proxy),this.textDocumentObservers=new j(this.proxy,L)}registerTestController(F,L){const M=(0,g.generateUuid)();this.controllers.set(M,{instance:L,extensionId:F}),this.proxy.$registerTestController(M);const x=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const J of x)(G=this.testControllers.get(J))===null||G===void 0||G.subscribeFn(M,L)},0),new o.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(F){return this.textDocumentObservers.checkout(F.uri)}createWorkspaceTestObserver(F){return this.workspaceObservers.checkout(F.uri)}async runTests(F,L=A.CancellationToken.None){const M=x=>x.map(this.getInternalTestForReference,this).filter(P.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:F.exclude?M(F.exclude).map(x=>x.testId):void 0,tests:M(F.tests),debug:F.debug},L)}createTestRun(F,L,M,x=!0){return this.runQueue.createTestRun(F,L,M,x)}$publishTestResults(F){this.results=Object.freeze(F.map(L=>(0,i.deepFreeze)(E.TestResults.to(L))).concat(this.results).sort((L,M)=>M.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(F,L){const M=d.URI.revive(L),x=w(F,M);if(!this.testControllers.has(x)){const G=new A.CancellationTokenSource;let J;if(F===1){let Fe=this.documents.getDocument(M);if(!Fe){const ze=new k.DisposableStore;Fe=await new Promise(H=>{ze.add((0,T.disposableTimeout)(()=>H(void 0),5e3)),ze.add(this.documents.onDidAddDocuments(q=>{const ee=q.find(se=>se.document.uri.toString()===M.toString());ee&&H(ee)}))}).finally(()=>ze.dispose())}if(Fe){const ze=await this.workspace.getWorkspaceFolder2(M,!1);J=H=>H.createDocumentTestRoot?H.createDocumentTestRoot(Fe.document,G.token):(0,e.createDefaultDocumentTestRoot)(H,Fe.document,ze,G.token)}}else{const Fe=await this.workspace.getWorkspaceFolder2(M,!1);Fe&&(J=ze=>ze.createWorkspaceTestRoot(Fe,G.token))}if(!!J){const te=async(Fe,ze)=>{try{const H=await J(ze);H&&Le.addRoot(H,Fe)}catch(H){console.error(H)}},me=new k.DisposableStore,Le=me.add(this.ownedTests.createForHierarchy(Fe=>this.proxy.$publishDiff(F,L,Fe)));me.add((0,k.toDisposable)(()=>G.dispose(!0)));const We=[];for(const[Fe,ze]of this.controllers)We.push(te(Fe,ze.instance));Promise.all(We).then(()=>Le.pushDiff([3,-1])),this.testControllers.set(x,{store:me,collection:Le,subscribeFn:te})}}}async $expandTest(F,L){const M=(0,v.mapFind)(this.testControllers.values(),x=>x.collection.treeId===F.src.tree?x:void 0);await(M==null?void 0:M.collection.expand(F.testId,L<0?Infinity:L)),this.flushCollectionDiffs()}$unsubscribeFromTests(F,L){var M;const x=d.URI.revive(L),G=w(F,x);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(F,L,M){F===1?this.textDocumentObservers.acceptDiff(d.URI.revive(L),M):this.workspaceObservers.acceptDiff(d.URI.revive(L),M)}async $runTestsForProvider(F,L){const M=this.controllers.get(F.tests[0].src.controller);if(!!M){const x=F.tests.map(({testId:te,src:me})=>this.ownedTests.getTestById(te,me==null?void 0:me.tree)).filter(P.isDefined).map(([te,me])=>me),G=F.excludeExtIds.map(te=>this.ownedTests.getTestById(te)).filter(P.isDefined).filter(([te,me])=>x.some(Le=>te.comparePositions(Le,me)===1));if(!!x.length){const J={tests:x.map(te=>B.unwrap(te.actual)),exclude:G.map(([,te])=>B.unwrap(te.actual)),debug:F.debug};await this.runQueue.enqueueRun({dto:h.fromInternal(F),token:L,extensionId:M.extensionId,req:J,doRun:()=>M.instance.runTests(J,L)})}}}$lookupTest(F){const L=this.ownedTests.getTestById(F.testId);if(!L)return Promise.resolve(void 0);const M=L[1],{actual:x,discoverCts:G,expandLevels:J}=M,te=Gt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(te)}flushCollectionDiffs(){for(const{collection:F}of this.testControllers.values())F.flushDiff()}getInternalTestForReference(F){var L,M;return(M=(L=this.workspaceObservers.getMirroredTestDataByReference(F))!==null&&L!==void 0?L:(0,v.mapFind)(this.testControllers.values(),x=>x.collection.getTestByReference(F)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(F)}};b=je([qe(0,p.IExtHostRpcService),qe(1,a.IExtHostDocumentsAndEditors),qe(2,c.IExtHostWorkspace)],b),e.ExtHostTesting=b;class I{constructor(F){this.proxy=F,this.state=new Map}enqueueRun(F){let L=this.state.get(F.extensionId);L||(L={queue:[],current:void 0},this.state.set(F.extensionId,L));const M=new T.DeferredPromise,x=()=>{const G=[],J=new Set;L.current={publicReq:F.req,factory:te=>{const me=new _(te,F.dto,J,this.proxy);return G.push(me),F.token.onCancellationRequested(()=>me.end()),me}},this.invokeRunner(F.extensionId,F.dto.id,F.doRun,G).finally(()=>M.complete())};return L.queue.push(x),L.queue.length===1&&x(),M.p}createTestRun(F,L,M,x){var G,J;const te=this.state.get(F);if((te==null?void 0:te.current.publicReq)===L)return te.current.factory(M);const me=h.fromPublic(L),Le=new _(M,me,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(J=(G=L.exclude)===null||G===void 0?void 0:G.map(We=>We.id))!==null&&J!==void 0?J:[],id:me.id,tests:L.tests.map(We=>We.id),persist:x}),Le.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(me.id)),Le}invokeRunner(F,L,M,x){try{const G=M();return(0,T.isThenable)(G)?G.then(()=>this.handleInvokeResult(F,L,x,void 0)).catch(J=>this.handleInvokeResult(F,L,x,J)):this.handleInvokeResult(F,L,x,void 0)}catch(G){return this.handleInvokeResult(F,L,x,G)}}async handleInvokeResult(F,L,M,x){const G=this.state.get(F);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(F),await Promise.all(M.map(J=>J.onEnd.wait())))}}class h{constructor(F,L,M){this.id=F,this.include=L,this.exclude=M}static fromPublic(F){var L,M;return new h((0,g.generateUuid)(),new Set(F.tests.map(x=>x.id)),new Set((M=(L=F.exclude)===null||L===void 0?void 0:L.map(x=>x.id))!==null&&M!==void 0?M:S.Iterable.empty()))}static fromInternal(F){return new h(F.runId,new Set(F.tests.map(L=>L.testId)),new Set(F.excludeExtIds))}isIncluded(F){for(let L=F;L;L=L.parent){if(this.include.has(L.id))return!0;if(this.exclude.has(L.id))return!1}return!0}}class _{constructor(F,L,M,x){this.name=F,n.set(this,void 0),l.set(this,void 0),s.set(this,(0,g.generateUuid)()),u.set(this,void 0),this.onEnd=new T.Barrier,it(this,n,x,"f"),it(this,l,L,"f"),it(this,u,M,"f"),x.$startedTestRunTask(L.id,{id:Ue(this,s,"f"),name:F,running:!0})}setState(F,L,M){Ue(this,l,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$updateTestStateInRun(Ue(this,l,"f").id,Ue(this,s,"f"),F.id,L,M))}appendMessage(F,L){Ue(this,l,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,l,"f").id,Ue(this,s,"f"),F.id,E.TestMessage.from(L)))}appendOutput(F){Ue(this,n,"f").$appendOutputToRun(Ue(this,l,"f").id,Ue(this,s,"f"),D.VSBuffer.fromString(F))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,l,"f").id,Ue(this,s,"f")),this.onEnd.open()}ensureTestIsKnown(F){const L=Ue(this,u,"f");if(!L.has(F.id)){const M=[];for(;M.unshift(E.TestItem.from(F)),!(L.has(F.id)||(L.add(F.id),!F.parent));)F=F.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,l,"f").id,M)}}}n=new WeakMap,l=new WeakMap,s=new WeakMap,u=new WeakMap;const R=async(U,F,L,M)=>{if(!!L){const x=await U.createWorkspaceTestRoot(L,M);if(!!x){M.onCancellationRequested(()=>{B.removeFilter(F)});const G=B.getWrapperForTestItem(x,F);return G.refreshMatch(),G}}};e.createDefaultDocumentTestRoot=R;class B extends o.TestItemImpl{constructor(F,L,M){super(F.id,F.label,F.uri,void 0);if(this.actual=F,this.filterDocument=L,this.actualParent=M,!(F instanceof o.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${F.id} did not`);this.debuggable=F.debuggable,this.runnable=F.runnable,this.description=F.description,this.error=F.error,this.status=F.status,this.range=F.range,this.resolveHandler=F.resolveHandler;const x=(0,f.getPrivateApiFor)(this);(0,f.getPrivateApiFor)(F).bus.event(J=>{switch(J[0]){case 3:this[J[1]]=J[2];break;case 0:const te=B.getWrapperForTestItem(J[1],this.filterDocument,this);(0,f.getPrivateApiFor)(te).parent=F,te.refreshMatch();break;default:x.bus.fire(J)}})}static removeFilter(F){this.wrapperMap.delete(F)}static getWrapperForTestItem(F,L,M){let x=this.wrapperMap.get(L);if(x==null?void 0:x.has(F))return x.get(F);x||(x=new WeakMap,this.wrapperMap.set(L,x));const G=new B(F,L,M);return x.set(F,G),G}static unwrap(F){return F instanceof B?F.actual:F}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var F,L;const M=this._cachedMatchesFilter;for(const G of this.actual.children.values()){const J=B.getWrapperForTestItem(G,this.filterDocument,this);J.hasNodeMatchingFilter?this.children.has(J.id)||this.addChild(J):J.dispose()}const x=this.children.size>0||((F=this.actual.uri)===null||F===void 0?void 0:F.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=x,x!==M&&((L=this.actualParent)===null||L===void 0||L.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,f.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,f.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=B,B.wrapperMap=new WeakMap;class z extends t.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,E.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:L,removed:M}=this;return{get added(){return[...F].map(x=>x.revived)},get updated(){return[...L].map(x=>x.revived)},get removed(){return[...M].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class he extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(F){let L=[];for(const M of F){const x=this.items.get(M);x&&L.push(x.revived)}return L}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,L){return Object.assign(Object.assign({},F),{revived:E.TestItem.toPlain(F.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new z(this.changeEmitter)}}e.MirroredTestCollection=he;class de{constructor(){this.resources=new Map}checkout(F){var L,M;const x=F.toString(),G=(L=this.resources.get(x))!==null&&L!==void 0?L:this.createObserverData(F);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,C.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(F))})}}getMirroredTestDataByReference(F){for(const{tests:L}of this.resources.values()){const M=L.getMirroredTestDataByReference(F);if(M)return M}}eventuallyDispose(F){return(0,T.disposableTimeout)(()=>this.unlisten(F),10*1e3)}createObserverData(F){const L=new he,M=this.listen(F,G=>L.apply(G)),x={observers:0,tests:L,listener:M};return this.resources.set(F.toString(),x),x}unlisten(F){var L;const M=F.toString(),x=this.resources.get(M);x&&(x.observers=-1,(L=x.pendingDeletion)===null||L===void 0||L.dispose(),x.listener.dispose(),this.resources.delete(M))}}class W extends de{constructor(F){super();this.proxy=F,this.diffListeners=new Map}acceptDiff(F,L){var M;(M=this.diffListeners.get(F.toString()))===null||M===void 0||M(L)}listen(F,L){this.proxy.$subscribeToDiffs(0,F);const M=F.toString();return this.diffListeners.set(M,L),new o.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,F),this.diffListeners.delete(M)})}}class j extends de{constructor(F,L){super();this.proxy=F,this.documents=L,this.diffListeners=new Map}acceptDiff(F,L){var M;(M=this.diffListeners.get(F.toString()))===null||M===void 0||M(L)}listen(F,L){if(!this.documents.getDocument(F))return new o.Disposable(()=>{});const x=F.toString();return this.diffListeners.set(x,L),this.proxy.$subscribeToDiffs(1,F),new o.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,F),this.diffListeners.delete(x)})}}}),define(ve[219],be([0,1,13,51,28,58,22,19,14,25,8,10,2,117,141,93,48,174,217,41]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(I,h,_,R){this.configurationService=I,this.workspaceContextService=h,this.editorGroupsService=_,this.pathService=R}text(I,h,_={}){I=this.getContentPattern(I,_);const R=this.configurationService.getValue(),B=h&&h.some(he=>!this.configurationService.getValue({resource:he}).search.useRipgrep),z=this.commonQuery(h==null?void 0:h.map(p.toWorkspaceFolder),_);return Object.assign(Object.assign({},z),{type:2,contentPattern:I,previewOptions:_.previewOptions,maxFileSize:_.maxFileSize,usePCRE2:R.search.usePCRE2||B||!1,beforeContext:_.beforeContext,afterContext:_.afterContext,userDisabledExcludesAndIgnoreFiles:_.disregardExcludeSettings&&_.disregardIgnoreFiles})}getContentPattern(I,h){const _=this.configurationService.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},I),{wordSeparators:_.editor.wordSeparators});return this.isCaseSensitive(I,h)&&(R.isCaseSensitive=!0),this.isMultiline(I)&&(R.isMultiline=!0),R}file(I,h={}){const _=this.commonQuery(I,h);return Object.assign(Object.assign({},_),{type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey})}handleIncludeExclude(I,h){return I?(I=Array.isArray(I)?I.map(s):s(I),h?this.parseSearchPaths(I):{pattern:t(...Array.isArray(I)?I:[I])}):{}}commonQuery(I=[],h={}){const _=this.handleIncludeExclude(h.includePattern,h.expandPatterns),R=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),B=I.length>1,z=(_.searchPaths&&_.searchPaths.length?_.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,h,R)):I.map(W=>this.getFolderQueryForRoot(W,h,R,B))).filter(W=>!!W),he={_reason:h._reason,folderQueries:z,usingSearchPaths:!!(_.searchPaths&&_.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:R.pattern,includePattern:_.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const j=v.coalesce(v.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(L=>L.resource)))).filter(F=>(0,o.pathIncludedInQuery)(he,F.fsPath)),U=this.commonQueryFromFileList(j);return Object.assign(Object.assign({},he),U)}const de=h.extraFileResources&&h.extraFileResources.filter(W=>(0,o.pathIncludedInQuery)(he,W.fsPath));return he.extraFileResources=de&&de.length?de:void 0,he}commonQueryFromFileList(I){const h=[],_=new y.ResourceMap,R={};let B=!1;return I.forEach(z=>{var he,de;if(z.scheme!==C.Schemas.walkThrough)if((0,k.isAbsolutePath)(z)){const j=(de=(he=this.workspaceContextService.getWorkspaceFolder(z))===null||he===void 0?void 0:he.uri)!==null&&de!==void 0?de:z.with({path:S.dirname(z.fsPath)});let U=_.get(j);U||(B=!0,U={folder:j,includePattern:{}},h.push(U),_.set(j,U));const F=S.relative(j.fsPath,z.fsPath);(0,P.assertIsDefined)(U.includePattern)[F.replace(/\\/g,"/")]=!0}else z.fsPath&&(B=!0,R[z.fsPath]=!0)}),{folderQueries:h,includePattern:R,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}isCaseSensitive(I,h){if(h.isSmartCase){if(I.isRegExp){if(i.containsUppercaseCharacter(I.pattern,!0))return!0}else if(i.containsUppercaseCharacter(I.pattern))return!0}return!!I.isCaseSensitive}isMultiline(I){return I.isMultiline||I.isRegExp&&(0,g.isMultilineRegexSource)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const h=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(I)?I:n(I)).map(U=>{const F=this.pathService.resolvedUserHome;return F?(0,A.untildify)(U,F.scheme===C.Schemas.file?F.fsPath:F.path):U}),B=T.groupBy(R,U=>h(U)?"searchPaths":"exprSegments"),z=(B.exprSegments||[]).map(U=>i.rtrim(U,"/")).map(U=>i.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),l(U))),he={},de=this.expandSearchPathPatterns(B.searchPaths||[]);de&&de.length&&(he.searchPaths=de);const W=v.flatten(z),j=t(...W);return j&&(he.pattern=j),he}getExcludesForFolder(I,h){return h.disregardExcludeSettings?void 0:(0,o.getExcludes)(I,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(I){if(!I||!I.length)return[];const h=v.flatten(I.map(R=>{let{pathPortion:B,globPortion:z}=m(R);z&&(z=u(z));const he=this.expandOneSearchPath(B);return v.flatten(he.map(de=>this.resolveOneSearchPathPattern(de,z)))})),_=new Map;return h.forEach(R=>{const B=R.searchPath.toString(),z=_.get(B);z?R.pattern&&(z.pattern=z.pattern||{},z.pattern[R.pattern]=!0):_.set(B,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(_.values())}expandOneSearchPath(I){if(S.isAbsolute(I)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==C.Schemas.file?[{searchPath:h[0].uri.with({path:I})}]:[{searchPath:d.URI.file(S.normalize(I))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(I=s(I),I.startsWith("../")||I===".."){const R=S.posix.resolve(h.path,I);return[{searchPath:h.with({path:R})}]}const _=u(I);return[{searchPath:h,pattern:_}]}else{if(I==="./"||I===".\\")return[];{const h=I.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(B=>{const z=h.match(new RegExp(`^${B.name}(?:/(.*))?`));return z?{match:z,folder:B}:null}).filter(P.isDefined);if(R.length)return R.map(B=>{const z=B.match[1];return{searchPath:B.folder.uri,pattern:z&&u(z)}});{const B=I.match(/\.[\/\\](.+)[\/\\]?/),z=B?B[1]:I,he=r.localize(0,null,z);throw new Error(he)}}}}resolveOneSearchPathPattern(I,h){const _=I.pattern&&h?`${I.pattern}/${h}`:I.pattern||h,R=[{searchPath:I.searchPath,pattern:_}];return _&&!_.endsWith("**")&&R.push({searchPath:I.searchPath,pattern:_+"/**"}),R}getFolderQueryForSearchPath(I,h,_){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(I.searchPath),h,_,!1);return R?Object.assign(Object.assign({},R),{includePattern:I.pattern}):null}getFolderQueryForRoot(I,h,_,R){let B;const z=d.URI.isUri(I)?I:I.uri;if(_.searchPaths){const U=_.searchPaths.filter(F=>(0,k.isEqual)(F.searchPath,z))[0];if(U&&!U.pattern)return null;U&&(B=U.pattern)}const he=this.configurationService.getValue({resource:z}),de=this.getExcludesForFolder(he,h),W=Object.assign(Object.assign({},de||{}),B||{}),j=d.URI.isUri(I)?(0,k.basename)(I):I.name;return{folder:z,folderName:R?j:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:he.files&&he.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!he.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!he.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!he.search.followSymlinks}}};c=je([qe(0,a.IConfigurationService),qe(1,p.IWorkspaceContextService),qe(2,f.IEditorGroupsService),qe(3,E.IPathService)],c),e.QueryBuilder=c;function m(b){const I=b.match(/[\*\{\}\(\)\[\]\?]/);if(I){const h=I.index,_=b.substr(0,h).match(/[/|\\][^/\\]*$/);if(_){let R=b.substr(0,_.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:b.substr((_.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((I,h)=>(I[h]=!0,I),Object.create(null)):void 0}function n(b){return D.splitGlobAware(b,",").map(I=>I.trim()).filter(I=>!!I.length)}function l(b){return[`**/${b}/**`,`**/${b}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function s(b){return b.replace(/\\/g,"/")}function u(b){return s(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(b,I){b=v.distinct(b,R=>R.toString());const h=[],_=I.getWorkspace();return b&&b.forEach(R=>{let B;if(I.getWorkbenchState()===2)B=(0,k.relativePath)(_.folders[0].uri,R),B&&B!=="."&&(B="./"+B);else{const z=I.getWorkspaceFolder(R);if(z){const he=z.name;if(_.folders.filter(W=>W.name===he).length===1){const W=(0,k.relativePath)(z.uri,R);W===""?B=`./${z.name}`:B=`./${z.name}/${W}`}else B=R.fsPath}}B&&h.push(B)}),h}e.resolveResourcesForSearchIncludes=w}),define(ve[220],be([0,1,25,2,20,12,4,219,41,48]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(a,p){const f=p.activationEvents;if(!f)return Promise.resolve(void 0);const E=[],o=[];for(const s of f)if(/^workspaceContains:/.test(s)){const u=s.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||a.forceUsingSearch?o.push(u):E.push(u)}if(E.length===0&&o.length===0)return Promise.resolve(void 0);let c;const m=new Promise((s,u)=>{c=s}),t=s=>c({activationEvent:s}),n=Promise.all(E.map(s=>d(a,s,t))).then(()=>{}),l=g(a,p.identifier,o,t);return Promise.all([n,l]).then(()=>{c(void 0)}),m}e.checkActivateWorkspaceContainsExtension=P;async function d(a,p,f){for(const E of a.folders)if(await a.exists(v.joinPath(T.URI.revive(E),p))){f(`workspaceContains:${p}`);return}}async function g(a,p,f,E){if(f.length===0)return Promise.resolve(void 0);const o=new D.CancellationTokenSource,c=a.checkExists(a.folders,f,o.token),m=setTimeout(async()=>{o.cancel(),E(`workspaceContainsTimeout:${f.join(",")}`)},i);let t=!1;try{t=await c}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}o.dispose(),clearTimeout(m),t&&E(`workspaceContains:${f.join(",")}`)}function r(a,p,f,E){const o=a.get(y.IInstantiationService),c=a.get(S.ISearchService),t=o.createInstance(C.QueryBuilder).file(p.map(n=>(0,k.toWorkspaceFolder)(T.URI.revive(n))),{_reason:"checkExists",includePattern:f,exists:!0});return c.fileSearch(t,E).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=r});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[35],be([0,1,133,14,81,25,11,6,22,2,18,5,34,185,79,30,33,183,12,26,24,161,7,67,4,27,80,15,65,71,40,3,220,75,162]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f,E,o,c,m,t,n,l,s,u,w,b,I,h,_,R,B,z){"use strict";var he,de,W;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let j=class Ln extends C.Disposable{constructor(M,x,G,J,te,me,Le,We,Fe,ze){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=x,this._extHostContext=G,this._initData=Le,this._extHostWorkspace=J,this._extHostConfiguration=te,this._logService=me,this._extHostTunnelService=Fe,this._extHostTerminalService=ze,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new f.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=M.createChild(new b.ServiceCollection([r.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const H=new Set;this._initData.hostExtensions.forEach(q=>H.add(o.ExtensionIdentifier.toKey(q))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(q,ee,se)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(q,E.transformErrorForSerialization(ee),se)},actualActivateExtension:async(q,ee)=>{if(H.has(o.ExtensionIdentifier.toKey(q)))return await this._mainThreadExtensionsProxy.$activateExtension(q,ee),new g.HostExtension;const se=this._registry.getExtensionDescription(q);return this._activateExtension(se,ee)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){E.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch(x){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,x){return this._activator.activateByEvent(M,x)}_activateById(M,x){return this._activator.activateById(M,x)}activateByIdWithErrors(M,x){return this._activateById(M,x).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=S.TernarySearchTree.forPaths(),x=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(J=>M.set(k.URI.file(J).fsPath,G))});this._extensionPathIndex=Promise.all(x).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let x=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return x;const G=this._activator.getActivatedExtension(M);if(!G)return x;try{typeof G.module.deactivate=="function"&&(x=Promise.resolve(G.module.deactivate()).then(void 0,J=>Promise.resolve(void 0)))}catch(J){}try{(0,C.dispose)(G.subscriptions)}catch(J){}return x}async _activateExtension(M,x){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,x).then(G=>{const J=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,x),this._logExtensionActivationTimes(M,x,"success",J),G},G=>{throw this._logExtensionActivationTimes(M,x,"failure"),G})}_logExtensionActivationTimes(M,x,G,J){const te=U(M,x);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},te),J||{}),{outcome:G}))}_doActivateExtension(M,x){const G=U(M,x);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const J=this._getEntryPoint(M);if(!J)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(x)}`),this._logService.flush();const te=new g.ExtensionActivationTimesBuilder(x.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,A.joinPath)(M.extensionLocation,J),te),this._loadExtensionContext(M)]).then(me=>(D.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Ln._callActivate(this._logService,M.identifier,me[0],me[1],te))).then(me=>(D.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),me))}_loadExtensionContext(M){const x=new m.ExtensionGlobalMemento(M,this._storage),G=new m.ExtensionMemento(M.identifier.value,!1,this._storage),J=new z.ExtensionSecrets(M,this._secretState),te=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([x.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Le=this;let We;return Object.freeze({globalState:x,workspaceState:G,secrets:J,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Fe){return T.join(M.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Le._storagePath.workspaceValue(M))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Le._storagePath.globalValue(M).fsPath},get logPath(){return T.join(Le._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(Le._initData.logsLocation,M.identifier.value)},get storageUri(){return Le._storagePath.workspaceValue(M)},get globalStorageUri(){return Le._storagePath.globalValue(M)},get extensionMode(){return te},get extension(){return We===void 0&&(We=new F(Le,M.identifier,M,me)),We},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(M),Le.extensionRuntime},get environmentVariableCollection(){return Le._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,x,G,J,te){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,x,G,J,te).then(me=>new g.ActivatedExtension(!1,null,te.build(),G,me,J.subscriptions))}static _callActivateOptional(M,x,G,J,te){if(typeof G.activate=="function")try{te.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${x.value}`);const me=typeof global=="object"?global:self,Le=G.activate.apply(me,[J]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(Le).then(We=>(te.activateResolveStop(),We))}catch(me){return Promise.reject(me)}else return Promise.resolve(G)}_activateOneStartupFinished(M,x){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:x}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const x of M.activationEvents)x==="onStartupFinished"&&this._activateOneStartupFinished(M,x)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,te=>{this._logService.error(te)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(te=>this._handleWorkspaceContainsEagerExtensions(te.added)));const x=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(x),J=Promise.all([M,G]).then(()=>{});return Promise.race([J,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),J}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(x=>this._handleWorkspaceContainsEagerExtension(M,x))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,x){if(!this.isActivated(x.identifier)){const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,J={folders:M.map(me=>me.uri),forceUsingSearch:G,exists:me=>this._hostUtils.exists(me.fsPath),checkExists:(me,Le,We)=>this._mainThreadWorkspaceProxy.$checkExists(me,Le,We)},te=await(0,R.checkActivateWorkspaceContainsExtension)(J,x);if(!!te)return this._activateById(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:te.activationEvent}).then(void 0,me=>this._logService.error(me))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:x}=this._initData.environment;if(!M||!x)throw new Error(v.localize(0,null));const G=await this._loadCommonJSModule(null,x,new g.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(v.localize(1,null,x.toString()));return new Promise((J,te)=>{const me=(Fe,ze)=>{Fe?te(Fe):J(typeof ze=="number"&&ze>0?1:0)},Le=(0,A.originalFSPath)(x),We=G.run(Le,me);We&&We.then&&We.then(()=>{J(0)}).catch(Fe=>{te(Fe.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,x){return this._resolvers[M]=x,(0,C.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,x){const G=M.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const J=M.substr(0,G);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${J}`,!1);const te=this._resolvers[J];if(!te)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${J}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(te)),D.mark(`code/extHost/willResolveAuthority/${J}`);const me=await te.resolve(M,{resolveAttempt:x});D.mark(`code/extHost/didResolveAuthorityOK/${J}`);const Le={authority:M,host:me.host,port:me.port,connectionToken:me.connectionToken},We={extensionHostEnv:me.extensionHostEnv,trust:me.trust};return{type:"ok",value:{authority:Le,options:We,tunnelInformation:{environmentTunnels:me.environmentTunnels}}}}catch(me){if(D.mark(`code/extHost/didResolveAuthorityError/${J}`),me instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:me._code,message:me._message,detail:me._detail}};throw me}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,x){return x===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,x){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,x),!0):!1}async $deltaExtensions(M,x){M.forEach(J=>J.extensionLocation=k.URI.revive(J.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(x.map(async J=>{const te=this._registry.getExtensionDescription(J);if(!!te){const me=await this._hostUtils.realpath(te.extensionLocation.fsPath);G.delete(k.URI.file(me).fsPath)}})),await Promise.all(M.map(async J=>{const te=await this._hostUtils.realpath(J.extensionLocation.fsPath);G.set(k.URI.file(te).fsPath,J)})),this._registry.deltaExtensions(M,x),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let x=c.VSBuffer.alloc(M),G=Math.random()%256;for(let J=0;J<M;J++)x.writeUInt8(G,J);return x}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};j=je([qe(0,l.IInstantiationService),qe(1,e.IHostUtils),qe(2,w.IExtHostRpcService),qe(3,a.IExtHostWorkspace),qe(4,d.IExtHostConfiguration),qe(5,i.ILogService),qe(6,s.IExtHostInitDataService),qe(7,u.IExtensionStoragePaths),qe(8,I.IExtHostTunnelService),qe(9,h.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function U(L,M){return{id:L.identifier.value,name:L.name,extensionVersion:L.version,publisherDisplayName:L.publisher,activationEvents:L.activationEvents?L.activationEvents.join(","):null,isBuiltin:L.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class F{constructor(M,x,G,J){he.set(this,void 0),de.set(this,void 0),W.set(this,void 0),it(this,he,M,"f"),it(this,de,x,"f"),it(this,W,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=T.normalize((0,A.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=J}get isActive(){return Ue(this,he,"f").isActivated(Ue(this,W,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,he,"f").getExtensionExports(Ue(this,W,"f"))}activate(){return Ue(this,he,"f").activateByIdWithErrors(Ue(this,W,"f"),{startup:!1,extensionId:Ue(this,de,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,he=new WeakMap,de=new WeakMap,W=new WeakMap}),define(ve[105],be([0,1,14,2,3,11,5,7,169,30,35,39,173,34,170,15,4,10,46,69]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let c=class{constructor(b,I,h,_,R,B){this._workspaceService=I,this._extensionService=h,this._editorsService=_,this._configurationService=R,this._editorTabs=B,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=b.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(he=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(b,I){const h=b;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let _=`debug:${encodeURIComponent(h.path||"")}`,R="?";return I&&(_+=`${R}session=${encodeURIComponent(I.id)}`,R="&"),_+=`${R}ref=${h.sourceReference}`,T.URI.parse(_)}else{if(h.path)return T.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(b){const I=[];for(const h of b.getAllExtensionDescriptions())if(h.contributes){const _=h.contributes.debuggers;if(_&&_.length>0)for(const R of _)(0,r.isDebuggerMainContribution)(R)&&I.push(R.type)}this._debugServiceProxy.$registerDebugTypes(I)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const b=[];return this._breakpoints.forEach(I=>b.push(I)),b}addBreakpoints(b){this.startBreakpoints();const I=b.filter(R=>{const B=R.id;return this._breakpoints.has(B)?!1:(this._breakpoints.set(B,R),!0)});this.fireBreakpointChanges(I,[],[]);const h=[],_=new Map;for(const R of I)if(R instanceof C.SourceBreakpoint){let B=_.get(R.location.uri.toString());B||(B={type:"sourceMulti",uri:R.location.uri,lines:[]},_.set(R.location.uri.toString(),B),h.push(B)),B.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof C.FunctionBreakpoint&&h.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(b){this.startBreakpoints();const I=b.filter(B=>this._breakpoints.delete(B.id));this.fireBreakpointChanges([],I,[]);const h=I.filter(B=>B instanceof C.SourceBreakpoint).map(B=>B.id),_=I.filter(B=>B instanceof C.FunctionBreakpoint).map(B=>B.id),R=I.filter(B=>B instanceof C.DataBreakpoint).map(B=>B.id);return this._debugServiceProxy.$unregisterBreakpoints(h,_,R)}startDebugging(b,I,h){return this._debugServiceProxy.$startDebugging(b?b.uri:void 0,I,{parentSessionID:h.parentSession?h.parentSession.id:void 0,repl:h.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact})}stopDebugging(b){return this._debugServiceProxy.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,I,h){if(!I)return new C.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:b,handle:_,provider:I}),this._debugServiceProxy.$registerDebugConfigurationProvider(b,h,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,_),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==I),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(b,I,h){if(!h)return new C.Disposable(()=>{});if(!this.definesDebugType(b,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.getAdapterDescriptorFactoryByType(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:I,handle:_,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(I,_),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(b,I){if(!I)return new C.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:b,handle:h,factory:I}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==I)})}async $runInTerminal(b,I){return Promise.resolve(void 0)}async $substituteVariables(b,I){if(!this._variableResolver){const[R,B]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,B)}let h;const _=await this.getFolder(b);return _&&(h={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,I)}createDebugAdapter(b,I){if(b.type==="implementation")return new s(b.implementation)}createSignService(){}async $startDASession(b,I){const h=this,_=await this.getSession(I);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const B=this.convertToDto(R),z=this.createDebugAdapter(B,_);if(!z)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const he=z;return this._debugAdapters.set(b,he),this.getDebugAdapterTrackers(_).then(de=>(de&&this._debugAdaptersTrackers.set(b,de),he.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const j=W,U={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(j.arguments.value);U.body={signature:F},he.sendResponse(U)}else throw new Error("no signer")}catch(F){U.success=!1,U.message=F.message,he.sendResponse(U)}}else de&&de.onDidSendMessage&&de.onDidSendMessage(W),W=(0,r.convertToVSCPaths)(W,!0),h._debugServiceProxy.$acceptDAMessage(b,W)}),he.onError(W=>{de&&de.onError&&de.onError(W),this._debugServiceProxy.$acceptDAError(b,W.name,W.message,W.stack)}),he.onExit(W=>{de&&de.onExit&&de.onExit((0,f.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(b,(0,f.withNullAsUndefined)(W),void 0)}),de&&de.onWillStartSession&&de.onWillStartSession(),he.startSession()))})}$sendDAMessage(b,I){I=(0,r.convertToDAPaths)(I,!1);const h=this._debugAdaptersTrackers.get(b);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(I);const _=this._debugAdapters.get(b);_&&_.sendMessage(I)}$stopDASession(b){const I=this._debugAdaptersTrackers.get(b);this._debugAdaptersTrackers.delete(b),I&&I.onWillStopSession&&I.onWillStopSession();const h=this._debugAdapters.get(b);return this._debugAdapters.delete(b),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const I=[],h=[],_=[];if(b.added)for(const R of b.added){const B=R.id;if(B&&!this._breakpoints.has(B)){let z;if(R.type==="function")z=new C.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")z=new C.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const he=T.URI.revive(R.uri);z=new C.SourceBreakpoint(new C.Location(he,new C.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}z._id=B,this._breakpoints.set(B,z),I.push(z)}}if(b.removed)for(const R of b.removed){const B=this._breakpoints.get(R);B&&(this._breakpoints.delete(R),h.push(B))}if(b.changed){for(const R of b.changed)if(R.id){const B=this._breakpoints.get(R.id);if(B){if(B instanceof C.FunctionBreakpoint&&R.type==="function"){const z=B;z.enabled=R.enabled,z.condition=R.condition,z.hitCondition=R.hitCondition,z.logMessage=R.logMessage,z.functionName=R.functionName}else if(B instanceof C.SourceBreakpoint&&R.type==="source"){const z=B;z.enabled=R.enabled,z.condition=R.condition,z.hitCondition=R.hitCondition,z.logMessage=R.logMessage,z.location=new C.Location(T.URI.revive(R.uri),new C.Position(R.line,R.character))}_.push(B)}}}this.fireBreakpointChanges(I,h,_)}$provideDebugConfigurations(b,I,h){return(0,A.asPromise)(async()=>{const _=this.getConfigProviderByHandle(b);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(I);return _.provideDebugConfigurations(R,h)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(b,I,h,_){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(b);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const B=await this.getFolder(I);return R.resolveDebugConfiguration(B,h,_)})}$resolveDebugConfigurationWithSubstitutedVariables(b,I,h,_){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(b);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const B=await this.getFolder(I);return R.resolveDebugConfigurationWithSubstitutedVariables(B,h,_)})}async $provideDebugAdapter(b,I){const h=this.getAdapterDescriptorFactoryByHandle(b);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(I);return this.getAdapterDescriptor(h,_).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(b){const I=await this.getSession(b);this._onDidStartDebugSession.fire(I)}async $acceptDebugSessionTerminated(b){const I=await this.getSession(b);I&&(this._onDidTerminateDebugSession.fire(I),this._debugSessions.delete(I.id))}async $acceptDebugSessionActiveChanged(b){this._activeDebugSession=b?await this.getSession(b):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(b,I){const h=await this.getSession(b);h&&h._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(b,I){const _={session:await this.getSession(b),event:I.event,body:I.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(b){if(b instanceof C.DebugAdapterExecutable)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof C.DebugAdapterServer)return{type:"server",port:b.port,host:b.host};if(b instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:b.path};if(b instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(b){const I=this._adapterFactories.filter(h=>h.type===b);if(I.length>0)return I[0].factory}getAdapterDescriptorFactoryByHandle(b){const I=this._adapterFactories.filter(h=>h.handle===b);if(I.length>0)return I[0].factory}getConfigProviderByHandle(b){const I=this._configProviders.filter(h=>h.handle===b);if(I.length>0)return I[0].provider}definesDebugType(b,I){if(b.contributes){const h=b.contributes.debuggers;if(h&&h.length>0){for(const _ of h)if(_.label&&_.type&&_.type===I)return!0}}return!1}getDebugAdapterTrackers(b){const h=b.configuration.type,_=this._trackerFactories.filter(R=>R.type===h||R.type==="*").map(R=>(0,A.asPromise)(()=>R.factory.createDebugAdapterTracker(b)).then(B=>B,B=>null));return Promise.race([Promise.all(_).then(R=>{const B=R.filter(z=>!!z);if(B.length>0)return new l(B)}),new Promise((R,B)=>{const z=setTimeout(()=>{clearTimeout(z),B(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(b,I){const h=I.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new C.DebugAdapterServer(h));if(b){const R=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>b.createDebugAdapterDescriptor(I,this.daExecutableFromPackage(I,R))).then(B=>{if(B)return B})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(I,_))}daExecutableFromPackage(b,I){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(b,I,h){(b.length>0||I.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:b,removed:I,changed:h}))}async getSession(b){if(b)if(typeof b=="string"){const I=this._debugSessions.get(b);if(I)return I}else{let I=this._debugSessions.get(b.id);if(!I){const h=await this.getFolder(b.folderUri);I=new m(this._debugServiceProxy,b.id,b.type,b.name,h,b.configuration),this._debugSessions.set(I.id,I),this._debugServiceProxy.$sessionCached(I.id)}return I}throw new Error("cannot find session")}getFolder(b){if(b){const I=T.URI.revive(b);return this._workspaceService.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}};c=je([qe(0,a.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,g.IExtHostConfiguration),qe(5,o.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class m{constructor(b,I,h,_,R,B){this._debugServiceProxy=b,this._id=I,this._type=h,this._name=_,this._workspaceFolder=R,this._configuration=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(b){this._name=b,this._debugServiceProxy.$setDebugSessionName(this._id,b)}_acceptNameChanged(b){this._name=b}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(b,I){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,b,I)}getDebugProtocolBreakpoint(b){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,b.id)}}e.ExtHostDebugSession=m;class t{constructor(b){this.value=Object.freeze({append(I){b.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.ExtHostDebugConsole=t;class n extends d.AbstractVariableResolverService{constructor(b,I,h,_,R){function B(){if(I){const z=I.activeEditor();if(z)return z.document.uri;const he=_.tabs.filter(de=>de.isActive);if(he.length>0)return he[0].resource}}super({getFolderUri:z=>{const he=b.filter(de=>de.name===z);if(he&&he.length>0)return he[0].uri},getWorkspaceFolderCount:()=>b.length,getConfigurationValue:(z,he)=>h.getConfiguration(void 0,z).get(he),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const z=B();if(z)return v.normalize(z.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const z=B();if(z){const he=R.getWorkspaceFolder(z);if(he)return v.normalize(he.uri.fsPath)}}},getSelectedText:()=>{if(I){const z=I.activeEditor();if(z&&!z.selection.isEmpty)return z.document.getText(z.selection)}},getLineNumber:()=>{if(I){const z=I.activeEditor();if(z)return String(z.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=n;class l{constructor(b){this.trackers=b}onWillStartSession(){this.trackers.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.trackers.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.trackers.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(b):void 0)}onWillStopSession(){this.trackers.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.trackers.forEach(I=>I.onError?I.onError(b):void 0)}onExit(b,I){this.trackers.forEach(h=>h.onExit?h.onExit(b,I):void 0)}}class s extends S.AbstractDebugAdapter{constructor(b){super();this.implementation=b,b.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.implementation.handleMessage(b)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends c{constructor(b,I,h,_,R,B){super(b,I,h,_,R,B)}createVariableResolver(b,I,h){return new n(b,I,h,this._editorTabs)}};u=je([qe(0,a.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,g.IExtHostConfiguration),qe(5,o.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(ve[221],be([0,1,81,2,5,34,33,26,15,27,4,35,46,18]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(o,c,m,t,n,l,s){this._apiFactory=o,this._extensionRegistry=c,this._instaService=m,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=l,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,c,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,c,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let c of o.nodeModuleName)this._factories.set(c,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(c=>o.alternativeModuleName(c))}};r=je([qe(2,i.IInstantiationService),qe(3,A.IExtHostConfiguration),qe(4,P.IExtHostExtensionService),qe(5,k.IExtHostInitDataService),qe(6,g.ILogService)],r),e.RequireInterceptor=r;class a{constructor(o,c,m,t,n){this._apiFactory=o,this._extensionPaths=c,this._extensionRegistry=m,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,c){const m=this._extensionPaths.findSubstr(c.fsPath);if(m){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(m.identifier));return t||(t=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(m.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,l)=>t+=`	${l} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(o,c){this.nodeModuleName="keytar";const{environment:m}=c,t=o.getProxy(D.MainContext.MainThreadKeytar);if(m.appRoot){let n=m.appRoot.fsPath;d.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,l)=>t.$getPassword(n,l),setPassword:(n,l,s)=>t.$setPassword(n,l,s),deletePassword:(n,l)=>t.$deletePassword(n,l),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(o,c){return this._impl}alternativeModuleName(o){const c=o.length;if(!(c<=7||!this.alternativeNames)){const m=c-7;if((o.charAt(m)==="/"||o.charAt(m)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}}};p=je([qe(0,S.IExtHostRpcService),qe(1,k.IExtHostInitDataService)],p);let f=class{constructor(o,c,m){this._extensionPaths=o,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(D.MainContext.MainThreadTelemetry);const t=m.getProxy(D.MainContext.MainThreadWindow);this._impl=(n,l)=>{const s=T.URI.parse(n);return l?this.callOriginal(n,l):s.scheme==="http"||s.scheme==="https"?t.$openUri(s,n,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?t.$openUri(s,n,{}):this.callOriginal(n,l)}}load(o,c,m){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=m(o),this._impl}callOriginal(o,c){return this.sendNoForwardTelemetry(),this._original(o,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=je([qe(2,S.IExtHostRpcService)],f)}),define(ve[222],be([0,1,11,12,81,6,2,5,214,18,61,65,27,152,15,72,35,40]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(c,m,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const l=new S.RPCProtocol(c,null,n);m=E._transform(m,l);const s=new P.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},m)),s.set(r.IExtHostRpcService,new r.ExtHostRpcService(l)),s.set(a.IURITransformerService,new a.URITransformerService(n)),s.set(p.IHostUtils,t);const u=new g.InstantiationService(s,!0),w=u.invokeFunction(_=>_.get(f.IExtHostTerminalService));this._disposables.add(w),this._logService=u.invokeFunction(_=>_.get(k.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",m),this._extensionService=u.invokeFunction(_=>_.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap;this._extensionService.getExtensionPathIndex().then(_=>{Error.prepareStackTrace=(R,B)=>{let z="",he,de;for(const W of B)z+=`
	at ${W.toString()}`,de=W.getFileName(),!he&&de&&(he=_.findSubstr(de));return b.set(R,he),`${R.name||"Error"}: ${R.message||""}${z}`}});const I=l.getProxy(C.MainContext.MainThreadExtensionService),h=l.getProxy(C.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(_=>{const R=T.transformErrorForSerialization(_),B=b.get(_);B?I.$onExtensionRuntimeError(B.identifier,R):h.$onUnexpectedError(R)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{});const m=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,v.timeout)(4e3),m]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,m){c.extensions.forEach(n=>n.extensionLocation=y.URI.revive(m.transformIncomingURIs(n.extensionLocation))),c.environment.appRoot=y.URI.revive(m.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(m.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=y.URI.revive(m.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(m.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(m.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(m.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(m.transformIncomingURIs(c.logFile)),c.workspace=m.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=E}),define(ve[223],be([0,1,14,20,60,28,25,55,41]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(d,g,r){this.config=d,this.provider=g,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&A.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&A.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const g=this.config.folderQueries||[];return new Promise((r,a)=>{const p=f=>{this.resultCount++,d(f)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const E=f.toString(),o=v.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,o)||this.matchFile(p,{base:f,basename:o})}),Promise.all(g.map(f=>this.searchInFolder(f,p))).then(f=>{r({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{a(new Error((0,D.toErrorMessage)(f)))})})}async searchInFolder(d,g){const r=new T.CancellationTokenSource,a=this.getSearchOptionsForFolder(d),p=this.initDirectoryTree(),f=new S.QueryGlobTester(this.config,d),E=!f.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(r),o=C.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,r.token),m=o.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(n=>{const l=v.posix.relative(d.folder.path,n.path);if(E){const s=v.basename(n.path);this.matchFile(g,{base:d.folder,relativePath:l,basename:s});return}this.addDirectoryEntries(p,d.folder,l,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,f,g),{providerTime:m,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(d){const g=(0,S.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),r=(0,S.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:r,includes:g,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},g,r,a){if(r===this.filePattern){const f=v.basename(this.filePattern);this.matchFile(a,{base:g,relativePath:this.filePattern,basename:f})}function p(f){const E=v.basename(f),o=v.dirname(f);let c=d[o];c||(c=d[o]=[],p(o)),c.push({base:g,relativePath:f,basename:E})}p(r)}matchDirectoryTree({rootEntries:d,pathToEntries:g},r,a){const p=this,f=this.filePattern;function E(o){const c=A.hasSiblingFn(()=>o.map(m=>m.basename));for(let m=0,t=o.length;m<t;m++){const n=o[m],{relativePath:l,basename:s}=n;if(!!r.includedInQuerySync(l,s,f!==s?c:void 0)){const u=g[l];if(u)E(u);else{if(l===f)continue;p.matchFile(a,n)}if(p.isLimitHit)break}}}E(d)}matchFile(d,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(g))}}class i{constructor(){this.sessions=new Map}fileSearch(d,g,r,a){const p=this.getSessionTokenSource(d.cacheKey),f=new k(d,g,p&&p.token);let E=0;const o=c=>{E+=c.length,r(c.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(f,i.BATCH_SIZE,o,a).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:c.stats}}))}clearCache(d){const g=this.getSessionTokenSource(d);g&&g.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new T.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:y.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,g,r,a){a.onCancellationRequested(()=>{d.cancel()});const p=E=>{E&&(f.push(E),g>0&&f.length>=g&&(r(f),f=[]))};let f=[];return d.search(p).then(E=>(f.length&&r(f),E),E=>(f.length&&r(f),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(ve[224],be([0,1,14,13,20,60,25,28,2,41,19,10]),function(Y,e,v,T,D,A,y,C,S,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(o,c,m){this.query=o,this.provider=c,this.fileUtils=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,c){const m=this.query.folderQueries||[],t=new D.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((n,l)=>{this.collector=new r(o);let s=!1;const u=(w,b)=>{if(!s&&!this.isLimitHit){const I=this.resultSize(w);p(w)&&typeof this.query.maxResults=="number"&&this.resultCount+I>this.query.maxResults&&(this.isLimitHit=!0,s=!0,t.cancel(),w=this.trimResultToSize(w,this.query.maxResults-this.resultCount));const h=this.resultSize(w);this.resultCount+=h,(h>0||!p(w))&&this.collector.add(w,b)}};Promise.all(m.map((w,b)=>this.searchInFolder(w,I=>u(I,b),t.token))).then(w=>{t.dispose(),this.collector.flush();const b=w.some(I=>!!I&&!!I.limitHit);n({limitHit:this.isLimitHit||b,messages:(0,T.flatten)(w.map(I=>(I==null?void 0:I.message)?(0,P.isArray)(I.message)?I.message:[I.message]:[])),stats:{type:"textSearchProvider"}})},w=>{t.dispose();const b=(0,A.toErrorMessage)(w);l(new Error(b))})})}resultSize(o){return p(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,c){const m=Array.isArray(o.ranges)?o.ranges:[o.ranges],t=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:m.slice(0,c),preview:{matches:t.slice(0,c),text:o.preview.text},uri:o.uri}}async searchInFolder(o,c,m){const t=new k.QueryGlobTester(this.query,o),n=[],l={report:w=>{if(!!this.validateProviderResult(w)){const b=o.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(w.uri))):void 0,I=y.relativePath(o.folder,w.uri);I&&n.push(t.includedInQuery(I,v.basename(I),b).then(h=>{h&&c(w)}))}}},s=this.getSearchOptionsForFolder(o),u=await this.provider.provideTextSearchResults(g(this.query.contentPattern),s,l,m);return await Promise.all(n),u}validateProviderResult(o){if(p(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const c=(0,k.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),m=(0,k.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),t={folder:S.URI.from(o.folder),excludes:m,includes:c,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function g(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class r{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new f(512,c=>this.sendItems(c))}add(o,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(a(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=r;function a(E){return p(E)?{preview:{matches:(0,T.mapArrayOrNot)(E.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:E.preview.text},ranges:(0,T.mapArrayOrNot)(E.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function p(E){return!!E.preview}e.extensionResultIsMatch=p;class f{constructor(o,c){this.maxBatchSize=o,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,c){!o||this.addItemToBatch(o,c)}addItems(o,c){!o||this.addItemsToBatch(o,c)}addItemToBatch(o,c){this.batch.push(o),this.batchSize+=c,this.onUpdate()}addItemsToBatch(o,c){this.batch=this.batch.concat(o),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<f.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},f.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=f,f.TIMEOUT=4e3,f.START_BATCH_AFTER_COUNT=50}),define(ve[106],be([0,1,6,5,4,223,15,72,18,2,224]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let P=class{constructor(a,p,f){this.extHostRpc=a,this._uriTransformer=p,this._logService=f,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,p){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const f=this._handlePool++;return this._textSearchProvider.set(f,p),this._proxy.$registerTextSearchProvider(f,this._transformScheme(a)),(0,v.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(a,p){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const f=this._handlePool++;return this._fileSearchProvider.set(f,p),this._proxy.$registerFileSearchProvider(f,this._transformScheme(a)),(0,v.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(a,p,f,E){const o=d(f),c=this._fileSearchProvider.get(a);if(c)return this._fileSearchManager.fileSearch(o,c,m=>{this._proxy.$handleFileMatch(a,p,m.map(t=>t.resource))},E);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,p,f,E){const o=this._textSearchProvider.get(a);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const c=d(f);return this.createTextSearchManager(c,o).search(t=>this._proxy.$handleTextMatch(a,p,t),E)}createTextSearchManager(a,p){return new i.TextSearchManager(a,p,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f})}};P=je([qe(0,y.IExtHostRpcService),qe(1,C.IURITransformerService),qe(2,S.ILogService)],P),e.ExtHostSearch=P;function d(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(g),extraFileResources:r.extraFileResources&&r.extraFileResources.map(a=>k.URI.revive(a))})}e.reviveQuery=d;function g(r){return Object.assign(Object.assign({},r),{folder:k.URI.revive(r.folder)})}}),define(ve[225],be([0,1,131,20,12,3,47,2,124,86,118,59,64,5,190,189,77,191,34,192,193,194,176,195,39,35,196,177,198,199,200,101,180,203,204,205,79,40,206,181,9,7,209,50,102,30,33,51,166,197,94,100,104,105,106,18,72,15,27,201,164,71,76,187,207,163,80,78,212,210,211,188,49,218,208,75,69,95,202,67,103]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f,E,o,c,m,t,n,l,s,u,w,b,I,h,_,R,B,z,he,de,W,j,U,F,L,M,x,G,J,te,me,Le,We,Fe,ze,H,q,ee,se,ce,_e,$e,fe,De,Re,He,we,Ke,V,Z,ge,Ne,Ve,xe,Xe,ye,Ee,Ce,ie,ae,N,Q,oe,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ie(Ae){const Be=Ae.get($e.IExtHostInitDataService),Ye=Ae.get(ye.IExtHostFileSystemInfo),rt=Ae.get(ge.IExtHostConsumerFileSystem),tt=Ae.get(s.IExtHostExtensionService),Qe=Ae.get(J.IExtHostWorkspace),gt=Ae.get(N.IExtHostTelemetry),bt=Ae.get(E.IExtHostConfiguration),pe=Ae.get(ce.IURITransformerService),ue=Ae.get(_e.IExtHostRpcService),re=Ae.get(de.IExtHostStorage),K=Ae.get(Z.IExtensionStoragePaths),Me=Ae.get(se.ILogService),Te=Ae.get(Re.IExtHostTunnelService),Je=Ae.get(He.IExtHostApiDeprecationService),et=Ae.get(G.IExtHostWindow),ut=Ae.get(ie.IExtHostSecretState),ct=Ae.get(ae.IExtHostEditorTabs);ue.set(g.ExtHostContext.ExtHostFileSystemInfo,Ye),ue.set(g.ExtHostContext.ExtHostLogService,Me),ue.set(g.ExtHostContext.ExtHostWorkspace,Qe),ue.set(g.ExtHostContext.ExtHostConfiguration,bt),ue.set(g.ExtHostContext.ExtHostExtensionService,tt),ue.set(g.ExtHostContext.ExtHostStorage,re),ue.set(g.ExtHostContext.ExtHostTunnelService,Te),ue.set(g.ExtHostContext.ExtHostWindow,et),ue.set(g.ExtHostContext.ExtHostSecretState,ut),ue.set(g.ExtHostContext.ExtHostTelemetry,gt),ue.set(g.ExtHostContext.ExtHostEditorTabs,ct);const Ze=ue.set(g.ExtHostContext.ExtHostDecorations,Ae.get(ze.IExtHostDecorations)),mt=ue.set(g.ExtHostContext.ExtHostDocumentsAndEditors,Ae.get(l.IExtHostDocumentsAndEditors)),ht=ue.set(g.ExtHostContext.ExtHostCommands,Ae.get(p.IExtHostCommands)),ft=ue.set(g.ExtHostContext.ExtHostTerminalService,Ae.get(W.IExtHostTerminalService)),at=ue.set(g.ExtHostContext.ExtHostDebugService,Ae.get(q.IExtHostDebugService)),yt=ue.set(g.ExtHostContext.ExtHostSearch,Ae.get(ee.IExtHostSearch)),Et=ue.set(g.ExtHostContext.ExtHostTask,Ae.get(H.IExtHostTask)),Ot=ue.set(g.ExtHostContext.ExtHostOutputService,Ae.get(_.IExtHostOutputService)),Tt=ue.set(g.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(ue)),_t=ue.set(g.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ue,mt)),Qt=ue.set(g.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(ue,mt,Me)),Yt=ue.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Me,_t,ue.getProxy(g.MainContext.MainThreadBulkEdits))),pt=ue.set(g.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(ue,ht,mt,_t,Me,K)),Jt=ue.set(g.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(ue,Be,pt)),Dt=ue.set(g.ExtHostContext.ExtHostEditors,new j.ExtHostEditors(ue,mt)),Vt=ue.set(g.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(ue.getProxy(g.MainContext.MainThreadTreeViews),ht,Me)),Xt=ue.set(g.ExtHostContext.ExtHostEditorInsets,new Le.ExtHostEditorInsets(ue.getProxy(g.MainContext.MainThreadEditorInsets),Dt,Object.assign(Object.assign({},Be.environment),{remote:Be.remote}))),jt=ue.set(g.ExtHostContext.ExtHostDiagnostics,new o.ExtHostDiagnostics(ue,Me)),lt=ue.set(g.ExtHostContext.ExtHostLanguageFeatures,new b.ExtHostLanguageFeatures(ue,pe,_t,ht,jt,Me,Je)),Zt=ue.set(g.ExtHostContext.ExtHostFileSystem,new u.ExtHostFileSystem(ue,lt)),Rt=ue.set(g.ExtHostContext.ExtHostFileSystemEventService,new w.ExtHostFileSystemEventService(ue,Me,mt)),$t=ue.set(g.ExtHostContext.ExtHostQuickOpen,(0,B.createExtHostQuickOpen)(ue,Qe,ht)),cn=ue.set(g.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(ue,ht,Me)),wn=ue.set(g.ExtHostContext.ExtHostComments,new f.ExtHostComments(ue,ht,_t)),dn=ue.set(g.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ue.getProxy(g.MainContext.MainThreadProgress))),en=ue.set(g.ExtHostContext.ExtHosLabelService,new We.ExtHostLabelService(ue)),qt=ue.set(g.ExtHostContext.ExtHostTheming,new De.ExtHostTheming(ue)),Nt=ue.set(g.ExtHostContext.ExtHostAuthentication,new we.ExtHostAuthentication(ue)),_n=ue.set(g.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(ue,ht)),tn=ue.set(g.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(ue,Object.assign(Object.assign({},Be.environment),{remote:Be.remote}),Qe,Me,Je)),nn=ue.set(g.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(ue,tn,Qe)),Kt=ue.set(g.ExtHostContext.ExtHostCustomEditors,new Ve.ExtHostCustomEditors(ue,_t,K,tn,nn)),En=ue.set(g.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(ue,tn)),Ft=ue.set(g.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting(ue,mt,Qe)),rn=ue.set(g.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(ue)),yn=(0,me.values)(g.ExtHostContext);ue.assertRegistered(yn);const xt=new Xe.ExtHostBulkEdits(ue,mt),sn=new a.ExtHostClipboard(ue),Ut=new h.ExtHostMessageService(ue,Me),Pt=new c.ExtHostDialogs(ue),hn=new he.ExtHostStatusBar(ue,ht.converter),Wt=new I.ExtHostLanguages(ue,_t);return r.ExtHostApiCommands.register(ht),function(Oe,on,an){const vt=function(){let X=!Oe.isUnderDevelopment;function le(Pe){X||(Me.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Pe(st){if(Array.isArray(st))st.forEach(Pe);else if(typeof st=="string")le(st);else{const wt=st;typeof wt.scheme=="undefined"&&le(st),!Oe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,te.throwProposedApiError)(Oe)}return st}}(),Sn={getSession(X,le,Pe){return Nt.getSession(Oe,X,le,Pe)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(X,le,Pe,st){return Nt.registerAuthenticationProvider(X,le,Pe,st)},get onDidChangeAuthenticationProviders(){return(0,te.checkProposedApiEnabled)(Oe),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,te.checkProposedApiEnabled)(Oe),Nt.providers},logout(X,le){return(0,te.checkProposedApiEnabled)(Oe),Nt.removeSession(X,le)}},Dn={registerCommand(X,le,Pe){return ht.registerCommand(!0,X,le,Pe)},registerTextEditorCommand(X,le,Pe){return ht.registerCommand(!0,X,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+X+" because there is no active text editor.");return}return wt.edit(Ct=>{le.apply(Pe,[wt,Ct,...st])}).then(Ct=>{Ct||Me.warn("Edits from command "+X+" were not applied.")},Ct=>{Me.warn("An error occurred while running command "+X,Ct)})})},registerDiffInformationCommand:(X,le,Pe)=>((0,te.checkProposedApiEnabled)(Oe),ht.registerCommand(!0,X,async(...st)=>{const wt=mt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+X+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(wt.id);le.apply(Pe,[Ct,...st])})),executeCommand(X,...le){return ht.executeCommand(X,...le)},getCommands(X=!1){return ht.getCommands(X)}},fn={get machineId(){return Be.telemetryInfo.machineId},get sessionId(){return Be.telemetryInfo.sessionId},get language(){return Be.environment.appLanguage},get appName(){return Be.environment.appName},get appRoot(){var X,le;return(le=(X=Be.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&le!==void 0?le:""},get uriScheme(){return Be.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return ft.getDefaultShell(!1,an)},get isTelemetryEnabled(){return gt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return gt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Be.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,le){return et.openUri(X,{allowTunneling:!!Be.remote.authority,allowContributedOpeners:le==null?void 0:le.allowContributedOpeners})},asExternalUri(X){return X.scheme===Be.environment.appUriScheme?Tt.createAppUri(X):et.asExternalUri(X,{allowTunneling:!!Be.remote.authority})},get remoteName(){return(0,Fe.getRemoteName)(Be.remote.authority)},get uiKind(){return Be.uiKind}};Be.environment.extensionTestsLocationURI||Object.freeze(fn);const mn=Be.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Ht={registerTestController(X){return(0,te.checkProposedApiEnabled)(Oe),Ft.registerTestController(Oe.identifier.value,X)},createDocumentTestObserver(X){return(0,te.checkProposedApiEnabled)(Oe),Ft.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,te.checkProposedApiEnabled)(Oe),Ft.createWorkspaceTestObserver(X)},runTests(X){return(0,te.checkProposedApiEnabled)(Oe),Ft.runTests(X)},createTestItem(X,le){return new L.TestItemImpl(X.id,X.label,X.uri,le)},createTestRun(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),Ft.createTestRun(Oe.identifier.value,X,le,Pe)},get onDidChangeTestResults(){return(0,te.checkProposedApiEnabled)(Oe),Ft.onResultsChanged},get testResults(){return(0,te.checkProposedApiEnabled)(Oe),Ft.results}};Ht.createTestRunTask=Ht.createTestRun;const Cn={getExtension(X){const le=on.getExtensionDescription(X);if(le)return new s.Extension(tt,Oe.identifier,le,mn)},get all(){return on.getAllExtensionDescriptions().map(X=>new s.Extension(tt,Oe.identifier,X,mn))},get onDidChange(){return on.onDidChange}},kn={createDiagnosticCollection(X){return jt.createDiagnosticCollection(Oe.identifier,X)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:X=>jt.getDiagnostics(X),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(X,le){return Wt.changeLanguage(X.uri,le)},match(X,le){return(0,P.score)(F.LanguageSelector.from(X),le.uri,le.languageId,!0)},registerCodeActionsProvider(X,le,Pe){return lt.registerCodeActionProvider(Oe,vt(X),le,Pe)},registerCodeLensProvider(X,le){return lt.registerCodeLensProvider(Oe,vt(X),le)},registerDefinitionProvider(X,le){return lt.registerDefinitionProvider(Oe,vt(X),le)},registerDeclarationProvider(X,le){return lt.registerDeclarationProvider(Oe,vt(X),le)},registerImplementationProvider(X,le){return lt.registerImplementationProvider(Oe,vt(X),le)},registerTypeDefinitionProvider(X,le){return lt.registerTypeDefinitionProvider(Oe,vt(X),le)},registerHoverProvider(X,le){return lt.registerHoverProvider(Oe,vt(X),le,Oe.identifier)},registerEvaluatableExpressionProvider(X,le){return lt.registerEvaluatableExpressionProvider(Oe,vt(X),le,Oe.identifier)},registerInlineValuesProvider(X,le){return lt.registerInlineValuesProvider(Oe,vt(X),le,Oe.identifier)},registerDocumentHighlightProvider(X,le){return lt.registerDocumentHighlightProvider(Oe,vt(X),le)},registerLinkedEditingRangeProvider(X,le){return lt.registerLinkedEditingRangeProvider(Oe,vt(X),le)},registerReferenceProvider(X,le){return lt.registerReferenceProvider(Oe,vt(X),le)},registerRenameProvider(X,le){return lt.registerRenameProvider(Oe,vt(X),le)},registerDocumentSymbolProvider(X,le,Pe){return lt.registerDocumentSymbolProvider(Oe,vt(X),le,Pe)},registerWorkspaceSymbolProvider(X){return lt.registerWorkspaceSymbolProvider(Oe,X)},registerDocumentFormattingEditProvider(X,le){return lt.registerDocumentFormattingEditProvider(Oe,vt(X),le)},registerDocumentRangeFormattingEditProvider(X,le){return lt.registerDocumentRangeFormattingEditProvider(Oe,vt(X),le)},registerOnTypeFormattingEditProvider(X,le,Pe,...st){return lt.registerOnTypeFormattingEditProvider(Oe,vt(X),le,[Pe].concat(st))},registerDocumentSemanticTokensProvider(X,le,Pe){return lt.registerDocumentSemanticTokensProvider(Oe,vt(X),le,Pe)},registerDocumentRangeSemanticTokensProvider(X,le,Pe){return lt.registerDocumentRangeSemanticTokensProvider(Oe,vt(X),le,Pe)},registerSignatureHelpProvider(X,le,Pe,...st){return typeof Pe=="object"?lt.registerSignatureHelpProvider(Oe,vt(X),le,Pe):lt.registerSignatureHelpProvider(Oe,vt(X),le,typeof Pe=="undefined"?[]:[Pe,...st])},registerCompletionItemProvider(X,le,...Pe){return lt.registerCompletionItemProvider(Oe,vt(X),le,Pe)},registerDocumentLinkProvider(X,le){return lt.registerDocumentLinkProvider(Oe,vt(X),le)},registerColorProvider(X,le){return lt.registerColorProvider(Oe,vt(X),le)},registerFoldingRangeProvider(X,le){return lt.registerFoldingRangeProvider(Oe,vt(X),le)},registerSelectionRangeProvider(X,le){return lt.registerSelectionRangeProvider(Oe,X,le)},registerCallHierarchyProvider(X,le){return lt.registerCallHierarchyProvider(Oe,X,le)},setLanguageConfiguration:(X,le)=>lt.setLanguageConfiguration(Oe,X,le),getTokenInformationAtPosition(X,le){return(0,te.checkProposedApiEnabled)(Oe),Wt.tokenAtPosition(X,le)},registerInlayHintsProvider(X,le){return(0,te.checkProposedApiEnabled)(Oe),lt.registerInlayHintsProvider(Oe,X,le)}},In={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(X,le,Pe){const st=await(C.URI.isUri(X)?Promise.resolve(gn.openTextDocument(X)):Promise.resolve(X));return Dt.showTextDocument(st,le,Pe)},createTextEditorDecorationType(X){return Dt.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,le,Pe){return Dt.onDidChangeActiveTextEditor(X,le,Pe)},onDidChangeVisibleTextEditors(X,le,Pe){return Dt.onDidChangeVisibleTextEditors(X,le,Pe)},onDidChangeTextEditorSelection(X,le,Pe){return Dt.onDidChangeTextEditorSelection(X,le,Pe)},onDidChangeTextEditorOptions(X,le,Pe){return Dt.onDidChangeTextEditorOptions(X,le,Pe)},onDidChangeTextEditorVisibleRanges(X,le,Pe){return Dt.onDidChangeTextEditorVisibleRanges(X,le,Pe)},onDidChangeTextEditorViewColumn(X,le,Pe){return Dt.onDidChangeTextEditorViewColumn(X,le,Pe)},onDidCloseTerminal(X,le,Pe){return ft.onDidCloseTerminal(X,le,Pe)},onDidOpenTerminal(X,le,Pe){return ft.onDidOpenTerminal(X,le,Pe)},onDidChangeActiveTerminal(X,le,Pe){return ft.onDidChangeActiveTerminal(X,le,Pe)},onDidChangeTerminalDimensions(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),ft.onDidChangeTerminalDimensions(X,le,Pe)},onDidWriteTerminalData(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),ft.onDidWriteTerminalData(X,le,Pe)},get state(){return et.state},onDidChangeWindowState(X,le,Pe){return et.onDidChangeWindowState(X,le,Pe)},showInformationMessage(X,...le){return Ut.showMessage(Oe,y.default.Info,X,le[0],le.slice(1))},showWarningMessage(X,...le){return Ut.showMessage(Oe,y.default.Warning,X,le[0],le.slice(1))},showErrorMessage(X,...le){return Ut.showMessage(Oe,y.default.Error,X,le[0],le.slice(1))},showQuickPick(X,le,Pe){return $t.showQuickPick(X,!!Oe.enableProposedApi,le,Pe)},showWorkspaceFolderPick(X){return $t.showWorkspaceFolderPick(X)},showInputBox(X,le){return $t.showInput(X,le)},showOpenDialog(X){return Pt.showOpenDialog(X)},showSaveDialog(X){return Pt.showSaveDialog(X)},createStatusBarItem(X,le){let Pe,st,wt,Ct;return X&&typeof X!="number"?(Pe=X.id,st=X.name,wt=X.alignment,le=X.priority,Ct=X.accessibilityInformation):(Pe=Oe.identifier.value,st=v.localize(0,null,Oe.displayName||Oe.name),wt=X),hn.createStatusBarEntry(Pe,st,wt,le,Ct)},setStatusBarMessage(X,le){return hn.setStatusBarMessage(X,le)},withScmProgress(X){return Je.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),dn.withProgress(Oe,{location:L.ProgressLocation.SourceControl},(le,Pe)=>X({report(st){}}))},withProgress(X,le){return dn.withProgress(Oe,X,le)},createOutputChannel(X){return Ot.createOutputChannel(X)},createWebviewPanel(X,le,Pe,st){return nn.createWebviewPanel(Oe,X,le,Pe,st)},createWebviewTextEditorInset(X,le,Pe,st){return(0,te.checkProposedApiEnabled)(Oe),Xt.createWebviewEditorInset(X,le,Pe,st,Oe)},createTerminal(X,le,Pe){return typeof X=="object"?"pty"in X?ft.createExtensionTerminal(X):(X.icon&&(0,te.checkProposedApiEnabled)(Oe),ft.createTerminalFromOptions(X)):ft.createTerminal(X,le,Pe)},registerTerminalLinkProvider(X){return ft.registerLinkProvider(X)},registerTreeDataProvider(X,le){return Vt.registerTreeDataProvider(X,le,Oe)},createTreeView(X,le){return Vt.createTreeView(X,le,Oe)},registerWebviewPanelSerializer:(X,le)=>nn.registerWebviewPanelSerializer(Oe,X,le),registerCustomEditorProvider:(X,le,Pe={})=>Kt.registerCustomEditorProvider(Oe,X,le,Pe),registerFileDecorationProvider(X){return Ze.registerFileDecorationProvider(X,Oe.identifier)},registerUriHandler(X){return Tt.registerUriHandler(Oe.identifier,X)},createQuickPick(){return $t.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return $t.createInputBox(Oe.identifier)},get activeColorTheme(){return qt.activeColorTheme},onDidChangeActiveColorTheme(X,le,Pe){return qt.onDidChangeActiveColorTheme(X,le,Pe)},registerWebviewViewProvider(X,le,Pe){return En.registerWebviewViewProvider(Oe,X,le,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,te.checkProposedApiEnabled)(Oe),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeActiveNotebookEditor(X,le,Pe)},get visibleNotebookEditors(){return(0,te.checkProposedApiEnabled)(Oe),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookEditorSelection(X,le,Pe)},onDidChangeNotebookEditorVisibleRanges(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookEditorVisibleRanges(X,le,Pe)},showNotebookDocument(X,le){return(0,te.checkProposedApiEnabled)(Oe),pt.showNotebookDocument(X,le)},registerExternalUriOpener(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),rn.registerExternalUriOpener(Oe.identifier,X,le,Pe)},get openEditors(){return(0,te.checkProposedApiEnabled)(Oe),ct.tabs},get onDidChangeOpenEditors(){return(0,te.checkProposedApiEnabled)(Oe),ct.onDidChangeTabs}},gn={get rootPath(){return Je.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Qe.getPath()},set rootPath(X){throw D.readonly()},getWorkspaceFolder(X){return Qe.getWorkspaceFolder(X)},get workspaceFolders(){return Qe.getWorkspaceFolders()},get name(){return Qe.name},set name(X){throw D.readonly()},get workspaceFile(){return Qe.workspaceFile},set workspaceFile(X){throw D.readonly()},updateWorkspaceFolders:(X,le,...Pe)=>Qe.updateWorkspaceFolders(Oe,X,le||0,...Pe),onDidChangeWorkspaceFolders:function(X,le,Pe){return Qe.onDidChangeWorkspace(X,le,Pe)},asRelativePath:(X,le)=>Qe.getRelativePath(X,le),findFiles:(X,le,Pe,st)=>Qe.findFiles(F.GlobPattern.from(X),F.GlobPattern.from(le),Pe,Oe.identifier,st),findTextInFiles:(X,le,Pe,st)=>{let wt,Ct;return typeof le=="object"?(wt=le,Ct=Pe):(wt={},Ct=le,st=Pe),Qe.findTextInFiles(X,wt||{},Ct,Oe.identifier,st)},saveAll:X=>Qe.saveAll(X),applyEdit(X){return xt.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,le,Pe,st)=>Rt.createFileSystemWatcher(F.GlobPattern.from(X),le,Pe,st),get textDocuments(){return _t.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw D.readonly()},openTextDocument(X){let le;const Pe=X;if(typeof X=="string")le=Promise.resolve(C.URI.file(X));else if(C.URI.isUri(X))le=Promise.resolve(X);else if(!Pe||typeof Pe=="object")le=_t.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(X,le,Pe)=>_t.onDidAddDocument(X,le,Pe),onDidCloseTextDocument:(X,le,Pe)=>_t.onDidRemoveDocument(X,le,Pe),onDidChangeTextDocument:(X,le,Pe)=>_t.onDidChangeDocument(X,le,Pe),onDidSaveTextDocument:(X,le,Pe)=>_t.onDidSaveDocument(X,le,Pe),onWillSaveTextDocument:(X,le,Pe)=>Yt.getOnWillSaveTextDocumentEvent(Oe)(X,le,Pe),onDidChangeConfiguration:(X,le,Pe)=>an.onDidChangeConfiguration(X,le,Pe),getConfiguration(X,le){return le=arguments.length===1?void 0:le,an.getConfiguration(X,le,Oe)},registerTextDocumentContentProvider(X,le){return Qt.registerTextDocumentContentProvider(X,le)},registerTaskProvider:(X,le)=>(Je.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Oe,X,le)),registerFileSystemProvider(X,le,Pe){return Zt.registerFileSystemProvider(Oe.identifier,X,le,Pe,Oe.enableProposedApi)},get fs(){return rt.value},registerFileSearchProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),yt.registerFileSearchProvider(X,le)),registerTextSearchProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),yt.registerTextSearchProvider(X,le)),registerRemoteAuthorityResolver:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),tt.registerRemoteAuthorityResolver(X,le)),registerResourceLabelFormatter:X=>((0,te.checkProposedApiEnabled)(Oe),en.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,le,Pe)=>Rt.onDidCreateFile(X,le,Pe),onDidDeleteFiles:(X,le,Pe)=>Rt.onDidDeleteFile(X,le,Pe),onDidRenameFiles:(X,le,Pe)=>Rt.onDidRenameFile(X,le,Pe),onWillCreateFiles:(X,le,Pe)=>Rt.getOnWillCreateFileEvent(Oe)(X,le,Pe),onWillDeleteFiles:(X,le,Pe)=>Rt.getOnWillDeleteFileEvent(Oe)(X,le,Pe),onWillRenameFiles:(X,le,Pe)=>Rt.getOnWillRenameFileEvent(Oe)(X,le,Pe),openTunnel:X=>((0,te.checkProposedApiEnabled)(Oe),Te.openTunnel(Oe,X).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,te.checkProposedApiEnabled)(Oe),Te.getTunnels()},onDidChangeTunnels:(X,le,Pe)=>((0,te.checkProposedApiEnabled)(Oe),Te.onDidChangeTunnels(X,le,Pe)),registerPortAttributesProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),Te.registerPortsAttributesProvider(X,le)),registerTimelineProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),_n.registerTimelineProvider(X,le,Oe.identifier,ht.converter)),get isTrusted(){return Qe.trusted},requestWorkspaceTrust:X=>((0,te.checkProposedApiEnabled)(Oe),Qe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,le,Pe)=>Qe.onDidGrantWorkspaceTrust(X,le,Pe)},Pn={get inputBox(){return Je.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Oe)},createSourceControl(X,le,Pe){return cn.createSourceControl(Oe,X,le,Pe)}},An={createCommentController(X,le){return wn.createCommentController(Oe,X,le)}},pn={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(X,le,Pe){return at.onDidStartDebugSession(X,le,Pe)},onDidTerminateDebugSession(X,le,Pe){return at.onDidTerminateDebugSession(X,le,Pe)},onDidChangeActiveDebugSession(X,le,Pe){return at.onDidChangeActiveDebugSession(X,le,Pe)},onDidReceiveDebugSessionCustomEvent(X,le,Pe){return at.onDidReceiveDebugSessionCustomEvent(X,le,Pe)},onDidChangeBreakpoints(X,le,Pe){return at.onDidChangeBreakpoints(X,le,Pe)},registerDebugConfigurationProvider(X,le,Pe){return at.registerDebugConfigurationProvider(X,le,Pe||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,le){return at.registerDebugAdapterDescriptorFactory(Oe,X,le)},registerDebugAdapterTrackerFactory(X,le){return at.registerDebugAdapterTrackerFactory(X,le)},startDebugging(X,le,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?at.startDebugging(X,le,{parentSession:Pe}):at.startDebugging(X,le,Pe||{})},stopDebugging(X){return at.stopDebugging(X)},addBreakpoints(X){return at.addBreakpoints(X)},removeBreakpoints(X){return at.removeBreakpoints(X)},asDebugSourceUri(X,le){return at.asDebugSourceUri(X,le)}},vn={registerTaskProvider:(X,le)=>Et.registerTaskProvider(Oe,X,le),fetchTasks:X=>Et.fetchTasks(X),executeTask:X=>Et.executeTask(Oe,X),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(X,le,Pe)=>Et.onDidStartTask(X,le,Pe),onDidEndTask:(X,le,Pe)=>Et.onDidEndTask(X,le,Pe),onDidStartTaskProcess:(X,le,Pe)=>Et.onDidStartTaskProcess(X,le,Pe),onDidEndTaskProcess:(X,le,Pe)=>Et.onDidEndTaskProcess(X,le,Pe)},Bt={openNotebookDocument:X=>((0,te.checkProposedApiEnabled)(Oe),pt.openNotebookDocument(X)),get onDidOpenNotebookDocument(){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,te.checkProposedApiEnabled)(Oe),pt.notebookDocuments.map(X=>X.apiNotebook)},registerNotebookSerializer(X,le,Pe,st){return(0,te.checkProposedApiEnabled)(Oe),pt.registerNotebookSerializer(Oe,X,le,Pe,Oe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(X,le,Pe,st)=>((0,te.checkProposedApiEnabled)(Oe),pt.registerNotebookContentProvider(Oe,X,le,Pe,Oe.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),pt.registerNotebookCellStatusBarItemProvider(Oe,X,le)),createNotebookEditorDecorationType(X){return(0,te.checkProposedApiEnabled)(Oe),pt.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookDocumentMetadata(X,le,Pe)},onDidChangeNotebookCells(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookCells(X,le,Pe)},onDidChangeNotebookCellExecutionState(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookCellExecutionState(X,le,Pe)},onDidChangeCellOutputs(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeCellOutputs(X,le,Pe)},onDidChangeCellMetadata(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeCellMetadata(X,le,Pe)},createConcatTextDocument(X,le){return(0,te.checkProposedApiEnabled)(Oe),new V.ExtHostNotebookConcatDocument(pt,_t,X,le)},createNotebookController(X,le,Pe,st,wt){return(0,te.checkProposedApiEnabled)(Oe),Jt.createNotebookController(Oe,X,le,Pe,st,wt)}};return{version:Be.version,authentication:Sn,commands:Dn,comments:An,debug:pn,env:fn,extensions:Cn,languages:kn,notebook:Bt,scm:Pn,tasks:vn,test:Ht,window:In,workspace:gn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:D.CancellationError,CancellationTokenSource:T.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:i.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:g.UIKind,Uri:C.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,RemoteTrustOption:oe.RemoteTrustOption,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookKernelPreload:L.NotebookKernelPreload,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TextSearchCompleteMessageType:ke.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ie}),define(ve[226],be([0,1,61,101,30,100,34,77,39,40,104,105,106,80,79,71,76,102,78,49,75,95,69]),function(Y,e,v,T,D,A,y,C,S,k,i,P,d,g,r,a,p,f,E,o,c,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,v.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,v.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,v.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,v.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,v.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,v.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,v.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,v.registerSingleton)(o.IExtHostFileSystemInfo,o.ExtHostFileSystemInfo),(0,v.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService),(0,v.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,v.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,v.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,v.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,v.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,v.registerSingleton)(f.IExtHostWindow,f.ExtHostWindow),(0,v.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,v.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,v.registerSingleton)(m.IExtHostTelemetry,m.ExtHostTelemetry),(0,v.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ve[227],be([0,1,225,35,221,7,11,5]),function(Y,e,v,T,D,A,y,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(r){var a;const p=(a=self.trustedTypes)===null||a===void 0?void 0:a.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...o)=>{o.forEach(n=>{var l;if(!((l=self.trustedTypes)===null||l===void 0?void 0:l.isScript(n)))throw new Error("TrustedScripts only, please")});const c=o.slice(0,-1).join(","),m=o.pop().toString();return`(function anonymous(${c}) {
${m}
})`}});function f(...E){return p?self.eval(p.createScript("",...E)):new Function(...E)}r.create=f})(k||(k={}));class i extends D.RequireInterceptor{_installInterceptor(){}getModule(a,p){for(let f of this._alternatives){let E=f(a);if(E){a=E;break}}if(this._factories.has(a))return this._factories.get(a).load(a,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);g(a,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(v.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,p,f){var E,o,c,m,t,n,l,s;p=p.with({path:d(p.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const u=await fetch(p.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),u.status!==200)throw new Error(u.statusText);const w=await u.text(),b=`${p.toString(!0)}#vscode-extension`,I=`${w}
//# sourceURL=${b}`;let h;try{h=k.create((o=(E=P._ttpExtensionScripts)===null||E===void 0?void 0:E.createScript("module"))!==null&&o!==void 0?o:"module",(m=(c=P._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&m!==void 0?m:"exports",(n=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(s=(l=P._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript(I))!==null&&s!==void 0?s:I)}catch(z){throw a?console.error(`Loading code for extension ${a.value} failed: ${z.message}`):console.error(`Loading code failed: ${z.message}`),console.error(`${p.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const _={},R={exports:_},B=z=>{const he=this._fakeModules.getModule(z,p);if(he===void 0)throw new Error(`Cannot load module '${z}'`);return he};try{return f.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),h(R,_,B),R.exports!==_?R.exports:_}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),f.codeLoadingStop()}}async $setRemoteEnvironment(a){throw new Error("Not supported")}async _waitForDebuggerAttachment(a=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const p=Date.now()+a;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(S=self.trustedTypes)===null||S===void 0?void 0:S.createPolicy("ExtensionScripts",{createScript:r=>r});function d(r,a){return r.endsWith(a)?r:r+a}function g(r,a){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(o,c){const m=console[o];console[o]=function(){r.$logExtensionHostMessage({type:"__$console",severity:c,arguments:E(arguments)}),a&&m.apply(console,arguments)}}const f=1e5;function E(o){const c=[],m=[];if(o.length)for(let t=0;t<o.length;t++){if(typeof o[t]=="undefined")o[t]="undefined";else if(o[t]instanceof Error){const n=o[t];n.stack?o[t]=n.stack:o[t]=n.toString()}m.push(o[t])}try{const t=JSON.stringify(m,function(n,l){if(l&&typeof l=="object"){if(c.indexOf(l)!==-1)return"[Circular]";c.push(l)}return l});return t.length>f?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(ve[228],be([0,1,61,18,35,227,213]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(D.IExtHostExtensionService,A.ExtHostExtensionService),(0,v.registerSingleton)(T.ILogService,y.ExtHostLogService)}),define(ve[230],be([0,1,24,3,184,222,215,14,81,226,228]),function(Y,e,v,T,D,A,y,C,S){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const P=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:E=>E}),f=self.Worker;Worker=function(E,o){const c=`importScripts('${E}');`;o=o||{},o.name=o.name||C.basename(E.toString());const m=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(m);return new f(p?p.createScriptURL(t):t,o)}}else self.Worker=class extends y.NestedWorker{constructor(p,f){super(P,p,Object.assign({name:C.basename(p.toString())},f))}};const d=new class{exit(p){i()}async exists(p){return!0}async realpath(p){return p}};class g{constructor(){const f=new MessageChannel,E=new T.Emitter;let o=!1;P(f.port2,[f.port2]),f.port1.onmessage=c=>{const{data:m}=c;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const t=v.VSBuffer.wrap(new Uint8Array(m,0,m.byteLength));if((0,D.isMessageOfType)(t,2)){o=!0,a("received terminate message from renderer");return}E.fire(t)},this.protocol={onMessage:E.event,send:c=>{if(!o){const m=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);f.port1.postMessage(m,[m])}}}}}function r(p){return new Promise(f=>{const E=p.onMessage(o=>{E.dispose();const c=JSON.parse(o.toString());p.send((0,D.createMessageOfType)(0)),f({protocol:p,initData:c})});p.send((0,D.createMessageOfType)(1))})}let a=p=>i();(function(){const f=new g;S.mark("code/extHost/willConnectToRenderer"),r(f.protocol).then(E=>{S.mark("code/extHost/didWaitForInitData");const o=new A.ExtensionHostMain(E.protocol,E.initData,d,null);a=c=>o.terminate(c)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9553ccbe6ed0224f2168c6fe503d2f20c55c1825/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
